<?php
 namespace App\Backup; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\FindChmodCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\WriteFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\RcloneCopyCommand; use App\System\Command\RcloneLsJsonCommand; use App\System\Command\RclonePurgeCommand; class Rclone { private const FREQUENCY_DAILY = "\144\141\151\154\171"; private const CONFIG_DIRECTORY = "\57\x72\157\157\164\57\56\x63\157\x6e\x66\151\147\x2f\x72\143\x6c\x6f\156\145\x2f"; private const CLP_USER_CONFIG_DIRECTORY = "\x2f\150\157\x6d\x65\57\x63\154\160\57\56\143\157\156\146\151\147\57"; private const CLP_USER = "\x63\x6c\x70"; public const CREDENTIALS_DIRECTORY = "\57\x68\157\155\x65\x2f\143\154\160\57\x2e\x63\157\x6e\146\x69\147\x2f\162\143\154\x6f\156\145\x2f\143\x72\145\x64\145\156\164\x69\x61\x6c\x73\x2f"; private const CONFIG_FILE = "\57\162\x6f\x6f\164\x2f\56\x63\157\x6e\146\151\x67\x2f\162\x63\154\x6f\x6e\x65\x2f\x72\143\x6c\157\x6e\145\x2e\x63\x6f\156\x66"; private const CRON_JOB_FILE = "\x2f\x65\164\x63\x2f\x63\162\x6f\156\x2e\144\57\x63\x6c\160\55\162\x63\154\157\156\145"; private CommandExecutor $commandExecutor; private ?string $configFile = null; private array $flags = []; public function __construct() { $this->commandExecutor = new CommandExecutor(); } public function setConfigFile(string $configFile) : void { $this->configFile = $configFile; } public function getConfigFile() : ?string { goto D3a28; D3a28: if (!(true === is_null($this->configFile))) { goto e3575; } goto f6775; Cfd23: e3575: goto e9f48; e9f48: return $this->configFile; goto B46cc; f6775: $this->configFile = self::CONFIG_FILE; goto Cfd23; B46cc: } public function addFlag(string $flag, string $value) { $this->flags[] = ["\146\x6c\141\147" => $flag, "\x76\141\154\165\145" => $value]; } public function getFlags() : array { return $this->flags; } public function copy(string $source, string $destination) : void { goto e0546; D1622: $rcloneCopyCommand = new RcloneCopyCommand(); goto beb2d; e0546: $flags = $this->getFlags(); goto A6506; F14cc: $rcloneCopyCommand->setDestination($destination); goto Add4d; Add4d: $this->addFlagsToCommand($flags, $rcloneCopyCommand); goto d5233; beb2d: $rcloneCopyCommand->setConfigFile($configFile); goto F5740; F5740: $rcloneCopyCommand->setSource($source); goto F14cc; d5233: $this->commandExecutor->execute($rcloneCopyCommand, 21600); goto A08e4; A6506: $configFile = $this->getConfigFile(); goto D1622; A08e4: } public function lsJson(?string $remotePath = null, $directoriesOnly = false) : array { goto Bedc7; c6191: $this->commandExecutor->execute($rcloneLsJsonCommand, 20); goto c5497; A1950: $rcloneLsJsonCommand->setRemotePath($remotePath); goto Dc2f5; Abe01: $this->addFlagsToCommand($flags, $rcloneLsJsonCommand); goto c6191; Bbd52: E17e7: goto Abe01; Bedc7: $flags = $this->getFlags(); goto a1cd5; Bf1d8: $rcloneLsJsonCommand->setDirectoriesOnly(true); goto Bbd52; acc07: $rcloneLsJsonCommand = new RcloneLsJsonCommand(); goto F00fe; F00fe: $rcloneLsJsonCommand->setConfigFile($configFile); goto A1950; dd57f: return $files; goto c572f; c5497: $files = $rcloneLsJsonCommand->getFiles(); goto dd57f; Dc2f5: if (!(true === $directoriesOnly)) { goto E17e7; } goto Bf1d8; a1cd5: $configFile = $this->getConfigFile(); goto acc07; c572f: } public function purge(string $remotePath) { goto a5f39; Cffc1: $this->commandExecutor->execute($rclonePurgeCommand, 21600); goto dc4f6; c53a4: $this->addFlagsToCommand($flags, $rclonePurgeCommand); goto Cffc1; cfd88: $rclonePurgeCommand->setRemotePath($remotePath); goto c53a4; a5f39: $flags = $this->getFlags(); goto Dc1d2; Dc1d2: $rclonePurgeCommand = new RclonePurgeCommand(); goto cfd88; dc4f6: } public function writeConfig(string $config) : void { goto B1ddf; e90ed: $createConfigDirectoryCommand = new CreateDirectoryCommand(); goto b41cb; f8b34: $this->commandExecutor->execute($createConfigDirectoryCommand); goto E1df5; bf40a: $writeConfigFileCommand = new WriteFileCommand(); goto af0ec; E1df5: $this->commandExecutor->execute($writeConfigFileCommand); goto c06de; Ec376: $writeConfigFileCommand->setContent($config); goto f8b34; B1ddf: $configFile = $this->getConfigFile(); goto e90ed; af0ec: $writeConfigFileCommand->setFile($configFile); goto Ec376; b41cb: $createConfigDirectoryCommand->setDirectory(self::CONFIG_DIRECTORY); goto bf40a; c06de: } public function writeCredentialsFile(string $file, string $content) : void { goto a7e8c; dd426: $chmodConfigDirectoryCommand->setFileChmod(770); goto add09; b2943: $this->commandExecutor->execute($chownConfigDirectoryCommand); goto F8647; E953a: $chownConfigDirectoryCommand = new ChownCommand(); goto e02e0; Dbf22: $credentialsDirectoryCommand->setDirectory(self::CREDENTIALS_DIRECTORY); goto E953a; F8647: $this->commandExecutor->execute($chmodConfigDirectoryCommand); goto E35bd; E35bd: file_put_contents($file, $content); goto c6a7e; e02e0: $chownConfigDirectoryCommand->setFile(self::CLP_USER_CONFIG_DIRECTORY); goto Bea35; add09: $this->commandExecutor->execute($credentialsDirectoryCommand); goto b2943; Cc6f5: $chmodConfigDirectoryCommand = new FindChmodCommand(); goto B9e96; C1080: $chownConfigDirectoryCommand->setGroup(self::CLP_USER); goto Cc6f5; F61aa: $chownConfigDirectoryCommand->setUser(self::CLP_USER); goto C1080; a7e8c: $credentialsDirectoryCommand = new CreateDirectoryCommand(); goto Dbf22; Bea35: $chownConfigDirectoryCommand->setRecursive(true); goto F61aa; B9e96: $chmodConfigDirectoryCommand->setFile(self::CLP_USER_CONFIG_DIRECTORY); goto B1575; B1575: $chmodConfigDirectoryCommand->setDirectoryChmod(770); goto dd426; c6a7e: } public function createCronJob(string $frequency, string $executionTime = null) : void { goto Bcdfa; d3985: goto C98da; goto B6ba9; B6ba9: b367f: goto b08e1; dcbbb: C98da: goto ab7b8; ab6e7: $this->commandExecutor->execute($writeCronJobFileCommand); goto F9837; C0366: $writeCronJobFileCommand->setFile(self::CRON_JOB_FILE); goto a1e40; cc53f: $cronJobContent .= sprintf("\x30\x20\x2a\x2f\45\163\x20\x2a\40\x2a\40\x2a\40\143\x6c\x70\x20\57\165\x73\x72\x2f\142\x69\156\x2f\142\141\163\x68\40\55\x63\40\42\x2f\x75\163\162\57\142\151\x6e\x2f\x63\x6c\x70\143\164\x6c\x20\162\x65\x6d\x6f\x74\x65\55\x62\x61\143\x6b\165\x70\x3a\x63\162\145\x61\x74\x65\40\x2d\x2d\144\x65\154\141\x79\75\x74\x72\165\x65\x22\40\46\76\40\x2f\x64\145\166\x2f\156\x75\154\x6c", $frequency); goto d3985; Bcdfa: $cronJobContent = sprintf("\115\101\111\x4c\124\117\75\42\42\x25\x73", PHP_EOL); goto f9465; a1e40: $writeCronJobFileCommand->setContent($cronJobContent); goto ab6e7; f9465: if (self::FREQUENCY_DAILY == $frequency) { goto b367f; } goto cc53f; ab7b8: $writeCronJobFileCommand = new WriteFileCommand(); goto C0366; b08e1: $cronJobContent .= sprintf("\x30\x20\x25\163\40\x2a\x20\x2a\40\52\x20\143\154\x70\x20\57\x75\x73\x72\x2f\x62\151\156\57\142\x61\163\150\x20\x2d\x63\x20\x22\57\165\163\162\x2f\x62\x69\156\57\143\154\x70\143\164\154\x20\x72\145\x6d\157\x74\145\x2d\x62\141\143\x6b\x75\160\72\143\x72\145\x61\164\145\x20\55\55\x64\145\x6c\x61\x79\x3d\164\x72\x75\145\42\40\x26\x3e\40\57\x64\145\166\57\156\x75\x6c\154", $executionTime); goto dcbbb; F9837: } private function addFlagsToCommand(array $flags, $command) : void { goto A72bc; B4de2: foreach ($flags as $flagData) { $command->addFlag($flagData["\146\x6c\141\147"], $flagData["\x76\x61\x6c\x75\145"]); Ba55f: } goto Afd09; Afd09: C9ba4: goto c04ca; c04ca: D5dea: goto a97ee; A72bc: if (!(false === empty($flags))) { goto D5dea; } goto B4de2; a97ee: } public function deleteCronJob() : void { goto Be0ac; d0412: $this->commandExecutor->execute($deleteCronJobFileCommand); goto B1922; Be0ac: $deleteCronJobFileCommand = new DeleteFileCommand(); goto E1872; E1872: $deleteCronJobFileCommand->setFile(self::CRON_JOB_FILE); goto d0412; B1922: } public function deleteCredentials() : void { goto D9195; c81ab: $this->commandExecutor->execute($deleteCredentialsDirectoryCommand); goto B9edc; f5e1d: $deleteCredentialsDirectoryCommand->setDirectory(self::CREDENTIALS_DIRECTORY); goto c81ab; D9195: $deleteCredentialsDirectoryCommand = new DeleteDirectoryCommand(); goto f5e1d; B9edc: } }
