<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\DatabaseUser as DatabaseUserEntity; use App\Database\Manager as DatabaseManager; use App\Service\Crypto; class DatabaseAddCommand extends BaseCommand { private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private ValidatorInterface $validator; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto a8a52; a8a52: $this->siteEntityManager = $siteEntityManager; goto bdfc8; d364c: $this->databaseServerEntityManager = $databaseServerEntityManager; goto C58ec; f9370: $this->databaseUserEntityManager = $databaseUserEntityManager; goto d364c; db8d9: parent::__construct(); goto Ba009; bdfc8: $this->databaseEntityManager = $databaseEntityManager; goto f9370; C58ec: $this->validator = $validator; goto db8d9; Ba009: } protected function configure() : void { goto e5b2a; ba313: $this->addOption("\x64\157\155\141\x69\156\x4e\x61\x6d\145", null, InputOption::VALUE_REQUIRED); goto A0c2c; D96ab: $this->addOption("\144\141\x74\x61\142\x61\x73\x65\125\x73\145\x72\116\x61\x6d\x65", null, InputOption::VALUE_REQUIRED); goto D8b04; A0c2c: $this->addOption("\x64\x61\164\141\142\x61\x73\145\116\x61\x6d\145", null, InputOption::VALUE_REQUIRED); goto D96ab; e5b2a: $this->setName("\x64\x62\72\x61\144\x64"); goto A625a; A625a: $this->setDescription("\143\x6c\160\143\x74\154\40\144\142\x3a\141\144\144\x20\55\x2d\144\x6f\155\x61\x69\x6e\x4e\x61\155\x65\x3d\x77\x77\167\x2e\144\157\x6d\x61\151\156\56\x63\157\155\x20\55\55\144\141\x74\141\x62\141\163\145\x4e\141\x6d\x65\75\155\x79\x2d\144\x61\x74\141\142\141\x73\x65\40\x2d\55\x64\x61\x74\141\142\141\163\145\125\163\x65\162\x4e\x61\x6d\x65\x3d\152\157\150\x6e\40\x2d\55\x64\x61\164\x61\142\x61\163\145\x55\x73\145\162\120\x61\x73\x73\167\x6f\x72\x64\75\x27\x21\163\x65\143\x72\x65\164\120\x61\x73\163\x77\x6f\x72\x64\41\x27"); goto ba313; D8b04: $this->addOption("\144\x61\164\141\142\x61\163\x65\125\163\145\162\x50\x61\163\163\x77\157\x72\144", null, InputOption::VALUE_REQUIRED); goto a5b98; a5b98: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto c9acf; D9090: $output->writeln(sprintf("\x3c\x69\x6e\x66\157\76\x44\x61\164\141\x62\141\163\145\x3c\x2f\x69\156\146\157\76\x20\74\143\157\x6d\155\x65\x6e\164\76\x25\163\x3c\57\143\157\155\155\145\x6e\x74\x3e\40\74\x69\156\146\x6f\76\150\141\163\x20\x62\145\145\156\x20\141\144\x64\145\x64\56\74\x2f\x69\x6e\x66\x6f\76", $databaseName)); goto B2d9f; bf9ed: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto C5f5d; Ffc33: return BaseCommand::FAILURE; goto b43c4; f10b2: $databaseUserEntity->setPermissions(DatabaseUserEntity::PERMISSIONS_READ_WRITE); goto B1408; D846a: $databaseEntity->setName($databaseName); goto B74a5; ebdf0: $databaseConstraints = $this->validator->validate($databaseEntity); goto d2a12; de167: $databaseUserPassword = trim($input->getOption("\144\141\164\x61\x62\x61\x73\145\125\x73\x65\x72\x50\141\163\x73\167\157\162\144")); goto c36a4; Fdc87: Bbf80: goto E0b08; afb81: $databaseEntity->setDatabaseServer($activeDatabaseServerEntity); goto D846a; Abf8e: $this->siteEntityManager->updateEntity($siteEntity); goto D9090; ec9dc: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto D7989; B2d9f: return BaseCommand::SUCCESS; goto Bc85a; B74a5: $databaseEntity->setSite($siteEntity); goto bf9ed; e6955: if (0 == count($databaseConstraints) && 0 == count($databaseUserConstraints)) { goto Bbf80; } goto fc0c8; fe671: $databaseEntity = $this->databaseEntityManager->createEntity(); goto afb81; ead90: $databaseEntity->addUser($databaseUserEntity); goto a7757; Ac983: Af58f: goto Ffc33; d2a12: $databaseUserConstraints = $this->validator->validate($databaseUserEntity); goto e6955; a7757: $siteEntity->addDatabase($databaseEntity); goto ebdf0; c36a4: $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); goto D005c; ac0fc: $domainName = trim($input->getOption("\144\x6f\x6d\x61\x69\x6e\116\x61\155\145")); goto E01ec; C7d8f: $databaseUserEntity->setPassword(Crypto::encrypt($databaseUserPassword)); goto f10b2; fc0c8: $constraints = new ConstraintViolationList(); goto Ed78b; c9acf: $this->validateInput($input); goto ac0fc; Bc85a: Ad610: goto Ac983; Ed78b: $constraints->addAll($databaseConstraints); goto Dd52d; E6cd9: throw new \Exception(sprintf("\x44\157\x6d\141\x69\156\116\141\155\x65\40\x22\x25\163\x22\40\144\x6f\145\163\40\x6e\157\x74\x20\x65\170\151\163\164\56", $domainName)); goto c94d4; D7989: if (!(false === is_null($activeDatabaseServerEntity))) { goto Af58f; } goto fe671; c94d4: Ac987: goto ec9dc; E01ec: $databaseName = trim($input->getOption("\144\x61\x74\x61\142\141\x73\145\x4e\141\155\x65")); goto C93bf; e0374: goto Ad610; goto Fdc87; C419c: return $this->renderConstraints($constraints, $output); goto e0374; Dd52d: $constraints->addAll($databaseUserConstraints); goto C419c; C93bf: $databaseUserName = trim($input->getOption("\144\141\164\141\x62\x61\163\145\x55\x73\x65\x72\116\x61\155\145")); goto de167; C48b5: $databaseManager->createUser($databaseUserEntity); goto Abf8e; A70be: $databaseManager->createDatabase($databaseEntity); goto C48b5; C5f5d: $databaseUserEntity->setUserName($databaseUserName); goto C7d8f; D005c: if (!(true === is_null($siteEntity))) { goto Ac987; } goto E6cd9; B1408: $databaseUserEntity->setDatabase($databaseEntity); goto ead90; E0b08: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto A70be; b43c4: } catch (\Exception $e) { goto c5df9; C7e94: $output->writeln(sprintf("\74\145\162\162\x6f\x72\76\x25\163\x3c\x2f\145\162\162\x6f\162\76", $errorMessage)); goto D57db; D57db: return BaseCommand::FAILURE; goto C45b0; c5df9: $errorMessage = $e->getMessage(); goto C7e94; C45b0: } } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\x6e\141\155\145", "\x64\x61\x74\x61\142\x61\x73\x65\116\x61\x6d\145", $constraints); $this->changePropertyPath("\x75\163\x65\162\116\141\155\x65", "\x64\141\x74\141\142\x61\x73\x65\x55\x73\x65\x72\116\141\x6d\145", $constraints); } }
