<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\Entity\Database as DatabaseEntity; use App\System\CommandExecutor; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\System\Command\DeleteOldFilesRecursiveCommand; use App\System\Command\FindChmodCommand; use App\System\Command\ChownCommand; use App\Database\Exporter as DatabaseExporter; class DatabaseBackupCommand extends BaseCommand { private const RETENTION_PERIOD = 7; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private int $retentionPeriod = 0; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto Af24d; F4a6c: parent::__construct(); goto Ee240; Af24d: $this->siteEntityManager = $siteEntityManager; goto c7f12; bbefa: $this->validator = $validator; goto F4a6c; cf90c: $this->databaseServerEntityManager = $databaseServerEntityManager; goto feb0b; feb0b: $this->commandExecutor = new CommandExecutor(); goto bbefa; c7f12: $this->databaseEntityManager = $databaseEntityManager; goto cf90c; Ee240: } protected function configure() : void { goto bce78; eeee3: $this->addOption("\151\147\x6e\x6f\162\x65\104\141\x74\x61\x62\x61\163\145\x73", null, InputOption::VALUE_OPTIONAL); goto Abfa0; bce78: $this->setName("\x64\142\72\142\141\x63\x6b\x75\x70"); goto Fa806; Fa806: $this->setDescription("\143\154\x70\x63\164\x6c\x20\x64\x62\x3a\142\x61\x63\x6b\x75\x70\40\55\x2d\151\x67\156\x6f\162\145\x44\x61\x74\141\x62\x61\x73\145\163\x3d\x27\x64\142\x31\x2c\x64\x62\x32\x27\40\55\55\162\x65\164\x65\156\x74\x69\157\x6e\x50\x65\162\x69\x6f\x64\x3d\x37"); goto eeee3; Abfa0: $this->addOption("\162\x65\x74\x65\x6e\x74\x69\x6f\x6e\x50\145\162\151\x6f\144", null, InputOption::VALUE_OPTIONAL, '', self::RETENTION_PERIOD); goto Ba663; Ba663: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto b614d; edea8: D3183: goto a6e5c; f11c6: Dab95: goto edea8; Effb4: $siteEntities = $this->siteEntityManager->findAll(); goto Cd20f; a6e5c: return BaseCommand::SUCCESS; goto fd30e; b614d: $this->validateInput($input); goto F6164; F6164: $ignoredDatabases = explode("\54", $input->getOption("\x69\147\x6e\157\162\x65\x44\141\x74\x61\x62\x61\163\145\163")); goto Dc642; Ffa2a: foreach ($siteEntities as $siteEntity) { goto f9b59; b413f: f90c8: goto C6dc5; e54e7: if (!count($databaseEntities)) { goto f90c8; } goto Cc781; C6dc5: A6077: goto c1206; f9b59: $databaseEntities = $siteEntity->getDatabases(); goto e54e7; Cc781: foreach ($databaseEntities as $databaseEntity) { goto A1b37; e16bd: Caad3: goto B8022; f773c: if (!(false === in_array($databaseName, $ignoredDatabases))) { goto cba19; } goto D09f2; Df308: cba19: goto e16bd; A1b37: $databaseName = $databaseEntity->getName(); goto f773c; D09f2: $this->createDatabaseDump($databaseEntity); goto Df308; B8022: } goto A28d7; A28d7: Fec6a: goto b413f; c1206: } goto f11c6; Cd20f: if (!count($siteEntities)) { goto D3183; } goto Ffa2a; Dc642: $this->retentionPeriod = (int) $input->getOption("\x72\145\164\x65\x6e\164\x69\157\156\x50\145\162\x69\157\x64"); goto Effb4; fd30e: } catch (\Exception $e) { goto E87bd; f8344: return BaseCommand::FAILURE; goto cd626; b7645: $output->writeln(sprintf("\x3c\145\x72\x72\x6f\162\x3e\x25\163\x3c\57\145\x72\x72\x6f\162\x3e", $errorMessage)); goto f8344; E87bd: $errorMessage = $e->getMessage(); goto b7645; cd626: } } private function createDatabaseDump(DatabaseEntity $databaseEntity) : void { try { goto b365a; Cab08: $this->cleanUpBackups($databaseEntity); goto c3575; Bd70d: $siteEntity = $databaseEntity->getSite(); goto adf16; cb2d6: $databaseName = $databaseEntity->getName(); goto f8901; f8901: $backupDirectory = sprintf("\57\x68\157\155\x65\x2f\x25\x73\57\142\141\143\x6b\165\160\x73\x2f\144\141\164\141\142\141\163\x65\x73\57", $siteUser); goto E4c2e; Def49: $this->resetPermissions($databaseEntity); goto Cab08; D7a0c: $databaseExporter->export(); goto Def49; b365a: $dateTime = new \DateTime("\156\157\167", new \DateTimeZone("\x55\x54\103")); goto Bd70d; Cc11e: $outputFile = sprintf("\x25\x73\x2f\45\163", rtrim($outputDirectory, "\x2f"), sprintf("\45\x73\x5f\x25\163\x2e\x73\161\154\56\147\x7a", $databaseName, $dateTime->getTimestamp())); goto F1965; E4c2e: $outputDirectory = sprintf("\x25\x73\57\45\163\57\45\x73\x2f", rtrim($backupDirectory, "\57"), $databaseName, $dateTime->format("\131\x2d\x6d\x2d\x64")); goto Cc11e; c2239: $databaseExporter->createOutputDirectory(); goto D7a0c; adf16: $siteUser = $siteEntity->getUser(); goto cb2d6; F1965: $databaseExporter = new DatabaseExporter($databaseEntity); goto f297c; f297c: $databaseExporter->setFile($outputFile); goto c2239; c3575: } catch (\Exception $e) { $logger = $this->getLogger(); $logger->exception($e); } } private function resetPermissions(DatabaseEntity $databaseEntity) { goto C2bb6; a0172: $backupDirectoryChownCommand->setRecursive(true); goto d1fa3; a7b66: $backupDirectory = sprintf("\57\x68\x6f\x6d\145\x2f\45\x73\57\x62\141\x63\x6b\165\x70\163\x2f\144\x61\x74\141\142\141\163\x65\163\57", $siteUser); goto Bb760; C2bb6: $siteEntity = $databaseEntity->getSite(); goto e8fb9; A45f9: $backupDirectoryChmodCommand->setFile($backupDirectory); goto ffefc; e8fb9: $siteUser = $siteEntity->getUser(); goto a7b66; ffefc: $backupDirectoryChmodCommand->setDirectoryChmod(750); goto Ba506; Bb760: $backupDirectoryChownCommand = new ChownCommand(); goto a5575; B51de: $this->commandExecutor->execute($backupDirectoryChownCommand); goto bc7a6; Ba506: $backupDirectoryChmodCommand->setFileChmod(760); goto B51de; Cd63f: $backupDirectoryChmodCommand = new FindChmodCommand(); goto A45f9; a5575: $backupDirectoryChownCommand->setFile($backupDirectory); goto a0172; c1da0: $backupDirectoryChownCommand->setGroup($siteUser); goto Cd63f; d1fa3: $backupDirectoryChownCommand->setUser($siteUser); goto c1da0; bc7a6: $this->commandExecutor->execute($backupDirectoryChmodCommand); goto B6848; B6848: } private function cleanUpBackups(DatabaseEntity $databaseEntity) { goto Bc1ac; b990e: $deleteOldBackupsCommand->setRetentionPeriod($this->retentionPeriod); goto D6c43; c4272: $deleteOldBackupsCommand = new DeleteOldFilesRecursiveCommand(); goto d9bda; A56e6: $databaseBackupDirectory = sprintf("\57\x68\157\x6d\x65\x2f\x25\x73\57\142\141\143\153\x75\160\163\57\144\141\x74\x61\142\x61\x73\x65\163\x2f", $siteUser); goto c4272; d9bda: $deleteOldBackupsCommand->setDirectory($databaseBackupDirectory); goto b990e; D6c43: $this->commandExecutor->execute($deleteOldBackupsCommand, 360); goto B88c4; a60c9: $siteUser = $siteEntity->getUser(); goto A56e6; Bc1ac: $siteEntity = $databaseEntity->getSite(); goto a60c9; B88c4: } }
