<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use Symfony\Component\Console\Question\ConfirmationQuestion; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Database\Manager as DatabaseManager; class DatabaseDeleteCommand extends BaseCommand { private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private ValidatorInterface $validator; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto a4b50; Ea517: $this->validator = $validator; goto e8670; d10fa: $this->databaseServerEntityManager = $databaseServerEntityManager; goto Ea517; a4b50: $this->siteEntityManager = $siteEntityManager; goto F8ce7; F8ce7: $this->databaseEntityManager = $databaseEntityManager; goto f1799; f1799: $this->databaseUserEntityManager = $databaseUserEntityManager; goto d10fa; e8670: parent::__construct(); goto B135a; B135a: } protected function configure() : void { goto D1492; B7386: $this->addOption("\x64\x61\164\141\x62\141\x73\x65\116\x61\155\145", null, InputOption::VALUE_REQUIRED); goto B119e; D1492: $this->setName("\144\142\72\x64\x65\154\x65\164\x65"); goto E4f6a; E4f6a: $this->setDescription("\x63\154\160\143\164\154\40\x64\x62\x3a\x64\x65\154\x65\x74\x65\x20\55\55\x64\141\164\141\x62\141\x73\145\116\x61\x6d\x65\75\155\171\x2d\x64\141\164\x61\142\x61\163\145"); goto B7386; B119e: $this->addOption("\x66\157\x72\143\145", "\x66", InputOption::VALUE_NONE); goto b7c45; b7c45: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto f16a0; d15c9: $databaseName = trim($input->getOption("\x64\x61\164\x61\x62\x61\x73\145\x4e\141\x6d\145")); goto Ebb3f; B2850: if (!(true === is_null($databaseEntity))) { goto c2dc0; } goto cf71c; Ebb3f: $force = $input->getOption("\146\157\162\x63\x65") === true; goto b3685; b3685: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto B2850; e99c4: C55ee: goto Cb7eb; A4b34: if (!(false === $force)) { goto C55ee; } goto d0153; eb495: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto fa811; Cb7eb: $siteEntity = $databaseEntity->getSite(); goto eb495; ffedc: c2dc0: goto A4b34; f16a0: $this->validateInput($input); goto d15c9; fb3f7: $databaseManager->deleteDatabase($databaseEntity, true); goto a750b; C4526: return BaseCommand::SUCCESS; goto d1e91; a750b: $siteEntity->removeDatabase($databaseEntity); goto e56f7; cf71c: throw new \Exception(sprintf("\x44\x61\x74\x61\x62\141\163\x65\40\42\45\163\42\40\144\x6f\x65\163\40\156\157\164\40\145\x78\x69\163\x74\56", $databaseName)); goto ffedc; Ab7ec: return BaseCommand::SUCCESS; goto C5dee; Feb6e: if (!(false === $answer)) { goto C20c3; } goto C4526; fa811: $databaseManager = new DatabaseManager($databaseServerEntity); goto fb3f7; C0eac: $output->writeln(sprintf("\74\x69\156\x66\x6f\76\104\x61\164\141\x62\x61\x73\x65\74\x2f\151\x6e\x66\x6f\x3e\40\x3c\x63\157\x6d\155\145\156\164\76\45\x73\74\x2f\x63\157\x6d\x6d\145\156\164\76\40\x3c\151\156\146\x6f\x3e\x68\x61\163\x20\142\x65\145\156\40\x64\x65\154\x65\x74\x65\144\x2e\74\x2f\x69\156\x66\x6f\x3e", $databaseName)); goto Ab7ec; da853: $question = new ConfirmationQuestion(sprintf("\x3c\x69\x6e\x66\x6f\x3e\x43\x6f\156\x66\x69\162\155\40\x74\x6f\x20\x64\145\154\145\164\x65\40\164\150\145\40\x64\141\x74\141\142\x61\x73\x65\x3a\40\45\x73\74\57\151\x6e\x66\x6f\76\x20\74\x63\x6f\x6d\x6d\x65\156\164\x3e\50\171\x65\163\x2f\x6e\x6f\x29\x3a\x3c\57\x63\157\155\155\145\x6e\164\x3e\40", $databaseName), false, "\57\x5e\x28\171\145\163\x29\57\x69"); goto F3e51; d1e91: C20c3: goto e99c4; F3e51: $answer = $helper->ask($input, $output, $question); goto Feb6e; d0153: $helper = $this->getHelper("\161\165\x65\x73\x74\x69\157\156"); goto da853; e56f7: $this->siteEntityManager->updateEntity($siteEntity); goto C0eac; C5dee: } catch (\Exception $e) { goto Ebd93; Dfecd: $output->writeln(sprintf("\x3c\145\162\x72\x6f\162\76\45\x73\x3c\57\x65\162\x72\157\162\x3e", $errorMessage)); goto c2728; c2728: return BaseCommand::FAILURE; goto fe32f; Ebd93: $errorMessage = $e->getMessage(); goto Dfecd; fe32f: } } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\156\x61\155\x65", "\144\x61\x74\x61\142\x61\x73\x65\116\x61\x6d\x65", $constraints); $this->changePropertyPath("\165\163\145\x72\116\141\155\145", "\144\x61\164\x61\x62\x61\163\x65\125\163\x65\162\116\141\x6d\x65", $constraints); } }
