<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Database\Importer as DatabaseImporter; use App\System\Command\CheckIfFileExistsCommand; use App\System\CommandExecutor; class DatabaseImportCommand extends BaseCommand { const SYSTEM_USER_ROOT = "\162\x6f\x6f\x74"; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private SshUserEntityManager $sshUserEntityManager; private CommandExecutor $commandExecutor; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, SshUserEntityManager $sshUserEntityManager) { goto D82b3; e2ef9: $this->databaseServerEntityManager = $databaseServerEntityManager; goto C4e19; D82b3: $this->siteEntityManager = $siteEntityManager; goto a5f29; C4e19: $this->sshUserEntityManager = $sshUserEntityManager; goto Abed5; a5f29: $this->databaseEntityManager = $databaseEntityManager; goto e2ef9; Abed5: $this->commandExecutor = new CommandExecutor(); goto da160; da160: parent::__construct(); goto d2527; d2527: } protected function configure() : void { goto b9de4; dc334: $this->addOption("\x66\x69\154\145", null, InputOption::VALUE_REQUIRED); goto e958f; F6572: $this->setDescription("\143\154\x70\143\x74\154\x20\x64\142\x3a\x69\x6d\x70\157\162\164\x20\55\x2d\144\141\164\x61\142\141\x73\x65\116\x61\x6d\x65\x3d\155\x79\x2d\144\141\164\141\x62\x61\x73\145\40\55\55\x66\151\x6c\145\x3d\x64\165\155\x70\x2e\163\161\154\x2e\147\x7a"); goto A0750; A0750: $this->addOption("\144\141\164\141\x62\x61\x73\x65\x4e\141\x6d\x65", null, InputOption::VALUE_REQUIRED); goto dc334; b9de4: $this->setName("\x64\142\x3a\151\x6d\x70\157\x72\164"); goto F6572; e958f: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto bf738; c9ba4: $userBelongsToSite = false === is_null($siteEntity) && $siteUser === $databaseEntity->getSite()->getUser(); goto cc39a; d666c: $siteUser = $siteEntity->getUser(); goto e7e6c; C6f29: goto A4692; goto f878b; C6cd5: throw new \Exception(sprintf("\104\x61\164\x61\142\141\163\x65\40\x22\45\163\42\40\144\157\145\x73\40\156\157\x74\x20\145\170\x69\x73\164\x2e", $databaseName)); goto f2c0b; D029a: $systemUserName = $_SERVER["\123\125\x44\x4f\x5f\125\x53\105\122"] ?? ''; goto Bd29f; b0ff5: $databaseName = $input->getOption("\x64\x61\x74\141\142\x61\163\x65\x4e\141\x6d\145"); goto E6e19; b6d63: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($systemUserName); goto cf43d; A2b5d: $siteEntity = $sshUserEntity->getSite(); goto f0bdb; cf43d: if (!(false === is_null($sshUserEntity))) { goto Aba21; } goto A2b5d; f878b: dc724: goto d666c; d819f: return BaseCommand::SUCCESS; goto eb1ca; Bc6e6: Aba21: goto C6f29; f0bdb: $siteUser = $siteEntity->getUser(); goto Bc6e6; c5c9b: Eba10: goto Eb33a; F3842: $userIsAllowedToImport = true === $isSuperUser || true === $userBelongsToSite; goto a2eef; D4f0e: $databaseImporter = new DatabaseImporter($databaseEntity); goto Ca199; acbc8: $systemUserName = self::SYSTEM_USER_ROOT; goto D557e; C1d3c: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto de445; F1a72: if (false === is_null($siteEntity)) { goto dc724; } goto b6d63; a2eef: if (!(true === $userIsAllowedToImport && false === is_null($siteUser))) { goto c2c03; } goto D4f0e; E6e19: $importFile = $input->getOption("\x66\151\x6c\145"); goto D029a; A7240: $siteUser = null; goto F1a72; eb1ca: c2c03: goto C0df8; Ca199: $databaseImporter->import($importFile); goto a6fc7; cc605: C4e2b: goto Ba76b; De9c3: if (!(false === str_contains($importFile, "\x2f"))) { goto C4e2b; } goto Abde6; eef97: $isSuperUser = true; goto a199c; bf738: $this->validateInput($input); goto b0ff5; D557e: a37af: goto De9c3; Bd29f: if (!("\x64\x65\x76" == $_ENV["\x41\x50\x50\137\x45\116\x56"])) { goto a37af; } goto acbc8; e7e6c: A4692: goto c9ba4; F4e8d: A6499: goto F3842; a6fc7: $output->writeln(sprintf("\74\151\x6e\146\157\76\x49\x6d\160\157\x72\x74\40\x69\x6e\164\157\40\144\x61\x74\141\142\x61\163\x65\74\x2f\151\x6e\146\157\x3e\40\74\143\157\x6d\155\x65\156\x74\76\x25\x73\74\x2f\x63\x6f\x6d\x6d\145\x6e\x74\x3e\x20\74\x69\156\146\x6f\76\x77\x61\x73\40\x73\x75\x63\143\x65\163\x73\146\165\x6c\x2e\74\57\x69\156\146\157\x3e", $databaseName)); goto d819f; A75a4: if (!(self::SYSTEM_USER_ROOT == $systemUserName)) { goto A6499; } goto eef97; Ba76b: $this->checkIfFileExists($importFile); goto C1d3c; C0df8: d7064: goto abd9d; de445: if (false === is_null($databaseEntity)) { goto Eba10; } goto C6cd5; Abde6: $importFile = sprintf("\x25\x73\57\45\163", rtrim(getcwd(), "\x2f"), $importFile); goto cc605; Eb33a: $siteEntity = $this->siteEntityManager->findOneByUser($systemUserName); goto A7240; f2c0b: goto d7064; goto c5c9b; cc39a: $isSuperUser = false; goto A75a4; abd9d: return BaseCommand::FAILURE; goto C63e5; a199c: $siteUser = self::SYSTEM_USER_ROOT; goto F4e8d; C63e5: } catch (\Exception $e) { goto C78dc; a8d48: $output->writeln(sprintf("\x3c\145\162\x72\x6f\x72\76\x25\x73\74\57\145\162\x72\157\162\76", $errorMessage)); goto e4744; C78dc: $errorMessage = $this->maskString($e->getMessage()); goto a8d48; e4744: return BaseCommand::FAILURE; goto A5a87; A5a87: } } private function checkIfFileExists(string $importFile) { try { goto fe4f1; a7c53: $checkIfFileExistsCommand->setFile($importFile); goto e8773; fe4f1: $checkIfFileExistsCommand = new CheckIfFileExistsCommand(); goto a7c53; e8773: $this->commandExecutor->execute($checkIfFileExistsCommand); goto b45ef; b45ef: } catch (\Exception $e) { throw new \Exception(sprintf("\106\x69\154\x65\40\42\45\163\42\x20\x64\157\x65\163\x20\156\x6f\164\40\x65\x78\x69\163\x74\56", $importFile)); } } }
