<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\System\CommandExecutor; use App\System\Command\WriteFileCommand; use App\System\Command\DeleteFileCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Site as SiteEntity; use App\Entity\Notification; use App\Notification\NotificationQueue; use App\Backup\Rclone; use App\Backup\Dropbox\Client as DropboxClient; use App\Backup\Rclone\DropboxConfigTemplate; use App\Backup\Rclone\ConfigBuilder as RcloneConfigBuilder; use App\Backup\StorageProvider; use App\Backup\TarCreator; use App\Service\Logger; class RemoteBackupCreateCommand extends BaseCommand { private SiteEntityManager $siteEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private ?\DateTime $serverDateTime = null; private array $excludes = []; private ?string $storageProvider = null; public function __construct(SiteEntityManager $siteEntityManager, Logger $logger, ValidatorInterface $validator) { goto bd853; Bb1c5: $this->validator = $validator; goto Fdd51; efe24: $this->commandExecutor = new CommandExecutor(); goto D052d; D052d: $this->logger = $logger; goto Bb1c5; bd853: $this->siteEntityManager = $siteEntityManager; goto efe24; Fdd51: parent::__construct(); goto a8a65; a8a65: } protected function configure() : void { goto d2e98; Ca810: $this->setDescription("\143\154\160\143\164\154\40\x72\x65\155\157\x74\145\55\142\141\143\153\x75\x70\72\143\x72\145\x61\164\145"); goto E9d4b; d2e98: $this->setName("\162\x65\155\157\x74\x65\x2d\x62\141\x63\153\x75\160\72\x63\162\145\x61\164\x65"); goto Ca810; E9d4b: $this->addOption("\144\x65\x6c\141\171", null, InputOption::VALUE_OPTIONAL, false); goto bd832; bd832: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto C9923; Ec480: $siteEntities = $this->siteEntityManager->findAll(); goto c3b5b; Fae20: d017b: goto c4ad8; ad44a: $this->backupDatabases(clone $input, clone $output); goto B4985; Ffa3d: $isEnabled = (bool) $this->getConfigValue("\162\145\155\157\x74\x65\x5f\142\x61\143\153\165\x70\137\x65\x6e\141\x62\154\145\144"); goto A93d1; C9923: $this->validateInput($input); goto Ffa3d; C40a8: a8d80: goto cb12a; ed29a: $delay = (bool) $input->getOption("\x64\x65\154\x61\x79"); goto f0fe8; B0148: $this->cleanBackups(); goto Fae20; fe702: Ffd24: goto B0148; B4985: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto a8d80; } goto ed29a; c4ad8: return BaseCommand::SUCCESS; goto e5ed2; e5278: if (!(true === $isEnabled && false === empty($this->storageProvider))) { goto d017b; } goto Ec480; Bd5ba: c8501: goto fe702; A93d1: $this->storageProvider = $this->getConfigValue("\162\x65\x6d\157\x74\x65\x5f\x62\141\x63\153\165\x70\x5f\x73\x74\157\x72\x61\x67\x65\137\160\162\x6f\x76\x69\x64\x65\162"); goto e5278; cb12a: foreach ($siteEntities as $siteEntity) { $this->backupSite($siteEntity); De222: } goto Bd5ba; c3b5b: if (!count($siteEntities)) { goto Ffd24; } goto ad44a; f0fe8: $this->refreshDropboxAccessToken($delay); goto C40a8; e5ed2: } catch (\Exception $e) { goto B0c4d; d6444: $output->writeln(sprintf("\x3c\x65\x72\162\157\162\x3e\x25\163\x3c\x2f\x65\162\x72\x6f\x72\76", $errorMessage)); goto a4b64; a4b64: return BaseCommand::FAILURE; goto f10f6; B0c4d: $errorMessage = $e->getMessage(); goto d6444; f10f6: } } private function backupDatabases(InputInterface $input, OutputInterface $output) : void { try { goto A6f81; e82c9: $command = $application->find("\x64\x62\x3a\x62\141\x63\x6b\165\160"); goto ebc81; ebc81: $exitCode = $command->run($input, $output); goto Af1c0; A6f81: $application = $this->getApplication(); goto e82c9; Af1c0: } catch (\Exception $e) { $this->logger->exception($e); } } private function backupSite(SiteEntity $siteEntity) { goto fb967; fb967: $isSiteExcluded = $this->isSiteExcluded($siteEntity); goto aa43f; aa43f: if (!(false === $isSiteExcluded)) { goto Da418; } goto Cb2a5; Cb2a5: try { try { goto e7c49; e7c49: $excludes = ["\x2e\163\163\150", "\x74\x6d\x70", "\x6c\x6f\147\163"]; goto D0cca; ddea8: $tarCreator = new TarCreator(); goto E4641; Bc247: $vhostFile = sprintf("\57\145\x74\x63\x2f\156\x67\x69\156\170\57\x73\151\x74\145\x73\x2d\145\156\141\x62\x6c\145\144\57\45\x73\x2e\143\157\156\x66", $domainName); goto db9bd; ab26a: switch ($this->storageProvider) { case StorageProvider::GOOGLE_DRIVE: goto ea7de; ff1bf: goto C3732; goto def06; D5b5a: $rclone->addFlag("\55\x2d\144\x72\151\166\x65\x2d\151\155\x70\145\162\x73\x6f\x6e\141\x74\145", $email); goto ff1bf; ea7de: $email = $this->getConfigValue("\x72\x65\x6d\x6f\164\145\137\142\x61\143\153\x75\x70\137\145\x6d\x61\151\x6c"); goto D5b5a; def06: } goto F1189; F1189: bb816: goto ff070; ff070: C3732: goto E9928; f7dd7: $siteUser = $siteEntity->getUser(); goto d3833; d8c3d: $sources = [$homeDirectory, $vhostFile]; goto ddea8; d9255: $destination = $this->getDestination($siteEntity); goto Ddee8; e128c: B5f12: goto f7dd7; E4641: $tarCreator->create($sources, $destinationFile, $excludes); goto d9255; Ddee8: $rclone = new Rclone(); goto ab26a; f071e: $this->createSiteSettingsFile($siteSettingsFile, $siteEntity); goto Ad2f2; c49e2: if (!(false === empty($siteExcludes))) { goto B5f12; } goto Ab5bf; db5ab: $siteSettingsFile = sprintf("\x2f\x68\x6f\x6d\x65\57\45\163\57\x73\x69\164\145\55\x73\x65\x74\x74\151\156\x67\163\56\152\163\x6f\156", $siteUser); goto c2db8; b67f1: $homeDirectory = sprintf("\x2f\150\157\x6d\145\57\x25\163\x2f", $siteUser); goto Bc247; d3833: $domainName = $siteEntity->getDomainName(); goto b67f1; db9bd: $destinationFile = sprintf("\57\x68\x6f\x6d\x65\x2f\45\163\57\164\x6d\x70\x2f\x62\x61\143\153\x75\160\56\164\x61\162", $siteUser); goto db5ab; E9928: $rclone->copy($destinationFile, $destination); goto e85df; Ad2f2: $this->createSiteVhostFile($siteVhostFile, $siteEntity); goto d8c3d; D0cca: $siteExcludes = $this->getSiteExcludes($siteEntity); goto c49e2; c2db8: $siteVhostFile = sprintf("\x2f\x68\157\x6d\x65\57\x25\163\57\163\151\164\145\x2d\x76\150\157\163\164", $siteUser); goto f071e; Ab5bf: $excludes = array_merge($excludes, $siteExcludes); goto e128c; e85df: } catch (\Exception $e) { throw $e; } finally { $files = [$destinationFile, $siteSettingsFile, $siteVhostFile]; foreach ($files as $file) { goto D3b1d; fe2ea: $this->commandExecutor->execute($deleteFileCommand, 60); goto e99da; e99da: E1364: goto be09d; Ad462: $deleteFileCommand->setFile($file); goto fe2ea; D3b1d: $deleteFileCommand = new DeleteFileCommand(); goto Ad462; be09d: } Ac4ea: } } catch (\Exception $e) { goto e81c9; c1843: $this->addNotification($subject, $errorMessage); goto c7e74; e81c9: $errorMessage = $e->getMessage(); goto A5d59; A5d59: $subject = sprintf("\122\x65\155\157\164\145\40\x42\141\143\x6b\x75\x70\40\146\x61\x69\154\145\x64\x3a\x20\45\163", $domainName); goto c1843; c7e74: } goto fbeaf; fbeaf: Da418: goto Ec3a6; Ec3a6: } private function createSiteSettingsFile(string $siteSettingsFile, SiteEntity $siteEntity) : void { goto E5dbd; E5dbd: $siteType = $siteEntity->getType(); goto Af203; Ab146: $writeFileCommand->setFile($siteSettingsFile); goto Fc7f1; A2eab: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto bc1b2; C36a8: $settings["\156\x6f\144\x65\x6a\x73\x53\x65\164\164\151\156\147\163"] = $nodejsSettings; goto bd4a4; bc1b2: $nodejsSettingsEntity = $siteEntity->getNodejsSettings(); goto a2479; a2479: $nodejsSettings = ["\166\x65\x72\163\151\x6f\156" => $nodejsSettingsEntity->getNodejsVersion(), "\160\x6f\x72\164" => $nodejsSettingsEntity->getPort()]; goto C36a8; bd4a4: goto e0484; goto a480a; a480a: case SiteEntity::TYPE_PHP: goto a337f; D35d3: $settings["\x70\x68\160\x53\x65\x74\164\151\x6e\x67\163"] = $phpSettings; goto E840c; a337f: $phpSettingsEntity = $siteEntity->getPhpSettings(); goto a6034; E840c: goto e0484; goto Ba17d; a6034: $phpSettings = ["\x76\145\162\163\x69\x6f\156" => $phpSettingsEntity->getPhpVersion(), "\155\145\155\157\162\171\114\x69\155\x69\164" => $phpSettingsEntity->getMemoryLimit(), "\155\x61\x78\105\170\145\x63\x75\164\151\157\156\x54\x69\155\145" => $phpSettingsEntity->getMaxExecutionTime(), "\x6d\141\x78\x49\x6e\160\x75\x74\x54\151\x6d\145" => $phpSettingsEntity->getMaxInputTime(), "\x6d\x61\x78\111\x6e\160\x75\164\x56\141\162\x73" => $phpSettingsEntity->getMaxInputVars(), "\160\157\163\164\x4d\141\170\123\x69\172\x65" => $phpSettingsEntity->getPostMaxSize(), "\x75\160\x6c\x6f\141\x64\115\x61\x78\106\151\154\145\x53\151\172\145" => $phpSettingsEntity->getUploadMaxFileSize(), "\x61\x64\x64\x69\164\x69\x6f\156\x61\154\x43\x6f\x6e\146\151\147\165\x72\x61\164\151\157\156" => $phpSettingsEntity->getAdditionalConfiguration()]; goto D35d3; Ba17d: case SiteEntity::TYPE_PYTHON: goto fac4b; Aa5d1: goto e0484; goto A560b; fac4b: $pythonSettingsEntity = $siteEntity->getPythonSettings(); goto A272a; eb35c: $settings["\160\x79\164\x68\157\156\123\145\164\x74\x69\156\x67\163"] = $pythonSettings; goto Aa5d1; A272a: $pythonSettings = ["\x76\145\162\x73\x69\157\x6e" => $pythonSettingsEntity->getPythonVersion(), "\x70\x6f\162\164" => $pythonSettingsEntity->getPort()]; goto eb35c; A560b: case SiteEntity::TYPE_REVERSE_PROXY: goto e9c28; e9c28: $reverseProxySettings = ["\165\x72\154" => $siteEntity->getReverseProxyUrl()]; goto b9c39; c8dc6: goto e0484; goto a842c; b9c39: $settings["\x72\145\166\145\162\x73\x65\120\162\x6f\170\x79\x53\x65\164\x74\x69\156\x67\163"] = $reverseProxySettings; goto c8dc6; a842c: } goto cad6a; Bdc39: $fileContent = json_encode($settings, JSON_PRETTY_PRINT); goto cbccc; cbccc: $writeFileCommand = new WriteFileCommand(); goto Ab146; e8394: e0484: goto Bdc39; cad6a: f0708: goto e8394; Fc7f1: $writeFileCommand->setContent($fileContent); goto d9ef6; d9ef6: $this->commandExecutor->execute($writeFileCommand, 15); goto bfadb; Af203: $settings = ["\x74\x79\160\x65" => $siteType, "\x64\157\155\141\151\x6e\116\x61\155\145" => $siteEntity->getDomainName(), "\162\157\x6f\164\104\x69\162\x65\143\164\157\162\171" => $siteEntity->getRootDirectory(), "\163\151\164\x65\x55\x73\145\162" => $siteEntity->getUser(), "\160\x61\147\145\123\160\145\145\144" => $siteEntity->getPageSpeedSettings()]; goto A2eab; bfadb: } private function createSiteVhostFile(string $siteVhostFile, SiteEntity $siteEntity) : void { goto a98b3; a98b3: $vhost = $siteEntity->getVhostTemplate(); goto c442f; c442f: $writeFileCommand = new WriteFileCommand(); goto d0f58; d0f58: $writeFileCommand->setFile($siteVhostFile); goto A9533; A9533: $writeFileCommand->setContent($vhost); goto af9b6; af9b6: $this->commandExecutor->execute($writeFileCommand, 15); goto Eebfd; Eebfd: } private function isSiteExcluded(SiteEntity $siteEntity) : bool { goto C3b7e; C3b7e: $isSiteExcluded = false; goto Ed01e; Ed01e: $excludes = $this->getExcludes(); goto B6482; Def0a: foreach ($excludes as $exclude) { goto D86ec; a98e1: $isSiteExcluded = true; goto a317a; cc9e5: cf096: goto F7250; D86ec: $exclude = rtrim($exclude, "\57"); goto F72f8; a317a: goto C1891; goto a8a03; F72f8: if (!($homeDirectory == $exclude)) { goto E7396; } goto a98e1; a8a03: E7396: goto cc9e5; F7250: } goto Dc68d; Dc68d: C1891: goto C1301; C1301: Eb844: goto dc92d; dc92d: return $isSiteExcluded; goto E2746; a0eba: $homeDirectory = sprintf("\57\150\157\x6d\145\57\45\x73", $siteUser); goto Def0a; fa29a: $siteUser = $siteEntity->getUser(); goto a0eba; B6482: if (!(false === empty($excludes))) { goto Eb844; } goto fa29a; E2746: } private function getExcludes() : array { goto ba050; b4261: B5d25: goto eda27; eda27: return $this->excludes; goto D4996; Cb2fb: if (!(false === empty($excludes))) { goto ccba4; } goto ae4b4; ba050: if (!(true === empty($this->excludes))) { goto B5d25; } goto d2712; d2712: $excludes = $this->getConfigValue("\162\x65\155\157\x74\x65\137\x62\x61\x63\x6b\165\x70\137\145\x78\x63\x6c\x75\x64\145\x73"); goto Cb2fb; ae4b4: $this->excludes = json_decode($excludes); goto B642d; B642d: ccba4: goto b4261; D4996: } private function getSiteExcludes(SiteEntity $siteEntity) : array { goto Fe407; f1641: foreach ($excludes as $exclude) { goto Dae43; bbec7: $siteExcludes[] = rtrim(ltrim($exclude, "\57"), "\57"); goto Ca052; Ca052: F7e1f: goto E344b; Db0cf: Bd4b6: goto bde42; c97d4: $exclude = substr($exclude, strlen($homeDirectory) - 1); goto B2cd8; E344b: e92ce: goto Db0cf; B2cd8: if (!(false === empty($exclude))) { goto F7e1f; } goto bbec7; Dae43: if (!($homeDirectory == substr($exclude, 0, strlen($homeDirectory)))) { goto e92ce; } goto c97d4; bde42: } goto B3a69; Ba852: C3214: goto D9494; Fe407: $siteExcludes = []; goto Fb762; D9494: return $siteExcludes; goto D071f; C57e2: if (!(false === empty($excludes))) { goto C3214; } goto c9967; Fb762: $excludes = $this->getExcludes(); goto C57e2; c9967: $siteUser = $siteEntity->getUser(); goto dca12; dca12: $homeDirectory = sprintf("\x2f\x68\157\155\145\57\45\163\57", $siteUser); goto f1641; B3a69: b9081: goto Ba852; D071f: } private function getServerDateTime() : \DateTime { goto D8d5f; Ef359: $timezone = $this->getConfigValue("\x74\151\155\145\172\x6f\x6e\x65"); goto e9bf1; C2998: abe67: goto F0a9f; e9bf1: $this->serverDateTime = new \DateTime("\156\157\x77"); goto Fea8d; D8d5f: if (!(true === is_null($this->serverDateTime))) { goto f1586; } goto Ef359; Fea8d: $this->serverDateTime->setTimezone(new \DateTimeZone("\125\124\x43")); goto db6c4; db6c4: if (!(false === empty($timezone))) { goto abe67; } goto Aaaf8; Aaaf8: $this->serverDateTime->setTimezone(new \DateTimeZone($timezone)); goto C2998; Ee2b8: return $this->serverDateTime; goto C75c4; F0a9f: f1586: goto Ee2b8; C75c4: } private function getDestination(SiteEntity $siteEntity) : string { goto d74e1; d74e1: $destination = ''; goto f0bf5; A2d0f: $destination = ltrim($destination, "\x2f"); goto ecf68; ffb00: $storageDirectory = $this->getConfigValue("\x72\x65\x6d\157\x74\x65\x5f\142\141\x63\x6b\165\x70\x5f\163\164\x6f\162\x61\147\145\x5f\x64\x69\x72\x65\x63\x74\157\162\171"); goto a8c95; a8c95: $serverDateTime = $this->getServerDateTime(); goto B548b; F718e: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto B1628; } goto A2d0f; D4fa0: $siteUser = $siteEntity->getUser(); goto ffb00; ecf68: B1628: goto e770e; e770e: return $destination; goto bd157; bcd97: b3026: goto D4fa0; B548b: $destination = sprintf("\45\163\57\45\x73\x2f\x25\x73\x2f\x25\163\x2f\150\157\155\x65\57\45\163\57", $destination, rtrim(ltrim($storageDirectory, "\x2f"), "\57"), $serverDateTime->format("\131\x2d\x6d\x2d\144"), $serverDateTime->format("\x48\56\151"), $siteUser); goto F718e; e045c: df9a0: goto bcd97; f0bf5: switch ($this->storageProvider) { case StorageProvider::AMAZON_S3: case StorageProvider::WASABI: $destination = $this->getConfigValue("\162\x65\x6d\x6f\x74\145\137\142\x61\143\153\165\160\x5f\142\165\x63\153\x65\164"); goto b3026; case StorageProvider::DIGITAL_OCEAN_SPACES: $destination = $this->getConfigValue("\162\145\155\157\164\145\x5f\142\x61\143\x6b\165\160\137\163\x70\x61\x63\x65"); goto b3026; } goto e045c; bd157: } private function cleanBackups() : void { goto eb352; Cfd9c: A6736: goto a3703; a3f16: if (!($retentionPeriod && false === empty($storageDirectory))) { goto A6736; } goto B27c0; F89a0: $storageDirectory = $this->getConfigValue("\162\x65\x6d\157\164\x65\137\142\141\143\153\165\160\137\x73\x74\x6f\162\141\147\x65\137\144\x69\162\x65\143\164\x6f\162\171"); goto a3f16; B27c0: try { goto Ac38b; C5f26: cece2: goto deb38; E3311: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto a8c6d; } goto c5f5b; f5aad: $deleteDateTime->setTime(0, 0, 0, 0); goto b9d32; Aa5a3: $directories = (array) $rclone->lsJson($remotePath, true); goto Ffea8; Ed810: foreach ($directories as $directory) { goto Afb27; d5917: Da3c8: goto cbdd0; Afb27: $directoryName = $directory["\x4e\x61\155\x65"] ?? null; goto Cebd9; D6b19: $purgeRemotePath = sprintf("\45\x73\57\45\x73\57", rtrim(ltrim($remotePath, "\57"), "\57"), $directoryName); goto f838a; bd4c9: if (!(true === isset($directoryDate) && $directoryDate <= $deleteDateTime)) { goto Da3c8; } goto D6b19; e3e47: bcfab: goto c6359; Ab79a: c8090: goto eb65d; F5746: if (!(StorageProvider::SFTP == $this->storageProvider)) { goto c8090; } goto Cda88; eb65d: $rclone->purge($purgeRemotePath); goto d5917; d22f3: D7ce9: goto e3e47; cbdd0: Cc318: goto d22f3; d1905: $purgeRemotePath = ltrim($purgeRemotePath, "\57"); goto c4d66; E36f4: if (!(true === $isValidDate)) { goto Cc318; } goto bd4c9; c4d66: f3d02: goto F5746; Cda88: $purgeRemotePath = sprintf("\x2f\x25\x73", ltrim($purgeRemotePath, "\x2f")); goto Ab79a; f838a: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto f3d02; } goto d1905; Bb42d: try { $isValidDate = true; $directoryDate = new \DateTime($directoryName); } catch (\Exception $e) { $isValidDate = false; } goto E36f4; Cebd9: if (!(false === is_null($directoryName))) { goto D7ce9; } goto Bb42d; c6359: } goto Bb6f2; Da6e8: F2ce6: goto F8210; e4084: $deleteDateTime->setTimezone(new \DateTimeZone("\125\124\x43")); goto f5aad; c5f5b: $remotePath = ltrim($remotePath, "\x2f"); goto Cfbdd; b5abd: switch ($this->storageProvider) { case StorageProvider::AMAZON_S3: case StorageProvider::WASABI: $remotePath = $this->getConfigValue("\162\145\155\157\164\x65\137\142\x61\143\x6b\165\x70\137\142\165\143\x6b\145\164"); goto F61ea; case StorageProvider::DIGITAL_OCEAN_SPACES: $remotePath = $this->getConfigValue("\162\145\155\157\164\145\x5f\x62\141\x63\153\x75\160\137\163\160\141\x63\145"); goto F61ea; case StorageProvider::GOOGLE_DRIVE: goto bf077; bf077: $email = $this->getConfigValue("\x72\x65\x6d\157\164\x65\137\x62\141\143\x6b\x75\x70\x5f\x65\x6d\x61\151\154"); goto b31c2; C86bf: goto F61ea; goto A2183; b31c2: $rclone->addFlag("\x2d\55\x64\162\x69\166\x65\55\x69\x6d\160\145\x72\163\157\x6e\141\164\145", $email); goto C86bf; A2183: } goto Da6e8; e9801: $deleteDateTime->modify(sprintf("\55\x25\163\x20\144\141\x79\163", $retentionPeriod)); goto e4084; Bb6f2: Cf035: goto C5f26; fcf3f: $rclone = new Rclone(); goto b5abd; F8210: F61ea: goto Bbfd9; Dee52: $deleteDateTime = clone $dateTime; goto e9801; Ffea8: if (!(false === empty($directories))) { goto cece2; } goto Ed810; Ac38b: $dateTime = new \DateTime(); goto Dee52; b9d32: $remotePath = ''; goto fcf3f; Cfbdd: a8c6d: goto Aa5a3; Bbfd9: $remotePath = sprintf("\x25\x73\57\45\x73\57", $remotePath, rtrim(ltrim($storageDirectory, "\x2f"), "\x2f")); goto E3311; deb38: } catch (\Exception $e) { goto A8a03; D2540: $subject = sprintf("\x52\x65\155\x6f\164\x65\40\102\141\143\153\x75\x70\x20\x63\x6c\145\141\x6e\x75\x70\40\x66\141\x69\154\x65\x64\x2e"); goto c7c03; A8a03: $errorMessage = $e->getMessage(); goto D2540; c7c03: $this->addNotification($subject, $errorMessage); goto Bcafc; Bcafc: } goto Cfd9c; eb352: $retentionPeriod = (int) $this->getConfigValue("\162\x65\155\157\164\145\137\x62\141\x63\x6b\x75\x70\137\162\145\164\x65\156\x74\x69\157\156\137\160\x65\162\151\x6f\144"); goto F89a0; a3703: } private function refreshDropboxAccessToken(bool $delay) { try { goto C4cfa; E6da7: $rcloneConfig = $rcloneConfigBuilder->build(); goto b160d; Fa7a1: $rcloneConfigTemplate = new DropboxConfigTemplate(); goto F958b; f2edb: $rcloneConfigBuilder = new RcloneConfigBuilder($rcloneConfigTemplate); goto E6da7; Faddd: $rclone->writeConfig($rcloneConfig); goto fc79e; A70d5: throw new \Exception("\101\x63\x63\145\x73\x73\40\x54\x6f\153\145\x6e\x20\x63\x61\156\x6e\157\x74\40\x62\x65\40\x65\155\160\164\x79\56"); goto Bc43b; Bc43b: goto f40ef; goto D49d6; E6660: A8e1c: goto a6a14; dbc90: if (false === empty($token)) { goto b9beb; } goto A70d5; Ad857: sleep(rand(5, 60)); goto E6660; D49d6: b9beb: goto Fa7a1; fbbd5: $token = $dropboxClient->getAccessToken($refreshToken); goto dbc90; fc79e: f40ef: goto e908a; b160d: $rclone = new Rclone(); goto Faddd; F958b: $rcloneConfigTemplate->setToken($token); goto f2edb; c6243: $dropboxClient = new DropboxClient(); goto fbbd5; C4cfa: if (!(true === $delay)) { goto A8e1c; } goto Ad857; a6a14: $refreshToken = $this->getConfigValue("\x72\x65\x6d\157\x74\x65\x5f\x62\x61\x63\153\165\160\137\162\x65\x66\162\x65\x73\150\137\164\x6f\x6b\145\x6e"); goto c6243; e908a: } catch (\Exception $e) { $errorMessage = $e->getMessage(); $this->addNotification("\122\145\146\x72\145\163\x68\x69\x6e\x67\40\x44\x72\157\x70\142\157\x78\40\101\x63\x63\x65\163\x73\40\124\157\153\x65\156\40\106\x61\151\154\x65\144", $errorMessage); } } private function addNotification(string $subject, string $errorMessage) : void { goto A07e5; be164: $notification->setMessage($errorMessage); goto Db191; D61d0: NotificationQueue::addNotification($notification); goto d2df9; Db191: $notification->setSeverity(Notification::SEVERITY_CRITICAL); goto D61d0; b2239: $notification->setSubject($subject); goto be164; A07e5: $notification = new Notification(); goto b2239; d2df9: } }
