<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\NodejsSettings as NodejsSettingsEntity; use App\Site\NodejsSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\NodejsTemplate as NodejsVhostTemplate; use App\Site\Creator\NodejsSite as NodejsSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddNodejsCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x4e\157\144\145\x6a\x73"; protected function configure() : void { goto d1f1e; e3050: $this->addOption("\x73\151\164\x65\x55\163\145\162\x50\x61\x73\163\167\x6f\162\144", null, InputOption::VALUE_REQUIRED); goto A695b; d1f1e: $this->setName("\163\x69\x74\145\72\x61\144\144\x3a\156\x6f\x64\145\x6a\163"); goto Ed6c1; f5f94: $this->addOption("\163\151\164\x65\125\163\x65\162", null, InputOption::VALUE_REQUIRED); goto e3050; F4f1e: $this->setComment("\x41\x64\x64\151\x6e\147\x20\x61\40\116\x6f\144\145\56\152\163\x20\123\x69\x74\x65"); goto f85e1; D5221: $this->addOption("\141\x70\160\x50\157\162\164", null, InputOption::VALUE_REQUIRED); goto f5f94; A7b4f: $this->addOption("\156\x6f\x64\145\152\163\126\145\162\163\x69\x6f\156", null, InputOption::VALUE_REQUIRED); goto D5221; Ed6c1: $this->setDescription("\x63\x6c\x70\143\x74\x6c\x20\163\151\x74\145\72\141\144\144\72\156\x6f\144\145\x6a\163\x20\55\x2d\x64\157\155\141\151\x6e\x4e\141\155\145\75\x77\x77\167\x2e\144\x6f\x6d\x61\x69\x6e\56\143\x6f\155\x20\55\55\156\157\x64\x65\x6a\x73\126\145\x72\163\x69\157\156\75\62\x32\x20\55\x2d\141\x70\160\x50\x6f\162\x74\75\x33\x30\60\x30\40\55\x2d\x73\x69\x74\145\125\x73\145\x72\x3d\152\157\150\x6e\40\55\55\x73\151\164\145\x55\x73\x65\162\x50\141\163\163\167\157\162\x64\75\47\x21\163\145\x63\x72\145\x74\120\141\x73\x73\167\157\162\144\x21\47"); goto F4f1e; f85e1: $this->addOption("\x64\x6f\x6d\141\151\156\116\141\155\x65", null, InputOption::VALUE_REQUIRED); goto A7b4f; A695b: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto Aeb9d; Cd712: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto Fc2e5; Cd3e0: if (!(true === is_null($subdomain) || "\x77\167\x77" == $subdomain)) { goto ab5f8; } goto E80ff; d7fac: $nodejsSiteCreator->createPrivateKeyAndCertificate(); goto B6680; E0e61: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto F6c9c; c948e: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto cf7c8; B59cf: $nodejsSettingsEntity->setPort($appPort); goto D3ff5; E2df2: $rsaKeyGenerator = new RsaKeyGenerator(); goto F189b; F6c9c: $rootDirectory = $domainName; goto Bb2dc; Da7f6: if (!(false === empty($redirectionVhostTemplate))) { goto e32d9; } goto A86a1; D6f64: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto ffcd7; Ed63b: $certificateEntity = $this->certificateEntityManager->createEntity(); goto Bd8ce; C24e9: D2f81: goto b7369; E4c14: goto D2f81; goto e268e; f81b3: $csr = $csrGenerator->generate(); goto C8cbe; A5457: $subjectAlternativeNames = []; goto Bef15; Ec8f2: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto A2c54; F5794: $siteEntity->setType(SiteEntity::TYPE_NODEJS); goto c5307; E80ff: if (true === isset($_ENV["\x41\120\120\137\x48\124\124\120\x33"]) && "\x74\x72\165\x65" === $_ENV["\x41\120\x50\x5f\110\x54\x54\x50\63"]) { goto F961d; } goto E585a; E0d79: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\x2e\x2e\57\x2e\x2e\57\162\x65\163\x6f\165\162\x63\x65\x73\57\x6e\x67\151\x6e\x78\x2f\x76\150\x6f\x73\164\137\x74\x65\155\160\x6c\141\164\x65\x2f\x72\145\144\x69\162\x65\143\x74\55\150\x74\164\x70\63"); goto Ab8c5; B6680: $nodejsSiteCreator->createNginxVhost(); goto d1cdb; f9bcd: $constraints = new ConstraintViolationList(); goto a723c; d20cd: goto E8ce9; goto d46c0; ed74c: $siteEntity->setUserPassword($siteUserPassword); goto Cd3e0; aa079: $siteEntity->setUser($siteUser); goto ed74c; d066f: $siteEntity->setRootDirectory($rootDirectory); goto aa079; ec8eb: $nodejsSite->setCertificate($certificateEntity); goto eaa4d; De645: $siteEntity->setVhostTemplate($vhostTemplate); goto fd5f0; D4460: ab5f8: goto De645; D3719: $nodejsSite = new NodejsSite(); goto f58c5; db330: F54b1: goto B08e9; f6f68: $certificateEntity->setDefaultCertificate(true); goto Cd712; Aeb9d: $this->validateInput($input); goto d960e; af0d8: $subjectAlternativeNames[] = $registrableDomain; goto bba97; F189b: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto A5457; Ae07a: $nodejsSite->setRootDirectory($siteEntity->getRootDirectory()); goto b9a34; E585a: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\x2e\56\x2f\56\x2e\x2f\x72\145\163\x6f\x75\162\143\145\x73\57\156\147\151\156\x78\x2f\x76\150\x6f\163\x74\137\164\145\155\160\154\x61\164\145\57\x72\145\x64\151\162\x65\143\x74"); goto d20cd; D4b61: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto Ab695; C1fae: e32d9: goto D4460; b58a9: return $this->renderConstraints($constraints, $output); goto F3278; d960e: $domainName = mb_strtolower(trim($input->getOption("\144\x6f\x6d\141\151\156\116\141\155\145"))); goto E0e61; D65b5: $nodejsSite->setUserPassword($siteEntity->getUserPassword()); goto C4c55; E0d83: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto D6f64; Fd85b: $siteEntity->setCertificate($certificateEntity); goto D3719; C9c5c: $subdomain = false === empty($subdomain) ? $subdomain : null; goto Dfd2a; B7da1: Fa0c9: goto C24e9; eceba: $siteConstraints = $this->validator->validate($siteEntity); goto ee198; Dfd2a: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto D0ddf; F70bc: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto Fc1ad; D8357: $nodejsSiteCreator = new NodejsSiteCreator($nodejsSite); goto b36ca; b36ca: $nodejsSiteCreator->createUser(); goto E9372; F51e5: $nodejsSite->setRegistrableDomain($registrableDomain); goto Db4c7; E9372: $nodejsSiteCreator->createRootDirectory(); goto ed9c1; E8aa5: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto a1e31; d46c0: F961d: goto E0d79; ffcd7: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto D66f4; ed9c1: $nodejsSiteCreator->createLogrotateFile(); goto acc8a; c5307: $siteEntity->setDomainName($domainName); goto d066f; C4c55: $nodejsSite->setDomainName($domainName); goto F51e5; Ab8c5: E8ce9: goto Af3c8; Fc2e5: $certificateEntity->setCsr($csr); goto Ec8f2; b9a34: $nodejsSite->setNodejsSettings($nodejsSettingsEntity); goto ec8eb; Cd979: return SiteCommand::SUCCESS; goto B7da1; bd10f: a3bd8: goto Ed63b; F3caa: $appPort = (int) $input->getOption("\x61\160\x70\x50\x6f\x72\164"); goto f17a4; Ab695: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto f81b3; Bb2dc: $nodejsVersion = (int) $input->getOption("\156\x6f\x64\x65\152\x73\x56\145\x72\163\151\x6f\x6e"); goto F3caa; d1cdb: $nodejsSiteCreator->reloadNginxService(); goto E7ffd; a1e31: $vhostTemplate->resetProcessors(); goto E0d83; d51df: $vhostTemplate = new NodejsVhostTemplate($nodejsSite); goto E8aa5; bba97: eeda4: goto D4b61; Bd8ce: $certificateEntity->setSite($siteEntity); goto E2df2; F3278: goto Fa0c9; goto bd10f; A3691: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto A178a; Db4c7: $nodejsSite->setSubdomain($subdomain); goto Ae07a; E0ab1: $constraints->addAll($nodejsSettingsConstraints); goto b58a9; A178a: $siteEntity = $this->siteEntityManager->createEntity(); goto F5794; E7ffd: $nodejsSiteCreator->resetPermissions(); goto d51df; C8cbe: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto f6f68; C13d6: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto c948e; A2c54: $certificateEntity->setCertificate($selfSignedCertificate); goto Fd85b; eaa4d: $nodejsSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto D8357; f17a4: $siteUser = trim($input->getOption("\163\151\164\x65\x55\163\145\x72")); goto B15da; Bef15: if (!(true === is_null($subdomain))) { goto F54b1; } goto Be8bb; bbb4d: $output->writeln(sprintf("\x3c\151\x6e\146\157\76\x53\151\x74\145\74\57\151\x6e\x66\157\x3e\40\x3c\143\157\155\155\x65\x6e\x74\76\x25\163\x3c\57\x63\x6f\x6d\x6d\x65\x6e\164\76\40\74\151\x6e\146\x6f\76\150\x61\x73\40\142\x65\145\156\x20\141\144\x64\145\x64\x2e\x3c\x2f\151\x6e\146\x6f\76", $domainName)); goto Cd979; e268e: B06bd: goto A3691; acc8a: $nodejsSiteCreator->createNvmDirectory(); goto Dfe0b; D66f4: $vhostTemplate->build(); goto F70bc; cf7c8: $subdomain = $resolvedDomainName->subDomain()->toString(); goto C9c5c; ee198: $nodejsSettingsConstraints = $this->validator->validate($nodejsSettingsEntity); goto A9efa; Ffa24: $nodejsSettingsEntity->setNodejsVersion($nodejsVersion); goto B59cf; Dfe0b: $nodejsSiteCreator->installNodejs(); goto d7fac; f58c5: $nodejsSite->setUser($siteEntity->getUser()); goto D65b5; fd5f0: $nodejsSettingsEntity = new NodejsSettingsEntity(); goto b5d2b; Be8bb: $subjectAlternativeNames[] = sprintf("\x77\x77\167\x2e\45\x73", $domainName); goto db330; a723c: $constraints->addAll($siteConstraints); goto E0ab1; A9efa: if (0 == count($siteConstraints) && 0 == count($nodejsSettingsConstraints)) { goto a3bd8; } goto f9bcd; Fc1ad: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto a004f; A86a1: $vhostTemplate = sprintf("\45\163\45\163", $redirectionVhostTemplate, $vhostTemplate); goto C1fae; B08e9: if (!(false === is_null($subdomain) && "\167\x77\x77" == $subdomain)) { goto eeda4; } goto af0d8; D0ddf: if (false === is_null($vhostTemplateEntity)) { goto B06bd; } goto e310a; b5d2b: $siteEntity->setNodejsSettings($nodejsSettingsEntity); goto Ffa24; e310a: throw new \Exception(sprintf("\126\x68\157\x73\x74\40\x54\x65\x6d\160\x6c\141\164\x65\x20\x22\x25\x73\42\x20\144\157\x65\x73\40\156\157\x74\40\145\x78\151\x73\164\56", $vhostTemplate)); goto E4c14; a004f: $this->siteEntityManager->updateEntity($siteEntity); goto bbb4d; D3ff5: $nodejsSettingsEntity->setSite($siteEntity); goto eceba; Af3c8: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto Da7f6; B15da: $siteUserPassword = trim($input->getOption("\163\151\x74\145\125\x73\x65\x72\x50\x61\x73\163\167\x6f\x72\x64")); goto C13d6; b7369: } catch (\Exception $e) { goto c29bc; aadcc: return SiteCommand::FAILURE; goto Fed46; c29bc: $errorMessage = $e->getMessage(); goto accc3; accc3: $output->writeln(sprintf("\x3c\145\x72\162\x6f\x72\x3e\45\163\74\x2f\x65\162\162\x6f\x72\76", $errorMessage)); goto aadcc; Fed46: } } }
