<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\PythonSettings as PythonSettingsEntity; use App\Site\PythonSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\PythonTemplate as PythonVhostTemplate; use App\Site\Creator\PythonSite as PythonSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddPythonCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\120\171\x74\x68\157\x6e"; protected function configure() : void { goto a6ddc; F3bc2: $this->addOption("\141\160\160\120\157\x72\164", null, InputOption::VALUE_REQUIRED); goto F49cc; b2a76: $this->addOption("\x70\171\x74\x68\157\156\x56\x65\x72\x73\x69\x6f\156", null, InputOption::VALUE_REQUIRED); goto F3bc2; f4c53: $this->addOption("\163\x69\x74\x65\x55\163\x65\162\120\x61\x73\x73\x77\157\162\144", null, InputOption::VALUE_REQUIRED); goto e612a; a6ddc: $this->setName("\163\151\164\145\x3a\141\x64\x64\72\x70\x79\x74\x68\157\x6e"); goto ea496; ea496: $this->setDescription("\143\x6c\x70\143\x74\154\x20\x73\x69\164\x65\x3a\141\144\x64\72\x70\171\164\x68\x6f\156\x20\55\x2d\144\x6f\x6d\141\x69\x6e\x4e\141\155\x65\x3d\167\x77\x77\56\x64\x6f\155\141\x69\156\56\143\x6f\155\40\55\55\x70\171\x74\x68\x6f\156\126\x65\162\x73\x69\x6f\156\x3d\x33\x2e\x31\62\40\x2d\55\141\x70\x70\x50\x6f\x72\x74\x3d\70\60\x38\x30\40\x2d\55\x73\x69\164\145\x55\x73\145\162\x3d\x6a\x6f\x68\156\40\x2d\x2d\x73\151\164\145\x55\163\145\162\x50\141\163\163\167\157\162\144\x3d\x27\41\163\145\x63\x72\145\164\120\141\163\163\167\157\x72\144\x21\x27"); goto B8f3a; F49cc: $this->addOption("\163\x69\x74\145\x55\163\x65\162", null, InputOption::VALUE_REQUIRED); goto f4c53; B8f3a: $this->setComment("\101\144\x64\x69\156\x67\x20\x61\40\x50\171\164\150\157\x6e\40\123\151\164\x65"); goto Ce1a1; Ce1a1: $this->addOption("\144\x6f\155\141\x69\156\x4e\x61\155\145", null, InputOption::VALUE_REQUIRED); goto b2a76; e612a: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto fd8ba; b0162: $pythonSiteCreator->createUser(); goto f4430; E8494: $this->siteEntityManager->updateEntity($siteEntity); goto A18e1; f446d: $pythonSite->setUser($siteEntity->getUser()); goto d9874; Dbc71: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto e5df4; Aedfb: $csr = $csrGenerator->generate(); goto cf8d0; edd7d: $rsaKeyGenerator = new RsaKeyGenerator(); goto Dbc71; F98f2: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto d6c5c; fa631: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\56\56\57\56\56\x2f\x72\145\x73\x6f\x75\x72\x63\x65\x73\x2f\x6e\x67\151\x6e\170\57\166\x68\157\x73\164\x5f\164\145\155\160\x6c\x61\x74\145\57\x72\145\144\151\x72\145\143\164\55\150\x74\x74\x70\x33"); goto C465b; Fde12: $pythonSiteCreator->resetPermissions(); goto Fb2e9; df77d: $pythonSiteCreator->reloadNginxService(); goto Fde12; Fad8b: $siteEntity->setDomainName($domainName); goto b4a3a; Bdef2: $pythonSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto b2fdc; c3023: $pythonSite = new PythonSite(); goto f446d; E63c9: $pythonSettingsEntity = new PythonSettingsEntity(); goto ce7dd; cf8d0: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto Ed238; E7b5d: $pythonSite->setRootDirectory($siteEntity->getRootDirectory()); goto F0f9d; fb502: goto Bcd12; goto C20f7; cdd83: Da4ab: goto F04ec; F2b63: throw new \Exception(sprintf("\x56\x68\x6f\x73\164\40\x54\145\x6d\160\x6c\x61\164\145\40\42\45\163\x22\40\144\157\145\163\x20\156\x6f\164\x20\145\x78\151\x73\164\x2e", $vhostTemplate)); goto Fb685; F1172: $pythonSettingsEntity->setPort($appPort); goto b051b; Aa9f9: $pythonSite->setRegistrableDomain($registrableDomain); goto E724d; Cb01f: f2534: goto ee29e; C465b: Fe62c: goto f6f8f; B2b6a: $subjectAlternativeNames[] = $registrableDomain; goto B2716; Ad3e1: if (true === isset($_ENV["\101\x50\120\137\x48\124\124\x50\x33"]) && "\164\162\x75\x65" === $_ENV["\x41\x50\120\x5f\110\x54\124\120\63"]) { goto b69a8; } goto aaa9b; e5433: $siteEntity->setUserPassword($siteUserPassword); goto A671a; f6b90: return SiteCommand::SUCCESS; goto A050c; C58bc: $vhostTemplate = sprintf("\45\163\45\x73", $redirectionVhostTemplate, $vhostTemplate); goto Cb01f; D0cc0: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto Ffc7a; E9bde: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto Bfec6; D3956: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto C2bce; Cdc53: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto C628e; f8c91: if (!(false === is_null($subdomain) && "\167\167\167" == $subdomain)) { goto d2092; } goto B2b6a; d9874: $pythonSite->setUserPassword($siteEntity->getUserPassword()); goto eb704; B0ea8: $constraints->addAll($pythonSettingsConstraints); goto b0bdd; C0533: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto Aedfb; C2bce: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto E8494; Bfec6: $certificateEntity->setCsr($csr); goto d8b7d; C20f7: a0e15: goto A055d; f4430: $pythonSiteCreator->createRootDirectory(); goto Ee864; e5df4: $subjectAlternativeNames = []; goto e6a7b; F8677: $pythonSiteCreator->createPrivateKeyAndCertificate(); goto B931e; F0f9d: $pythonSite->setPythonSettings($pythonSettingsEntity); goto E6e6b; A055d: $certificateEntity = $this->certificateEntityManager->createEntity(); goto Aa50c; a8719: $domainName = mb_strtolower(trim($input->getOption("\144\x6f\155\x61\151\x6e\x4e\141\155\145"))); goto Cdc53; a8f73: $certificateEntity->setCertificate($selfSignedCertificate); goto bf7fa; B931e: $pythonSiteCreator->createNginxVhost(); goto df77d; a85d2: $constraints->addAll($siteConstraints); goto B0ea8; aaa9b: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\56\x2e\x2f\56\56\x2f\162\x65\163\x6f\165\x72\x63\145\x73\57\156\147\151\x6e\x78\57\166\x68\x6f\163\164\x5f\164\x65\x6d\x70\154\141\164\x65\x2f\x72\x65\144\151\162\x65\143\164"); goto f9115; b8dba: $siteUserPassword = trim($input->getOption("\x73\x69\x74\x65\x55\163\145\x72\120\141\163\x73\x77\157\162\144")); goto e3b3c; C5f01: $siteUser = trim($input->getOption("\x73\x69\164\145\125\x73\145\162")); goto b8dba; cdb6f: $pythonSiteCreator->writePythonVersionFile(); goto F8677; b4a3a: $siteEntity->setRootDirectory($rootDirectory); goto bfc25; Ed238: $certificateEntity->setDefaultCertificate(true); goto E9bde; bfc25: $siteEntity->setUser($siteUser); goto e5433; A18e1: $output->writeln(sprintf("\x3c\151\156\146\x6f\76\123\151\164\145\74\x2f\151\156\x66\157\76\x20\74\143\157\x6d\155\145\x6e\164\76\x25\163\x3c\x2f\x63\x6f\155\155\145\x6e\164\76\x20\x3c\151\x6e\x66\157\76\150\141\x73\x20\142\145\145\x6e\40\x61\144\144\x65\144\x2e\x3c\x2f\x69\156\146\157\x3e", $domainName)); goto f6b90; C628e: $rootDirectory = $domainName; goto C306b; A671a: if (!(true === is_null($subdomain) || "\x77\x77\167" == $subdomain)) { goto f05a2; } goto Ad3e1; Aa50c: $certificateEntity->setSite($siteEntity); goto edd7d; aed90: $pythonSettingsEntity->setPythonVersion($pythonVersion); goto F1172; c015d: $vhostTemplate->resetProcessors(); goto e7f78; ce7dd: $siteEntity->setPythonSettings($pythonSettingsEntity); goto aed90; b051b: $pythonSettingsEntity->setSite($siteEntity); goto d5291; B5976: $siteEntity = $this->siteEntityManager->createEntity(); goto e0ecf; b7c3c: b6e13: goto d43d0; B27bd: $vhostTemplate->build(); goto D3956; e6a7b: if (!(true === is_null($subdomain))) { goto D53cc; } goto C3c34; eb704: $pythonSite->setDomainName($domainName); goto Aa9f9; E5d02: $siteEntity->setVhostTemplate($vhostTemplate); goto E63c9; F04ec: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto B5976; C846d: $subdomain = $resolvedDomainName->subDomain()->toString(); goto b14d5; e3b3c: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto b4a80; e7f78: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto F98f2; b2fdc: $pythonSiteCreator = new PythonSiteCreator($pythonSite); goto b0162; Db685: $pythonSettingsConstraints = $this->validator->validate($pythonSettingsEntity); goto E43f5; f5fbf: $constraints = new ConstraintViolationList(); goto a85d2; bf7ad: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto c015d; Ee864: $pythonSiteCreator->createLogrotateFile(); goto cdb6f; f8d5e: D53cc: goto f8c91; Db391: if (!(false === empty($redirectionVhostTemplate))) { goto f2534; } goto C58bc; B2716: d2092: goto b7312; d8b7d: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto a8f73; C306b: $pythonVersion = $input->getOption("\x70\x79\x74\150\x6f\156\x56\x65\x72\163\151\157\156"); goto F8fd6; C3c34: $subjectAlternativeNames[] = sprintf("\x77\x77\167\x2e\45\x73", $domainName); goto f8d5e; Ffc7a: if (false === is_null($vhostTemplateEntity)) { goto Da4ab; } goto F2b63; c106e: b69a8: goto fa631; F8fd6: $appPort = (int) $input->getOption("\x61\x70\160\120\x6f\x72\164"); goto C5f01; E6e6b: $pythonSite->setCertificate($certificateEntity); goto Bdef2; b7312: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto C0533; Fb685: goto b6e13; goto cdd83; fd8ba: $this->validateInput($input); goto a8719; d6c5c: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto B27bd; d5291: $siteConstraints = $this->validator->validate($siteEntity); goto Db685; e0ecf: $siteEntity->setType(SiteEntity::TYPE_PYTHON); goto Fad8b; f9115: goto Fe62c; goto c106e; E43f5: if (0 == count($siteConstraints) && 0 == count($pythonSettingsConstraints)) { goto a0e15; } goto f5fbf; A050c: Bcd12: goto b7c3c; b4a80: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto C846d; E724d: $pythonSite->setSubdomain($subdomain); goto E7b5d; b14d5: $subdomain = false === empty($subdomain) ? $subdomain : null; goto D0cc0; Fb2e9: $vhostTemplate = new PythonVhostTemplate($pythonSite); goto bf7ad; b0bdd: return $this->renderConstraints($constraints, $output); goto fb502; bf7fa: $siteEntity->setCertificate($certificateEntity); goto c3023; ee29e: f05a2: goto E5d02; f6f8f: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto Db391; d43d0: } catch (\Exception $e) { goto d491e; Bad9d: return SiteCommand::FAILURE; goto b5a8b; d491e: $errorMessage = $e->getMessage(); goto ff036; ff036: $output->writeln(sprintf("\x3c\x65\x72\162\x6f\x72\x3e\x25\x73\x3c\x2f\x65\x72\x72\157\x72\x3e", $errorMessage)); goto Bad9d; b5a8b: } } }
