<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Site\ReverseProxySite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\ReverseProxyTemplate as ReverseProxyVhostTemplate; use App\Site\Creator\ReverseProxySite as ReverseProxySiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddReverseProxyCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\122\145\x76\145\x72\x73\145\120\x72\157\x78\x79"; protected function configure() : void { goto F86db; db8b0: $this->addOption("\163\151\164\145\x55\x73\145\x72\120\x61\163\163\167\x6f\x72\x64", null, InputOption::VALUE_REQUIRED); goto d9a52; F86db: $this->setName("\163\151\x74\x65\72\141\144\144\x3a\x72\145\166\x65\162\x73\x65\x2d\160\x72\x6f\170\171"); goto Dc073; Dc073: $this->setDescription("\x63\x6c\160\x63\x74\x6c\x20\163\151\x74\145\x3a\141\x64\x64\x3a\x72\145\x76\145\x72\163\x65\55\x70\x72\157\x78\x79\x20\x2d\55\144\157\155\x61\151\156\x4e\141\x6d\145\75\x77\167\167\56\144\157\x6d\141\151\x6e\56\143\x6f\x6d\40\x2d\55\x72\x65\x76\145\x72\x73\145\x50\x72\157\x78\171\125\162\x6c\x3d\47\x68\164\164\160\x3a\x2f\x2f\x31\62\67\56\60\56\x30\x2e\61\x3a\x38\60\x30\60\47\40\x2d\55\x73\x69\x74\x65\125\x73\145\x72\75\152\157\x68\156\40\55\55\x73\x69\x74\x65\125\163\145\x72\120\x61\163\163\x77\x6f\x72\144\x3d\47\x21\x73\x65\x63\162\x65\164\x50\141\x73\163\167\x6f\162\x64\41\47"); goto f6d26; Ff043: $this->addOption("\163\x69\x74\145\125\x73\x65\162", null, InputOption::VALUE_REQUIRED); goto db8b0; a8221: $this->addOption("\x64\157\x6d\x61\151\156\x4e\141\x6d\x65", null, InputOption::VALUE_REQUIRED); goto B102c; B102c: $this->addOption("\x72\145\x76\145\x72\x73\x65\120\162\x6f\170\x79\125\162\x6c", null, InputOption::VALUE_REQUIRED); goto Ff043; f6d26: $this->setComment("\101\144\144\151\156\147\x20\x61\40\x52\x65\166\145\162\163\x65\40\x50\162\x6f\170\171"); goto a8221; d9a52: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto E3a68; B6a18: b62b0: goto A173e; c3ca3: $vhostTemplate = new ReverseProxyVhostTemplate($reverseProxySite); goto B619e; Bb372: $this->siteEntityManager->updateEntity($siteEntity); goto Be3be; Df8cb: B84ae: goto D77f9; E8006: $csr = $csrGenerator->generate(); goto f08be; Ec9cc: goto ff55e; goto B6a18; d737c: $constraints = new ConstraintViolationList(); goto e93aa; b93d4: cf61b: goto E4dd0; f08be: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto Fddbc; E6024: $siteConstraints = $this->validator->validate($siteEntity); goto D6352; f8820: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto b1225; Ff293: return SiteCommand::SUCCESS; goto C3f63; b3408: $siteEntity->setType(SiteEntity::TYPE_REVERSE_PROXY); goto aaa35; Fde1d: if (!(true === is_null($subdomain) || "\167\167\x77" == $subdomain)) { goto B84ae; } goto dfcbb; c3257: $siteUser = trim($input->getOption("\x73\151\x74\x65\x55\163\145\162")); goto C2573; b7465: $subjectAlternativeNames[] = $registrableDomain; goto Ef442; ebe7c: a31b4: goto Df8cb; E30fa: ff55e: goto Db342; Ef8de: $reverseProxyUrl = trim($input->getOption("\162\145\166\145\162\x73\x65\x50\x72\x6f\170\171\x55\162\154")); goto c3257; E3a68: $this->validateInput($input); goto F89e9; b7790: $subdomain = $resolvedDomainName->subDomain()->toString(); goto c59d2; d17af: $reverseProxySite->setCertificate($certificateEntity); goto d3da0; d3da0: $reverseProxySite->setReverseProxyUrl($reverseProxyUrl); goto D4bff; b1225: $certificateEntity->setCertificate($selfSignedCertificate); goto e05bb; F89e9: $domainName = mb_strtolower(trim($input->getOption("\144\157\155\x61\151\156\116\x61\155\x65"))); goto f37e5; be4c5: goto c56f8; goto df18e; B619e: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto D39ea; E8ebd: goto Eb036; goto Ea674; f7d10: $reverseProxySite->setUser($siteEntity->getUser()); goto Ed72b; e16f7: $subjectAlternativeNames = []; goto f0d68; addd1: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto E8006; F09fd: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto De81c; Cb554: $rootDirectory = $domainName; goto Ef8de; Ef442: Da64f: goto d32b5; f0d68: if (!(true === is_null($subdomain))) { goto cf61b; } goto d8f4a; be87b: $rsaKeyGenerator = new RsaKeyGenerator(); goto C2995; ac32b: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto e34c1; C2573: $siteUserPassword = trim($input->getOption("\163\151\164\x65\125\163\x65\x72\x50\x61\x73\163\x77\x6f\162\x64")); goto facbe; Dd993: if (!(false === empty($redirectionVhostTemplate))) { goto a31b4; } goto f184a; D77f9: $siteEntity->setVhostTemplate($vhostTemplate); goto E6024; d32b5: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto addd1; f78e6: $reverseProxySite->setRegistrableDomain($registrableDomain); goto c7243; e845e: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto b7790; b1cd7: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto Ad39d; aaa35: $siteEntity->setDomainName($domainName); goto A4ee3; A4ee3: $siteEntity->setUser($siteUser); goto fa069; fa069: $siteEntity->setUserPassword($siteUserPassword); goto E901e; b42f1: Eb036: goto af255; c0031: $siteEntity->setReverseProxyUrl($reverseProxyUrl); goto Fde1d; A7bbe: $reversProxySiteCreator->createPrivateKeyAndCertificate(); goto B12fa; D6ff9: $reversProxySiteCreator->createRootDirectory(); goto Bd622; Fddbc: $certificateEntity->setDefaultCertificate(true); goto ac32b; f184a: $vhostTemplate = sprintf("\45\163\45\x73", $redirectionVhostTemplate, $vhostTemplate); goto ebe7c; facbe: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto e845e; b222d: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto e99ff; A5b99: throw new \Exception(sprintf("\126\x68\x6f\x73\x74\x20\124\145\155\x70\154\x61\x74\x65\40\x22\45\x73\x22\x20\144\157\145\163\40\x6e\157\164\40\145\x78\x69\x73\x74\x2e", $vhostTemplate)); goto Ec9cc; De81c: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto b222d; ad750: return $this->renderConstraints($constraints, $output); goto be4c5; Ad39d: if (false === is_null($vhostTemplateEntity)) { goto b62b0; } goto A5b99; A173e: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto C7ba6; C3f63: c56f8: goto E30fa; e05bb: $siteEntity->setCertificate($certificateEntity); goto Dff27; f37e5: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto Cb554; df18e: f18e8: goto C66fc; e93aa: $constraints->addAll($siteConstraints); goto ad750; c6eae: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\x2e\56\x2f\x2e\56\57\162\145\x73\157\165\162\143\x65\163\57\x6e\x67\151\156\170\57\166\x68\x6f\x73\164\137\164\145\x6d\x70\x6c\141\164\145\x2f\x72\145\144\x69\162\145\x63\164\55\150\x74\164\x70\x33"); goto b42f1; Bd622: $reversProxySiteCreator->createLogrotateFile(); goto A7bbe; C2995: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto e16f7; b1e1a: $reverseProxySite->setRootDirectory($siteEntity->getRootDirectory()); goto d17af; e34c1: $certificateEntity->setCsr($csr); goto f8820; E901e: $siteEntity->setRootDirectory($rootDirectory); goto c0031; c7243: $reverseProxySite->setSubdomain($subdomain); goto b1e1a; addf0: $reversProxySiteCreator->resetPermissions(); goto c3ca3; fe46f: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto C22da; C66fc: $certificateEntity = $this->certificateEntityManager->createEntity(); goto Fa486; D6352: if (0 == count($siteConstraints)) { goto f18e8; } goto d737c; C7ba6: $siteEntity = $this->siteEntityManager->createEntity(); goto b3408; Ea674: Fbf42: goto c6eae; E4dd0: if (!(false === is_null($subdomain) && "\x77\167\167" == $subdomain)) { goto Da64f; } goto b7465; dbeb6: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\56\x2e\57\56\x2e\x2f\162\145\x73\x6f\165\162\143\x65\163\57\156\147\151\156\170\x2f\166\x68\x6f\163\164\x5f\x74\145\x6d\160\x6c\x61\164\x65\57\162\145\x64\151\x72\145\x63\164"); goto E8ebd; dfcbb: if (true === isset($_ENV["\x41\120\120\137\110\124\x54\x50\x33"]) && "\x74\x72\x75\x65" === $_ENV["\101\x50\120\137\110\x54\x54\120\63"]) { goto Fbf42; } goto dbeb6; ab2e1: $reverseProxySite->setDomainName($domainName); goto f78e6; D4bff: $reverseProxySite->setVhostTemplate($siteEntity->getVhostTemplate()); goto F909d; F909d: $reversProxySiteCreator = new ReverseProxySiteCreator($reverseProxySite); goto cf243; d8f4a: $subjectAlternativeNames[] = sprintf("\x77\x77\167\x2e\45\x73", $domainName); goto b93d4; B12fa: $reversProxySiteCreator->createNginxVhost(); goto E1bb3; Fa486: $certificateEntity->setSite($siteEntity); goto be87b; E1bb3: $reversProxySiteCreator->reloadNginxService(); goto addf0; Be3be: $output->writeln(sprintf("\74\151\156\146\x6f\76\x53\x69\x74\145\x3c\x2f\x69\x6e\x66\x6f\x3e\x20\x3c\143\157\x6d\x6d\x65\156\x74\76\x25\x73\74\57\143\x6f\x6d\155\145\156\x74\76\40\x3c\x69\x6e\146\x6f\76\150\141\163\x20\x62\x65\x65\x6e\x20\141\144\144\x65\144\56\x3c\x2f\x69\x6e\146\157\76", $domainName)); goto Ff293; af255: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto Dd993; e99ff: $vhostTemplate->build(); goto fe46f; C22da: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto Bb372; cf243: $reversProxySiteCreator->createUser(); goto D6ff9; Dff27: $reverseProxySite = new ReverseProxySite(); goto f7d10; D39ea: $vhostTemplate->resetProcessors(); goto F09fd; Ed72b: $reverseProxySite->setUserPassword($siteEntity->getUserPassword()); goto ab2e1; c59d2: $subdomain = false === empty($subdomain) ? $subdomain : null; goto b1cd7; Db342: } catch (\Exception $e) { goto f4c4d; Fb05a: $output->writeln(sprintf("\x3c\145\x72\x72\157\162\x3e\x25\x73\x3c\57\x65\x72\162\x6f\x72\76", $errorMessage)); goto E11f3; E11f3: return SiteCommand::FAILURE; goto b8026; f4c4d: $errorMessage = $e->getMessage(); goto Fb05a; b8026: } } }
