<?php
 namespace App\Command; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use Doctrine\Common\Collections\ArrayCollection; use App\Command\Command as BaseCommand; use App\Entity\Site as SiteEntity; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\ReverseProxySite; use App\Site\Deleter as SiteDeleter; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Updater\ReverseProxySite as ReverseProxySiteUpdater; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Deleter\ReverseProxySite as ReverseProxySiteDeleter; use App\Site\Parser\DomainName as DomainNameParser; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\VhostTemplateManager as VhostTemplateEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; class SiteCommand extends BaseCommand { protected DomainNameParser $domainNameParser; protected SiteEntityManager $siteEntityManager; protected CertificateEntityManager $certificateEntityManager; protected DatabaseServerEntityManager $databaseServerEntityManager; protected VhostTemplateEntityManager $vhostTemplateEntityManager; protected ValidatorInterface $validator; public function __construct(DomainNameParser $domainNameParser, SiteEntityManager $siteEntityManager, CertificateEntityManager $certificateEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, VhostTemplateEntityManager $vhostTemplateEntityManager, ValidatorInterface $validator) { goto f6b86; C7f3d: $this->siteEntityManager = $siteEntityManager; goto e0922; e0922: $this->certificateEntityManager = $certificateEntityManager; goto a8c87; a8c87: $this->databaseServerEntityManager = $databaseServerEntityManager; goto C51e6; f6b86: $this->domainNameParser = $domainNameParser; goto C7f3d; b57c5: parent::__construct(); goto d34e7; C51e6: $this->vhostTemplateEntityManager = $vhostTemplateEntityManager; goto Caf61; Caf61: $this->validator = $validator; goto b57c5; d34e7: } protected function configure() : void { $this->setName("\x73\x69\x74\x65\72\164\x6d\160"); } protected function getSite(string $domainName) : ?Site { goto Fab17; a2969: goto A9d09; goto fd3f5; b9b08: throw new \Exception(sprintf("\123\x69\164\145\x20\x22\x25\163\x22\x20\x64\x6f\145\x73\40\x6e\157\164\40\x65\x78\x69\x73\x74\56", $domainName)); goto a2969; af6c8: $siteType = $siteEntity->getType(); goto ad703; Ca8d4: $site->setRegistrableDomain($registrableDomain); goto F0966; Cc63c: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto f9461; Dcdee: $site->setCertificates($siteEntity->getCertificates()); goto a523d; a523d: $site->setCronJobs($siteEntity->getCronJobs()); goto B2912; f435b: $site->setBasicAuth($siteEntity->getBasicAuth()); goto cf06e; b65d9: $siteEntity = $this->getSiteEntity($domainName); goto D896e; B59c0: Cebc9: goto C1fe9; bad00: $subdomain = false === empty($subdomain) ? $subdomain : null; goto D3e79; F0966: $site->setSubdomain($subdomain); goto bd50a; C1fe9: E6725: goto da0d0; C2c3a: $site->setDatabases($siteDatabases); goto f435b; Ae4bd: $site->setSshUsers($siteEntity->getSshUsers()); goto f838b; D4871: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto A662b; f9461: $subdomain = $resolvedDomainName->subDomain()->toString(); goto bad00; a550b: B073b: goto Cb9ea; A967e: $site->setUser($siteEntity->getUser()); goto E9145; bec4c: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto a550b; Ac64b: return $site; goto a8717; Fab17: $site = null; goto b65d9; fd3f5: a3331: goto af6c8; bd50a: $site->setRootDirectory($siteEntity->getRootDirectory()); goto C2c3a; A662b: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto bec4c; D896e: if (false === is_null($siteEntity)) { goto a3331; } goto b9b08; da0d0: if (!(false === is_null($site))) { goto B073b; } goto B87ed; adc7b: $site->setBlockedIps($siteEntity->getBlockedIps()); goto Cb423; B87ed: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto Cc63c; E9145: $site->setDomainName($siteEntity->getDomainName()); goto Ca8d4; f838b: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto D4871; Cb9ea: A9d09: goto Ac64b; ad703: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto E136a; Cf586: goto E6725; goto C6fe4; d8823: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto Cf586; E136a: $site = new NodejsSite(); goto d8823; C6fe4: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto E6725; case SiteEntity::TYPE_PHP: goto a3996; c4db7: $site->setPhpSettings($siteEntity->getPhpSettings()); goto d5e22; b5e7b: goto E6725; goto cb1de; a3996: $site = new PhpSite(); goto c4db7; d5e22: $site->setVarnishCache($siteEntity->getVarnishCache()); goto b5e7b; cb1de: case SiteEntity::TYPE_PYTHON: goto E340d; E340d: $site = new PythonSite(); goto Fb548; ec7b9: goto E6725; goto Affcc; Fb548: $site->setPythonSettings($siteEntity->getPythonSettings()); goto ec7b9; Affcc: case SiteEntity::TYPE_REVERSE_PROXY: goto A8ec4; A8ec4: $site = new ReverseProxySite(); goto be261; be261: $site->setReverseProxyUrl($siteEntity->getReverseProxyUrl()); goto E3b82; E3b82: goto E6725; goto Afdf7; Afdf7: } goto B59c0; D3e79: $siteDatabases = $this->getSiteDatabases($siteEntity); goto A967e; B2912: $site->setFtpUsers($siteEntity->getFtpUsers()); goto Ae4bd; Cb423: $site->setCertificate($siteEntity->getCertificate()); goto Dcdee; cf06e: $site->setBlockedBots($siteEntity->getBlockedBots()); goto adc7b; a8717: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto Bf8c0; Bf8c0: $siteDatabases = new ArrayCollection(); goto a61b1; B4dbf: $databaseEntities = $siteEntity->getDatabases(); goto Baa1c; c351e: return $siteDatabases; goto a05f2; a61b1: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto B4dbf; C7046: a13f7: goto c351e; Baa1c: foreach ($databaseEntities as $databaseEntity) { goto dd14b; c3e6b: D682a: goto a1b15; B1c88: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto D682a; } goto Af460; dd14b: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto B1c88; a1b15: B47b3: goto B076d; Af460: $siteDatabases->add($databaseEntity); goto c3e6b; B076d: } goto C7046; a05f2: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto d955d; A0858: $siteType = $site->getType(); goto d768f; Dbb4f: return $siteDeleter; goto Dc35c; d955d: $siteDeleter = null; goto A0858; fe854: e4003: goto Dc64c; Dc64c: ce974: goto Dbb4f; d768f: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto ce974; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto ce974; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto ce974; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto ce974; case SiteEntity::TYPE_REVERSE_PROXY: $siteDeleter = new ReverseProxySiteDeleter($site); goto ce974; } goto fe854; Dc35c: } protected function getSiteUpdater(Site $site) : ?SiteUpdater { goto b65b0; F621d: A1977: goto c7b22; b65b0: $siteUpdater = null; goto ce089; c7b22: return $siteUpdater; goto F6452; ce089: $siteType = $site->getType(); goto e5f37; F5e3e: b250d: goto F621d; e5f37: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto A1977; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto A1977; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto A1977; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto A1977; case SiteEntity::TYPE_REVERSE_PROXY: $siteUpdater = new ReverseProxySiteUpdater($site); goto A1977; } goto F5e3e; F6452: } protected function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } protected function getSiteEntityBySiteUser(string $siteUser) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByUser($siteUser); return $siteEntity; } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\x75\x73\145\162", "\x73\x69\164\145\125\163\145\x72", $constraints); $this->changePropertyPath("\x75\x73\x65\x72\x50\141\x73\163\x77\157\x72\x64", "\163\x69\164\x65\x55\163\145\162\120\141\163\x73\167\x6f\x72\144", $constraints); } }
