<?php
 namespace App\Controller\Admin; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Component\Form\Form; use App\Controller\Controller; use Symfony\Contracts\Translation\TranslatorInterface; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\UserManager as UserEntityManager; use App\Entity\Manager\TimezoneManager as TimezoneEntityManager; use App\Entity\User as UserEntity; use App\Event\EventQueue; use App\Service\Logger; class UserController extends Controller { private UserEntityManager $userEntityManager; private SiteEntityManager $siteEntityManager; private TimezoneEntityManager $timezoneEntityManager; public function __construct(UserEntityManager $userEntityManager, SiteEntityManager $siteEntityManager, TimezoneEntityManager $timezoneEntityManager, TranslatorInterface $translator, Logger $logger) { goto D86cc; fa248: $this->timezoneEntityManager = $timezoneEntityManager; goto de264; D86cc: $this->userEntityManager = $userEntityManager; goto Bcc4f; de264: parent::__construct($translator, $logger); goto d37d7; Bcc4f: $this->siteEntityManager = $siteEntityManager; goto fa248; d37d7: } public function index(Request $request) : Response { goto d01cf; cc55c: $users = array_filter($users, function ($user) use($currentUser) { return $currentUser->getId() != $user->getId(); }); goto b41aa; bf327: $users = $this->userEntityManager->findAll([], ["\x75\x73\x65\x72\x4e\141\x6d\145" => "\x61\x73\x63"]); goto cc55c; d01cf: $currentUser = $this->getUser(); goto bf327; C8ddc: return $response; goto b7ea9; b41aa: $response = $this->render("\x41\144\155\x69\x6e\x2f\125\163\145\x72\57\x69\x6e\144\145\x78\56\150\x74\x6d\154\x2e\x74\x77\151\147", ["\x75\163\x65\x72\163" => $users]); goto C8ddc; b7ea9: } public function new(Request $request) : Response { goto A7c62; e0e75: if (!(false === is_null($response))) { goto D7d66; } goto cb4c9; f9a99: $response = $this->render("\101\x64\x6d\151\x6e\x2f\125\x73\145\162\x2f\x6e\145\x77\x2e\x68\164\155\154\56\x74\x77\151\x67", ["\165\x73\145\x72" => $userEntity, "\163\151\164\145\163" => $sites, "\x66\157\x72\155" => $form->createView(), "\146\x6f\x72\x6d\x45\x72\x72\157\162\x73" => $this->formErrors]); goto E5de9; A7c62: $userEntity = $this->userEntityManager->createEntity(); goto C5b53; d4266: if (!(true === $form->isSubmitted())) { goto Eb7bf; } goto c78d6; c78d6: $response = $this->handleUserForm($request, $form); goto e0e75; ee51c: Eb7bf: goto c70ca; E5de9: return $response; goto E06d9; B343c: $form->handleRequest($request); goto d4266; c70ca: fc753: goto f9a99; C5b53: $defaultTimezone = $this->timezoneEntityManager->findOneByName(UserEntity::DEFAULT_TIMEZONE); goto aadd3; cb4c9: return $response; goto Cacdf; dfc52: $userEntity->setTimezone($defaultTimezone); goto a4d65; Cacdf: D7d66: goto ee51c; aadd3: $sites = $this->siteEntityManager->findAll([], ["\x64\157\155\141\151\156\116\141\x6d\x65" => "\101\123\103"]); goto dfc52; a4d65: $form = $this->createUserForm($userEntity); goto e817d; e817d: if (!(true === $request->isMethod("\120\117\123\124"))) { goto fc753; } goto B343c; E06d9: } private function createUserForm(UserEntity $userEntity) : Form { goto A2f95; b2b27: return $form; goto F24f7; A2f95: $form = $this->createForm("\101\x70\x70\x5c\106\x6f\162\155\134\101\144\x6d\x69\x6e\125\x73\x65\162\x54\171\160\145", $userEntity, ["\141\143\x74\x69\x6f\156" => $this->generateUrl("\x63\x6c\160\137\x61\x64\x6d\151\156\137\x75\x73\x65\162\137\x6e\145\x77"), "\x6d\145\x74\x68\x6f\144" => "\x50\117\123\124", "\x61\164\x74\x72" => []]); goto Ec4dd; Ec4dd: $form->add("\x73\165\x62\x6d\151\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\x61\x73\x73" => "\x62\x74\x6e\x20\142\164\x6e\55\142\154\165\145\x20\x62\164\156\x2d\x6c\x67"], "\154\141\142\145\154" => "\101\144\x64\x20\125\x73\145\162"]); goto b2b27; F24f7: } private function handleUserForm(Request $request, Form $form) { goto C921d; C921d: if (true === $form->isValid()) { goto Dc4cd; } goto A5330; d087c: goto e20c3; goto d1ced; d1ced: Dc4cd: goto Aecdf; Aecdf: try { goto E018a; db31b: $this->userEntityManager->updateUser($userEntity); goto F013a; b64e0: if (!(count($sites) && UserEntity::ROLE_USER == $userEntity->getRole())) { goto Cadf6; } goto aeb59; F013a: $eventData = ["\x75\x73\145\162\116\x61\x6d\x65" => $userEntity->getUserName(), "\x66\x69\162\x73\x74\116\141\155\145" => $userEntity->getFirstName(), "\154\141\163\x74\x4e\x61\x6d\x65" => $userEntity->getLastName(), "\x65\155\x61\x69\x6c" => $userEntity->getEMail(), "\162\157\154\x65" => $userEntity->getRole(), "\163\x69\x74\145\x73" => implode("\x2c\40", $domainNames)]; goto A9958; bdb89: sort($domainNames); goto db31b; fab25: A1983: goto F4424; F4424: Cadf6: goto bdb89; aeb59: foreach ($sites as $site) { $domainNames[] = $site->getDomainName(); D4638: } goto fab25; c3dc6: $userEntity = $form->getData(); goto Aa58c; Af9b3: $session = $request->getSession(); goto c3dc6; e2136: $domainNames = []; goto b64e0; E9f37: return $response; goto Cb624; c5bb0: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\141\x64\155\x69\x6e\x5f\165\x73\145\x72\x73")); goto E9f37; A9958: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_ADD, $currentUser, $eventData, $request); goto c83e8; E018a: $currentUser = $this->getUser(); goto Af9b3; c83e8: $session->getFlashBag()->set("\x73\x75\x63\143\145\163\x73", $this->translator->trans("\125\163\145\x72\x20\x68\x61\x73\40\142\x65\x65\156\40\141\144\144\145\144\x2e")); goto c5bb0; Aa58c: $sites = $userEntity->getSites(); goto e2136; Cb624: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\x72", $this->translator->trans("\101\156\40\x65\x72\x72\x6f\x72\x20\x68\141\163\x20\x6f\x63\143\x75\x72\x72\x65\144\54\40\145\x72\162\x6f\x72\x20\x6d\145\x73\x73\141\x67\x65\72\40\45\x65\x72\x72\157\162\x4d\x65\x73\x73\141\147\145\45", ["\45\x65\x72\x72\x6f\162\x4d\145\163\163\141\x67\145\45" => $e->getMessage()])); } goto bb304; A5330: $this->formErrors = $this->getErrorMessages($form); goto d087c; bb304: e20c3: goto abf5e; abf5e: } public function edit(Request $request) : Response { goto f9390; a2703: goto Cbaa2; goto C1ae1; f9390: $id = (int) $request->get("\x69\144"); goto cdb2f; ff0e5: Cbaa2: goto De842; ab1ab: $form = $this->createUserEditForm($userEntity); goto df2ad; Ba6de: if (!(true === $form->isSubmitted())) { goto da8f1; } goto B2d88; C1ae1: F0937: goto C83be; C83be: $sites = $this->siteEntityManager->findAll([], ["\x64\x6f\155\x61\x69\x6e\x4e\x61\155\x65" => "\x41\x53\103"]); goto ab1ab; a7648: if (!(false === is_null($response))) { goto c5afa; } goto Fe66e; f72f3: if (false === is_null($userEntity)) { goto F0937; } goto Da313; ecb91: c5afa: goto E4392; Fe66e: return $response; goto ecb91; d1165: A2cf1: goto b0ab0; De842: return $response; goto F2447; E4392: da8f1: goto d1165; B62f2: $form->handleRequest($request); goto Ba6de; Da313: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\141\144\x6d\151\156\137\x75\163\x65\x72\163")); goto a2703; B2d88: $response = $this->handleUserEditForm($request, $form); goto a7648; df2ad: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto A2cf1; } goto B62f2; cdb2f: $userEntity = $this->userEntityManager->findOneById($id); goto f72f3; b0ab0: $response = $this->render("\x41\144\155\x69\156\57\x55\163\145\x72\57\x65\144\151\x74\56\150\x74\x6d\x6c\56\x74\x77\x69\147", ["\165\x73\x65\x72" => $userEntity, "\x73\x69\x74\x65\163" => $sites, "\x66\157\x72\155" => $form->createView(), "\x66\157\x72\x6d\105\162\162\157\x72\163" => $this->formErrors]); goto ff0e5; F2447: } private function createUserEditForm(UserEntity $userEntity) : Form { goto f2321; Dd868: $form->add("\x73\x75\x62\155\151\164", SubmitType::class, ["\x61\164\164\x72" => ["\143\154\141\163\x73" => "\x62\x74\156\x20\142\164\156\55\142\x6c\165\x65\x20\142\x74\156\x2d\154\147"], "\x6c\141\142\x65\x6c" => "\123\x61\x76\145"]); goto a6e4a; a6e4a: return $form; goto A36e4; f2321: $form = $this->createForm("\x41\160\160\134\x46\157\x72\155\134\101\x64\x6d\151\156\x55\x73\x65\x72\x45\x64\x69\164\x54\x79\160\145", $userEntity, ["\141\x63\x74\151\x6f\156" => $this->generateUrl("\x63\154\x70\x5f\x61\x64\x6d\151\x6e\137\165\x73\x65\x72\137\145\144\151\x74", ["\151\144" => $userEntity->getId()]), "\x6d\145\x74\x68\x6f\x64" => "\x50\x4f\123\124", "\x61\x74\x74\x72" => []]); goto Dd868; A36e4: } private function handleUserEditForm(Request $request, Form $form) { goto Caac4; f0f21: $this->formErrors = $this->getErrorMessages($form); goto C2970; C2970: goto b2fc6; goto Efd3d; b0880: try { goto bde0d; b92ce: $userEntity = $form->getData(); goto A6082; b9723: Df49a: goto b7541; b7541: Ac002: goto cd5e0; cd5e0: sort($domainNames); goto ba8cd; B9026: $sites = $userEntity->getSites(); goto edd94; Bb278: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\141\144\x6d\x69\x6e\137\x75\x73\145\x72\x5f\x65\144\x69\164", ["\151\144" => $userEntity->getId()])); goto Cf684; df019: $eventData = ["\x75\163\145\162\x4e\141\x6d\x65" => $userEntity->getUserName(), "\146\151\x72\x73\x74\x4e\x61\x6d\145" => $userEntity->getFirstName(), "\x6c\141\x73\164\116\141\x6d\145" => $userEntity->getLastName(), "\x65\x6d\x61\x69\x6c" => $userEntity->getEMail(), "\162\157\154\145" => $userEntity->getRole(), "\x73\164\141\x74\165\163" => (int) $userEntity->getStatus(), "\x73\x69\164\145\x73" => implode("\54\x20", $domainNames)]; goto b27bb; E2bd1: $session->getFlashBag()->set("\163\165\143\x63\x65\163\x73", $this->translator->trans("\x55\163\145\x72\40\150\x61\x73\40\142\145\145\156\x20\165\x70\144\x61\164\x65\144\56")); goto Bb278; b27bb: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_UPDATE, $currentUser, $eventData, $request); goto E2bd1; e3a54: d07f2: goto df019; edd94: $domainNames = []; goto cfc8b; fd5dc: $this->userEntityManager->updateUser($userEntity); goto A9605; bde0d: $currentUser = $this->getUser(); goto Dbcb1; F9def: $this->userEntityManager->updateUser($userEntity, true, true); goto e3a54; F1cf3: c5d1e: goto F9def; ec539: foreach ($sites as $site) { $domainNames[] = $site->getDomainName(); a7826: } goto b9723; Dbcb1: $session = $request->getSession(); goto b92ce; A6082: $plainPassword = $userEntity->getPlainPassword(); goto B9026; cfc8b: if (!(count($sites) && UserEntity::ROLE_USER == $userEntity->getRole())) { goto Ac002; } goto ec539; Cf684: return $response; goto a6299; ba8cd: if (false === empty($plainPassword)) { goto c5d1e; } goto fd5dc; A9605: goto d07f2; goto F1cf3; a6299: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\x72", $this->translator->trans("\101\156\x20\145\x72\162\x6f\162\x20\x68\x61\163\x20\157\143\143\165\162\162\145\144\x2c\40\x65\x72\162\x6f\162\40\155\145\x73\163\141\147\145\72\x20\45\x65\162\x72\157\162\x4d\145\x73\163\x61\x67\145\x25", ["\45\145\162\x72\157\x72\115\145\x73\163\141\x67\145\x25" => $e->getMessage()])); } goto E365c; E365c: b2fc6: goto a1166; Efd3d: Ff6b0: goto b0880; Caac4: if (true === $form->isValid()) { goto Ff6b0; } goto f0f21; a1166: } public function delete(Request $request) : Response { goto e55f0; Bde64: $session->getFlashBag()->set("\x73\x75\x63\143\145\163\x73", $this->translator->trans("\125\x73\145\x72\x20\x68\141\x73\x20\x62\x65\x65\156\x20\144\x65\x6c\145\x74\x65\144\56")); goto d3ad7; F1d58: C2f2b: goto cc16c; D5bd1: $id = (int) $request->get("\151\144"); goto bb8a6; e55f0: $currentUser = $this->getUser(); goto D5bd1; cc16c: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x61\144\155\x69\156\137\x75\163\145\162\163")); goto Cbe1e; bccdc: $eventData = ["\165\x73\145\x72\116\x61\x6d\x65" => $userEntity->getUserName(), "\x66\151\162\x73\x74\x4e\x61\155\145" => $userEntity->getFirstName(), "\154\141\x73\x74\116\141\x6d\x65" => $userEntity->getLastName(), "\145\155\x61\x69\154" => $userEntity->getEMail(), "\x72\x6f\154\145" => $userEntity->getRole()]; goto a2a5b; Cbe1e: return $response; goto Efb2e; d3ad7: Cd6bd: goto F1d58; ef078: $this->userEntityManager->deleteUser($userEntity); goto Bde64; c1ef4: $userEntity = $this->userEntityManager->findOneById($id); goto Bacd7; A22de: $session = $request->getSession(); goto bccdc; a2a5b: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_DELETE, $currentUser, $eventData, $request); goto ef078; ed62c: if (!(true === isset($id) && $id != $currentUser->getId())) { goto C2f2b; } goto c1ef4; Bacd7: if (!(false === is_null($userEntity))) { goto Cd6bd; } goto A22de; bb8a6: $this->checkCsrfToken($request, "\144\145\x6c\145\164\145\x2d\x75\163\145\x72"); goto ed62c; Efb2e: } }
