<?php
 namespace App\Controller\Frontend; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Contracts\Translation\TranslatorInterface; use App\Controller\Controller; use App\Entity\Manager\InstanceCpuManager as InstanceCpuEntityManager; use App\Entity\Manager\InstanceMemoryManager as InstanceMemoryEntityManager; use App\Entity\Manager\InstanceDiskUsageManager as InstanceDiskUsageEntityManager; use App\Entity\Manager\InstanceLoadAverageManager as InstanceLoadAverageEntityManager; use App\System\CommandExecutor; use App\System\Command\MemoryInformationCommand; use App\System\Command\ProcessorCoresCommand; use App\Entity\InstanceDiskUsage as InstanceDiskUsageEntity; use App\Entity\InstanceLoadAverage as InstanceLoadAverageEntity; use App\Monitoring\Chart; use App\Monitoring\LoadAverageChart; use App\Util\HumanFileSize as HumanFileSizeUtil; use App\Util\Time as TimeUtil; use App\Service\Logger; use App\Entity\User; class DashboardController extends Controller { public const TIME_RANGE_LAST_THIRTY_MINUTES = 1; public const TIME_RANGE_LAST_HOUR = 2; public const TIME_RANGE_LAST_THREE_HOURS = 3; public const TIME_RANGE_LAST_SIX_HOURS = 4; public const TIME_RANGE_LAST_TWELVE_HOURS = 5; private static array $timeRanges = [self::TIME_RANGE_LAST_THIRTY_MINUTES, self::TIME_RANGE_LAST_HOUR, self::TIME_RANGE_LAST_THREE_HOURS, self::TIME_RANGE_LAST_SIX_HOURS, self::TIME_RANGE_LAST_TWELVE_HOURS]; private InstanceCpuEntityManager $instanceCpuEntityManager; private InstanceMemoryEntityManager $instanceMemoryEntityManager; private InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager; private InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager; public function __construct(InstanceCpuEntityManager $instanceCpuEntityManager, InstanceMemoryEntityManager $instanceMemoryEntityManager, InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager, InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager, TranslatorInterface $translator, Logger $logger) { goto c793f; c793f: $this->instanceCpuEntityManager = $instanceCpuEntityManager; goto Ee3c0; Ee3c0: $this->instanceMemoryEntityManager = $instanceMemoryEntityManager; goto Ebd39; B7a5f: parent::__construct($translator, $logger); goto f624f; Ebd39: $this->instanceDiskUsageEntityManager = $instanceDiskUsageEntityManager; goto ec7f8; ec7f8: $this->instanceLoadAverageEntityManager = $instanceLoadAverageEntityManager; goto B7a5f; f624f: } public function index(Request $request) : Response { goto a347e; c857e: $timeRange = $request->get("\x74\151\x6d\x65\122\141\156\x67\x65"); goto f89da; aac5b: $diskData = $this->getDiskDataForTimeRange($startTime, $endTime, $minuteInterval); goto ab2a2; b4096: $dateTime = new \DateTime(); goto f3246; f89da: $timeRange = true === is_null($timeRange) ? self::TIME_RANGE_LAST_THIRTY_MINUTES : (true === in_array($timeRange, self::$timeRanges) ? $timeRange : self::TIME_RANGE_LAST_THIRTY_MINUTES); goto b2ce0; D2b31: $diskData = [["\x6e\141\155\x65" => sprintf("\57\40\50\x25\x73\51", $rootDiskSize), "\143\157\154\157\162" => "\43\x37\63\x62\x66\x34\x63", "\144\x61\x74\x61" => $diskData["\x72\157\157\164"] ?: []]]; goto F0049; De01a: $cloud = $environment->getCloudProvider(); goto c857e; a347e: $user = $this->getUser(); goto f1034; d9198: $memoryData = $this->getMemoryDataForTimeRange($startTime, $endTime, $minuteInterval); goto aac5b; b9023: $memoryChart->setData($memoryData); goto fb33a; B27e6: $homeDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_HOME); goto E10d1; E10d1: $homeDiskSize = HumanFileSizeUtil::convert($homeDiskSizeInBytes, "\107\x42", 0); goto b4096; Bcae0: $diskChart->setData($diskData); goto Db171; Abc34: $loadAverageRawData = $this->getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval); goto a8f11; E6f31: C33bd: goto fb0f3; e3b5e: af5df: goto D46bf; E06fb: $cpuChart->setData($cpuData); goto D15f3; D15f3: $cpuChart->setCategories($categories); goto D2d40; d46fe: $cpuInformation = sprintf("\45\163\x20\45\x73", $numberOfProcessorCores, $this->translator->trans("\x43\120\x55")); goto e8b60; Bec26: $loadAverageChart = new LoadAverageChart("\x4c\157\x61\x64\x20\101\166\145\x72\141\x67\x65"); goto Bcc83; fb33a: $memoryChart->setCategories($categories); goto D9b77; a3e62: $categories = $this->getCategoriesForTimeRange($user, $startTime, $endTime, $minuteInterval); goto e0893; D2a39: try { goto ebe63; Adbe7: $memoryInformationCommand = new MemoryInformationCommand(); goto fd09b; D7750: $commandExecutor->execute($processorCoresCommand); goto ac434; F4af2: $totalMemory = HumanFileSizeUtil::convert($totalMemoryInBytes, "\107\x42", 0); goto E5b2f; fd09b: $commandExecutor->execute($memoryInformationCommand); goto B994d; ebe63: $commandExecutor = new CommandExecutor(); goto Adbe7; ac434: $numberOfProcessorCores = $processorCoresCommand->getNumberOfProcessorCores(); goto e1421; E5b2f: $processorCoresCommand = new ProcessorCoresCommand(); goto D7750; B994d: $totalMemoryInBytes = $memoryInformationCommand->getTotalMemoryInBytes(); goto F4af2; e1421: } catch (\Exception $e) { $this->logger->exception($e); } goto a6e0e; Db171: $diskChart->setCategories($categories); goto Cfadf; E4f23: $rootDiskSize = HumanFileSizeUtil::convert($rootDiskSizeInBytes, "\x47\102", 0); goto B27e6; cfca8: $memoryChart->setInformation($totalMemory); goto b9023; Cd434: $numberOfProcessorCores = 0; goto D2a39; fb0f3: $diskData = [["\x6e\141\x6d\x65" => sprintf("\57\40\x28\45\x73\51", $rootDiskSize), "\x63\x6f\x6c\157\162" => "\43\x37\x33\142\x66\x34\143", "\144\x61\164\141" => $diskData["\x72\x6f\157\x74"] ?: []], ["\156\141\x6d\x65" => sprintf("\x2f\150\157\155\145\40\x28\45\x73\x29", $homeDiskSize), "\143\x6f\x6c\157\x72" => "\x23\146\x33\x62\x66\x30\x30", "\144\x61\x74\x61" => $diskData["\150\157\x6d\145"] ?: []]]; goto a50d0; e0893: $cpuData = $this->getCpuDataForTimeRange($startTime, $endTime, $minuteInterval); goto d9198; D2d40: $memoryChart = new Chart("\115\x65\155\x6f\162\x79\40\125\x73\x61\147\145"); goto cfca8; a8f11: $loadAverageData = [["\156\x61\155\x65" => $this->translator->trans("\61\x20\115\x69\156\x75\x74\x65"), "\x63\157\x6c\157\x72" => "\43\67\x37\x34\141\x61\x34", "\x64\141\164\x61" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_ONE_MINUTE] ?? []], ["\156\141\x6d\145" => $this->translator->trans("\65\x20\115\151\x6e\165\x74\145\x73"), "\143\157\x6c\x6f\162" => "\x23\145\x62\x35\70\66\x63", "\x64\x61\x74\141" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES] ?? []], ["\156\141\x6d\x65" => $this->translator->trans("\61\65\40\115\x69\156\165\164\x65\x73"), "\x63\x6f\x6c\157\x72" => "\43\x30\x30\x37\x38\144\x34", "\x64\141\164\x61" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] ?? []]]; goto d46fe; e465a: $loadAverageChart->setCategories($categories); goto a2ade; D46bf: Ac0ea: goto a3e62; e8b60: $cpuChart = new Chart("\x43\x50\x55\40\125\x73\141\x67\x65"); goto d651e; Ad67e: switch ($timeRange) { case self::TIME_RANGE_LAST_THIRTY_MINUTES: goto e262c; e262c: $minuteInterval = 5; goto f7cab; C0334: goto Ac0ea; goto a7bb9; f7cab: $startTime = (clone $endTime)->modify("\55\63\60\x20\155\x69\x6e\165\164\x65\x73"); goto C0334; a7bb9: case self::TIME_RANGE_LAST_HOUR: goto C8b5b; C8b5b: $minuteInterval = 10; goto B26e0; B26e0: $startTime = (clone $endTime)->modify("\x2d\61\40\x68\157\x75\162"); goto F00ad; F00ad: goto Ac0ea; goto ca817; ca817: case self::TIME_RANGE_LAST_THREE_HOURS: goto cfd36; f27a0: goto Ac0ea; goto da6a3; d88a8: $startTime = (clone $dateTime)->modify("\x2d\63\40\150\x6f\165\x72\163"); goto f27a0; cfd36: $minuteInterval = 30; goto d88a8; da6a3: case self::TIME_RANGE_LAST_SIX_HOURS: goto b2fb3; b2fb3: $minuteInterval = 60; goto D13d1; cb80b: goto Ac0ea; goto eb392; D13d1: $startTime = (clone $dateTime)->modify("\x2d\x36\40\x68\157\165\x72\x73"); goto cb80b; eb392: case self::TIME_RANGE_LAST_TWELVE_HOURS: goto C9d14; Ab54e: $startTime = (clone $dateTime)->modify("\x2d\x31\x32\40\150\x6f\x75\162\x73"); goto B9bf3; B9bf3: goto Ac0ea; goto C0ec9; C9d14: $minuteInterval = 120; goto Ab54e; C0ec9: } goto e3b5e; a6e0e: $rootDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_ROOT); goto E4f23; a50d0: Cdecf: goto Abc34; B7864: $environment = $instance->getEnvironment(); goto De01a; d651e: $cpuChart->setInformation($cpuInformation); goto E06fb; D9b77: $diskChart = new Chart("\104\x69\x73\153\x20\125\163\141\147\x65"); goto Bcae0; f3246: $endTime = TimeUtil::roundToNearestMinuteInterval($dateTime, 5); goto Ad67e; ecefc: $loadAverageChart->setData($loadAverageData); goto e465a; b2ce0: $totalMemory = ''; goto Cd434; Ad716: return $response; goto E5f84; F0049: goto Cdecf; goto E6f31; Cfadf: $loadAverageChartInformation = sprintf("\x25\x73\40\x25\x73", $numberOfProcessorCores, $this->translator->trans("\103\120\125")); goto Bec26; Bcc83: $loadAverageChart->setInformation($loadAverageChartInformation); goto ecefc; f1034: $instance = $request->attributes->get("\151\x6e\163\164\x61\156\x63\145"); goto B7864; ab2a2: if ($homeDiskSize != $rootDiskSize) { goto C33bd; } goto D2b31; a2ade: $response = $this->render("\106\162\157\x6e\164\145\x6e\144\57\104\x61\x73\x68\142\x6f\141\162\144\57\x69\x6e\x64\x65\170\56\150\164\155\x6c\x2e\164\x77\151\147", ["\143\154\157\x75\144" => $cloud, "\x69\x6e\163\164\141\156\143\145" => $instance, "\165\x73\145\x72" => $user, "\x74\151\155\x65\x52\x61\x6e\x67\x65" => $timeRange, "\143\160\165\103\150\141\162\164" => $cpuChart, "\x6d\x65\x6d\x6f\162\x79\x43\150\141\162\x74" => $memoryChart, "\144\151\x73\153\x43\150\141\x72\x74" => $diskChart, "\x6c\x6f\141\144\101\x76\145\x72\x61\x67\x65\x43\x68\x61\x72\x74" => $loadAverageChart]); goto Ad716; E5f84: } private function getCategoriesForTimeRange(User $user, \DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto c4162; Fbc7b: return $categories; goto D42c2; eeb82: $endDataDate->modify(sprintf("\x2b\x25\60\65\144\x20\x6d\x69\x6e\x75\164\x65\163", $minuteInterval)); goto cd6c7; f3930: $categories[] = $categoryDateTime->format("\110\x3a\x69"); goto ed3eb; cd6c7: goto cf377; goto f7383; Aa43b: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\60\65\144\x20\x6d\x69\x6e\165\164\x65\163", $minuteInterval)); goto a3946; Dacf9: if (!($endDataDate <= $endTime)) { goto A8d72; } goto Fc17f; Ea627: cf377: goto Dacf9; ed3eb: $startDataDate->modify(sprintf("\53\45\60\65\x64\x20\155\151\156\x75\164\x65\x73", $minuteInterval)); goto eeb82; a3946: $endDataDate = clone $startTime; goto Ea627; f7383: A8d72: goto Fbc7b; fd216: $categoryDateTime->setTimezone(new \DateTimeZone($user->getTimezone())); goto f3930; Fc17f: $categoryDateTime = clone $endDataDate; goto fd216; c4162: $categories = []; goto Aa43b; D42c2: } private function getCpuDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto cabb1; c22ef: $endDataDate = clone $startTime; goto Bb0df; c833b: return $cpuData; goto Ee3aa; Dab73: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\60\65\144\40\x6d\151\156\x75\x74\x65\x73", $minuteInterval)); goto c22ef; c3eea: $endDataDate->modify(sprintf("\x2b\x25\x30\x35\x64\x20\x6d\x69\x6e\x75\x74\x65\x73", $minuteInterval)); goto Cfa4c; cabb1: $cpuData = []; goto Dab73; Cfa4c: goto a1f53; goto D972d; B6ef3: $averageCpuValue = $this->instanceCpuEntityManager->getAverageCpuValue($startDataDate, $endDataDate); goto b45c5; D972d: F3f58: goto c833b; D5c5d: $startDataDate->modify(sprintf("\53\45\x30\x35\144\40\155\x69\156\x75\164\145\163", $minuteInterval)); goto c3eea; Bb0df: a1f53: goto D5bb5; b45c5: $cpuData[] = $averageCpuValue; goto D5c5d; D5bb5: if (!($endDataDate <= $endTime)) { goto F3f58; } goto B6ef3; Ee3aa: } private function getMemoryDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto f6c2f; Ff830: $endDataDate = clone $startTime; goto E9705; d9641: $endDataDate->modify(sprintf("\53\45\x30\x35\x64\x20\155\151\x6e\165\164\x65\x73", $minuteInterval)); goto C089a; Dde0d: return $memoryData; goto efe8a; f9712: b1028: goto Dde0d; C39a3: if (!($endDataDate <= $endTime)) { goto b1028; } goto df591; ba3dd: $memoryData[] = (int) $averageMemoryValue; goto fe474; C089a: goto C19ed; goto f9712; f6c2f: $memoryData = []; goto Ed7f3; fe474: $startDataDate->modify(sprintf("\x2b\x25\x30\x35\x64\40\155\151\156\x75\164\145\x73", $minuteInterval)); goto d9641; E9705: C19ed: goto C39a3; df591: $averageMemoryValue = $this->instanceMemoryEntityManager->getAverageMemoryValue($startDataDate, $endDataDate); goto ba3dd; Ed7f3: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\x30\x35\x64\x20\x6d\151\x6e\x75\x74\x65\163", $minuteInterval)); goto Ff830; efe8a: } private function getDiskDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto Df29a; Dab97: c975b: goto Fa87b; Ab969: if (!($endDataDate <= $endTime)) { goto c975b; } goto d4e28; B5c2b: Cdfe1: goto E63e7; F5647: E352e: goto Ab969; Df29a: $diskData = []; goto A6b20; E468a: goto E352e; goto Dab97; A5985: $endDataDate->modify(sprintf("\53\45\x30\x35\x64\x20\155\151\x6e\x75\x74\145\163", $minuteInterval)); goto E468a; d4e28: foreach (["\57", "\57\x68\x6f\155\x65"] as $disk) { goto Da311; E70ef: B95eb: goto Abc4a; Abc4a: $diskData["\162\x6f\157\x74"][] = (int) $averageDiskSizeValue; goto Cef44; Da311: $averageDiskSizeValue = (int) $this->instanceDiskUsageEntityManager->getAverageDiskSizeValue($disk, $startDataDate, $endDataDate); goto dfe75; Bcc68: d8251: goto ea59d; c5931: $diskData["\150\157\x6d\x65"][] = (int) $averageDiskSizeValue; goto ca074; Cef44: D0731: goto Bcc68; ca074: goto D0731; goto E70ef; dfe75: if ("\57" == $disk) { goto B95eb; } goto c5931; ea59d: } goto B5c2b; D39c6: $endDataDate = clone $startTime; goto F5647; Fa87b: return $diskData; goto e85dd; A6b20: $startDataDate = (clone $startTime)->modify(sprintf("\55\45\60\65\144\40\x6d\x69\156\165\164\145\x73", $minuteInterval)); goto D39c6; E63e7: $startDataDate->modify(sprintf("\x2b\x25\60\65\x64\x20\x6d\x69\x6e\x75\164\x65\163", $minuteInterval)); goto A5985; e85dd: } private function getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto F6ecd; fa532: return $loadAverageData; goto e03f3; C58b1: goto A59b2; goto c8aa9; B1b6d: $endDataDate->modify(sprintf("\x2b\x25\60\x35\x64\x20\155\151\x6e\165\164\145\163", $minuteInterval)); goto C58b1; B3762: $endDataDate = clone $startTime; goto C0983; c1753: e4a1e: goto A370a; F6ecd: $loadAverageData = []; goto C5823; C5823: $startDataDate = (clone $startTime)->modify(sprintf("\55\x25\60\65\144\40\155\x69\156\165\164\145\163", $minuteInterval)); goto B3762; A370a: $startDataDate->modify(sprintf("\x2b\x25\x30\x35\x64\x20\x6d\151\x6e\165\164\x65\163", $minuteInterval)); goto B1b6d; c3bad: foreach ([InstanceLoadAverageEntity::PERIOD_ONE_MINUTE, InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES, InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] as $period) { goto dbe95; dbe95: $loadAverageValue = $this->instanceLoadAverageEntityManager->getLoadAverageValue($period, $startDataDate, $endDataDate); goto Aa597; Aa597: $loadAverageData[$period][] = round($loadAverageValue, 2); goto E2ce7; E2ce7: e1583: goto d6255; d6255: } goto c1753; c8aa9: Ee6f8: goto fa532; C0983: A59b2: goto B6840; B6840: if (!($endDataDate <= $endTime)) { goto Ee6f8; } goto c3bad; e03f3: } }
