<?php
 namespace App\Controller\Frontend; use Symfony\Component\Form\FormError; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\HttpFoundation\RedirectResponse; use Symfony\Component\Form\Extension\Core\Type\ButtonType; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Component\Security\Core\Exception\InvalidCsrfTokenException; use Symfony\Contracts\Translation\TranslatorInterface; use Symfony\Component\HttpFoundation\Cookie; use Symfony\Component\Form\Form; use Twig\Environment as Twig; use Doctrine\Common\Collections\ArrayCollection; use App\Controller\Controller; use App\Event\EventQueue; use App\Service\Crypto; use App\Service\Logger; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\ReverseProxySite; use App\Entity\Site as SiteEntity; use App\Entity\NodejsSettings; use App\Entity\PhpSettings; use App\Entity\PythonSettings; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\BlockedBot as BlockedBotEntity; use App\Entity\BlockedIp as BlockedIpEntity; use App\Entity\Database as DatabaseEntity; use App\Entity\DatabaseUser as DatabaseUserEntity; use App\Entity\User as UserEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\CronJob as CronJobEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Updater\ReverseProxySite as ReverseProxySiteUpdater; use App\Site\Deleter as SiteDeleter; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Deleter\ReverseProxySite as ReverseProxySiteDeleter; use App\Database\Manager as DatabaseManager; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\BasicAuthManager as BasicAuthEntityManager; use App\Entity\Manager\BlockedIpManager as BlockedIpEntityManager; use App\Entity\Manager\BlockedBotManager as BlockedBotEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\CronJobManager as CronJobEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\NodejsSettingsManager as NodejsSettingsEntityManager; use App\Entity\Manager\FtpUserManager as FtpUserEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Log\LogfileReader; use App\Log\LogsFinder; use App\Log\Parser\NginxAccessLogParser; use App\Log\Parser\NginxErrorLogParser; use App\Log\Parser\PhpFpmErrorLogParser; use App\Site\Parser\DomainName as DomainNameParser; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\LetsEncryptClient; use App\Site\VarnishCache\Client as VarnishCacheClient; class SitesController extends Controller { private const FILE_MANAGER_COOKIE_EXPIRATION = 3; private ConfigManager $configManager; private SiteEntityManager $siteEntityManager; private BasicAuthEntityManager $basicAuthEntityManager; private BlockedIpEntityManager $blockedIpEntityManager; private BlockedBotEntityManager $blockedBotEntityManager; private CertificateEntityManager $certificateEntityManager; private CronJobEntityManager $cronJobEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private NodejsSettingsEntityManager $nodejsSettingsEntityManager; private FtpUserEntityManager $ftpUserEntityManager; private SshUserEntityManager $sshUserEntityManager; private DomainNameParser $domainNameParser; public function __construct(ConfigManager $configManager, SiteEntityManager $siteEntityManager, BasicAuthEntityManager $basicAuthEntityManager, BlockedIpEntityManager $blockedIpEntityManager, BlockedBotEntityManager $blockedBotEntityManager, CertificateEntityManager $certificateEntityManager, CronJobEntityManager $cronJobEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, NodejsSettingsEntityManager $nodejsSettingsEntityManager, FtpUserEntityManager $ftpUserEntityManager, SshUserEntityManager $sshUserEntityManager, DomainNameParser $domainNameParser, TranslatorInterface $translator, Logger $logger) { goto b47db; E99ae: $this->basicAuthEntityManager = $basicAuthEntityManager; goto Fb748; b47db: $this->configManager = $configManager; goto ec2bb; b80ee: $this->blockedBotEntityManager = $blockedBotEntityManager; goto b83d2; e128d: $this->domainNameParser = $domainNameParser; goto D534f; D1d41: $this->ftpUserEntityManager = $ftpUserEntityManager; goto f21b1; Ac9c8: $this->cronJobEntityManager = $cronJobEntityManager; goto dd0e4; dd0e4: $this->databaseEntityManager = $databaseEntityManager; goto A84a9; D534f: parent::__construct($translator, $logger); goto A73b5; Fb748: $this->blockedIpEntityManager = $blockedIpEntityManager; goto b80ee; ec2bb: $this->siteEntityManager = $siteEntityManager; goto E99ae; F2d89: $this->nodejsSettingsEntityManager = $nodejsSettingsEntityManager; goto D1d41; A84a9: $this->databaseUserEntityManager = $databaseUserEntityManager; goto d0074; d0074: $this->databaseServerEntityManager = $databaseServerEntityManager; goto F2d89; f21b1: $this->sshUserEntityManager = $sshUserEntityManager; goto e128d; b83d2: $this->certificateEntityManager = $certificateEntityManager; goto Ac9c8; A73b5: } public function index(Request $request) : Response { goto ab8ee; ab8ee: $user = $this->getUser(); goto Ff231; c873a: $response = $this->render("\106\x72\157\x6e\164\145\156\144\x2f\123\151\164\x65\x2f\151\x6e\144\x65\x78\x2e\x68\x74\155\x6c\56\164\x77\x69\147", ["\165\x73\x65\x72" => $user, "\163\151\x74\x65\163" => $sites]); goto E6d0d; Ff231: $sites = $this->siteEntityManager->getUserSites($user, ["\144\157\x6d\x61\151\x6e\x4e\141\x6d\x65" => "\141\x73\x63"]); goto c873a; E6d0d: return $response; goto C3f07; C3f07: } public function fileManager(Request $request) : Response { goto b2794; A84d7: ae42e: goto Db7c3; cfbf9: $cookieExpirationDate->modify(sprintf("\x2b\45\163\40\x68\157\x75\x72\163", self::FILE_MANAGER_COOKIE_EXPIRATION)); goto Dcf33; a0b8d: if (false === is_null($site)) { goto ae42e; } goto F9a0c; Ff10f: C0889: goto B1338; Dcf33: $data = ["\x75\163\x65\162" => $siteUser, "\154\157\x63\x61\154\x65" => $locale]; goto B2b90; B1338: return $response; goto Cc19b; b0238: $cookieExpirationDate = new \DateTime("\x6e\x6f\167"); goto cfbf9; F9a0c: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\164\x65\x73")); goto F506e; B5b98: $response = $this->render("\x46\x72\157\x6e\x74\x65\156\x64\x2f\x53\x69\x74\145\x2f\x66\151\x6c\x65\55\x6d\x61\156\x61\147\x65\162\x2e\x68\164\155\154\x2e\164\167\x69\x67", ["\x73\151\x74\x65" => $site, "\x66\x69\x6c\145\115\141\156\141\x67\x65\162\x55\x72\x6c" => $fileManagerUrl, "\146\157\162\x6d\105\x72\x72\157\x72\163" => $this->formErrors]); goto Ff10f; b3d44: $session = $request->getSession(); goto a0892; a0892: $locale = $request->getLocale(); goto b0238; D4d7d: $fileManagerUrl = sprintf("\45\x73\57\146\151\x6c\x65\x2d\x6d\141\x6e\x61\147\145\x72\x2f", rtrim($request->getSchemeAndHttpHost(), "\x2f")); goto B5b98; Db7c3: $siteUser = $site->getUser(); goto b3d44; b2794: $site = $this->getSite($request); goto a0b8d; B2b90: $session->set("\x63\154\160\x2d\146\151\x6c\145\x2d\155\141\x6e\141\147\145\x72", $data); goto D4d7d; F506e: goto C0889; goto A84d7; Cc19b: } public function view(Request $request) : Response { goto eae0f; eae0f: $domainName = $request->get("\x64\x6f\x6d\141\x69\x6e\x4e\x61\x6d\145"); goto C19a0; Bfc74: return $response; goto b97ee; C19a0: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\x69\x74\x65\137\x73\x65\164\164\151\156\147\163", ["\144\x6f\x6d\141\x69\156\x4e\x61\x6d\145" => $domainName])); goto Bfc74; b97ee: } public function logs(Request $request) : Response { goto F4663; dc574: $response = $this->render("\x46\162\157\x6e\x74\145\156\144\x2f\123\x69\164\x65\x2f\x6c\x6f\x67\163\56\x68\164\x6d\154\56\164\167\151\147", ["\x73\151\164\145" => $site, "\146\157\x72\155\105\162\162\157\162\163" => $this->formErrors, "\146\x6f\x72\x6d" => $form->createView()]); goto A2365; Ecf30: if (false === is_null($site)) { goto aabc0; } goto c4493; E5a9c: return $response; goto Cbb89; d73d8: goto F62bc; goto ff90e; A2365: F62bc: goto E5a9c; caa85: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto a43b9; F4663: $site = $this->getSite($request); goto Ecf30; c4493: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\145\x73")); goto d73d8; ff90e: aabc0: goto caa85; a43b9: $form = $this->createLogsForm($siteEntity); goto dc574; Cbb89: } private function createLogsForm(SiteEntity $siteEntity) : Form { goto B76cb; Afef4: $form->add("\165\x70\x64\x61\x74\x65", ButtonType::class, ["\141\x74\x74\x72" => ["\x63\154\x61\163\x73" => "\x62\x74\156\40\142\x74\156\55\154\147\40\x62\x74\156\55\x62\x6c\x75\x65\x20\142\164\156\x2d\165\x70\x64\x61\x74\145"], "\x6c\x61\x62\x65\x6c" => "\125\x70\x64\x61\164\145"]); goto B34d3; B34d3: return $form; goto a4f48; B76cb: $form = $this->createForm("\x41\160\x70\x5c\106\x6f\x72\155\134\123\x69\x74\145\114\x6f\147\163\x54\171\160\145", [], ["\x61\143\164\151\x6f\156" => $this->generateUrl("\143\x6c\160\x5f\x73\x69\x74\x65\137\x6c\x6f\x67\163", ["\144\157\155\141\x69\156\x4e\141\155\x65" => $siteEntity->getDomainName()]), "\x6d\145\x74\x68\157\x64" => "\x50\x4f\x53\x54", "\x61\164\x74\x72" => []]); goto Afef4; a4f48: } public function logFileContent(Request $request, Twig $twig) : Response { goto e1a05; D9c30: return $response; goto B3ea9; d745a: $numberOfLines = (int) $request->get("\x6e\x75\x6d\x62\x65\x72\117\x66\x4c\x69\156\x65\x73"); goto c8d6a; c9c81: Bf666: goto F138f; Dae7a: $site = $this->getSite($request); goto C87c8; f031d: $response = $this->json($data); goto D9c30; c8d6a: if (!(false === empty($service) && false === empty($logfileName))) { goto Bf666; } goto Fa620; e1a05: $data = []; goto Dae7a; d5c8f: $logfileName = trim($request->get("\x6c\157\147\106\x69\x6c\145")); goto d745a; C87c8: if (!(false === is_null($site))) { goto c6c13; } goto D0cea; F138f: c6c13: goto f031d; Fa620: try { goto b8692; f9c9b: $phpFpmErrorLogParser = new PhpFpmErrorLogParser($logLines); goto A5f23; cb738: $logfileReader = new LogfileReader($logfile); goto d083a; C76ad: $logMessages = $nginxErrorLogParser->parse(); goto baac2; d083a: $logLines = $logfileReader->getLines($numberOfLines); goto d2099; aa814: A03cf: goto e0d87; F2274: f2187: goto E8526; baac2: $logMessagesHtml = $twig->render("\106\162\x6f\x6e\x74\x65\156\x64\x2f\x53\x69\x74\x65\x2f\x4c\157\x67\163\57\156\x67\151\x6e\x78\55\x65\x72\x72\x6f\x72\x2d\154\x6f\x67\55\x6d\x65\x73\163\x61\x67\145\x73\x2e\150\164\x6d\154\56\164\x77\151\x67", ["\x6c\x6f\147\x4d\x65\x73\x73\x61\147\145\163" => $logMessages]); goto cbe3b; ad600: $nginxErrorLogParser = new NginxErrorLogParser($logLines); goto C76ad; Ab97e: $userTimezone = $user->getTimezone(); goto C41bb; e0d87: $nginxAccessLogParser = new NginxAccessLogParser($logLines); goto E89c8; f1f6c: $logMessages = $nginxAccessLogParser->parse(); goto A6157; Fa594: $user = $this->getUser(); goto Ee420; C41bb: if ("\x61\x63\x63\x65\x73\163\x2e\x6c\157\x67" == substr($logfileName, 0, 10)) { goto A03cf; } goto ad600; E89c8: $nginxAccessLogParser->setTimezone($userTimezone->getName()); goto f1f6c; E8526: if (!("\160\150\x70" == $service)) { goto C74d9; } goto f9c9b; d2099: $logMessagesHtml = ''; goto Fa594; Bfdbc: C74d9: goto cb205; a2f35: $logMessagesHtml = $twig->render("\106\x72\x6f\156\164\x65\x6e\x64\x2f\123\x69\x74\x65\57\x4c\157\x67\163\x2f\x70\x68\160\55\146\160\x6d\x2d\x65\162\162\x6f\162\55\x6c\x6f\147\x2d\155\145\x73\x73\x61\147\x65\x73\56\x68\x74\x6d\154\x2e\x74\167\151\147", ["\154\x6f\147\x4d\145\163\163\x61\147\145\x73" => $logMessages]); goto Bfdbc; cb205: $data["\x6c\x6f\x67\x4d\x65\163\x73\x61\x67\145\163\110\164\x6d\x6c"] = $logMessagesHtml; goto C9cf2; Ebbae: $logfile = sprintf("\x2f\150\x6f\155\x65\57\x25\163\x2f\x6c\x6f\147\163\x2f\x25\x73\57\x25\163", $site->getUser(), $service, $logfileName); goto cb738; Ee420: if (!("\x6e\x67\x69\x6e\x78" == $service)) { goto f2187; } goto Ab97e; A5f23: $logMessages = $phpFpmErrorLogParser->parse(); goto a2f35; f9e28: af79a: goto F2274; A6157: $logMessagesHtml = $twig->render("\x46\x72\x6f\156\164\x65\x6e\x64\x2f\x53\x69\164\x65\57\114\157\x67\x73\57\x6e\147\151\156\170\55\141\143\143\x65\x73\x73\x2d\x6c\x6f\147\55\155\x65\x73\x73\141\147\145\163\x2e\x68\164\x6d\x6c\x2e\164\x77\x69\x67", ["\x6c\157\147\x4d\145\163\163\x61\147\145\x73" => $logMessages]); goto f9e28; b8692: $service = basename($service); goto Ebbae; cbe3b: goto af79a; goto aa814; C9cf2: } catch (\Exception $e) { $this->logger->exception($e); } goto c9c81; D0cea: $service = trim($request->get("\163\x65\162\x76\x69\x63\145")); goto d5c8f; B3ea9: } public function loadLogfilesForService(Request $request) : Response { goto b0154; A4a35: return $response; goto Fa9d6; Beca4: if (!(false === empty($service))) { goto fa399; } goto f3d69; D9403: $response = $this->json($data); goto A4a35; b0154: $data = []; goto B6ea5; C8621: Cbed2: goto D9403; B6ea5: $site = $this->getSite($request); goto a68da; a6ec8: fa399: goto C8621; f3d69: try { goto Ce05e; c037e: $logfilesDirectory = sprintf("\57\150\x6f\155\x65\x2f\45\x73\x2f\x6c\157\x67\163\57\45\x73\x2f", $site->getUser(), $service); goto dcff3; a9fc3: $logfiles = $logsFinder->getLogfiles(); goto C8bb6; dcff3: $logsFinder = new LogsFinder($logfilesDirectory); goto a9fc3; C1f06: Fbc1c: goto bcaeb; C8bb6: if (!(false === empty($logfiles))) { goto Fbc1c; } goto Eed75; Ce05e: $service = basename($service); goto c037e; Eed75: $data["\x6c\157\x67\146\x69\x6c\145\163"] = $logfiles; goto C1f06; bcaeb: } catch (\Exception $e) { $this->logger->exception($e); } goto a6ec8; a68da: if (!(false === is_null($site))) { goto Cbed2; } goto Ea283; Ea283: $service = trim($request->get("\163\x65\162\x76\x69\143\145")); goto Beca4; Fa9d6: } public function cronJobs(Request $request) : Response { goto d7ae0; B7e1b: A0481: goto Ce634; Ee467: goto A0481; goto f2a07; D9142: if (false === is_null($site)) { goto d2fbf; } goto f26e8; d7ae0: $site = $this->getSite($request); goto D9142; Ce634: return $response; goto Cd857; f2a07: d2fbf: goto Ee6c8; Ee6c8: $response = $this->render("\106\162\157\x6e\164\x65\x6e\144\57\x53\151\x74\x65\x2f\143\162\x6f\x6e\55\152\x6f\x62\x73\56\150\x74\x6d\154\56\x74\x77\151\x67", ["\x73\151\x74\x65" => $site, "\x66\157\x72\x6d\105\162\x72\157\162\x73" => $this->formErrors]); goto B7e1b; f26e8: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\x73\x69\x74\145\163")); goto Ee467; Cd857: } public function newCronJob(Request $request) : Response { goto bc74b; f5dca: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\151\164\x65\163")); goto E0049; b9185: $form = $this->createCronJobForm($cronJobEntity); goto Cceaa; df4d2: $response = $this->render("\x46\162\157\x6e\x74\x65\156\144\57\123\x69\164\x65\57\156\145\167\55\143\162\157\x6e\x2d\x6a\157\142\56\150\164\155\154\x2e\164\x77\151\x67", ["\163\x69\164\145" => $site, "\x66\157\x72\155" => $form->createView(), "\146\x6f\x72\x6d\105\162\x72\157\162\x73" => $this->formErrors]); goto e1157; F8e27: ff56d: goto fa606; Be277: Df6d2: goto dca90; bc74b: $site = $this->getSite($request); goto Cbcac; fa606: Dd892: goto df4d2; dca90: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto db346; A2bfb: if (!(false === is_null($response))) { goto E73c1; } goto e17e4; bc8f0: return $response; goto A1477; B1eca: if (!(true === $form->isSubmitted())) { goto ff56d; } goto Abe9c; Feee9: E73c1: goto F8e27; e1157: Fe919: goto bc8f0; Cbcac: if (false === is_null($site)) { goto Df6d2; } goto f5dca; E41e7: $cronJobEntity->setSite($siteEntity); goto b9185; fac23: $form->handleRequest($request); goto B1eca; Cceaa: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto Dd892; } goto fac23; E0049: goto Fe919; goto Be277; db346: $cronJobEntity = $this->cronJobEntityManager->createEntity(); goto E41e7; e17e4: return $response; goto Feee9; Abe9c: $response = $this->handleCronJobForm($request, $form, $site); goto A2bfb; A1477: } private function createCronJobForm(CronJobEntity $cronJobEntity) : Form { goto Eb1c2; Bb86c: $form = $this->createForm("\x41\160\160\x5c\106\157\162\x6d\134\x53\151\164\145\103\x72\x6f\x6e\x4a\x6f\x62\124\x79\160\x65", $cronJobEntity, ["\x61\x63\x74\151\x6f\156" => $this->generateUrl("\x63\x6c\160\137\163\x69\x74\145\137\x63\x72\x6f\x6e\x5f\x6a\x6f\142\137\x6e\145\x77", ["\144\x6f\x6d\141\x69\156\116\x61\155\145" => $siteEntity->getDomainName()]), "\x6d\x65\164\x68\157\x64" => "\120\117\x53\124", "\141\164\164\x72" => []]); goto bc663; Eb1c2: $siteEntity = $cronJobEntity->getSite(); goto Bb86c; fc2e8: return $form; goto a18b7; bc663: $form->add("\163\x75\142\155\x69\x74", SubmitType::class, ["\x61\x74\164\162" => ["\x63\154\141\163\x73" => "\142\164\156\40\142\164\x6e\x2d\x62\154\x75\145\x20\142\x74\x6e\55\x6c\147"], "\154\141\x62\145\x6c" => "\101\x64\144\40\103\x72\157\x6e\40\x4a\x6f\x62"]); goto fc2e8; a18b7: } private function handleCronJobForm(Request $request, Form $form, Site $site) { goto A16ef; Ab1fc: Dbb98: goto c95d2; b4a45: $this->formErrors = $this->getErrorMessages($form); goto a5862; a5862: goto Bf16f; goto Ab1fc; A16ef: if (true === $form->isValid()) { goto Dbb98; } goto b4a45; Af657: Bf16f: goto Cab2e; c95d2: try { goto C060a; A9742: $user = $this->getUser(); goto ae696; a6678: $siteUpdater->updateUserCrontab(); goto Daec5; Ae877: $siteEntity->addCronJob($cronJobEntity); goto Bc0cd; c2bd5: $session->getFlashBag()->set("\163\165\143\x63\145\x73\163", $this->translator->trans("\103\162\157\x6e\x20\112\157\142\40\x68\141\163\x20\142\x65\x65\x6e\40\141\144\144\x65\x64\56")); goto Ed35c; Ed35c: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\x73\x69\164\145\137\x63\x72\157\x6e\137\152\157\142\x73", ["\x64\x6f\155\x61\x69\x6e\x4e\x61\155\145" => $site->getDomainName()])); goto B4479; b6ecd: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\145\x73")); goto Dcc7b; Bc0cd: $site->setCronJobs($siteEntity->getCronJobs()); goto e4687; bf490: $siteUpdater = $this->getSiteUpdater($site); goto a6678; e2830: return $response; goto F0c3a; d0f84: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_ADD, $user, $eventData, $request); goto c2bd5; Ad506: $siteEntity = $this->getSiteEntity($domainName); goto b273a; e4687: $this->siteEntityManager->updateEntity($siteEntity); goto bf490; ae696: $cronJobEntity = $form->getData(); goto Ae877; Dcc7b: goto Ef616; goto a1be9; a1be9: C2f83: goto A9742; ef2c5: $domainName = $site->getDomainName(); goto Ad506; Daec5: $eventData = ["\163\x69\x74\x65" => $domainName, "\x63\162\157\x6e\164\x61\142\105\170\160\x72\145\x73\x73\151\x6f\156" => $cronJobEntity->getCrontabExpression()]; goto d0f84; b273a: if (false === is_null($siteEntity)) { goto C2f83; } goto b6ecd; C060a: $session = $request->getSession(); goto ef2c5; B4479: Ef616: goto e2830; F0c3a: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\x65\162", $this->translator->trans("\101\x6e\40\x65\162\162\x6f\x72\x20\x68\x61\163\40\x6f\143\x63\165\x72\x72\145\144\54\x20\x65\x72\x72\157\162\x20\x6d\x65\163\163\x61\147\x65\x3a\x20\45\145\x72\x72\x6f\x72\x4d\145\163\x73\141\147\x65\45", ["\45\145\x72\162\x6f\x72\x4d\145\163\x73\141\x67\x65\x25" => $e->getMessage()])); } goto Af657; Cab2e: } public function deleteCronJob(Request $request) : Response { goto deb77; deb77: $site = $this->getSite($request); goto D91b2; e2429: try { goto Ea3f9; da3d6: if (!(false === is_null($siteEntity) && false === is_null($cronJobEntity))) { goto Dc1cb; } goto e188f; Cd116: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto da3d6; f78b7: if (!($siteEntity->getDomainName() == $cronJobSiteEntity->getDomainName())) { goto ab866; } goto B185a; e3b29: $domainName = $site->getDomainName(); goto ea80e; bcee4: $siteUpdater->updateUserCrontab(); goto B7681; C47dc: ab866: goto b37fb; e188f: $cronJobSiteEntity = $cronJobEntity->getSite(); goto f78b7; B310e: $id = (int) $request->get("\x69\x64"); goto e3b29; B7681: $evenData = ["\163\x69\164\145" => $domainName, "\143\x6f\x6d\155\x61\156\x64" => $cronJobEntity->getCommand()]; goto b8ce3; Ff1a1: $siteEntity->removeCronJob($cronJobEntity); goto c2977; Ea3f9: $session = $request->getSession(); goto B310e; c2977: $site->setCronJobs($siteEntity->getCronJobs()); goto bf7cc; E91ac: $siteUpdater = $this->getSiteUpdater($site); goto bcee4; fc619: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\151\164\145\x5f\x63\162\x6f\x6e\137\152\157\x62\163", ["\x64\157\x6d\x61\151\x6e\x4e\141\x6d\x65" => $site->getDomainName()])); goto B3470; b8ce3: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_DELETE, $user, $evenData, $request); goto Bfcda; bf7cc: $this->siteEntityManager->updateEntity($siteEntity); goto E91ac; Bfcda: $session->getFlashBag()->set("\163\x75\x63\143\145\163\x73", $this->translator->trans("\103\162\157\156\x20\x4a\157\142\x20\150\141\163\x20\x62\x65\x65\x6e\40\x64\x65\x6c\x65\x74\145\144\x2e")); goto fc619; b37fb: Dc1cb: goto cd1fc; ea80e: $siteEntity = $this->getSiteEntity($domainName); goto Cd116; B3470: return $response; goto C47dc; B185a: $user = $this->getUser(); goto Ff1a1; cd1fc: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\145\x72", $this->translator->trans("\101\x6e\x20\x65\162\x72\157\x72\40\150\141\163\x20\x6f\143\143\165\162\162\x65\x64\54\40\145\x72\x72\x6f\162\x20\x6d\x65\x73\x73\141\x67\145\72\x20\45\x65\x72\162\x6f\x72\x4d\145\163\x73\141\x67\145\x25", ["\45\x65\162\162\x6f\162\115\145\163\x73\141\x67\x65\x25" => $e->getMessage()])); } goto e85bd; D0eca: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\x74\145\163")); goto Af789; Af789: return $response; goto B7b9b; D91b2: $this->checkCsrfToken($request, "\143\x72\x6f\x6e\x6a\x6f\x62\55\x64\x65\x6c\x65\164\145"); goto Ef255; Ef255: if (!(false === is_null($site))) { goto c5945; } goto e2429; e85bd: c5945: goto D0eca; B7b9b: } public function editCronJob(Request $request) : Response { goto E0772; E6f3f: return $response; goto B4fa3; f76f9: d4a93: goto E6f3f; F373f: $site = $this->getSite($request); goto Be6db; Bf4eb: $response = $this->render("\106\x72\157\156\x74\145\x6e\x64\57\x53\x69\164\x65\x2f\x65\144\151\164\x2d\143\162\x6f\156\x2d\152\157\142\x2e\x68\x74\x6d\x6c\56\164\167\x69\x67", ["\163\x69\164\x65" => $site, "\146\x6f\x72\x6d" => $form->createView(), "\146\x6f\162\x6d\105\162\162\x6f\162\x73" => $this->formErrors]); goto f76f9; Ac74e: goto d4a93; goto d20b3; F65eb: if (!(true === $form->isSubmitted())) { goto D91ca; } goto A825f; a741c: Ecc34: goto B59dc; b3910: a38df: goto Bf4eb; e4c23: if (!(false === is_null($response))) { goto Ecc34; } goto c942e; B18dc: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto a38df; } goto B866c; B59dc: D91ca: goto b3910; B866c: $form->handleRequest($request); goto F65eb; d20b3: adbb7: goto Aeb2f; Ef412: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\164\145\x73")); goto Ac74e; c942e: return $response; goto a741c; Be6db: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto c6eab; E0772: $id = (int) $request->get("\x69\144"); goto F373f; Aeb2f: $form = $this->createCronJobEditForm($cronJobEntity); goto B18dc; c6eab: if (false === is_null($cronJobEntity) && false === is_null($site) && $cronJobEntity->getSite()->getDomainName() == $site->getDomainName()) { goto adbb7; } goto Ef412; A825f: $response = $this->handleCronJobEditForm($request, $form, $site); goto e4c23; B4fa3: } private function createCronJobEditForm(CronJobEntity $cronJobEntity) : Form { goto E02a1; D081c: return $form; goto F3708; f4e8f: $form = $this->createForm("\101\x70\160\134\x46\x6f\x72\x6d\x5c\123\x69\x74\x65\103\x72\157\x6e\112\157\142\x45\144\x69\164\x54\171\160\x65", $cronJobEntity, ["\141\143\164\x69\x6f\156" => $this->generateUrl("\x63\154\160\137\163\151\164\145\x5f\143\x72\x6f\x6e\137\x6a\157\x62\x5f\x65\x64\151\x74", ["\x64\157\155\x61\x69\156\116\x61\x6d\145" => $siteEntity->getDomainName(), "\x69\144" => $cronJobEntity->getId()]), "\x6d\145\164\150\x6f\x64" => "\120\117\123\124", "\x61\x74\164\162" => []]); goto b82b8; E02a1: $siteEntity = $cronJobEntity->getSite(); goto f4e8f; b82b8: $form->add("\163\165\x62\155\x69\164", SubmitType::class, ["\x61\x74\x74\162" => ["\x63\154\141\x73\x73" => "\142\164\x6e\40\142\x74\x6e\55\x62\x6c\165\x65\40\x62\x74\x6e\x2d\x6c\147"], "\154\141\142\x65\154" => "\123\141\x76\145"]); goto D081c; F3708: } private function handleCronJobEditForm(Request $request, Form $form, Site $site) { goto b6115; Df0b8: try { goto a51ca; a929c: $siteEntity = $this->getSiteEntity($domainName); goto ecac1; C0086: $domainName = $site->getDomainName(); goto a929c; E6c9a: $eventData = ["\163\151\164\x65" => $domainName, "\x63\162\157\156\x74\141\142\105\170\x70\162\145\x73\x73\151\x6f\156" => $cronJobEntity->getCrontabExpression()]; goto d3cbb; bcabc: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\163")); goto a0fdf; d239c: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\x73", $this->translator->trans("\x43\162\x6f\156\40\x4a\157\x62\x20\x68\141\x73\x20\142\145\x65\x6e\40\x73\x61\x76\145\144\56")); goto a4aee; ecac1: if (false === is_null($siteEntity)) { goto a7109; } goto bcabc; a4aee: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\164\x65\137\x63\x72\157\156\137\152\x6f\x62\x73", ["\x64\x6f\155\x61\151\x6e\116\x61\155\145" => $site->getDomainName()])); goto E9237; addab: $siteUpdater->updateUserCrontab(); goto E6c9a; b25ad: $site->setCronJobs($siteEntity->getCronJobs()); goto a9eda; Ca44c: a7109: goto d8397; db8e5: $siteEntity->addCronJob($cronJobEntity); goto b25ad; d3cbb: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_EDIT, $user, $eventData, $request); goto d239c; a0fdf: goto d0115; goto Ca44c; aec52: return $response; goto db237; d8397: $user = $this->getUser(); goto e075e; E9237: d0115: goto aec52; b80c7: $siteUpdater = $this->getSiteUpdater($site); goto addab; a51ca: $session = $request->getSession(); goto C0086; a9eda: $this->siteEntityManager->updateEntity($siteEntity); goto b80c7; e075e: $cronJobEntity = $form->getData(); goto db8e5; db237: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\x65\162", $this->translator->trans("\x41\156\40\x65\162\162\x6f\162\40\150\141\163\x20\157\x63\x63\165\162\162\145\144\54\x20\x65\x72\162\157\162\40\x6d\145\x73\x73\141\147\x65\x3a\x20\x25\x65\x72\162\157\162\x4d\x65\163\163\141\147\x65\x25", ["\45\x65\162\x72\x6f\x72\x4d\x65\x73\163\x61\147\145\45" => $e->getMessage()])); } goto ffa06; D96b1: D3fe5: goto Df0b8; b6115: if (true === $form->isValid()) { goto D3fe5; } goto Ba6c8; A6219: goto a4c4f; goto D96b1; ffa06: a4c4f: goto ca29b; Ba6c8: $this->formErrors = $this->getErrorMessages($form); goto A6219; ca29b: } public function users(Request $request) : Response { goto c6c43; c478e: return $response; goto dad01; Bc5d1: goto d3cb0; goto Bc96e; a537c: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\164\x65\x73")); goto Bc5d1; Bc96e: e8c29: goto a8f0c; d4e76: if (false === is_null($site)) { goto e8c29; } goto a537c; B68eb: d3cb0: goto c478e; c6c43: $site = $this->getSite($request); goto d4e76; a8f0c: $response = $this->render("\x46\x72\157\156\164\145\x6e\x64\x2f\123\151\164\x65\57\x75\163\x65\x72\163\x2e\150\164\x6d\x6c\56\x74\x77\151\x67", ["\x73\x69\x74\145" => $site, "\146\x6f\162\x6d\x45\x72\x72\157\x72\163" => $this->formErrors]); goto B68eb; dad01: } public function newFtpUser(Request $request) : Response { goto B7e36; c89f1: $form->handleRequest($request); goto A5959; F28c2: A23e8: goto D354e; Cf2de: $form = $this->createFtpUserForm($ftpUserEntity); goto e0452; E02a4: $response = $this->handleFtpUserForm($request, $form, $site); goto a3756; A4cb2: if (false === is_null($site)) { goto Bc6c2; } goto Bd264; b0967: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto a3700; D354e: b1b80: goto E28fc; f13fa: return $response; goto D5436; E28fc: $response = $this->render("\x46\x72\x6f\x6e\164\x65\156\144\x2f\x53\x69\x74\x65\57\156\145\167\x2d\146\x74\160\x2d\165\163\145\x72\56\150\164\x6d\x6c\56\164\x77\151\147", ["\x73\x69\164\145" => $site, "\146\157\x72\155" => $form->createView(), "\x66\x6f\x72\155\105\162\162\x6f\x72\163" => $this->formErrors]); goto ae624; B7e36: $site = $this->getSite($request); goto A4cb2; Bd264: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\151\x74\x65\x73")); goto f91d2; B0d3a: $ftpUserEntity->setSite($siteEntity); goto Cf2de; a3700: $ftpUserEntity = $this->ftpUserEntityManager->createEntity(); goto B0d3a; ae624: c0a07: goto fbaaf; D5436: e625e: goto F28c2; f91d2: goto c0a07; goto F90b4; a3756: if (!(false === is_null($response))) { goto e625e; } goto f13fa; F90b4: Bc6c2: goto b0967; e0452: if (!(true === $request->isMethod("\120\117\123\124"))) { goto b1b80; } goto c89f1; A5959: if (!(true === $form->isSubmitted())) { goto A23e8; } goto E02a4; fbaaf: return $response; goto F5e9e; F5e9e: } private function createFtpUserForm(FtpUserEntity $ftpUserEntity) : Form { goto B002a; b0bf0: return $form; goto C7bf5; B002a: $siteEntity = $ftpUserEntity->getSite(); goto ba438; ba438: $form = $this->createForm("\101\160\x70\134\x46\x6f\x72\x6d\x5c\123\x69\x74\145\106\164\160\125\163\x65\162\x54\x79\x70\145", $ftpUserEntity, ["\141\x63\164\x69\x6f\x6e" => $this->generateUrl("\143\154\x70\x5f\x73\151\164\x65\137\x66\x74\x70\137\x75\x73\x65\x72\x5f\x6e\x65\x77", ["\144\x6f\x6d\141\x69\156\116\x61\x6d\x65" => $siteEntity->getDomainName()]), "\155\x65\164\x68\x6f\x64" => "\120\x4f\x53\x54", "\x61\164\164\162" => []]); goto B677a; B677a: $form->add("\x73\165\142\155\151\x74", SubmitType::class, ["\x61\164\x74\162" => ["\x63\x6c\141\163\163" => "\142\x74\156\40\142\x74\x6e\55\x62\x6c\165\x65\40\x62\164\x6e\55\154\147"], "\x6c\x61\142\145\154" => "\x41\144\144\40\x55\x73\145\x72"]); goto b0bf0; C7bf5: } private function handleFtpUserForm(Request $request, Form $form, Site $site) { goto Acf6c; bb5e5: a5a13: goto B456a; f4b7e: try { goto C93ef; e2801: $siteEntity = $this->getSiteEntity($domainName); goto Af4eb; Cb558: $session->getFlashBag()->set("\x73\165\x63\143\145\163\x73", $this->translator->trans("\x55\x73\x65\162\x20\150\x61\163\40\142\145\x65\156\x20\141\144\x64\x65\144\x2e")); goto C2c2a; Fd650: $domainName = $site->getDomainName(); goto e2801; a58e9: d13be: goto d4e39; A03c9: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_ADD, $user, $eventData, $request); goto Cb558; D62fd: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\x69\164\145\x73")); goto Fd5eb; C087f: $this->siteEntityManager->updateEntity($siteEntity); goto cda24; B16cf: $siteUpdater->createFtpUser($ftpUserEntity); goto A31e3; b47c9: return $response; goto c1c76; E4359: $siteEntity->addFtpUser($ftpUserEntity); goto C087f; cda24: $siteUpdater = $this->getSiteUpdater($site); goto B16cf; A31e3: $eventData = ["\163\151\164\145" => $domainName, "\165\163\x65\162\116\x61\x6d\x65" => $ftpUserName, "\150\x6f\x6d\145\104\151\x72\x65\143\x74\157\x72\171" => $ftpUserEntity->getHomeDirectory()]; goto A03c9; D8aa0: $ftpUserPassword = $form->get("\x70\x61\163\163\167\157\x72\x64")->getData(); goto Ecdc7; C93ef: $session = $request->getSession(); goto Fd650; C2c2a: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\x69\164\x65\x5f\165\163\x65\x72\163", ["\144\x6f\x6d\x61\151\156\x4e\x61\x6d\145" => $site->getDomainName()])); goto Accd7; Ecdc7: $ftpUserEntity->setPassword($ftpUserPassword); goto E4359; A8fc7: $ftpUserName = $ftpUserEntity->getUserName(); goto D8aa0; Fd5eb: goto F889e; goto a58e9; Cc0ba: $ftpUserEntity = $form->getData(); goto A8fc7; Accd7: F889e: goto b47c9; Af4eb: if (false === is_null($siteEntity)) { goto d13be; } goto D62fd; d4e39: $user = $this->getUser(); goto Cc0ba; c1c76: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\145\x72", $this->translator->trans("\x41\156\40\x65\x72\162\x6f\x72\x20\150\x61\163\x20\x6f\143\143\x75\x72\162\145\144\54\x20\145\x72\x72\x6f\162\40\x6d\145\163\x73\141\147\x65\x3a\x20\x25\145\162\162\157\x72\x4d\145\x73\x73\141\x67\x65\x25", ["\45\x65\x72\x72\157\162\x4d\145\163\x73\141\x67\145\45" => $e->getMessage()])); } goto bb5e5; Fa4e1: $this->formErrors = $this->getErrorMessages($form); goto E667f; Acf6c: if (true === $form->isValid()) { goto f2802; } goto Fa4e1; E667f: goto a5a13; goto Ec43e; Ec43e: f2802: goto f4b7e; B456a: } public function editFtpUser(Request $request) : Response { goto ce658; bcae5: return $response; goto Ded1b; Ddbb4: b6f98: goto fffe0; decb7: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\164\x65\163")); goto f7809; ec857: if (false === is_null($ftpUserEntity) && false === is_null($site) && $ftpUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto Ce690; } goto decb7; f7809: goto F4ccf; goto ee144; fffe0: $response = $this->render("\x46\162\157\156\x74\145\x6e\x64\x2f\x53\151\x74\145\57\x65\144\151\164\55\x66\x74\160\x2d\x75\x73\x65\162\x2e\150\164\x6d\154\56\164\167\x69\147", ["\163\151\164\x65" => $site, "\146\x6f\162\x6d" => $form->createView(), "\x66\x6f\162\x6d\x45\x72\x72\x6f\162\x73" => $this->formErrors]); goto D0e8e; e4dfe: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto ec857; ce658: $userName = $request->get("\165\163\145\162\116\x61\x6d\x65"); goto cdf50; D0e8e: F4ccf: goto bcae5; De0be: $form->handleRequest($request); goto Cb0b0; e7682: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto b6f98; } goto De0be; Fbe2e: $form = $this->createFtpUserEditForm($ftpUserEntity); goto e7682; D9d72: $response = $this->handleFtpUserEditForm($request, $form, $site); goto ac10a; A8397: ae13b: goto F9402; Cb0b0: if (!(true === $form->isSubmitted())) { goto cdcb9; } goto D9d72; cdf50: $site = $this->getSite($request); goto e4dfe; F9402: cdcb9: goto Ddbb4; E8317: return $response; goto A8397; ee144: Ce690: goto Fbe2e; ac10a: if (!(false === is_null($response))) { goto ae13b; } goto E8317; Ded1b: } private function createFtpUserEditForm(FtpUserEntity $ftpUserEntity) : Form { goto a7715; a7715: $siteEntity = $ftpUserEntity->getSite(); goto d56a9; Fd4e7: $form->add("\x73\x75\142\x6d\x69\164", SubmitType::class, ["\141\x74\164\x72" => ["\143\154\x61\x73\x73" => "\142\x74\156\40\x62\164\156\55\142\x6c\x75\x65\40\142\x74\x6e\55\x6c\147"], "\154\141\142\145\154" => "\x53\x61\x76\145"]); goto fdf9e; d56a9: $form = $this->createForm("\101\x70\x70\x5c\106\157\x72\155\x5c\x53\x69\x74\x65\x46\164\x70\125\x73\145\162\x45\144\151\x74\x54\x79\x70\x65", $ftpUserEntity, ["\141\x63\x74\x69\157\156" => $this->generateUrl("\x63\154\160\x5f\x73\151\x74\145\x5f\x66\164\160\137\x75\163\145\x72\x5f\x65\144\151\x74", ["\144\157\155\x61\x69\x6e\116\141\155\145" => $siteEntity->getDomainName(), "\165\x73\x65\162\x4e\x61\155\x65" => $ftpUserEntity->getUserName()]), "\155\x65\164\150\x6f\x64" => "\x50\x4f\x53\x54", "\x61\164\x74\x72" => []]); goto Fd4e7; fdf9e: return $form; goto acd49; acd49: } private function handleFtpUserEditForm(Request $request, Form $form, Site $site) { goto Fe9c4; Bdfeb: goto c0bdf; goto C304b; Fe9c4: if (true === $form->isValid()) { goto ea06d; } goto B5aa7; C304b: ea06d: goto a237d; f4f8d: c0bdf: goto c40a0; a237d: try { goto b88be; Aa2a6: Dbde3: goto D949a; b4962: $siteUpdater->changeUserHomeDirectory($ftpUserName, $ftpUserHomeDirectory); goto a5a74; F5b12: $ftpUserName = $ftpUserEntity->getUserName(); goto e0a5b; e74a1: F8519: goto Ffce0; C658d: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\x74\145\x5f\x75\x73\145\162\163", ["\x64\157\155\141\x69\156\x4e\x61\x6d\x65" => $site->getDomainName()])); goto e74a1; Fcef5: $siteEntity = $this->getSiteEntity($domainName); goto ecd30; cd32b: B48ac: goto bcb38; Ccec0: $siteUpdater->changeUserPassword($ftpUserName, $ftpUserPassword); goto Aa2a6; ef3d3: $ftpUserEntity = $form->getData(); goto F5b12; Ffce0: return $response; goto F29af; b88be: $session = $request->getSession(); goto C3fd2; b22f1: goto F8519; goto cd32b; E420a: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\151\x74\145\163")); goto b22f1; a5a74: if (!(false === empty($ftpUserPassword))) { goto Dbde3; } goto Ccec0; ccdd4: $siteUpdater = $this->getSiteUpdater($site); goto b4962; bcb38: $user = $this->getUser(); goto ef3d3; cae4a: $session->getFlashBag()->set("\x73\165\x63\x63\145\x73\x73", $this->translator->trans("\x55\x73\145\162\40\150\141\163\40\x62\145\145\x6e\40\163\141\x76\145\x64\56")); goto C658d; e0a5b: $ftpUserPassword = $form->get("\160\141\x73\163\x77\157\162\144")->getData(); goto cbfe3; C3fd2: $domainName = $site->getDomainName(); goto Fcef5; D949a: $eventData = ["\x73\x69\x74\145" => $domainName, "\x75\163\145\x72\x4e\x61\x6d\x65" => $ftpUserName, "\150\157\x6d\145\x44\151\x72\145\x63\164\157\162\x79" => $ftpUserHomeDirectory]; goto d7abc; cbfe3: $ftpUserHomeDirectory = $ftpUserEntity->getHomeDirectory(); goto c000a; ecd30: if (false === is_null($siteEntity)) { goto B48ac; } goto E420a; c000a: $this->siteEntityManager->updateEntity($siteEntity); goto ccdd4; d7abc: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_EDIT, $user, $eventData, $request); goto cae4a; F29af: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\x41\x6e\x20\145\x72\x72\x6f\162\40\150\x61\x73\x20\x6f\x63\143\165\162\162\x65\144\54\x20\145\x72\x72\x6f\162\40\x6d\x65\163\163\141\x67\x65\72\40\45\145\162\x72\x6f\x72\115\145\163\x73\141\147\x65\45", ["\x25\145\x72\162\x6f\x72\x4d\x65\163\163\x61\147\x65\x25" => $e->getMessage()])); } goto f4f8d; B5aa7: $this->formErrors = $this->getErrorMessages($form); goto Bdfeb; c40a0: } public function deleteFtpUser(Request $request) : Response { goto a5183; eb6c1: b22c4: goto F6432; b0435: if (!(false === is_null($site))) { goto b22c4; } goto Ecaf4; c3602: return $response; goto F922d; A7864: $this->checkCsrfToken($request, "\165\x73\145\x72\55\x64\x65\154\145\x74\145"); goto b0435; F6432: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\x74\145\163")); goto c3602; Ecaf4: try { goto c5764; Cd362: $siteEntity->removeFtpUser($ftpUserEntity); goto E592c; f5a76: $siteEntity = $this->getSiteEntity($domainName); goto dbbd6; F7612: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($ftpUserEntity))) { goto b12db; } goto C8ef9; F3707: $userName = $request->get("\x75\x73\x65\162\116\141\x6d\x65"); goto E7218; d83cf: $session->getFlashBag()->set("\x73\x75\x63\143\145\163\x73", $this->translator->trans("\125\x73\145\162\x20\x68\x61\163\40\142\x65\x65\x6e\40\144\145\x6c\x65\164\x65\144\x2e")); goto E545a; dfa68: ad0be: goto ac81a; A1489: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_DELETE, $user, $evenData, $request); goto d83cf; E545a: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\151\164\x65\137\x75\x73\x65\x72\x73", ["\x64\157\155\141\x69\x6e\x4e\x61\x6d\x65" => $site->getDomainName()])); goto d8d19; C8ef9: $ftpUserSiteEntity = $ftpUserEntity->getSite(); goto C5ae6; ac81a: b12db: goto C8617; E7218: $domainName = $site->getDomainName(); goto f5a76; B57e7: $siteUpdater->deleteUser($userName, false); goto Aceec; a4a77: $userName = $ftpUserEntity->getUserName(); goto Cd362; eac8e: $user = $this->getUser(); goto a4a77; c5764: $session = $request->getSession(); goto F3707; D652c: $siteUpdater = $this->getSiteUpdater($site); goto B57e7; d8d19: return $response; goto dfa68; Aceec: $evenData = ["\x73\x69\164\145" => $domainName, "\x75\x73\x65\162\116\141\155\145" => $userName]; goto A1489; dbbd6: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto F7612; C5ae6: if (!($siteEntity->getDomainName() == $ftpUserSiteEntity->getDomainName())) { goto ad0be; } goto eac8e; E592c: $this->siteEntityManager->updateEntity($siteEntity); goto D652c; C8617: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\162", $this->translator->trans("\101\156\40\145\162\162\x6f\x72\x20\150\x61\x73\40\x6f\x63\x63\x75\x72\x72\145\x64\x2c\40\145\162\162\x6f\x72\x20\155\x65\x73\163\x61\147\x65\x3a\x20\x25\x65\x72\x72\x6f\162\115\145\163\x73\141\147\145\x25", ["\45\145\162\x72\157\162\115\145\x73\163\x61\147\x65\45" => $e->getMessage()])); } goto eb6c1; a5183: $site = $this->getSite($request); goto A7864; F922d: } public function newSshUser(Request $request) : Response { goto f9310; Ceff1: goto cba57; goto b72de; e9cf3: if (!(false === is_null($response))) { goto fc746; } goto e0809; b72de: A6306: goto be8de; bd615: fc746: goto A6573; b488a: cba57: goto F82a0; be8de: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ff806; dd9c3: $sshUserEntity->setSite($siteEntity); goto F6625; A6573: fb183: goto A9277; F6625: $form = $this->createSshUserForm($sshUserEntity); goto Cc0d5; B6e74: $response = $this->render("\106\x72\x6f\156\x74\145\156\x64\x2f\x53\151\164\145\x2f\x6e\x65\167\55\x73\x73\150\55\165\x73\145\x72\x2e\150\164\x6d\x6c\x2e\x74\x77\151\x67", ["\163\x69\164\x65" => $site, "\x66\157\x72\x6d" => $form->createView(), "\146\157\x72\x6d\x45\x72\162\157\162\163" => $this->formErrors]); goto b488a; A9277: D127b: goto B6e74; D3e5b: $response = $this->handleSshUserForm($request, $form, $site); goto e9cf3; f9310: $site = $this->getSite($request); goto Efcfd; Cc0d5: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto D127b; } goto ef6d9; e7fbc: if (!(true === $form->isSubmitted())) { goto fb183; } goto D3e5b; ff806: $sshUserEntity = $this->sshUserEntityManager->createEntity(); goto dd9c3; ef6d9: $form->handleRequest($request); goto e7fbc; Efcfd: if (false === is_null($site)) { goto A6306; } goto Da5d6; F82a0: return $response; goto C3015; e0809: return $response; goto bd615; Da5d6: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\151\164\x65\163")); goto Ceff1; C3015: } private function createSshUserForm(SshUserEntity $sshUserEntity) : Form { goto D5d75; cd88f: return $form; goto b6ef9; D5d75: $siteEntity = $sshUserEntity->getSite(); goto Fa138; Ae938: $form->add("\163\165\x62\155\x69\164", SubmitType::class, ["\x61\164\x74\162" => ["\x63\x6c\x61\163\x73" => "\142\164\156\x20\x62\164\156\55\x62\154\165\145\x20\x62\164\x6e\x2d\x6c\x67"], "\x6c\141\142\145\154" => "\101\144\x64\x20\x55\x73\x65\162"]); goto cd88f; Fa138: $form = $this->createForm("\101\x70\160\134\106\x6f\162\x6d\x5c\123\x69\x74\145\123\163\150\125\x73\145\162\124\171\x70\x65", $sshUserEntity, ["\141\x63\x74\151\x6f\x6e" => $this->generateUrl("\143\x6c\x70\137\163\x69\x74\145\137\x73\x73\150\x5f\165\163\x65\162\x5f\156\x65\167", ["\144\157\x6d\141\151\156\116\x61\155\145" => $siteEntity->getDomainName()]), "\x6d\145\164\150\x6f\x64" => "\120\x4f\x53\x54", "\141\164\164\162" => []]); goto Ae938; b6ef9: } private function handleSshUserForm(Request $request, Form $form, Site $site) { goto f8949; b8361: cf2bd: goto f93c3; f8949: if (true === $form->isValid()) { goto Bc4bf; } goto f7f7b; A9ce4: Bc4bf: goto E177f; f7f7b: $this->formErrors = $this->getErrorMessages($form); goto fb9fc; fb9fc: goto cf2bd; goto A9ce4; E177f: try { goto A2c39; E3d09: if (false === is_null($siteEntity)) { goto e473f; } goto Fe757; C7297: goto b04c4; goto Dac45; a62f9: Ecc95: goto a14f2; A7876: $sshUserEntity->setPassword($sshUserPassword); goto Cf417; f5942: $this->siteEntityManager->updateEntity($siteEntity); goto c504c; Bcab0: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_ADD, $user, $eventData, $request); goto f3349; b5ed0: $sshUserPassword = $form->get("\x70\141\x73\163\x77\157\162\144")->getData(); goto A7876; Cf417: $sshKeys = $sshUserEntity->getSshKeys(); goto da771; c7b71: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\145\137\165\163\145\162\163", ["\x64\x6f\155\141\x69\x6e\116\x61\155\x65" => $site->getDomainName()])); goto F74d1; ccb05: $domainName = $site->getDomainName(); goto B3454; e69a6: $siteUpdater->createSshUser($sshUserEntity); goto Ef9d9; B3454: $siteEntity = $this->getSiteEntity($domainName); goto E3d09; Fe757: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\x69\164\x65\163")); goto C7297; E4fe8: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto a62f9; Dac45: e473f: goto d85f6; d85f6: $user = $this->getUser(); goto Be670; Be670: $sshUserEntity = $form->getData(); goto e7505; A2481: return $response; goto F7351; A2c39: $session = $request->getSession(); goto ccb05; F74d1: b04c4: goto A2481; f3349: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\x73", $this->translator->trans("\125\163\x65\162\x20\x68\141\163\40\142\145\x65\x6e\x20\141\x64\x64\x65\144\56")); goto c7b71; da771: $siteEntity->addSshUser($sshUserEntity); goto f5942; a14f2: $eventData = ["\x73\151\x74\x65" => $domainName, "\x75\x73\x65\162\116\141\x6d\145" => $sshUserName, "\163\x73\x68\113\145\x79\163" => $sshKeys]; goto Bcab0; e7505: $sshUserName = $sshUserEntity->getUserName(); goto b5ed0; c504c: $siteUpdater = $this->getSiteUpdater($site); goto e69a6; Ef9d9: if (!(false === empty($sshKeys))) { goto Ecc95; } goto E4fe8; F7351: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\145\162", $this->translator->trans("\x41\156\40\145\162\162\157\162\40\x68\141\x73\x20\157\143\143\165\162\162\145\144\54\40\145\x72\x72\x6f\x72\40\x6d\x65\163\163\x61\x67\145\x3a\40\x25\145\x72\x72\157\x72\x4d\145\x73\x73\x61\x67\145\x25", ["\45\x65\x72\162\157\162\x4d\x65\163\x73\x61\x67\x65\45" => $e->getMessage()])); } goto b8361; f93c3: } public function editSshUser(Request $request) : Response { goto cf7de; b3443: $site = $this->getSite($request); goto ad7a1; E4543: a1e5b: goto E8a94; aa882: $response = $this->handleSshUserEditForm($request, $form, $site); goto Dfb6e; F671c: $response = $this->render("\106\x72\157\x6e\164\145\156\x64\57\123\x69\x74\145\x2f\x65\144\151\164\55\x73\163\150\55\x75\x73\145\x72\x2e\x68\164\x6d\154\56\x74\x77\x69\147", ["\163\x69\164\145" => $site, "\x66\x6f\x72\155" => $form->createView(), "\146\157\162\x6d\105\x72\162\157\x72\163" => $this->formErrors]); goto E4543; Afa11: goto a1e5b; goto D034b; Dac82: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\x74\145\163")); goto Afa11; Acb68: return $response; goto e0f81; E8a94: return $response; goto C4031; c2ee2: f2f98: goto Ba297; a1fe2: $form = $this->createSshUserEditForm($sshUserEntity); goto a890b; Fcf4f: if (false === is_null($sshUserEntity) && false === is_null($site) && $sshUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto d98a4; } goto Dac82; ae8ef: if (!(true === $form->isSubmitted())) { goto f2f98; } goto aa882; c8bd4: $form->handleRequest($request); goto ae8ef; ad7a1: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto Fcf4f; Ba297: A4d83: goto F671c; D034b: d98a4: goto a1fe2; cf7de: $userName = $request->get("\x75\163\x65\x72\x4e\141\155\145"); goto b3443; a890b: if (!(true === $request->isMethod("\120\117\123\x54"))) { goto A4d83; } goto c8bd4; Dfb6e: if (!(false === is_null($response))) { goto b80ae; } goto Acb68; e0f81: b80ae: goto c2ee2; C4031: } private function createSshUserEditForm(SshUserEntity $sshUserEntity) : Form { goto f30ed; b2acb: return $form; goto c204b; f30ed: $siteEntity = $sshUserEntity->getSite(); goto A68f1; A68f1: $form = $this->createForm("\x41\160\x70\x5c\x46\x6f\162\x6d\134\123\151\164\145\x53\163\x68\x55\163\145\162\105\144\151\164\124\x79\x70\x65", $sshUserEntity, ["\x61\x63\x74\x69\157\x6e" => $this->generateUrl("\143\154\x70\x5f\x73\x69\x74\x65\x5f\163\x73\150\137\x75\163\x65\162\137\x65\x64\151\164", ["\x64\157\x6d\x61\x69\x6e\116\141\155\x65" => $siteEntity->getDomainName(), "\165\163\145\162\116\x61\155\x65" => $sshUserEntity->getUserName()]), "\x6d\x65\x74\150\x6f\144" => "\x50\117\123\124", "\141\164\164\162" => []]); goto acc14; acc14: $form->add("\x73\165\142\x6d\151\x74", SubmitType::class, ["\x61\x74\164\162" => ["\143\x6c\141\x73\163" => "\142\x74\156\40\142\164\156\55\142\154\165\145\40\142\x74\156\55\x6c\x67"], "\154\x61\x62\x65\154" => "\x53\141\x76\145"]); goto b2acb; c204b: } private function handleSshUserEditForm(Request $request, Form $form, Site $site) { goto F2024; A3445: C99d4: goto D3a53; F2024: if (true === $form->isValid()) { goto C99d4; } goto fed47; fed47: $this->formErrors = $this->getErrorMessages($form); goto Fdcb1; D3a53: try { goto c3765; Eaf57: bc41a: goto Fe561; Baf83: $sshUserName = $sshUserEntity->getUserName(); goto a65db; c10bd: $domainName = $site->getDomainName(); goto Cdf79; a65db: $sshUserPassword = $form->get("\160\141\x73\163\167\x6f\162\144")->getData(); goto b9b62; B01e0: $sshUserEntity = $form->getData(); goto Baf83; Ba727: if (!(false === empty($sshUserPassword))) { goto C42c6; } goto C8552; fa724: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\151\164\145\x5f\165\x73\x65\x72\163", ["\x64\x6f\x6d\141\x69\x6e\116\x61\x6d\145" => $site->getDomainName()])); goto Eaf57; Dd9b8: C42c6: goto e8bbb; Fe561: return $response; goto D385d; e8fcd: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_EDIT, $user, $eventData, $request); goto D1be8; b3915: $siteUpdater = $this->getSiteUpdater($site); goto Ba727; c3765: $session = $request->getSession(); goto c10bd; C033c: if (false === is_null($siteEntity)) { goto e2a69; } goto e7f5b; b9b62: $sshKeys = false === is_null($sshUserEntity->getSshKeys()) ? $sshUserEntity->getSshKeys() : ''; goto f68c4; De098: $eventData = ["\163\x69\x74\x65" => $domainName, "\x75\x73\x65\x72\x4e\141\155\145" => $sshUserName, "\x73\x73\150\x4b\x65\171\x73" => $sshKeys]; goto e8fcd; f68c4: $this->siteEntityManager->updateEntity($siteEntity); goto b3915; e8bbb: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto De098; F1c6d: $user = $this->getUser(); goto B01e0; C8552: $siteUpdater->changeUserPassword($sshUserName, $sshUserPassword); goto Dd9b8; D1be8: $session->getFlashBag()->set("\x73\x75\143\143\x65\x73\x73", $this->translator->trans("\x55\163\145\162\40\x68\x61\163\x20\x62\x65\145\156\40\x73\141\166\x65\x64\56")); goto fa724; Ec34f: e2a69: goto F1c6d; f28bb: goto bc41a; goto Ec34f; Cdf79: $siteEntity = $this->getSiteEntity($domainName); goto C033c; e7f5b: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\151\x74\x65\x73")); goto f28bb; D385d: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\145\162", $this->translator->trans("\x41\156\x20\145\162\162\157\162\40\150\x61\163\x20\157\143\143\165\162\x72\x65\144\x2c\x20\x65\162\162\x6f\162\40\x6d\145\163\163\141\x67\145\x3a\x20\x25\145\x72\x72\157\162\x4d\145\x73\x73\141\x67\145\45", ["\45\145\162\x72\x6f\162\x4d\145\163\x73\x61\x67\x65\45" => $e->getMessage()])); } goto Aef94; Aef94: c1797: goto d1003; Fdcb1: goto c1797; goto A3445; d1003: } public function deleteSshUser(Request $request) : Response { goto f7fad; cf95b: return $response; goto E54c8; C6a02: try { goto Facec; ea351: $userName = $request->get("\x75\163\145\x72\x4e\141\155\x65"); goto f6732; c4679: $session->getFlashBag()->set("\163\165\x63\143\145\163\x73", $this->translator->trans("\125\x73\x65\162\x20\150\141\x73\40\x62\x65\145\156\x20\144\x65\x6c\x65\164\x65\x64\x2e")); goto Ed69a; B7ad1: $this->siteEntityManager->updateEntity($siteEntity); goto E884d; A7aa1: $siteUpdater->deleteUser($userName, true); goto Bd4be; Ed69a: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\151\x74\145\137\165\x73\x65\x72\163", ["\x64\x6f\x6d\x61\x69\156\116\x61\155\145" => $site->getDomainName()])); goto Af828; E884d: $siteUpdater = $this->getSiteUpdater($site); goto A7aa1; bea0f: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_DELETE, $user, $evenData, $request); goto c4679; B20ec: f3ee4: goto fc3a5; A3a07: $siteEntity = $this->getSiteEntity($domainName); goto C7203; D1450: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($sshUserEntity))) { goto f3ee4; } goto C9eff; Facec: $session = $request->getSession(); goto ea351; D6041: $userName = $sshUserEntity->getUserName(); goto Bbba2; Bbba2: $siteEntity->removeSshUser($sshUserEntity); goto B7ad1; ec593: $user = $this->getUser(); goto D6041; Ee309: afd99: goto B20ec; f5f40: if (!($siteEntity->getDomainName() == $sshUserSiteEntity->getDomainName())) { goto afd99; } goto ec593; Af828: return $response; goto Ee309; Bd4be: $evenData = ["\x73\x69\164\145" => $domainName, "\165\163\145\162\x4e\x61\155\145" => $userName]; goto bea0f; C7203: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto D1450; C9eff: $sshUserSiteEntity = $sshUserEntity->getSite(); goto f5f40; f6732: $domainName = $site->getDomainName(); goto A3a07; fc3a5: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\x65\x72", $this->translator->trans("\x41\156\40\145\x72\162\157\x72\40\150\x61\163\40\x6f\x63\x63\165\x72\x72\145\x64\54\x20\x65\162\162\x6f\162\x20\x6d\x65\x73\x73\x61\x67\145\72\x20\45\145\162\162\x6f\162\115\x65\x73\x73\x61\x67\145\x25", ["\45\x65\162\162\157\x72\115\145\x73\x73\x61\147\x65\45" => $e->getMessage()])); } goto B5a95; B7bc3: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\164\145\163")); goto cf95b; a39f9: $this->checkCsrfToken($request, "\x75\163\145\162\55\144\x65\x6c\x65\164\145"); goto f8405; f8405: if (!(false === is_null($site))) { goto B0372; } goto C6a02; B5a95: B0372: goto B7bc3; f7fad: $site = $this->getSite($request); goto a39f9; E54c8: } public function security(Request $request) : Response { goto dc039; A8bd5: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto Fb72a; } goto a5206; B6305: if (!(true === is_null($basicAuthEntity))) { goto fddd7; } goto Eb514; dc039: $site = $this->getSite($request); goto B720f; bb768: return $response; goto Aa8f4; ccebc: return $response; goto C4c4f; C2ac3: $blockedBots = $site->getBlockedBots(); goto Eb638; Aa5a9: C3a78: goto c1ffb; Eb638: $blockedIps = $site->getBlockedIps(); goto Ca64f; f2600: $cloudflareForm = $this->createCloudflareForm($siteEntity, $cloudflareData); goto A8bd5; C03fa: if (!(true === $cloudflareForm->isSubmitted())) { goto ba026; } goto fdd0a; c2e12: D8d28: goto bb768; B8432: $response = $this->handleBasicAuthForm($request, $basicAuthForm, $site); goto A16fb; A0c55: E793e: goto e27b5; E839e: $response = $this->render("\x46\x72\157\x6e\164\145\156\x64\57\123\x69\164\145\57\x73\x65\143\x75\162\151\164\x79\56\x68\x74\155\x6c\x2e\164\167\151\x67", ["\x73\151\x74\145" => $site, "\x62\x6c\x6f\143\153\145\x64\x49\160\163" => $blockedIps, "\x62\154\157\x63\153\145\x64\x42\x6f\164\163" => $blockedBots, "\x62\x61\163\x69\143\x41\x75\x74\150\x46\157\x72\155" => $basicAuthForm->createView(), "\143\154\x6f\x75\144\x66\154\141\162\x65\x46\x6f\162\155" => $cloudflareForm->createView(), "\x66\157\162\155\x45\x72\x72\157\162\163" => $this->formErrors]); goto c2e12; c9a89: Bb838: goto C03fa; B237d: if (!(true === $basicAuthForm->isSubmitted())) { goto Bb838; } goto B8432; a9532: Fb72a: goto E839e; Eb514: $basicAuthEntity = $this->basicAuthEntityManager->createEntity(); goto aca2c; a5206: $basicAuthForm->handleRequest($request); goto f7c16; B720f: if (false === is_null($site)) { goto C3a78; } goto ab8c3; c1ffb: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto aef73; A16fb: if (!(false === is_null($response))) { goto fbedb; } goto ccebc; aca2c: fddd7: goto Afe1f; f7c16: $cloudflareForm->handleRequest($request); goto B237d; F47ff: return $response; goto A0c55; aef73: $cloudflareData = ["\141\154\x6c\157\167\x54\x72\x61\x66\146\x69\143\106\162\157\155\x43\x6c\x6f\x75\144\146\x6c\x61\x72\x65\117\156\x6c\x79" => $siteEntity->allowTrafficFromCloudflareOnly()]; goto C2ac3; Cd1a9: $basicAuthForm = $this->createBasicAuthForm($basicAuthEntity); goto f2600; fdd0a: $response = $this->handleCloudflareForm($request, $cloudflareForm, $site); goto d299e; Afe1f: $basicAuthEntity->setSite($siteEntity); goto Cd1a9; d299e: if (!(false === is_null($response))) { goto E793e; } goto F47ff; Ca64f: $basicAuthEntity = $site->getBasicAuth(); goto B6305; C4c4f: fbedb: goto c9a89; e27b5: ba026: goto a9532; F1ce2: goto D8d28; goto Aa5a9; ab8c3: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\151\164\x65\x73")); goto F1ce2; Aa8f4: } private function createCloudflareForm(SiteEntity $siteEntity, array $data) : Form { goto E2166; Fb05e: $form->add("\x73\165\142\x6d\x69\164", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\141\163\x73" => "\x62\x74\156\x20\142\164\156\x2d\x62\154\x75\145\x20\x62\164\156\x2d\154\147"], "\x6c\x61\x62\145\154" => "\123\141\166\x65"]); goto C3c9c; E2166: $form = $this->createForm("\101\160\160\x5c\106\157\162\155\x5c\123\151\164\x65\x43\x6c\157\165\x64\146\154\x61\162\145\x54\171\160\145", $data, ["\x61\x63\x74\x69\x6f\156" => $this->generateUrl("\x63\x6c\x70\137\163\x69\x74\145\x5f\x73\145\x63\165\162\x69\164\171", ["\x64\x6f\155\x61\151\156\x4e\141\x6d\145" => $siteEntity->getDomainName()]), "\155\x65\164\x68\x6f\144" => "\x50\117\x53\124", "\141\164\164\162" => []]); goto Fb05e; C3c9c: return $form; goto c64ee; c64ee: } private function createBasicAuthForm(BasicAuthEntity $basicAuthEntity) : Form { goto D3066; Bde2e: $form = $this->createForm("\101\160\x70\134\106\157\x72\155\134\x53\x69\164\145\x42\141\163\151\x63\x41\165\164\x68\124\x79\x70\x65", $basicAuthEntity, ["\141\x63\164\151\157\156" => $this->generateUrl("\x63\154\x70\x5f\x73\x69\164\145\137\x73\x65\x63\165\x72\151\x74\171", ["\144\x6f\x6d\141\151\x6e\x4e\x61\155\x65" => $siteEntity->getDomainName()]), "\155\145\x74\150\x6f\x64" => "\120\117\x53\x54", "\141\164\164\162" => []]); goto Deee2; Deee2: $form->add("\x73\x75\x62\x6d\151\164", SubmitType::class, ["\141\x74\x74\162" => ["\143\154\x61\x73\163" => "\x62\164\x6e\x20\x62\x74\156\55\x62\x6c\x75\x65\40\x62\164\x6e\55\154\x67"], "\x6c\x61\142\x65\154" => "\123\x61\166\145"]); goto D60bf; D3066: $siteEntity = $basicAuthEntity->getSite(); goto Bde2e; D60bf: return $form; goto aca24; aca24: } private function handleBasicAuthForm(Request $request, Form $form, Site $site) { goto c0cdf; E36ef: Eb193: goto c39ae; c0cdf: if (true === $form->isValid()) { goto A55b4; } goto B1085; B1085: $this->formErrors = $this->getErrorMessages($form); goto aae51; Bdee5: A55b4: goto Fb505; Fb505: try { goto F2b70; a3da9: $siteUpdater->createBasicAuthFile($basicAuthEntity); goto ffa39; Db252: goto bc4ce; goto Efb2c; D90ee: if (false === is_null($siteEntity)) { goto Ecd09; } goto b81da; b81da: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\151\x74\x65\163")); goto Db252; Efb2c: Ecd09: goto Be02d; b110c: $siteUpdater = $this->getSiteUpdater($site); goto a3da9; Ce2e1: $site->setBasicAuth($basicAuthEntity); goto Dab39; A6cf9: $eventData = ["\163\x69\164\x65" => $domainName, "\x61\x63\x74\x69\x76\145" => true === $basicAuthEntity->getIsActive() ? "\x31" : "\x30", "\165\163\x65\162\x4e\x61\155\145" => $basicAuthEntity->getUserName(), "\x77\x68\x69\164\x65\x6c\151\163\164\145\x64\x49\160\x73" => $basicAuthEntity->getWhitelistedIps()]; goto e1729; Bc38b: $siteUpdater->reloadNginxService(); goto A6cf9; e1729: EventQueue::addEvent(EventQueue::EVENT_SITE_BASIC_AUTHENTIFICATION_SETTINGS, $user, $eventData, $request); goto Ec03b; D2b59: $domainName = $site->getDomainName(); goto cf5b8; Ec03b: $session->getFlashBag()->set("\163\x75\x63\x63\145\x73\163", $this->translator->trans("\x42\x61\163\151\143\40\x41\165\x74\x68\145\156\164\x69\x63\x61\164\151\x6f\x6e\x20\163\145\164\164\151\x6e\x67\x73\x20\x68\141\x76\x65\x20\142\145\145\x6e\x20\163\x61\166\x65\x64\x2e")); goto ef00c; Be02d: $user = $this->getUser(); goto cfc32; F2b70: $session = $request->getSession(); goto D2b59; Dab39: $this->siteEntityManager->updateEntity($siteEntity); goto b110c; da859: bc4ce: goto a5c5c; ed4e3: $siteEntity->setBasicAuth($basicAuthEntity); goto Ce2e1; cf5b8: $siteEntity = $this->getSiteEntity($domainName); goto D90ee; a5c5c: return $response; goto ab7f8; ef00c: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\x74\x65\137\163\x65\x63\x75\162\x69\x74\171", ["\144\x6f\x6d\141\x69\x6e\x4e\141\x6d\x65" => $site->getDomainName()])); goto da859; ffa39: $siteUpdater->updateNginxVhost(); goto Bc38b; cfc32: $basicAuthEntity = $form->getData(); goto ed4e3; ab7f8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\x72", $this->translator->trans("\101\x6e\40\145\x72\162\157\x72\40\150\x61\x73\x20\x6f\143\143\165\x72\162\145\144\54\40\x65\x72\162\x6f\x72\x20\155\145\x73\x73\141\x67\x65\x3a\x20\45\145\162\x72\157\x72\115\x65\x73\x73\141\x67\145\45", ["\45\145\162\x72\157\x72\115\x65\163\x73\141\x67\145\x25" => $e->getMessage()])); } goto E36ef; aae51: goto Eb193; goto Bdee5; c39ae: } private function handleCloudflareForm(Request $request, Form $form, Site $site) { goto Ba490; be092: try { goto D000d; Dcdb0: return $response; goto A4320; d7012: $session->getFlashBag()->set("\x73\165\143\143\x65\163\163", $this->translator->trans("\103\154\x6f\x75\x64\146\154\x61\x72\145\40\163\145\x74\164\x69\156\147\x73\40\x68\141\x76\145\40\x62\145\x65\156\x20\163\x61\166\145\144\56")); goto Ce3a8; b4e6e: $site->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto d06ae; E529a: EventQueue::addEvent(EventQueue::EVENT_SITE_CLOUDFLARE_SETTINGS, $user, $eventData, $request); goto d7012; e1ff6: F1000: goto Dcdb0; Ce1c2: $siteUpdater->updateNginxVhost(); goto bb74d; C8e61: E1117: goto ca8a4; bb74d: $siteUpdater->reloadNginxService(); goto bdd3c; D000d: $session = $request->getSession(); goto f0118; f7bc6: if (false === is_null($siteEntity)) { goto E1117; } goto ebfd5; ebfd5: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\x69\x74\x65\163")); goto Dc98b; Cc931: $siteEntity->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto b4e6e; Ec31b: $allowTrafficFromCloudflareOnly = $form->get("\141\154\154\157\x77\x54\x72\141\146\x66\151\x63\x46\x72\x6f\x6d\x43\154\157\165\144\x66\154\x61\162\145\117\156\x6c\x79")->getData(); goto Cc931; d0f5b: $siteEntity = $this->getSiteEntity($domainName); goto f7bc6; d06ae: $this->siteEntityManager->updateEntity($siteEntity); goto a036a; a036a: $siteUpdater = $this->getSiteUpdater($site); goto Ce1c2; ca8a4: $user = $this->getUser(); goto Ec31b; bdd3c: $eventData = ["\163\x69\x74\x65" => $domainName, "\141\154\x6c\x6f\167\x54\162\x61\x66\146\x69\x63\106\x72\157\155\x43\154\x6f\x75\144\146\154\x61\x72\x65\x4f\156\x6c\171" => true === $allowTrafficFromCloudflareOnly ? "\x31" : "\60"]; goto E529a; f0118: $domainName = $site->getDomainName(); goto d0f5b; Dc98b: goto F1000; goto C8e61; Ce3a8: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\x74\145\137\163\x65\143\x75\162\x69\164\x79", ["\x64\x6f\155\141\151\156\x4e\x61\155\145" => $site->getDomainName()])); goto e1ff6; A4320: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\145\162", $this->translator->trans("\x41\x6e\x20\x65\162\x72\x6f\x72\x20\x68\141\x73\x20\157\x63\143\x75\162\x72\145\x64\54\40\x65\x72\x72\x6f\x72\x20\155\145\x73\163\x61\147\x65\x3a\40\x25\x65\x72\x72\157\162\115\x65\x73\163\141\147\145\x25", ["\x25\x65\162\162\x6f\162\115\145\163\163\141\147\145\x25" => $e->getMessage()])); } goto Ba921; d4aef: $this->formErrors = $this->getErrorMessages($form); goto B526d; Ba490: if (true === $form->isValid()) { goto F8e03; } goto d4aef; B526d: goto fa4b8; goto B2649; Ba921: fa4b8: goto f11e0; B2649: F8e03: goto be092; f11e0: } public function newBlockedIp(Request $request) : Response { goto fe1c6; E5465: $response = $this->render("\106\x72\157\156\x74\x65\x6e\144\57\x53\151\164\x65\57\156\x65\x77\x2d\142\x6c\x6f\x63\x6b\145\x64\x2d\151\x70\56\150\164\155\x6c\x2e\164\167\151\147", ["\163\x69\x74\x65" => $site, "\146\157\x72\155" => $form->createView(), "\x66\x6f\162\x6d\105\162\162\157\x72\163" => $this->formErrors]); goto F1025; F1025: B5954: goto f61d8; c95e6: $form = $this->createBlockedIpForm($blockedIpEntity); goto fe5a9; B1dd2: $response = $this->handleBlockedIpForm($request, $form, $site); goto b8bce; d0467: $blockedIpEntity = $this->blockedIpEntityManager->createEntity(); goto Eb012; d6df3: b099c: goto E5465; b1f7e: goto B5954; goto b2be0; ce6e1: E182e: goto d6df3; db58f: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto d0467; fe1c6: $site = $this->getSite($request); goto D5bc0; D5bc0: if (false === is_null($site)) { goto d0854; } goto E67d1; f61d8: return $response; goto b259e; dd542: if (!(true === $form->isSubmitted())) { goto E182e; } goto B1dd2; df4e5: return $response; goto E4223; F5197: $form->handleRequest($request); goto dd542; Eb012: $blockedIpEntity->setSite($siteEntity); goto c95e6; b8bce: if (!(false === is_null($response))) { goto C8338; } goto df4e5; E67d1: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\x69\x74\x65\x73")); goto b1f7e; E4223: C8338: goto ce6e1; fe5a9: if (!(true === $request->isMethod("\x50\117\123\124"))) { goto b099c; } goto F5197; b2be0: d0854: goto db58f; b259e: } private function createBlockedIpForm(BlockedIpEntity $blockedIpEntity) : Form { goto E1dd6; d0cd4: $form->add("\x73\165\x62\x6d\151\164", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\141\x73\x73" => "\x62\x74\x6e\40\x62\164\x6e\x2d\x62\x6c\x75\145\x20\x62\x74\x6e\x2d\x6c\x67"], "\154\x61\x62\x65\x6c" => "\x41\x64\x64\x20\111\x50"]); goto a2d04; E1dd6: $siteEntity = $blockedIpEntity->getSite(); goto d05da; a2d04: return $form; goto aa714; d05da: $form = $this->createForm("\101\160\x70\134\x46\157\162\x6d\134\x53\151\164\145\102\154\157\x63\x6b\145\144\x49\120\124\171\160\x65", $blockedIpEntity, ["\141\x63\x74\151\157\x6e" => $this->generateUrl("\143\x6c\160\x5f\x73\151\x74\145\137\163\145\143\165\x72\x69\x74\171\x5f\142\154\x6f\143\x6b\145\144\137\151\160\137\156\x65\x77", ["\x64\157\x6d\141\x69\156\x4e\141\x6d\x65" => $siteEntity->getDomainName()]), "\155\145\x74\150\x6f\x64" => "\120\117\x53\x54", "\141\164\x74\162" => []]); goto d0cd4; aa714: } private function handleBlockedIpForm(Request $request, Form $form, Site $site) { goto Df711; Ceee6: $this->formErrors = $this->getErrorMessages($form); goto Fa615; Fa615: goto D7348; goto E004b; E1651: try { goto Dd999; b7700: $siteUpdater->reloadNginxService(); goto cdfae; B161d: if (false === is_null($siteEntity)) { goto Fcba5; } goto F9b9e; ba7b6: $blockedIp = $form->getData(); goto B10d2; c9338: D4f78: goto C18e4; C18e4: return $response; goto cdfa0; C4273: $siteEntity = $this->getSiteEntity($domainName); goto B161d; F3733: $siteUpdater->updateNginxVhost(); goto b7700; F9b9e: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\x74\x65\x73")); goto B5725; Bec36: Fcba5: goto cf2a8; A8486: $siteUpdater = $this->getSiteUpdater($site); goto F3733; cf2a8: $user = $this->getUser(); goto ba7b6; Dd999: $session = $request->getSession(); goto A919d; B10d2: $siteEntity->addBlockedIp($blockedIp); goto ba5c5; b3f37: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\x74\x65\137\163\145\143\x75\x72\151\x74\x79", ["\x64\157\x6d\x61\151\x6e\116\x61\155\145" => $site->getDomainName()])); goto c9338; cdfae: $eventData = ["\x73\x69\x74\145" => $domainName, "\x69\160" => $blockedIp->getIp()]; goto Ded65; B5725: goto D4f78; goto Bec36; Ded65: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_ADD, $user, $eventData, $request); goto Ede78; A919d: $domainName = $site->getDomainName(); goto C4273; ba5c5: $this->siteEntityManager->updateEntity($siteEntity); goto A8486; Ede78: $session->getFlashBag()->set("\163\x75\143\x63\x65\x73\x73", $this->translator->trans("\111\120\x20\150\141\x73\40\142\145\145\x6e\x20\x61\144\x64\x65\x64\56")); goto b3f37; cdfa0: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\x72", $this->translator->trans("\101\156\x20\145\162\x72\157\x72\x20\x68\141\x73\x20\x6f\143\143\165\x72\x72\145\144\x2c\x20\x65\162\162\157\x72\40\155\145\x73\x73\141\x67\x65\72\x20\45\x65\162\x72\157\162\x4d\145\163\x73\x61\147\145\x25", ["\45\145\x72\162\157\x72\x4d\x65\x73\x73\141\147\145\45" => $e->getMessage()])); } goto aa59d; Df711: if (true === $form->isValid()) { goto bc9e8; } goto Ceee6; aa59d: D7348: goto fb3c9; E004b: bc9e8: goto E1651; fb3c9: } public function deleteBlockedIp(Request $request) : Response { goto c4f04; c4f04: $site = $this->getSite($request); goto B08a0; E7618: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\151\164\145\163")); goto f7018; ebf05: fe892: goto E7618; f7018: return $response; goto B5d28; Ff3f0: try { goto B0eb9; e7a3d: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedIpEntity) && $siteEntity == $blockedIpEntity->getSite())) { goto b11ca; } goto b6147; Afb0e: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_DELETE, $user, $eventData, $request); goto B6d6b; A1e90: $this->siteEntityManager->updateEntity($siteEntity); goto f04e6; B0eb9: $session = $request->getSession(); goto ef196; d3276: $domainName = $site->getDomainName(); goto df28c; c34eb: $siteEntity->removeBlockedIp($blockedIpEntity); goto A1e90; A00df: return $response; goto E7e40; b6147: $user = $this->getUser(); goto c34eb; f04e6: $siteUpdater = $this->getSiteUpdater($site); goto bb04b; E7e40: b11ca: goto Ed95e; Dfa1f: $siteUpdater->reloadNginxService(); goto B1c9f; ef196: $id = (int) $request->get("\x69\144"); goto d3276; B6d6b: $session->getFlashBag()->set("\163\x75\143\x63\x65\x73\x73", $this->translator->trans("\111\x50\40\150\x61\x73\x20\142\145\x65\x6e\40\x64\145\154\x65\164\145\x64\56")); goto db283; df28c: $siteEntity = $this->getSiteEntity($domainName); goto b34f1; B1c9f: $eventData = ["\163\x69\x74\145" => $domainName, "\x69\x70" => $blockedIpEntity->getIp()]; goto Afb0e; db283: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\164\145\x5f\163\145\143\165\162\x69\x74\171", ["\x64\157\155\141\151\156\116\x61\155\145" => $site->getDomainName()])); goto A00df; bb04b: $siteUpdater->updateNginxVhost(); goto Dfa1f; b34f1: $blockedIpEntity = $this->blockedIpEntityManager->findOneById($id); goto e7a3d; Ed95e: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\x65\x72", $this->translator->trans("\x41\156\x20\x65\x72\162\157\162\40\x68\x61\x73\x20\x6f\x63\143\x75\x72\162\x65\144\54\x20\145\x72\x72\157\x72\x20\x6d\x65\163\x73\x61\x67\x65\72\40\45\145\x72\162\157\x72\x4d\145\163\x73\141\x67\145\x25", ["\45\145\x72\x72\x6f\x72\x4d\x65\x73\x73\x61\x67\x65\45" => $e->getMessage()])); } goto ebf05; B08a0: $this->checkCsrfToken($request, "\151\160\x2d\144\145\x6c\x65\164\145"); goto bb30f; bb30f: if (!(false === is_null($site))) { goto fe892; } goto Ff3f0; B5d28: } public function newBlockedBot(Request $request) : Response { goto B7a90; ec8c1: goto F90e0; goto D6310; b7bd4: $blockedBotEntity->setSite($siteEntity); goto d5ba7; c9a1f: if (false === is_null($site)) { goto Cf616; } goto C81d7; d5ba7: $form = $this->createBlockedBotForm($blockedBotEntity); goto D3cf7; c6530: c828b: goto ff2e2; ed71b: $form->handleRequest($request); goto d2895; D6310: Cf616: goto C5b68; E41f7: C94e7: goto c6530; D3cf7: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto c828b; } goto ed71b; E1b23: return $response; goto dcdbc; A56c5: F90e0: goto E13ab; d2895: if (!(true === $form->isSubmitted())) { goto C94e7; } goto Ace2b; Ace2b: $response = $this->handleBlockedBotForm($request, $form, $site); goto A782e; A782e: if (!(false === is_null($response))) { goto C8f5c; } goto E1b23; dcdbc: C8f5c: goto E41f7; B7a90: $site = $this->getSite($request); goto c9a1f; A655f: $blockedBotEntity = $this->blockedBotEntityManager->createEntity(); goto b7bd4; E13ab: return $response; goto d13e1; ff2e2: $response = $this->render("\x46\162\x6f\x6e\x74\x65\x6e\144\57\123\x69\x74\x65\57\156\145\x77\x2d\x62\x6c\x6f\x63\x6b\145\x64\55\142\157\x74\x2e\x68\164\155\154\x2e\164\x77\151\x67", ["\x73\x69\x74\145" => $site, "\x66\x6f\162\x6d" => $form->createView(), "\146\157\x72\155\x45\x72\x72\157\x72\163" => $this->formErrors]); goto A56c5; C5b68: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto A655f; C81d7: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\x74\145\163")); goto ec8c1; d13e1: } private function createBlockedBotForm(BlockedBotEntity $blockedBotEntity) : Form { goto a8975; f55eb: return $form; goto c14fc; f4693: $form->add("\163\x75\142\x6d\151\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\143\154\x61\163\x73" => "\x62\x74\x6e\40\142\x74\x6e\x2d\x62\154\165\145\40\142\164\156\55\x6c\147"], "\154\x61\x62\145\x6c" => "\x41\144\x64\x20\102\157\164"]); goto f55eb; C8ac0: $form = $this->createForm("\101\x70\x70\x5c\106\x6f\162\x6d\x5c\123\x69\164\145\x42\x6c\x6f\143\153\x65\x64\x42\x6f\x74\124\171\160\x65", $blockedBotEntity, ["\x61\143\164\x69\157\156" => $this->generateUrl("\143\154\x70\x5f\163\x69\x74\x65\137\x73\x65\143\x75\162\x69\x74\171\x5f\x62\x6c\157\x63\153\x65\144\137\x62\x6f\164\137\x6e\x65\x77", ["\x64\x6f\155\141\151\x6e\116\141\x6d\x65" => $siteEntity->getDomainName()]), "\155\145\164\150\157\x64" => "\120\x4f\x53\x54", "\x61\x74\x74\162" => []]); goto f4693; a8975: $siteEntity = $blockedBotEntity->getSite(); goto C8ac0; c14fc: } private function handleBlockedBotForm(Request $request, Form $form, Site $site) { goto f24aa; Ad060: try { goto Fbedc; ca3f6: $siteUpdater->updateNginxVhost(); goto c3107; D38bf: $siteEntity->addBlockedBot($blockedBot); goto B9070; Feee4: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\x69\x74\x65\x73")); goto aac52; A0fc0: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_ADD, $user, $eventData, $request); goto F852a; e819e: F7215: goto b2105; B9070: $this->siteEntityManager->updateEntity($siteEntity); goto d4cea; aac52: goto B8898; goto e819e; d9ad3: $siteEntity = $this->getSiteEntity($domainName); goto c6f24; a8d39: return $response; goto adcad; A562f: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\145\137\163\145\143\x75\162\151\164\x79", ["\144\157\155\x61\151\x6e\x4e\x61\155\x65" => $site->getDomainName()])); goto Eacac; c3107: $siteUpdater->reloadNginxService(); goto ea1de; b2105: $user = $this->getUser(); goto B0a15; B0a15: $blockedBot = $form->getData(); goto D38bf; c6f24: if (false === is_null($siteEntity)) { goto F7215; } goto Feee4; d4cea: $siteUpdater = $this->getSiteUpdater($site); goto ca3f6; b7dd5: $domainName = $site->getDomainName(); goto d9ad3; ea1de: $eventData = ["\x73\x69\164\145" => $domainName, "\156\x61\x6d\x65" => $blockedBot->getName()]; goto A0fc0; Eacac: B8898: goto a8d39; F852a: $session->getFlashBag()->set("\x73\x75\143\x63\145\x73\x73", $this->translator->trans("\x42\x6f\x74\x20\x68\141\163\40\142\x65\145\156\x20\x61\144\x64\x65\x64\56")); goto A562f; Fbedc: $session = $request->getSession(); goto b7dd5; adcad: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\147\145\x72", $this->translator->trans("\101\x6e\40\x65\162\162\157\162\40\x68\x61\x73\x20\157\x63\143\x75\x72\x72\145\x64\x2c\x20\145\162\x72\157\162\x20\155\145\x73\163\141\x67\145\x3a\x20\45\x65\162\162\x6f\x72\115\x65\x73\x73\x61\x67\145\x25", ["\45\x65\x72\x72\x6f\162\x4d\145\x73\163\141\x67\145\x25" => $e->getMessage()])); } goto F14fa; f24aa: if (true === $form->isValid()) { goto d3b4a; } goto A6561; d2b28: d3b4a: goto Ad060; A6561: $this->formErrors = $this->getErrorMessages($form); goto bf1da; F14fa: B0317: goto E287f; bf1da: goto B0317; goto d2b28; E287f: } public function deleteBlockedBot(Request $request) : Response { goto d1215; b24f9: $this->checkCsrfToken($request, "\x62\x6f\x74\55\x64\x65\x6c\x65\164\145"); goto Ab3cb; Ab3cb: if (!(false === is_null($site))) { goto F5db7; } goto ad887; db419: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\x69\164\145\163")); goto e8c75; d1215: $site = $this->getSite($request); goto b24f9; ad887: try { goto f1417; b84e0: $siteUpdater = $this->getSiteUpdater($site); goto E19a0; E807c: $siteEntity = $this->getSiteEntity($domainName); goto b77f7; f1417: $session = $request->getSession(); goto d9fba; E19a0: $siteUpdater->updateNginxVhost(); goto e6261; e5bbb: return $response; goto d1bf0; fab9d: $siteEntity->removeBlockedBot($blockedBotEntity); goto Ffc09; Ffc09: $this->siteEntityManager->updateEntity($siteEntity); goto b84e0; c2a0b: $eventData = ["\x73\x69\164\145" => $domainName, "\x6e\141\x6d\x65" => $blockedBotEntity->getName()]; goto f4b2c; f4b2c: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_DELETE, $user, $eventData, $request); goto D1ea3; a54be: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedBotEntity) && $siteEntity == $blockedBotEntity->getSite())) { goto F7fa3; } goto c0726; d755b: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\x74\x65\137\163\145\x63\165\x72\151\x74\x79", ["\144\157\155\x61\x69\x6e\116\141\155\145" => $site->getDomainName()])); goto e5bbb; D1ea3: $session->getFlashBag()->set("\163\165\x63\143\145\163\163", $this->translator->trans("\x42\x6f\164\x20\x68\141\x73\x20\x62\x65\145\x6e\40\144\145\154\145\x74\x65\144\56")); goto d755b; d1bf0: F7fa3: goto ae0a0; e6261: $siteUpdater->reloadNginxService(); goto c2a0b; d9fba: $id = (int) $request->get("\151\144"); goto ba459; ba459: $domainName = $site->getDomainName(); goto E807c; c0726: $user = $this->getUser(); goto fab9d; b77f7: $blockedBotEntity = $this->blockedBotEntityManager->findOneById($id); goto a54be; ae0a0: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\162", $this->translator->trans("\x41\x6e\x20\145\x72\x72\x6f\162\40\x68\141\163\x20\x6f\x63\143\165\x72\x72\x65\144\x2c\x20\145\x72\x72\157\162\x20\x6d\145\x73\163\141\x67\x65\72\x20\45\x65\x72\162\157\162\115\145\163\163\x61\147\145\45", ["\x25\x65\162\x72\x6f\162\x4d\145\x73\163\141\x67\x65\45" => $e->getMessage()])); } goto fcaa4; e8c75: return $response; goto B0bf4; fcaa4: F5db7: goto db419; B0bf4: } public function certificates(Request $request) : Response { goto E7c3e; a0df0: $certificates = $site->getCertificates(); goto C6ef6; ac3b1: d4759: goto bd803; b7d94: return $response; goto C38c3; bc4ae: if (false === is_null($site)) { goto d4759; } goto ce15d; C6ef6: $response = $this->render("\x46\162\157\156\164\x65\156\x64\57\123\151\164\x65\57\143\x65\x72\x74\151\x66\x69\143\x61\x74\x65\163\56\x68\164\x6d\x6c\x2e\164\167\x69\147", ["\163\x69\164\x65" => $site, "\151\x6e\x73\x74\141\x6c\154\x65\x64\103\x65\162\164\x69\x66\151\143\x61\x74\x65" => $installedCertificate, "\143\x65\162\164\x69\x66\x69\143\x61\x74\145\163" => $certificates]); goto F4792; ce15d: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\x74\145\163")); goto Ce702; F4792: f9dd5: goto b7d94; E7c3e: $site = $this->getSite($request); goto bc4ae; Ce702: goto f9dd5; goto ac3b1; bd803: $installedCertificate = $site->getCertificate(); goto a0df0; C38c3: } public function importCertificate(Request $request) : Response { goto C60e5; Bb4e4: $certificateEntity->setType(CertificateEntity::TYPE_IMPORTED); goto a4b65; E808a: if (!(false === is_null($response))) { goto e4d8e; } goto E5193; c03fa: e4d8e: goto C78c5; Ea988: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\151\x74\145\x73")); goto b313c; C8fc4: $form->handleRequest($request); goto ae5db; A6307: a256e: goto Feace; A25e4: $response = $this->render("\106\162\x6f\156\x74\x65\156\144\x2f\123\x69\164\x65\x2f\151\155\x70\157\162\x74\55\x63\145\x72\164\151\146\x69\143\x61\164\x65\x2e\x68\x74\155\154\x2e\164\167\x69\x67", ["\163\151\x74\x65" => $site, "\x66\157\x72\x6d" => $form->createView(), "\x66\157\162\x6d\x45\162\162\x6f\x72\x73" => $this->formErrors]); goto A6307; cbb14: $certificateEntity = $this->certificateEntityManager->createEntity(); goto Bb4e4; C5580: aafb8: goto A25e4; Feace: return $response; goto B62bd; A4df0: a877c: goto Fd701; E9440: $response = $this->handleImportCertificateForm($request, $form, $site); goto E808a; c0b5c: if (false === is_null($site)) { goto a877c; } goto Ea988; b313c: goto a256e; goto A4df0; ae5db: if (!(true === $form->isSubmitted())) { goto F441f; } goto E9440; C60e5: $site = $this->getSite($request); goto c0b5c; Fd701: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto cbb14; C78c5: F441f: goto C5580; a4b65: $certificateEntity->setSite($siteEntity); goto E93e2; Ec168: if (!(true === $request->isMethod("\x50\117\123\124"))) { goto aafb8; } goto C8fc4; E5193: return $response; goto c03fa; E93e2: $form = $this->createImportCertificateForm($certificateEntity); goto Ec168; B62bd: } private function createImportCertificateForm(CertificateEntity $certificateEntity) : Form { goto F680f; Ba340: return $form; goto af610; C9eb4: $form->add("\x73\165\142\x6d\151\164", SubmitType::class, ["\141\x74\x74\162" => ["\x63\154\141\x73\x73" => "\142\x74\x6e\x20\x62\164\156\x2d\142\x6c\165\x65\40\x62\x74\156\x2d\154\147"], "\x6c\x61\x62\x65\x6c" => "\111\x6d\x70\x6f\162\x74\x20\x61\x6e\144\x20\x49\x6e\x73\164\141\x6c\x6c"]); goto Ba340; F680f: $siteEntity = $certificateEntity->getSite(); goto d91a8; d91a8: $form = $this->createForm("\101\160\160\134\x46\x6f\162\x6d\134\123\151\x74\145\111\x6d\160\x6f\x72\x74\103\145\162\164\x69\146\x69\143\x61\x74\145\124\171\160\145", $certificateEntity, ["\x61\143\x74\x69\157\x6e" => $this->generateUrl("\143\154\160\137\163\151\x74\x65\137\143\145\162\x74\151\146\151\x63\x61\x74\x65\x5f\x69\155\160\x6f\162\x74", ["\x64\157\155\x61\151\156\x4e\141\x6d\x65" => $siteEntity->getDomainName()]), "\x6d\145\x74\150\x6f\x64" => "\x50\117\x53\x54", "\141\164\164\162" => []]); goto C9eb4; af610: } private function handleImportCertificateForm(Request $request, Form $form, Site $site) { goto bf52c; b8744: afb61: goto bffba; Fb16b: goto E9255; goto b8744; Acc9c: $this->formErrors = $this->getErrorMessages($form); goto Fb16b; bffba: try { goto B0e29; C90d0: return $response; goto aff4f; Eb342: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto aaaa6; E99b7: D7e31: goto B0f56; E3717: $siteEntity->setCertificate($certificateEntity); goto Ffeea; a2689: $evenData = ["\x73\151\x74\x65" => $domainName]; goto Eb342; D2561: $certificateEntity = $form->getData(); goto b912d; Bbaa2: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\x69\164\x65\x5f\x63\145\x72\164\151\146\x69\x63\x61\164\145\163", ["\144\x6f\x6d\x61\x69\x6e\116\141\155\x65" => $site->getDomainName()])); goto D8ae6; E3d6f: goto a3916; goto E99b7; a6a49: $this->siteEntityManager->updateEntity($siteEntity); goto a2689; D6467: $siteUpdater->installCertificate($certificateEntity); goto E3717; B0e29: $session = $request->getSession(); goto Ec05a; Ffeea: $siteEntity->addCertificate($certificateEntity); goto a6a49; D8ae6: a3916: goto C90d0; df499: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\x69\164\x65\163")); goto E3d6f; Ec05a: $domainName = $site->getDomainName(); goto f2cb3; dd031: if (false === is_null($siteEntity)) { goto D7e31; } goto df499; b912d: $siteUpdater = $this->getSiteUpdater($site); goto D6467; f2cb3: $siteEntity = $this->getSiteEntity($domainName); goto dd031; aaaa6: $session->getFlashBag()->set("\x73\165\143\x63\145\x73\x73", $this->translator->trans("\103\145\x72\164\151\x66\x69\x63\x61\164\145\40\150\x61\163\40\142\145\145\156\40\151\156\163\x74\141\x6c\x6c\x65\x64\56")); goto Bbaa2; B0f56: $user = $this->getUser(); goto D2561; aff4f: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\x72", $this->translator->trans("\101\x6e\x20\x65\x72\x72\x6f\x72\40\x68\x61\163\40\157\x63\143\165\162\162\145\x64\x2c\x20\x65\162\162\x6f\162\40\155\145\x73\x73\141\147\145\x3a\x20\x25\x65\162\x72\x6f\162\115\x65\163\x73\141\x67\x65\x25", ["\45\145\x72\x72\157\x72\x4d\x65\x73\163\141\147\x65\45" => $e->getMessage()])); } goto eecbe; eecbe: E9255: goto Fd338; bf52c: if (true === $form->isValid()) { goto afb61; } goto Acc9c; Fd338: } public function newLetsEncryptCertificate(Request $request) : Response { goto Fb38b; d5979: $response = $this->render("\x46\x72\157\156\164\145\156\144\x2f\123\x69\164\145\x2f\x6e\x65\x77\x2d\154\145\x74\x73\x2d\145\x6e\143\x72\171\x70\164\55\x63\145\162\x74\x69\146\x69\143\141\164\145\x2e\150\164\x6d\x6c\x2e\x74\x77\x69\x67", ["\x73\151\164\145" => $site, "\x64\x6f\155\x61\x69\156\x73" => $domains, "\x66\x6f\162\x6d" => $form->createView(), "\146\157\x72\x6d\x45\x72\x72\157\162\x73" => $this->formErrors]); goto a3f8d; F3559: $domains = array_unique($domains); goto a9c39; Bba11: e7e07: goto Db59b; Db59b: b0e50: goto d5979; d6ed3: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto d18a2; Ca67f: $form = $this->createLetsEncryptCertificateForm($domainName); goto e5cd2; E0a16: E5660: goto D2609; f21fc: $subdomain = $resolvedDomainName->subDomain()->toString(); goto e3cc2; E8860: $domainName = $site->getDomainName(); goto Ca67f; E4c4d: return $response; goto A686e; C919a: $domains = (array) $request->get("\144\157\x6d\x61\151\x6e\x73"); goto B4876; F479c: $domains = array_map("\x74\x72\x69\x6d", $domains); goto F3559; Af83b: goto b0e50; goto bfcf1; dad4f: if (!(false === is_null($response))) { goto d9159; } goto Fc230; d35c5: if (true === $request->isMethod("\120\117\x53\x54")) { goto e2823; } goto d6ed3; F99fa: d9159: goto Bba11; Fb38b: $site = $this->getSite($request); goto Bcfc7; e3cc2: $subdomain = false === empty($subdomain) ? $subdomain : null; goto cb2f7; C59f8: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\x73")); goto Fafc3; d63e1: if (!(true === $form->isSubmitted())) { goto e7e07; } goto C919a; Fafc3: goto Bb6a3; goto B49f9; a3f8d: Bb6a3: goto E4c4d; d894f: ba756: goto Af83b; cb2f7: if (true === is_null($subdomain) || "\x77\x77\167" == $subdomain) { goto E5660; } goto ddc52; Fc230: return $response; goto F99fa; bfcf1: e2823: goto c2d23; B4876: $domains = array_filter($domains, function ($value) { return false === empty(trim($value)); }); goto F479c; Bcfc7: if (false === is_null($site)) { goto C8b12; } goto C59f8; D2609: $domains = [$registrableDomain, sprintf("\167\x77\167\x2e\45\163", $registrableDomain)]; goto d894f; d18a2: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto f21fc; c2d23: $form->handleRequest($request); goto d63e1; e5cd2: $domains = []; goto d35c5; b4ca6: goto ba756; goto E0a16; a9c39: $response = $this->handleLetsEncryptCertificateForm($request, $form, $site, $domains); goto dad4f; B49f9: C8b12: goto E8860; ddc52: $domains = [$domainName]; goto b4ca6; A686e: } private function createLetsEncryptCertificateForm(string $domainName) : Form { goto D5c27; Fba1f: return $form; goto F02ec; D5c27: $form = $this->createForm("\101\160\x70\134\106\157\x72\155\x5c\123\151\x74\145\x4c\x65\164\x73\105\156\143\162\x79\160\164\103\145\162\x74\x69\x66\x69\x63\x61\164\x65\x54\171\160\x65", [], ["\x61\143\164\x69\x6f\x6e" => $this->generateUrl("\x63\x6c\160\137\163\x69\x74\x65\x5f\x6c\145\164\163\137\x65\x6e\x63\162\x79\x70\x74\x5f\x63\145\x72\x74\151\146\x69\x63\x61\164\145\137\x6e\145\167", ["\x64\157\155\141\151\156\116\141\155\145" => $domainName]), "\x6d\x65\164\x68\x6f\144" => "\120\x4f\x53\124", "\141\x74\x74\x72" => ["\x69\144" => "\x63\162\x65\141\164\x65\x2d\x6c\145\164\163\x2d\145\156\x63\162\171\x70\164\x2d\x63\145\162\164\x69\x66\x69\x63\x61\164\x65\x2d\x66\x6f\162\x6d"]]); goto a0ab0; a0ab0: $form->add("\x73\x75\x62\155\151\x74", SubmitType::class, ["\x61\164\x74\x72" => ["\143\x6c\141\163\x73" => "\x62\x74\156\x20\142\x74\156\55\x62\x6c\x75\x65\x20\x62\x74\x6e\55\154\x67"], "\154\141\x62\x65\x6c" => "\x43\x72\x65\141\x74\x65\40\x61\x6e\144\x20\x49\x6e\163\x74\141\154\154"]); goto Fba1f; F02ec: } private function handleLetsEncryptCertificateForm(Request $request, Form $form, Site $site, array $domains) { goto d9cfa; Ce9e3: F0cbb: goto Db831; a6a25: try { goto d3d11; B6067: c799b: goto Cd678; E38a5: return $response; goto F8b3b; A2f29: $letsEncryptPrivateKey = $this->configManager->get("\154\145\x5f\x70\x72\x69\x76\141\164\x65\x5f\153\145\x79"); goto cb57b; D4b3f: $certificateEntity->setSite($siteEntity); goto E741e; D4e30: $certificateEntity->setPrivateKey($certificate->getPrivateKey()); goto C35c2; d1ccf: $certificateEntity->setType(CertificateEntity::TYPE_LETS_ENCRYPT); goto D4b3f; Fd5ea: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto a1314; a6720: $user = $this->getUser(); goto A2f29; C9863: $siteEntity->addCertificate($certificateEntity); goto abdac; A694a: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto ffb5b; bd63e: $letsEncryptClient = new LetsEncryptClient($privateKey); goto F52a1; E316e: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\x69\x74\x65\163")); goto E38a5; Cbe54: $siteEntity = $this->getSiteEntity($domainName); goto d92db; bfdd1: foreach ($validationErrors as $domain => $validationErrorMessage) { $form->addError(new FormError(sprintf("\x25\163\x3a\40\x25\163", $domain, $validationErrorMessage))); D1216: } goto Eec99; ef6d6: ce4c0: goto C7337; Fd721: $siteUpdater->installCertificate($certificateEntity); goto c33b5; B8dee: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto f5ea8; Eec99: e3735: goto E4eb4; d92db: if (false === is_null($siteEntity)) { goto Be367; } goto E316e; F8b3b: goto A3ab4; goto c4946; c9f1b: $certificateEntity->setCertificateChain($certificate->getCertificateChain()); goto Cfd00; d033d: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto c4ae8; ebcfd: $session->getFlashBag()->set("\x73\165\x63\x63\145\x73\163", $this->translator->trans("\103\x65\162\164\151\146\151\143\141\x74\145\40\150\x61\x73\40\142\x65\x65\x6e\x20\151\x6e\163\164\x61\x6c\154\x65\x64\56")); goto ac09a; Dba61: $domainName = $site->getDomainName(); goto Cbe54; c4946: Be367: goto a6720; e7a4f: $certificateEntity = $this->certificateEntityManager->createEntity(); goto d1ccf; E4eb4: goto c799b; goto ef6d6; F30f1: $evenData = ["\x73\151\x74\x65" => $domainName]; goto b32f3; ea14e: return $response; goto B6067; Cd678: A3ab4: goto d905e; f5ea8: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto Df902; D96e7: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto d033d; Ff586: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto e7a4f; F52a1: $letsEncryptClient->registerAccount(); goto Fd5ea; Df902: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto eb55c; cb57b: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto Fba34; C7337: $distinguishedNameDomains = $domains; goto dbc10; b32f3: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto ebcfd; A35b7: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto D96e7; Df1de: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto Fba68; f7f3a: $letsEncryptClient->setDryRun(true); goto Fb829; bae88: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto A073c; ffb5b: $csr = $csrGenerator->generate(); goto Ff586; eb55c: if (!(true === empty($validationErrors))) { goto Dd2af; } goto bd63e; A073c: $siteUpdater = $this->getSiteUpdater($site); goto B8dee; Cfd00: $siteUpdater = $this->getSiteUpdater($site); goto Fd721; abdac: $this->siteEntityManager->updateEntity($siteEntity); goto F30f1; c33b5: $siteEntity->setCertificate($certificateEntity); goto C9863; Fba68: $rsaKeyGenerator = new RsaKeyGenerator(); goto E6f92; Ef14a: if (true === empty($validationErrors)) { goto ce4c0; } goto bfdd1; a1314: $siteUpdater = $this->getSiteUpdater($site); goto A35b7; E6f92: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto A694a; d3d11: $session = $request->getSession(); goto Dba61; ac09a: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\x73\151\164\x65\137\x63\145\x72\164\x69\x66\x69\143\141\164\145\x73", ["\x64\157\155\141\151\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto ea14e; E741e: $certificateEntity->setCsr($certificate->getCsr()); goto D4e30; Fba34: $letsEncryptClient = new LetsEncryptClient($privateKey); goto f7f3a; dbc10: $commonName = array_shift($distinguishedNameDomains); goto Df1de; C35c2: $certificateEntity->setCertificate($certificate->getCertificate()); goto c9f1b; c4ae8: Dd2af: goto Ef14a; Fb829: $letsEncryptClient->registerAccount(); goto bae88; d905e: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\x72", $this->translator->trans("\x41\x6e\x20\145\162\162\157\162\40\x68\141\163\x20\x6f\x63\143\x75\162\162\145\x64\x2c\x20\x65\x72\162\x6f\162\x20\155\x65\x73\x73\141\147\145\72\x20\x25\x65\162\x72\x6f\x72\115\x65\163\163\x61\147\x65\x25", ["\x25\x65\x72\x72\157\x72\x4d\x65\163\x73\141\x67\x65\45" => $e->getMessage()])); } finally { if (!(true === isset($siteUpdater))) { goto bfff3; } $siteUpdater->deleteLetsEncryptChallengeDirectory(); bfff3: } goto Ce9e3; d9cfa: if (!(true === $form->isValid())) { goto F0cbb; } goto a6a25; Db831: $this->formErrors = $this->getErrorMessages($form); goto D2a23; D2a23: } public function installCertificate(Request $request) : Response { goto f8700; f8700: $site = $this->getSite($request); goto e6973; Aebde: return $response; goto faacb; e6973: if (!(false === is_null($site))) { goto d422e; } goto e8ce9; e8ce9: try { goto E1c59; c249f: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto Fa9f2; } goto b81fa; B3d71: return $response; goto A59b6; ac00a: $session->getFlashBag()->set("\x73\x75\143\143\x65\163\163", $this->translator->trans("\103\x65\162\x74\x69\x66\151\143\141\x74\x65\x20\150\x61\163\40\x62\x65\x65\x6e\40\151\x6e\163\x74\141\x6c\x6c\x65\x64\x2e")); goto E90fa; b05b2: $evenData = ["\163\151\x74\x65" => $domainName]; goto cd3a1; f187b: $siteEntity = $this->getSiteEntity($domainName); goto e8ed4; b81fa: $user = $this->getUser(); goto Cdf81; E1c59: $session = $request->getSession(); goto a8dd6; a00f4: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity))) { goto cc3f3; } goto a2fe5; A59b6: Fa9f2: goto f4acb; f4acb: cc3f3: goto A517c; Cdf81: $siteUpdater = $this->getSiteUpdater($site); goto f1632; f1632: $siteUpdater->installCertificate($certificateEntity); goto fd91c; a2fe5: $certificateSiteEntity = $certificateEntity->getSite(); goto c249f; e8ed4: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto a00f4; cd3a1: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto ac00a; fd91c: $siteEntity->setCertificate($certificateEntity); goto E3371; E3371: $this->siteEntityManager->updateEntity($siteEntity); goto b05b2; d171c: $domainName = $site->getDomainName(); goto f187b; E90fa: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\x74\145\x5f\143\x65\162\x74\151\146\151\143\141\164\x65\x73", ["\144\x6f\155\141\151\x6e\116\141\x6d\x65" => $site->getDomainName()])); goto B3d71; a8dd6: $uid = $request->get("\x75\151\x64"); goto d171c; A517c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\162", $this->translator->trans("\101\x6e\x20\x65\162\162\x6f\162\40\150\x61\163\x20\157\x63\x63\165\162\162\145\x64\54\x20\145\162\x72\x6f\162\x20\x6d\145\x73\x73\141\x67\145\72\40\45\x65\162\162\157\162\115\145\163\x73\x61\x67\145\x25", ["\45\145\162\x72\x6f\162\115\145\x73\163\141\147\x65\x25" => $e->getMessage()])); } goto aa0c3; f1279: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\151\x74\145\163")); goto Aebde; aa0c3: d422e: goto f1279; faacb: } public function deleteCertificate(Request $request) : Response { goto f008d; B31fc: try { goto Aa6be; c41ff: $evenData = ["\x73\151\164\145" => $domainName]; goto Aa37d; D8f71: $siteEntity = $this->getSiteEntity($domainName); goto C8e30; B64e6: $domainName = $site->getDomainName(); goto D8f71; B8096: $this->siteEntityManager->updateEntity($siteEntity); goto c41ff; C73cd: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto e8669; } goto eb926; cc351: $siteEntity->removeCertificate($certificateEntity); goto B8096; Aa6be: $session = $request->getSession(); goto Fd935; Aa37d: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_DELETE, $user, $evenData, $request); goto D1f50; Fd935: $uid = $request->get("\x75\x69\x64"); goto B64e6; D1f50: $session->getFlashBag()->set("\163\165\x63\x63\x65\163\163", $this->translator->trans("\x43\x65\162\164\x69\146\x69\143\x61\x74\145\40\x68\141\x73\40\x62\145\x65\156\40\x64\x65\x6c\145\x74\x65\144\x2e")); goto Dbd7f; b7739: return $response; goto Ca7a0; bb8e2: A0f1b: goto b6b53; eb926: $user = $this->getUser(); goto cc351; Ca7a0: e8669: goto bb8e2; Dbd7f: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\x74\145\137\x63\x65\162\164\151\x66\x69\x63\x61\x74\145\163", ["\144\157\155\141\151\156\x4e\x61\155\x65" => $site->getDomainName()])); goto b7739; E1704: $certificateSiteEntity = $certificateEntity->getSite(); goto C73cd; Da6ba: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity) && false === $certificateEntity->getDefaultCertificate())) { goto A0f1b; } goto E1704; C8e30: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto Da6ba; b6b53: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\x65\x72", $this->translator->trans("\x41\156\x20\145\x72\162\157\162\x20\x68\x61\163\40\157\x63\143\165\x72\x72\145\144\54\40\145\162\162\157\162\40\155\x65\163\163\x61\x67\x65\72\40\45\x65\x72\162\157\x72\115\145\163\x73\141\147\145\x25", ["\45\145\162\162\157\162\x4d\x65\x73\x73\x61\x67\145\x25" => $e->getMessage()])); } goto A6d7f; B0848: $this->checkCsrfToken($request, "\x63\145\x72\x74\x69\146\x69\143\141\x74\x65\x2d\144\145\154\145\164\145"); goto A4c9a; A4c9a: if (!(false === is_null($site))) { goto d537a; } goto B31fc; c5155: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\151\x74\145\x73")); goto d8391; A6d7f: d537a: goto c5155; f008d: $site = $this->getSite($request); goto B0848; d8391: return $response; goto Aa579; Aa579: } public function databases(Request $request) : Response { goto fb0e4; ede8e: $numberOfDatabaseUsers = 0; goto ca5ee; D8081: if (false === is_null($site)) { goto B633f; } goto cd6e9; Bc31c: B633f: goto ed5bd; D3b87: return $response; goto a62ef; E8f52: Ce568: goto faaa0; fab49: $databaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ede8e; a50bf: goto Ad173; goto Bc31c; faaa0: $response = $this->render("\x46\162\157\x6e\x74\x65\156\144\x2f\123\151\164\145\57\x64\x61\164\141\142\141\x73\145\x73\56\x68\164\x6d\x6c\56\x74\167\151\x67", ["\x73\x69\164\145" => $site, "\144\x61\x74\141\x62\141\163\x65\163" => $databases, "\156\165\155\x62\x65\162\x4f\x66\104\141\x74\x61\x62\141\163\x65\x55\x73\145\x72\163" => $numberOfDatabaseUsers, "\x64\141\x74\x61\x62\141\163\145\123\x65\x72\x76\x65\162" => $databaseServerEntity]); goto D6cee; ed5bd: $databases = $site->getDatabases(); goto fab49; ca5ee: foreach ($databases as $database) { $numberOfDatabaseUsers += count($database->getUsers()); c79b5: } goto E8f52; D6cee: Ad173: goto D3b87; cd6e9: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\163")); goto a50bf; fb0e4: $site = $this->getSite($request); goto D8081; a62ef: } public function newDatabase(Request $request) : Response { goto e608a; Db1f4: $response = $this->handleDatabaseForm($request, $form, $site); goto c2f6e; b940f: $databaseEntity->setSite($siteEntity); goto e8e3e; C5d18: goto fda68; goto b07f8; D7b04: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\x74\145\x73")); goto C5d18; Bd071: return $response; goto D62b3; a93c1: D9e59: goto F998f; c144e: return $response; goto a93c1; Be0e9: c130c: goto ad32d; B6d17: if (!(true === $form->isSubmitted())) { goto d9b1f; } goto Db1f4; e8e3e: $form = $this->createDatabaseForm($site, $databaseEntity); goto Eb3ab; b07f8: f501a: goto dbae6; C5463: $form->handleRequest($request); goto B6d17; c2f6e: if (!(false === is_null($response))) { goto D9e59; } goto c144e; dbae6: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto f9dad; F998f: d9b1f: goto Be0e9; f9dad: $databaseEntity = $this->databaseEntityManager->createEntity(); goto b940f; e608a: $site = $this->getSite($request); goto Cfae5; c0081: fda68: goto Bd071; Cfae5: if (false === is_null($site)) { goto f501a; } goto D7b04; Eb3ab: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto c130c; } goto C5463; ad32d: $response = $this->render("\x46\x72\x6f\156\x74\145\x6e\x64\x2f\123\x69\x74\x65\x2f\x6e\145\167\55\x64\x61\164\x61\142\141\x73\145\x2e\x68\x74\155\154\x2e\x74\x77\x69\147", ["\163\151\164\x65" => $site, "\146\157\x72\x6d" => $form->createView(), "\x66\157\162\155\105\x72\162\157\x72\x73" => $this->formErrors]); goto c0081; D62b3: } private function createDatabaseForm(Site $site, DatabaseEntity $databaseEntity) : Form { goto C53d5; Bb745: return $form; goto D49cc; C53d5: $form = $this->createForm("\x41\160\x70\134\106\157\x72\155\x5c\123\151\x74\145\x44\141\164\x61\142\141\x73\145\124\x79\x70\x65", $databaseEntity, ["\x61\x63\x74\x69\157\156" => $this->generateUrl("\x63\x6c\160\x5f\163\151\x74\x65\137\x64\141\164\141\x62\141\163\145\x5f\x6e\145\x77", ["\144\157\155\141\x69\156\116\141\x6d\145" => $site->getDomainName()]), "\155\145\164\x68\157\x64" => "\x50\117\x53\124", "\141\164\x74\x72" => []]); goto A751d; A751d: $form->add("\163\165\142\x6d\151\x74", SubmitType::class, ["\141\164\x74\162" => ["\x63\x6c\x61\163\163" => "\x62\164\156\40\142\164\x6e\x2d\x62\x6c\165\x65\40\x62\164\156\x2d\x6c\147"], "\154\141\x62\145\x6c" => "\x41\144\144\x20\x44\141\164\141\x62\141\163\145"]); goto Bb745; D49cc: } private function handleDatabaseForm(Request $request, Form $form, Site $site) { goto f2b9a; D48fe: B8365: goto ca31b; Fb676: cae67: goto E5c0c; E5c0c: try { goto B1b11; f4061: cf531: goto B2479; D6998: $databaseEntity = $form->getData(); goto bc6c7; d0b05: $siteEntity = $this->getSiteEntity($domainName); goto C8790; Bdf93: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto F2b7c; B1b11: $user = $this->getUser(); goto e964e; B3767: $databaseUserEntity->setDatabase($databaseEntity); goto Fbc34; e964e: $session = $request->getSession(); goto fc119; Fbc34: $databaseEntity->addUser($databaseUserEntity); goto f2cd3; C8790: if (false === is_null($siteEntity)) { goto cb038; } goto C5791; Bcd56: $databaseManager->createUser($databaseUserEntity); goto f1769; Ea574: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\x69\x74\x65\x5f\x64\x61\164\x61\x62\141\163\145\x73", ["\144\x6f\155\141\x69\x6e\x4e\x61\x6d\145" => $site->getDomainName()])); goto f4061; c9f87: $databaseUserEntity->setPassword(Crypto::encrypt($databaseUserPassword)); goto De68c; F2b7c: $databaseEntity->setDatabaseServer($activeDatabaseServerEntity); goto aa9a4; F128e: goto cf531; goto A9b0f; f1769: $this->siteEntityManager->updateEntity($siteEntity); goto bf4c9; B2479: return $response; goto e7f93; aa9a4: $databaseEntity->setSite($siteEntity); goto deadf; bc6c7: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Bdf93; deadf: $databaseUserName = $form->get("\165\x73\x65\162\116\x61\x6d\x65")->getData(); goto e319d; C5791: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\164\x65\x5f\144\141\x74\141\142\x61\x73\145\137\156\x65\x77", ["\x64\157\x6d\x61\151\x6e\116\x61\155\x65" => $site->getDomainName()])); goto F128e; bf4c9: $eventData = ["\x73\151\164\145" => $domainName, "\x64\x61\x74\141\142\x61\x73\145" => $databaseEntity->getName(), "\x64\141\x74\141\x62\141\x73\145\x55\163\145\x72\116\141\x6d\x65" => $databaseUserEntity->getUserName()]; goto f23dc; F7060: $databaseManager->createDatabase($databaseEntity); goto Bcd56; f2cd3: $siteEntity->addDatabase($databaseEntity); goto F7060; e319d: $databaseUserPassword = $form->get("\165\x73\145\162\120\x61\x73\x73\167\157\x72\x64")->getData(); goto f1aad; f89b8: $databaseUserEntity->setUserName($databaseUserName); goto c9f87; De68c: $databaseUserEntity->setPermissions(DatabaseUserEntity::PERMISSIONS_READ_WRITE); goto B3767; f23dc: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_ADD, $user, $eventData, $request); goto C14a0; f1aad: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto f89b8; C14a0: $session->getFlashBag()->set("\163\165\143\x63\145\x73\x73", $this->translator->trans("\x44\x61\164\x61\142\141\x73\x65\x20\150\141\x73\40\142\145\x65\x6e\x20\x61\144\x64\x65\144\56")); goto Ea574; A9b0f: cb038: goto D6998; fc119: $domainName = $site->getDomainName(); goto d0b05; e7f93: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\x72", $this->translator->trans("\x41\x6e\40\145\x72\162\x6f\162\x20\x68\141\163\x20\x6f\x63\x63\x75\x72\162\145\x64\54\40\x65\162\x72\157\x72\x20\x6d\145\163\x73\x61\147\x65\x3a\40\x25\x65\x72\162\157\162\115\145\x73\163\141\147\145\x25", ["\x25\x65\x72\x72\x6f\162\115\x65\x73\x73\x61\x67\145\45" => $e->getMessage()])); } goto D48fe; c3e7b: $this->formErrors = $this->getErrorMessages($form); goto a1af0; a1af0: goto B8365; goto Fb676; f2b9a: if (true === $form->isValid()) { goto cae67; } goto c3e7b; ca31b: } public function deleteDatabase(Request $request) : Response { goto f55e5; fd41b: try { goto c7384; f00a8: $session->getFlashBag()->set("\x73\x75\x63\143\x65\x73\163", $this->translator->trans("\x44\x61\x74\141\142\141\163\145\x20\150\141\163\40\142\x65\x65\156\40\x64\145\x6c\x65\164\145\144\56")); goto b46bc; E8d71: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto edb94; E03ff: $session = $request->getSession(); goto bb50a; f8609: $siteEntity->removeDatabase($databaseEntity); goto E5b57; bb50a: $domainName = $site->getDomainName(); goto E8d71; C5f53: $eventData = ["\163\x69\164\x65" => $domainName, "\144\141\x74\x61\142\x61\x73\x65" => $databaseEntity->getName()]; goto Ec657; d093b: $databaseManager->deleteDatabase($databaseEntity, true); goto f8609; c7384: $user = $this->getUser(); goto E03ff; Ec657: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_DELETE, $user, $eventData, $request); goto f00a8; edb94: $databaseManager = new DatabaseManager($databaseServerEntity); goto d093b; E5b57: $this->siteEntityManager->updateEntity($siteEntity); goto C5f53; b46bc: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\101\156\40\x65\x72\x72\x6f\x72\40\x68\141\163\x20\157\x63\x63\165\162\x72\x65\144\54\40\x65\162\x72\x6f\x72\40\x6d\x65\163\163\141\x67\145\x3a\40\45\x65\x72\x72\x6f\162\x4d\x65\x73\163\x61\147\145\45", ["\45\x65\162\162\x6f\162\115\x65\163\x73\141\x67\145\45" => $e->getMessage()])); } goto Fa81a; f55e5: $site = $this->getSite($request); goto d9049; Fe958: a5639: goto e898e; da1ca: A0643: goto Fe958; Bcb41: $databaseName = $request->get("\144\x61\x74\141\142\141\163\145\116\141\155\145"); goto d8720; d8720: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto d0355; Fa81a: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\164\x65\137\144\141\164\x61\x62\141\x73\145\x73", ["\144\x6f\155\x61\x69\156\x4e\141\155\145" => $site->getDomainName()])); goto fcabb; ce587: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName() && false === is_null($siteEntity))) { goto A0643; } goto fd41b; d9049: $this->checkCsrfToken($request, "\x64\141\x74\141\x62\x61\x73\145\55\x64\145\x6c\145\164\145"); goto E9e78; e898e: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\163\x69\164\145\x73")); goto Ffe50; E9e78: if (!(false === is_null($site))) { goto a5639; } goto Bcb41; d0355: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ce587; Ffe50: return $response; goto d368e; fcabb: return $response; goto da1ca; d368e: } public function phpMyAdmin(Request $request) : Response { goto Fbd21; C5a05: $phpMyAdminUrl = sprintf("\x68\164\x74\160\x73\72\x2f\57\x25\x73\x3a\45\x73\x2f\x70\x68\160\155\x79\141\144\155\151\x6e\57\x6c\157\x67\x69\x6e\56\x70\x68\x70", $request->getHost(), $request->getPort()); goto B9c20; f52c3: e5910: goto dbceb; bc11a: goto e76ab; goto b2d4a; cc091: $response->headers->clearCookie("\160\150\x70\x4d\171\x41\144\x6d\151\x6e\137\150\x74\x74\x70\163"); goto f4b99; De3c9: if (!(false === is_null($activeDatabaseServerEntity))) { goto B55a4; } goto F739f; De850: $session->set("\143\154\x70\55\160\155\141", $data); goto Faa32; e7b85: $data = ["\x68\157\163\164" => $activeDatabaseServerEntity->getHost(), "\160\157\162\x74" => $activeDatabaseServerEntity->getPort()]; goto E0a15; E0a15: $session->set("\x63\154\x70\x2d\x70\155\141", $data); goto e7094; F706a: return $response; goto a0bb8; Fbd21: $domainName = $request->get("\x64\x6f\x6d\141\151\x6e\116\141\x6d\145"); goto E1efc; E9890: if (!(false === is_null($activeDatabaseServerEntity) && false === is_null($activeDatabaseServerEntity))) { goto e5910; } goto F7a7c; d33dc: $databaseUserName = $request->get("\144\141\164\141\x62\x61\x73\145\125\163\x65\x72\116\x61\x6d\x65"); goto D79a1; ff192: $site = $this->getSite($request); goto Bf0d0; Feacc: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto F8c74; } goto C5a05; D79a1: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto A406f; e7094: $response = new RedirectResponse($phpMyAdminUrl); goto d31e0; A406f: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto E9890; f4b99: $response->headers->clearCookie("\x70\155\141\x41\165\x74\150\x2d\61\137\x68\x74\x74\160\x73"); goto f870e; d7ac7: F8c74: goto f52c3; bc9e3: return $response; goto d7ac7; C83ec: return $response; goto e60f1; f758a: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\x69\164\145\163")); goto F706a; Faa32: $response = new RedirectResponse($phpMyAdminUrl); goto bc9e3; b2d4a: E5e9b: goto ff192; B7099: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto De3c9; F739f: $phpMyAdminUrl = sprintf("\150\x74\x74\x70\163\72\57\x2f\x25\163\x3a\45\x73\57\160\150\160\155\x79\141\144\x6d\151\x6e\x2f\x6c\157\x67\151\x6e\56\x70\150\x70", $request->getHost(), $request->getPort()); goto e7b85; b5195: if (false === is_null($domainName)) { goto E5e9b; } goto B7099; B9c20: $data = ["\x68\x6f\163\164" => $activeDatabaseServerEntity->getHost(), "\x75\x73\x65\162\x4e\141\155\145" => $databaseUserEntity->getUserName(), "\x70\x61\x73\x73\167\x6f\162\x64" => $databaseUserEntity->getDecryptedPassword(), "\x70\157\162\164" => $activeDatabaseServerEntity->getPort()]; goto De850; F7a7c: $databaseEntity = $databaseUserEntity->getDatabase(); goto Feacc; E1efc: $session = $request->getSession(); goto b5195; B4933: e76ab: goto f758a; f870e: $response->headers->clearCookie("\123\x69\x67\x6e\x6f\x6e\x53\145\x73\x73\151\157\x6e"); goto C83ec; e60f1: B55a4: goto bc11a; d31e0: $response->headers->clearCookie("\x63\x6c\160\x2d\160\x6d\141"); goto cc091; Bf0d0: if (!(false === is_null($site))) { goto D2c51; } goto d33dc; dbceb: D2c51: goto B4933; a0bb8: } public function phpMyAdminLogout(Request $request) { goto e4938; C9c3c: $response->headers->clearCookie("\143\x6c\x70\x2d\x70\x6d\x61"); goto Bb15f; becfb: $response->headers->clearCookie("\x70\x6d\x61\101\x75\164\x68\x2d\x31\137\x68\164\164\x70\x73"); goto ebc07; ebc07: $response->headers->clearCookie("\x53\151\147\x6e\157\156\x53\145\163\x73\151\x6f\x6e"); goto A3a38; e4938: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\164\x65\163")); goto C9c3c; A3a38: return $response; goto C2d34; Bb15f: $response->headers->clearCookie("\x70\x68\160\x4d\171\101\144\x6d\x69\x6e\x5f\x68\164\164\x70\x73"); goto becfb; C2d34: } public function newDatabaseUser(Request $request) : Response { goto F955a; f7360: return $response; goto b4c71; D2560: Bd525: goto f7360; A61cc: $response = $this->render("\x46\162\x6f\x6e\x74\145\156\x64\x2f\123\151\x74\x65\x2f\156\x65\x77\55\144\x61\x74\141\x62\x61\x73\145\55\165\163\145\x72\56\150\x74\x6d\154\x2e\164\x77\x69\x67", ["\x73\151\164\x65" => $site, "\144\x61\164\x61\142\x61\x73\x65\x55\163\x65\x72" => $databaseUserEntity, "\144\x61\x74\x61\142\141\163\x65\163" => $databases, "\x66\157\x72\155" => $form->createView(), "\x66\157\x72\155\105\162\x72\157\162\163" => $this->formErrors]); goto A9096; b6fa2: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto C7260; C057d: D497a: goto f8c4a; B513f: goto B6f54; goto B922a; f8c4a: $databases = $site->getDatabases(); goto ee827; E1349: if (false === is_null($site)) { goto D497a; } goto cef8e; C7260: $databaseUserEntity->setSite($siteEntity); goto cb8c3; A9096: B6f54: goto D2560; fddf5: $siteEntity = $this->getSiteEntity($domainName); goto fb103; eefa0: if (!(true === $form->isSubmitted())) { goto c7418; } goto ccba3; a5dce: E5cdf: goto A61cc; F955a: $site = $this->getSite($request); goto E1349; B922a: F104f: goto b6fa2; B55f3: $form->handleRequest($request); goto eefa0; cb8c3: $form = $this->createDatabaseUserForm($site, $databaseUserEntity); goto fb02b; Ed399: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\x74\145\x5f\x64\x61\x74\x61\142\141\163\x65\x73", ["\x64\x6f\x6d\141\151\156\116\x61\155\145" => $site->getDomainName()])); goto B513f; De067: f0e56: goto Fbd52; ccba3: $response = $this->handleDatabaseUserForm($request, $form, $site); goto B4c66; f2c59: return $response; goto De067; fb103: if (count($databases) && false === is_null($siteEntity)) { goto F104f; } goto B2edf; F1043: goto Bd525; goto C057d; Fbd52: c7418: goto a5dce; B4c66: if (!(false === is_null($response))) { goto f0e56; } goto f2c59; fb02b: if (!(true === $request->isMethod("\120\x4f\123\x54"))) { goto E5cdf; } goto B55f3; A1a72: $session->getFlashBag()->set("\x64\x61\x6e\147\x65\162", $this->translator->trans("\x4e\157\x20\x64\x61\164\141\142\141\x73\145\x20\146\x6f\x75\x6e\144\x3b\40\x63\x72\x65\141\164\145\40\141\x20\x64\141\x74\141\x62\141\x73\145\x20\x66\x69\162\x73\x74\x2e")); goto Ed399; B2edf: $session = $request->getSession(); goto A1a72; ee827: $domainName = $site->getDomainName(); goto fddf5; cef8e: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\x74\145\163")); goto F1043; b4c71: } private function createDatabaseUserForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto da162; A9a15: $form->add("\163\165\x62\155\x69\164", SubmitType::class, ["\141\x74\x74\162" => ["\143\154\x61\x73\x73" => "\x62\x74\x6e\x20\x62\x74\x6e\x2d\x62\x6c\165\145\40\142\164\156\x2d\154\147"], "\x6c\141\142\x65\154" => "\101\x64\144\40\x44\x61\164\141\x62\x61\163\145\x20\x55\163\x65\162"]); goto E4e90; da162: $form = $this->createForm("\101\160\x70\x5c\x46\157\x72\x6d\134\x53\151\x74\x65\x44\141\164\141\x62\141\x73\x65\125\x73\x65\162\124\x79\160\145", $databaseUserEntity, ["\141\143\x74\x69\157\x6e" => $this->generateUrl("\143\x6c\x70\x5f\163\151\x74\145\x5f\144\x61\x74\141\x62\141\163\145\x5f\165\163\145\x72\x5f\x6e\145\x77", ["\x64\x6f\155\x61\151\156\116\141\x6d\x65" => $site->getDomainName()]), "\x6d\x65\x74\x68\157\144" => "\x50\117\123\124", "\x61\x74\164\162" => []]); goto A9a15; E4e90: return $form; goto F7ffd; F7ffd: } private function handleDatabaseUserForm(Request $request, Form $form, Site $site) { goto c1af0; F1f69: goto B8c1a; goto D5782; e31c8: try { goto f624a; E6c54: $databaseManager->createUser($databaseUserEntity); goto a6ae9; e6364: $databaseName = $databaseEntity->getName(); goto A40f2; A40f2: $eventData = ["\163\x69\164\145" => $domainName, "\144\141\164\x61\142\141\x73\x65\125\163\x65\x72\x4e\141\155\x65" => $databaseUserEntity->getUserName(), "\160\x65\162\155\151\x73\x73\x69\x6f\x6e\x73" => $databaseUserEntity->getPermissions(), "\144\141\164\x61\142\141\x73\145" => $databaseName]; goto bdb4f; b6e5c: Aaf3d: goto Adbea; B83e8: if (false === is_null($siteEntity)) { goto bf4db; } goto da70d; D2988: $databaseUserEntity = $form->getData(); goto d19df; Bdaf9: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto E6c54; a6ae9: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto e9de0; b391d: $session->getFlashBag()->set("\x73\x75\x63\x63\x65\x73\163", $this->translator->trans("\x44\141\164\141\142\x61\x73\145\40\125\x73\145\x72\40\150\x61\x73\40\x62\145\145\x6e\x20\x61\x64\144\x65\144\x2e")); goto A6db4; d19df: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto A17bf; A6db4: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\164\x65\137\x64\x61\x74\x61\x62\x61\163\x65\x73", ["\144\157\x6d\x61\x69\156\x4e\x61\155\145" => $site->getDomainName()])); goto b6e5c; e9de0: $databaseEntity = $databaseUserEntity->getDatabase(); goto e6364; da70d: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\x69\164\x65\137\144\x61\x74\x61\x62\141\x73\x65\137\165\x73\145\x72\x5f\x6e\145\x77", ["\144\157\x6d\141\151\156\x4e\x61\x6d\145" => $site->getDomainName()])); goto C1aac; A17bf: $databaseUserEntity->setPassword($encryptedPassword); goto de4b9; Adbea: return $response; goto aa3d8; de4b9: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Bdaf9; C1aac: goto Aaf3d; goto cf187; bdb4f: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_ADD, $user, $eventData, $request); goto b391d; E265c: $domainName = $site->getDomainName(); goto f2bfb; cf187: bf4db: goto D2988; f2bfb: $siteEntity = $this->getSiteEntity($domainName); goto B83e8; f624a: $user = $this->getUser(); goto dc6bb; dc6bb: $session = $request->getSession(); goto E265c; aa3d8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\x72", $this->translator->trans("\x41\156\40\145\162\x72\x6f\x72\x20\x68\x61\163\40\157\x63\x63\x75\162\x72\145\144\x2c\40\x65\162\x72\x6f\162\40\x6d\145\163\x73\x61\147\x65\72\x20\45\x65\162\162\x6f\x72\115\145\x73\163\141\x67\x65\x25", ["\x25\x65\162\162\x6f\x72\115\x65\163\x73\x61\x67\145\x25" => $e->getMessage()])); } goto Ebdca; fc163: $this->formErrors = $this->getErrorMessages($form); goto F1f69; D5782: Befd2: goto e31c8; c1af0: if (true === $form->isValid()) { goto Befd2; } goto fc163; Ebdca: B8c1a: goto E5f28; E5f28: } public function editDatabaseUser(Request $request) : Response { goto Ae003; c0592: if (!(true === $form->isSubmitted())) { goto a8cac; } goto eb459; e50bf: if (!(false === is_null($databaseUserEntity))) { goto E2ee9; } goto Bbd1f; Ae003: $site = $this->getSite($request); goto Cede9; Ea268: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\164\x65\163")); goto E3daa; Fb9ad: c5219: goto ff37c; Eeea7: goto c5219; goto cba29; ef728: B77ed: goto A597d; Dd6b1: if (count($databases) && false === is_null($siteEntity)) { goto A3ef2; } goto Bf6ff; ff37c: cf2e2: goto d8188; F2371: $databaseUserName = $request->get("\x64\141\x74\141\x62\141\163\x65\125\163\x65\162\116\x61\155\x65"); goto ab24b; C8fbb: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto E9b90; } goto b4cad; F1ce6: E9b90: goto D5941; Bf6ff: $session = $request->getSession(); goto e4610; b4cad: $form->handleRequest($request); goto c0592; fc1a8: a8cac: goto F1ce6; f02e9: $domainName = $site->getDomainName(); goto Cfce8; Cede9: if (false === is_null($site)) { goto B77ed; } goto Ea268; B940b: $form = $this->createDatabaseUserEditForm($site, $databaseUserEntity); goto C8fbb; D5c43: F6a2c: goto fc1a8; d8188: return $response; goto B6dcf; B33d0: if (!(false === is_null($response))) { goto F6a2c; } goto dbd93; E3daa: goto cf2e2; goto ef728; Bbd1f: $databaseUserEntity->setPassword(''); goto B940b; eb459: $response = $this->handleDatabaseUserEditForm($request, $form, $site); goto B33d0; F3b0d: E2ee9: goto Fb9ad; Cfce8: $siteEntity = $this->getSiteEntity($domainName); goto Dd6b1; e4610: $session->getFlashBag()->set("\144\141\156\x67\x65\162", $this->translator->trans("\x4e\x6f\x20\144\141\164\x61\x62\141\x73\145\40\146\x6f\x75\156\x64\x3b\40\x63\162\145\x61\x74\145\x20\x61\40\144\x61\x74\141\x62\x61\163\145\x20\146\151\x72\x73\x74\56")); goto f1ab3; A597d: $databases = $site->getDatabases(); goto f02e9; dbd93: return $response; goto D5c43; f1ab3: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\164\x65\x5f\x64\141\164\141\x62\141\163\x65\x73", ["\x64\x6f\x6d\141\151\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto Eeea7; D5941: $response = $this->render("\106\162\157\x6e\x74\x65\x6e\x64\57\x53\151\164\x65\57\x65\144\x69\x74\55\144\141\164\141\x62\x61\x73\x65\55\165\x73\x65\x72\x2e\x68\164\155\x6c\x2e\x74\167\151\147", ["\x73\x69\x74\145" => $site, "\x64\x61\164\141\142\x61\163\145\125\163\145\x72" => $databaseUserEntity, "\x66\157\162\155" => $form->createView(), "\146\157\x72\x6d\x45\162\x72\157\x72\x73" => $this->formErrors]); goto F3b0d; ab24b: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto e50bf; cba29: A3ef2: goto F2371; B6dcf: } private function createDatabaseUserEditForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto e8826; Bb7a4: $form->add("\x73\165\x62\155\x69\x74", SubmitType::class, ["\x61\x74\164\162" => ["\143\154\x61\x73\163" => "\x62\164\x6e\40\142\164\156\55\x62\x6c\165\145\40\142\x74\x6e\x2d\x6c\x67"], "\154\141\142\x65\154" => "\x53\141\x76\145"]); goto cd0ee; cd0ee: return $form; goto Ef1a7; e8826: $form = $this->createForm("\101\x70\x70\x5c\x46\x6f\162\155\x5c\123\151\164\145\104\141\x74\x61\142\x61\163\145\125\163\145\162\x45\144\151\164\124\x79\160\145", $databaseUserEntity, ["\141\x63\164\x69\157\x6e" => $this->generateUrl("\x63\154\160\137\163\151\x74\x65\x5f\144\141\164\x61\142\x61\163\145\137\x75\163\x65\x72\137\x65\144\151\x74", ["\144\x6f\155\x61\x69\x6e\x4e\141\155\x65" => $site->getDomainName(), "\144\141\x74\141\x62\x61\163\145\125\163\x65\162\116\x61\x6d\145" => $databaseUserEntity->getUserName()]), "\x6d\x65\164\150\x6f\144" => "\120\117\123\124", "\141\x74\x74\x72" => []]); goto Bb7a4; Ef1a7: } private function handleDatabaseUserEditForm(Request $request, Form $form, Site $site) { goto Bd4f5; c4142: cc49c: goto C9b4b; E8080: goto cc49c; goto cc750; Dc336: $this->formErrors = $this->getErrorMessages($form); goto E8080; cc750: b2032: goto a01e8; a01e8: try { goto f259b; be99d: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\151\x74\x65\137\x64\x61\x74\141\142\141\x73\145\137\165\x73\145\162\x5f\156\145\x77", ["\144\x6f\x6d\x61\151\156\x4e\x61\x6d\145" => $site->getDomainName()])); goto b9600; c61dd: $databaseName = $databaseEntity->getName(); goto b4706; a1cc4: $session->getFlashBag()->set("\163\165\143\x63\145\x73\x73", $this->translator->trans("\x44\x61\x74\x61\x62\x61\163\x65\40\125\x73\145\x72\40\x68\141\x73\40\142\145\x65\x6e\x20\165\160\144\141\x74\145\x64\56")); goto b80fd; d80db: $databaseManager->createUser($databaseUserEntity); goto Dc9a5; Bd470: $domainName = $site->getDomainName(); goto E3543; f259b: $user = $this->getUser(); goto B20c5; B20c5: $session = $request->getSession(); goto Bd470; b80fd: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\x65\x5f\x64\x61\x74\x61\x62\x61\163\145\x73", ["\x64\157\155\141\x69\x6e\x4e\141\x6d\x65" => $site->getDomainName()])); goto A88f4; Dc9a5: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto Dc3d2; C81dc: $databaseUserEntity->setPassword($encryptedPassword); goto bf102; b9600: goto A9cee; goto eb9fe; cfc58: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto d80db; ac926: $databaseUserEntity = $form->getData(); goto Bb83d; B5a69: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_EDIT, $user, $eventData, $request); goto a1cc4; db4ed: return $response; goto Eedc2; A88f4: A9cee: goto db4ed; eb9fe: fd872: goto ac926; b4706: $eventData = ["\x73\151\x74\x65" => $domainName, "\144\x61\164\x61\142\141\163\145\x55\163\145\x72\116\x61\x6d\x65" => $databaseUserEntity->getUserName(), "\x70\x65\162\155\x69\x73\163\151\x6f\x6e\163" => $databaseUserEntity->getPermissions(), "\144\x61\x74\x61\x62\141\x73\x65" => $databaseName]; goto B5a69; bf102: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto cfc58; ce661: if (false === is_null($siteEntity)) { goto fd872; } goto be99d; E3543: $siteEntity = $this->getSiteEntity($domainName); goto ce661; Bb83d: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto C81dc; Dc3d2: $databaseEntity = $databaseUserEntity->getDatabase(); goto c61dd; Eedc2: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\162", $this->translator->trans("\101\x6e\40\x65\162\x72\157\x72\40\150\141\163\x20\x6f\x63\x63\x75\162\162\145\x64\54\x20\145\x72\x72\x6f\x72\x20\155\x65\x73\x73\141\147\145\x3a\x20\45\x65\x72\162\157\x72\115\145\163\x73\x61\x67\145\x25", ["\x25\x65\162\162\x6f\162\115\x65\163\163\x61\x67\145\x25" => $e->getMessage()])); } goto c4142; Bd4f5: if (true === $form->isValid()) { goto b2032; } goto Dc336; C9b4b: } public function deleteDatabaseUser(Request $request) : Response { goto C537e; C5df8: if (!(false === is_null($site))) { goto D0f04; } goto e49a0; a7eda: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\151\x74\x65\137\x64\141\164\141\x62\141\x73\x65\163", ["\144\x6f\155\x61\151\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto a7047; e49a0: $databaseUserName = $request->get("\144\x61\x74\141\x62\x61\163\x65\x55\163\x65\x72\x4e\141\155\x65"); goto D2f86; C537e: $site = $this->getSite($request); goto C2abe; F5e2d: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\x69\164\x65\163")); goto fc1f9; ce3d4: try { goto D067a; b7a7f: fe21d: goto C1775; a7d0e: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto fe21d; } goto bf125; cb206: $domainName = $site->getDomainName(); goto d2dfa; bf125: $user = $this->getUser(); goto cb206; a331e: $eventData = ["\163\x69\x74\145" => $domainName, "\144\x61\164\141\142\141\x73\x65\x55\x73\145\x72\x4e\141\x6d\145" => $databaseUserName]; goto bb54c; D238c: $databaseManager->deleteUser($databaseUserEntity); goto bc461; D067a: $databaseEntity = $databaseUserEntity->getDatabase(); goto a7d0e; E42bc: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto D238c; bc461: $this->databaseUserEntityManager->deleteEntity($databaseUserEntity); goto d9702; bb54c: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_DELETE, $user, $eventData, $request); goto b7a7f; d2dfa: $session = $request->getSession(); goto B3582; B3582: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto E42bc; d9702: $session->getFlashBag()->set("\163\165\143\x63\145\x73\x73", $this->translator->trans("\x44\141\x74\x61\x62\x61\163\x65\40\x55\x73\x65\162\40\x68\x61\x73\40\142\145\x65\x6e\x20\x64\145\154\145\x74\145\144\56")); goto a331e; C1775: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\162", $this->translator->trans("\x41\x6e\40\x65\162\162\x6f\162\x20\x68\x61\163\40\157\143\143\165\162\x72\x65\144\x2c\40\x65\162\x72\157\x72\x20\155\x65\163\163\x61\147\x65\72\x20\45\145\x72\x72\x6f\162\115\x65\163\x73\141\147\145\x25", ["\x25\x65\x72\x72\157\x72\115\x65\x73\x73\141\x67\x65\x25" => $e->getMessage()])); } goto a7eda; d983a: C02f5: goto Ea62d; Ea62d: D0f04: goto F5e2d; fc1f9: return $response; goto c8c76; a7047: return $response; goto d983a; C2abe: $this->checkCsrfToken($request, "\144\x61\164\x61\142\141\x73\x65\x2d\x75\x73\x65\x72\55\144\145\154\x65\164\145"); goto C5df8; A455a: if (!(false === is_null($databaseUserEntity))) { goto C02f5; } goto ce3d4; D2f86: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto A455a; c8c76: } public function varnishCache(Request $request) : Response { goto a0eed; F96e9: return $response; goto d956e; fffb3: Cb88e: goto F96e9; f8c31: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto Ecbdc; e0bb2: Db032: goto D327c; e39ca: if (!(false === is_null($response))) { goto c629d; } goto D66a8; a6dc8: F7bae: goto E5afe; F5ae4: return $response; goto e0bb2; D327c: ab198: goto f3602; f3602: if (!(true === $purgeCacheForm->isSubmitted())) { goto F7bae; } goto b112f; Ecbdc: $varnishCacheSettingsData = ["\x69\163\105\x6e\x61\x62\154\x65\144" => true === isset($varnishCacheSettings["\x65\156\141\142\154\x65\x64"]) && true === $varnishCacheSettings["\145\x6e\141\x62\154\145\144"] ? true : false, "\163\x65\x72\166\145\x72" => true === isset($varnishCacheSettings["\163\x65\x72\x76\145\x72"]) ? $varnishCacheSettings["\163\145\x72\x76\x65\x72"] : "\x31\x32\x37\x2e\x30\x2e\x30\56\61\72\x36\x30\70\x31", "\x63\x61\x63\150\145\124\141\147\x50\x72\x65\146\x69\170" => true === isset($varnishCacheSettings["\x63\141\143\x68\145\124\141\147\120\x72\145\x66\151\x78"]) ? $varnishCacheSettings["\143\x61\143\150\x65\x54\x61\147\x50\x72\x65\x66\151\170"] : substr(md5(time()), 0, 4), "\143\x61\x63\150\x65\x4c\151\x66\145\164\x69\x6d\145" => true === isset($varnishCacheSettings["\143\x61\143\150\x65\114\x69\146\x65\x74\151\x6d\x65"]) ? $varnishCacheSettings["\x63\141\x63\150\x65\114\151\146\145\x74\x69\x6d\x65"] : "\x36\60\x34\x38\60\60", "\145\x78\x63\154\x75\x64\x65\x64\120\x61\162\x61\x6d\163" => true === isset($varnishCacheSettings["\x65\x78\x63\154\165\x64\x65\144\x50\141\162\x61\x6d\163"]) ? implode("\x2c", $varnishCacheSettings["\145\170\143\x6c\165\144\x65\x64\x50\141\x72\x61\x6d\x73"]) : "\x5f\x5f\123\x49\x44\x2c\156\157\x43\x61\143\150\x65\x2c", "\x65\170\143\154\x75\x64\145\x73" => true === isset($varnishCacheSettings["\x65\170\x63\x6c\x75\x64\145\163"]) ? implode(PHP_EOL, $varnishCacheSettings["\x65\170\143\x6c\x75\x64\145\x73"]) : '']; goto B632d; dd612: $settingsForm->handleRequest($request); goto b4c9a; F0d06: $response = $this->handleVarnishCacheSettingsForm($request, $settingsForm, $site); goto f6a36; d0311: F0e33: goto f8c31; Ccd30: $purgeCacheForm = $this->createVarnishCachePurgeCacheForm($site); goto Fa898; D66a8: return $response; goto a15b8; B632d: $settingsForm = $this->createVarnishCacheSettingsForm($site, $varnishCacheSettingsData); goto Ccd30; f952f: if (false === is_null($site) && true === $site->getVarnishCache()) { goto F0e33; } goto D470a; D2607: goto Cb88e; goto d0311; a15b8: c629d: goto a6dc8; a0eed: $site = $this->getSite($request); goto f952f; b112f: $response = $this->handleVarnishCachePurgeCacheForm($request, $purgeCacheForm, $site); goto e39ca; b4c9a: $purgeCacheForm->handleRequest($request); goto E3d69; D470a: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\145\163")); goto D2607; f6a36: if (!(false === is_null($response))) { goto Db032; } goto F5ae4; E5afe: d10a9: goto a18cf; a18cf: $response = $this->render("\x46\x72\157\x6e\x74\145\x6e\144\57\123\x69\164\x65\x2f\x76\141\162\156\151\x73\150\55\143\141\x63\x68\145\x2e\150\164\x6d\154\x2e\164\x77\151\x67", ["\163\151\x74\145" => $site, "\163\145\164\x74\x69\x6e\147\163\106\157\162\155" => $settingsForm->createView(), "\x70\165\x72\x67\145\103\x61\x63\150\x65\106\157\162\155" => $purgeCacheForm->createView(), "\x66\x6f\162\155\x45\x72\162\157\162\x73" => $this->formErrors]); goto fffb3; Fa898: if (!(true === $request->isMethod("\120\x4f\123\x54"))) { goto d10a9; } goto dd612; E3d69: if (!(true === $settingsForm->isSubmitted())) { goto ab198; } goto F0d06; d956e: } private function createVarnishCacheSettingsForm(Site $site, array $data) : Form { goto b30e9; b6043: return $form; goto b4d6b; b30e9: $form = $this->createForm("\x41\160\x70\134\106\157\x72\155\134\x53\x69\164\145\126\x61\162\x6e\151\x73\x68\x43\x61\x63\x68\x65\123\x65\164\164\x69\x6e\x67\163\x54\171\160\145", $data, ["\x61\x63\x74\x69\157\156" => $this->generateUrl("\143\x6c\160\x5f\x73\x69\164\x65\x5f\x76\x61\x72\156\151\x73\x68\137\x63\x61\x63\150\145", ["\x64\157\x6d\141\151\156\x4e\x61\x6d\x65" => $site->getDomainName()]), "\x6d\145\x74\150\157\144" => "\x50\117\123\x54", "\x61\x74\x74\x72" => []]); goto Bb89f; Bb89f: $form->add("\x73\x75\x62\x6d\x69\164", SubmitType::class, ["\x61\x74\x74\x72" => ["\143\x6c\141\163\x73" => "\x62\164\156\40\x62\x74\156\55\x62\154\x75\145\x20\142\164\x6e\x2d\154\x67"], "\x6c\x61\142\145\x6c" => "\123\x61\166\x65"]); goto b6043; b4d6b: } private function createVarnishCachePurgeCacheForm(Site $site) : Form { goto e8052; e2a9e: return $form; goto Bffb4; e8052: $form = $this->createForm("\x41\160\x70\134\x46\157\162\155\134\123\x69\x74\x65\126\141\x72\x6e\x69\x73\x68\x43\x61\143\x68\x65\120\x75\x72\x67\145\x43\x61\x63\150\145\x54\171\160\145", ["\x73\151\164\145" => $site], ["\x61\x63\x74\151\x6f\156" => $this->generateUrl("\143\x6c\160\x5f\x73\151\164\x65\137\x76\141\162\x6e\151\x73\x68\137\x63\x61\143\x68\145", ["\x64\157\x6d\141\x69\x6e\116\x61\155\145" => $site->getDomainName()]), "\x6d\145\x74\150\x6f\x64" => "\120\117\x53\x54", "\141\x74\164\x72" => []]); goto D5ede; D5ede: $form->add("\x73\x75\x62\x6d\151\164", SubmitType::class, ["\x61\164\x74\x72" => ["\x63\154\141\163\163" => "\x62\x74\156\40\142\164\156\55\x62\154\165\145\x20\142\x74\156\x2d\154\x67"], "\x6c\141\x62\x65\x6c" => "\x50\165\x72\147\145\40\x43\x61\x63\x68\x65"]); goto e2a9e; Bffb4: } private function handleVarnishCacheSettingsForm(Request $request, Form $form, Site $site) { goto F3870; aa604: E7c66: goto ff492; Bd716: $this->formErrors = $this->getErrorMessages($form); goto e7c69; e6d01: faecd: goto E0100; F3870: if (true === $form->isValid()) { goto faecd; } goto Bd716; E0100: try { goto Fff45; Cac3f: $siteUpdater = $this->getSiteUpdater($site); goto d5542; E6b26: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_SETTINGS_UPDATE, $user, $eventData, $request); goto eabb9; f1202: $cacheTagPrefix = $form->get("\x63\x61\143\150\145\x54\x61\x67\x50\162\x65\x66\151\170")->getData(); goto bfcde; bc66c: $domainName = $site->getDomainName(); goto C5cf5; faaf0: $siteUpdater->phpSettings(); goto B9e34; b363d: $user = $this->getUser(); goto D0baf; eabb9: $session->getFlashBag()->set("\x73\x75\x63\143\x65\x73\163", $this->translator->trans("\x56\x61\162\x6e\151\163\150\40\x43\x61\x63\150\x65\x20\123\145\x74\164\151\156\x67\163\x20\x68\x61\166\x65\40\142\145\145\x6e\40\x73\x61\x76\x65\x64\56")); goto C9081; F9652: $varnishCacheSettings = ["\x65\156\141\x62\x6c\x65\x64" => $isEnabled, "\x73\145\162\166\x65\x72" => $server, "\x63\x61\x63\150\x65\124\141\147\x50\162\145\x66\151\170" => $cacheTagPrefix, "\143\141\x63\x68\145\114\x69\146\x65\x74\151\x6d\x65" => $cacheLifetime, "\145\x78\143\154\x75\x64\145\x73" => $excludes, "\145\x78\143\154\165\x64\x65\x64\120\x61\162\x61\x6d\x73" => $excludedParams]; goto Cb254; D0baf: $isEnabled = $form->get("\151\x73\105\x6e\x61\x62\x6c\145\x64")->getData(); goto fe269; f2e08: Be6f9: goto D5460; Cb254: $site->setVarnishCacheSettings($varnishCacheSettings); goto Cac3f; d9d5c: $excludes = array_map("\164\x72\151\x6d", array_filter(explode(PHP_EOL, trim($form->get("\145\170\x63\x6c\165\x64\x65\x73")->getData())))); goto F9652; bfcde: $excludedParams = array_map("\x74\x72\151\x6d", array_filter(explode("\54", trim($form->get("\145\170\143\x6c\165\x64\x65\144\x50\x61\162\x61\155\163")->getData())))); goto d9d5c; D5460: return $response; goto Fa3e9; f7a18: if (false === is_null($siteEntity)) { goto Aae74; } goto E15ae; d5542: $siteUpdater->writeVarnishCacheSettingsFile($varnishCacheSettings); goto faaf0; E5fbe: $cacheLifetime = $form->get("\143\141\143\150\145\114\151\146\x65\164\x69\155\x65")->getData(); goto f1202; a7c2c: goto Be6f9; goto d7b3d; d7b3d: Aae74: goto b363d; fe269: $server = $form->get("\163\145\162\x76\x65\162")->getData(); goto E5fbe; B9e34: $eventData = ["\x73\151\164\145" => $domainName, "\x76\x61\162\156\x69\x73\150\x43\x61\x63\150\x65\105\156\141\x62\x6c\x65\144" => $isEnabled, "\163\145\162\166\x65\162" => $server, "\x63\141\143\150\x65\124\141\147\120\162\145\146\x69\170" => $cacheTagPrefix, "\x63\141\143\150\145\114\x69\146\x65\164\151\155\x65" => $cacheLifetime, "\x65\x78\143\154\165\144\145\163" => $excludes, "\x65\170\143\154\x75\x64\x65\x64\120\141\162\x61\x6d\x73" => $excludedParams]; goto E6b26; Fff45: $session = $request->getSession(); goto bc66c; C9081: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\x73\x69\164\x65\137\166\x61\162\156\x69\163\150\137\x63\141\143\150\145", ["\144\x6f\155\141\151\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto f2e08; E15ae: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\145\x73")); goto a7c2c; C5cf5: $siteEntity = $this->getSiteEntity($domainName); goto f7a18; Fa3e9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\x65\162", $this->translator->trans("\101\156\x20\145\162\162\157\162\40\x68\x61\x73\40\x6f\143\143\x75\162\162\145\144\54\x20\x65\162\x72\157\162\40\155\x65\163\163\141\147\x65\72\40\45\145\x72\162\x6f\x72\x4d\x65\x73\x73\141\147\145\x25", ["\x25\145\x72\x72\x6f\162\115\145\x73\x73\x61\x67\x65\45" => $e->getMessage()])); } goto aa604; e7c69: goto E7c66; goto e6d01; ff492: } private function handleVarnishCachePurgeCacheForm(Request $request, Form $form, Site $site) { goto b2588; b2588: if (true === $form->isValid()) { goto c8e11; } goto B1104; B1104: $this->formErrors = $this->getErrorMessages($form); goto c15a4; Bfe1b: try { goto f23d5; fd88c: $user = $this->getUser(); goto fed53; D610b: foreach ($purgeValues as $purgeValue) { goto f7acf; Bbf6e: if (true === str_starts_with($purgeValue, "\x68\164\164\x70")) { goto Ed608; } goto aad1e; bbb3c: if (!(false === empty($purgeValue))) { goto A2b93; } goto Bbf6e; Bfcd2: a915e: goto Ca381; ef9df: Ed608: goto E962e; E962e: $varnishCacheClient->purgeUrl($purgeValue); goto Bfcd2; aad1e: $varnishCacheClient->purgeTag($purgeValue); goto B6aca; b2aac: f414c: goto ca293; B6aca: goto a915e; goto ef9df; f7acf: $purgeValue = trim($purgeValue); goto bbb3c; Ca381: A2b93: goto b2aac; ca293: } goto Fe290; bac83: goto F6341; goto a29bf; f441d: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_PURGE, $user, $eventData, $request); goto Cbbfd; a1031: if (false === is_null($siteEntity)) { goto Aeb14; } goto cd398; c766d: $domainName = $site->getDomainName(); goto B904e; Aac5e: return $response; goto ab752; F0069: E2cd7: goto C613a; fa750: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\x74\145\x5f\x76\141\162\x6e\151\163\x68\x5f\143\141\x63\x68\x65", ["\144\x6f\x6d\141\151\156\x4e\x61\x6d\x65" => $site->getDomainName()])); goto B850b; B904e: $siteEntity = $this->getSiteEntity($domainName); goto a1031; A5663: Efb77: goto F18dc; a29bf: Aeb14: goto fd88c; f23d5: $session = $request->getSession(); goto c766d; C613a: $varnishCacheClient = new VarnishCacheClient(); goto eeaa1; cd398: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\151\164\x65\163")); goto bac83; eeaa1: $varnishCacheClient->setServer($varnishCacheSettings["\163\145\162\x76\145\x72"]); goto D610b; fed53: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto F9078; F18dc: $eventData = ["\x73\151\x74\145" => $domainName, "\x76\141\154\x75\x65\x73" => implode("\x2c", $purgeValues)]; goto f441d; Ced0e: throw new \Exception("\x56\x61\162\156\151\x73\150\40\x43\x61\143\150\x65\x20\123\x65\164\164\x69\156\x67\163\40\x63\141\x6e\156\x6f\164\x20\x62\145\x20\x65\155\x70\164\x79\56"); goto B0940; Cbbfd: $session->getFlashBag()->set("\x73\165\x63\x63\145\x73\163", $this->translator->trans("\126\141\x72\x6e\151\x73\150\x20\103\141\x63\x68\x65\40\150\x61\163\40\x62\x65\x65\156\x20\160\165\162\147\x65\144\x2e")); goto fa750; b7d1b: if (false === empty($purgeValues) && true === isset($varnishCacheSettings["\163\x65\162\166\x65\162"]) && false === empty($varnishCacheSettings["\163\145\x72\166\145\x72"])) { goto E2cd7; } goto Ced0e; Fe290: A2959: goto A5663; B0940: goto Efb77; goto F0069; B850b: F6341: goto Aac5e; F9078: $purgeValues = array_map("\x74\162\x69\155", array_filter(explode("\x2c", trim($form->get("\x76\x61\x6c\165\145")->getData())))); goto b7d1b; ab752: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\x67\145\x72", $this->translator->trans("\x41\x6e\x20\x65\x72\162\157\x72\40\x68\141\x73\40\157\143\x63\165\x72\162\x65\144\x2c\40\145\x72\x72\157\x72\x20\155\145\163\x73\141\147\x65\72\x20\x25\145\x72\162\x6f\162\115\145\163\163\x61\x67\145\45", ["\x25\145\x72\162\157\x72\115\x65\x73\163\x61\147\145\45" => $e->getMessage()])); } goto D3f9c; D3f9c: C69cf: goto ad797; Dd4cb: c8e11: goto Bfe1b; c15a4: goto C69cf; goto Dd4cb; ad797: } public function purgeVarnishCache(Request $request) : Response { goto a078c; B019d: C7f9a: goto f8255; be725: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\151\x74\145\137\x76\141\162\x6e\x69\x73\150\137\x63\x61\x63\x68\145", ["\x64\157\155\x61\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto e0daf; d41db: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\x74\145\163")); goto b6b5e; C7e41: if (false === is_null($site)) { goto fc73f; } goto d41db; f8255: return $response; goto e3f67; b6b5e: goto C7f9a; goto Cc9f8; e0daf: return $response; goto B019d; a078c: $site = $this->getSite($request); goto C7e41; Cc9f8: fc73f: goto A8003; A8003: try { goto C1640; B949c: $varnishCacheClient->setServer($varnishCacheSettings["\x73\x65\x72\166\x65\x72"]); goto a8d1f; a8d1f: $varnishCacheClient->purgeTag($cacheTagPrefix); goto c5d89; F9fdc: F66ad: goto Ab534; Ab534: $eventData = ["\163\151\x74\145" => $domainName, "\x70\165\162\x67\145" => "\146\x75\x6c\154"]; goto db769; F82db: $session->getFlashBag()->set("\163\x75\x63\x63\x65\x73\x73", $this->translator->trans("\126\x61\162\156\151\x73\150\x20\103\141\x63\150\145\40\x68\x61\x73\x20\x62\145\x65\x6e\40\x70\165\162\x67\x65\x64\56")); goto b3594; C1640: $user = $this->getUser(); goto Ba73a; c5d89: $varnishCacheClient->purgeHost($domainName); goto F9fdc; B60b9: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto f6828; db769: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_PURGE, $user, $eventData, $request); goto F82db; ce887: $varnishCacheClient = new VarnishCacheClient(); goto B949c; b7ece: $cacheTagPrefix = $varnishCacheSettings["\143\141\143\x68\x65\124\141\147\x50\x72\x65\146\x69\170"]; goto ce887; f6828: if (!(true === isset($varnishCacheSettings["\163\145\162\x76\145\x72"]) && true === isset($varnishCacheSettings["\143\141\143\x68\x65\x54\x61\x67\x50\162\x65\146\x69\170"]) && false === empty($varnishCacheSettings["\x63\141\x63\x68\x65\x54\x61\147\120\162\x65\146\151\170"]))) { goto F66ad; } goto b7ece; Ba73a: $session = $request->getSession(); goto C15df; C15df: $domainName = $site->getDomainName(); goto B60b9; b3594: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\162", $this->translator->trans("\x41\x6e\40\145\x72\162\157\162\x20\x68\x61\163\x20\x6f\x63\x63\165\x72\162\x65\x64\x2c\x20\145\162\x72\157\162\x20\155\145\x73\x73\x61\x67\x65\72\x20\45\x65\x72\162\157\x72\x4d\x65\163\x73\141\147\x65\x25", ["\x25\x65\x72\162\157\x72\x4d\145\163\x73\141\147\x65\45" => $e->getMessage()])); } goto be725; e3f67: } public function vhost(Request $request) : Response { goto A7725; F8183: Cd778: goto Cfec3; e6f8c: if (!(false === is_null($response))) { goto A0ae4; } goto A9fd5; A649f: $response = $this->handleVhostUpdate($request, $site, $siteEntity, $oldVhostTemplate); goto e6f8c; B10e4: A0ae4: goto Ad106; A9fd5: return $response; goto B10e4; A3be9: $isCsrfTokenValid = $this->isCsrfTokenValid("\166\x68\157\163\x74\x2d\165\x70\x64\141\164\x65", (string) $request->get("\x74\x6f\x6b\145\156")); goto e88c9; Ad106: Bdb53: goto F8183; c6057: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\x74\145\163")); goto Cc55f; a1412: ebc52: goto C3496; e4139: $vhostTemplate = trim($request->get("\x76\x68\x6f\x73\x74\x2d\x74\145\155\x70\154\141\164\145")); goto E8307; e88c9: if (!(false === $isCsrfTokenValid)) { goto b2fd8; } goto Ac7c5; A7725: $site = $this->getSite($request); goto cda06; Ac7c5: throw new InvalidCsrfTokenException("\x54\x68\x65\40\103\x53\122\x46\40\164\157\153\x65\x6e\x20\x69\x73\x20\151\x6e\x76\141\154\x69\x64\x2e"); goto Dd8d5; Cf8d4: $siteEntity = $this->getSiteEntity($domainName); goto Ca265; Cc55f: goto ebc52; goto dc6de; cda06: if (false === is_null($site)) { goto B39ed; } goto c6057; dc6de: B39ed: goto fa365; Cfec3: $response = $this->render("\x46\x72\x6f\156\164\x65\156\144\x2f\x53\151\x74\145\x2f\x76\150\157\163\164\56\x68\x74\155\154\x2e\x74\x77\x69\147", ["\x73\151\x74\x65" => $site]); goto a1412; Dd8d5: b2fd8: goto e4139; fa365: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto Cd778; } goto A3be9; e3685: $domainName = $site->getDomainName(); goto Cf8d4; C3496: return $response; goto cdcda; Ca265: $oldVhostTemplate = $siteEntity->getVhostTemplate(); goto Bc732; E8307: if (!(false === empty($vhostTemplate))) { goto Bdb53; } goto e3685; Bc732: $site->setVhostTemplate($vhostTemplate); goto A649f; cdcda: } private function handleVhostUpdate(Request $request, Site $site, SiteEntity $siteEntity, string $oldVhostTemplate) { try { goto D6830; a1784: $siteUpdater = $this->getSiteUpdater($site); goto F4071; e0fcb: throw new InvalidVhostException("\x64\x69\x73\141\142\154\145\x5f\163\171\155\x6c\151\156\153\163\40\x69\x73\40\x6e\157\164\40\141\154\154\157\x77\x65\144\56"); goto B4202; A2e54: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\x74\145\x5f\166\150\x6f\163\x74", ["\x64\157\x6d\141\x69\x6e\x4e\141\x6d\145" => $domainName])); goto B2be2; D6830: $user = $this->getUser(); goto e497c; b58c3: if (!(true === str_contains($site->getVhostTemplate(), "\x64\151\x73\141\x62\x6c\x65\137\163\171\x6d\x6c\x69\x6e\153\x73"))) { goto d6eb1; } goto e0fcb; E866a: $siteEntity->setVhostTemplate($vhostTemplate); goto c6632; ce456: $session->getFlashBag()->set("\x73\165\x63\x63\145\163\163", $this->translator->trans("\x56\150\x6f\163\164\x20\x68\141\163\40\x62\x65\145\156\x20\163\141\x76\x65\144\56")); goto E6a12; E1054: EventQueue::addEvent(EventQueue::EVENT_SITE_VHOST_UPDATE, $user, $eventData, $request); goto A2e54; d2ee3: $domainName = $site->getDomainName(); goto Ca87d; B4202: d6eb1: goto d2ee3; Ca87d: $vhostTemplate = $site->getVhostTemplate(); goto a1784; F4071: $siteUpdater->updateNginxVhostWithRollback(); goto E866a; E6a12: $eventData = ["\163\x69\164\x65" => $domainName, "\166\x68\157\x73\x74" => $vhostTemplate, "\x6f\x6c\144\126\x68\157\163\x74" => $oldVhostTemplate]; goto E1054; c6632: $this->siteEntityManager->updateEntity($siteEntity); goto ce456; e497c: $session = $request->getSession(); goto b58c3; B2be2: return $response; goto a4d17; a4d17: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\x64\x61\156\x67\145\162", $this->translator->trans("\126\x68\157\163\x74\x20\151\x73\40\x6e\157\164\40\166\x61\x6c\151\144\54\x20\145\x72\x72\157\x72\x20\x6d\145\163\163\x61\147\145\72\x20\x25\x65\162\162\x6f\162\x4d\145\x73\x73\141\x67\x65\45", ["\45\x65\x72\162\157\x72\x4d\x65\163\163\141\x67\145\x25" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\145\x72", $this->translator->trans("\101\x6e\x20\x65\162\x72\157\x72\x20\x68\141\163\40\x6f\143\143\165\x72\x72\145\144\54\40\x65\162\x72\157\162\x20\155\145\163\x73\141\147\x65\72\40\x25\x65\162\162\157\162\x4d\145\x73\x73\x61\x67\x65\x25", ["\45\145\x72\162\x6f\x72\115\145\163\163\141\x67\145\x25" => $e->getMessage()])); } } public function settings(Request $request) : Response { goto c48b7; eab84: E0956: goto D21a2; B9c48: unset($parameters["\x70\x61\147\145\123\160\x65\x65\x64\123\x65\164\x74\x69\x6e\x67\x73\106\x6f\162\x6d"]); goto eab84; f124e: if (!(SiteEntity::TYPE_REVERSE_PROXY == $site->getType())) { goto C4840; } goto Ede94; Ce187: if (!(SiteEntity::TYPE_PYTHON == $site->getType())) { goto E0512; } goto deba7; Ef408: if (!(true === $pageSpeedSettingsForm->isSubmitted())) { goto Dba3d; } goto Fd04e; C9b61: $response = $this->handlePythonSettingsForm($request, $pythonSettingsForm, $site); goto C96de; Ad9f4: $siteUserSettingsForm->handleRequest($request); goto fc637; d9190: if (!(true === $domainSettingsForm->isSubmitted())) { goto D619f; } goto F88df; b64c7: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto D6181; } goto dea30; e985e: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto bb0f7; } goto e4624; B166d: e8a3e: goto f69c0; fb0f2: F54ff: goto c7d2f; bee60: $currentPhpSettings = clone $phpSettings; goto dfe31; Bc489: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\151\164\145\x73")); goto a4df5; fba2d: A16b9: goto f588d; E458b: return $response; goto f60c9; Fd04e: $response = $this->handlePageSpeedSettingsForm($request, $pageSpeedSettingsForm, $site); goto B7c7c; Ffa56: $nodejsSettingsForm->handleRequest($request); goto E80d3; dc3d5: $pythonSettingsForm = $this->createPythonSettingsForm($site, $pythonSettings); goto e985e; F125e: $phpSettings = $site->getPhpSettings(); goto fbf38; bc37a: $parameters["\x6e\x6f\144\145\x6a\x73\x53\x65\x74\164\x69\156\x67\163\106\x6f\162\x6d"] = $nodejsSettingsForm->createView(); goto B9c48; C9736: c05e6: goto B166d; Aa72e: $pageSpeedSettingsData = ["\151\163\x45\x6e\141\142\x6c\x65\144" => $site->getPageSpeedEnabled(), "\163\145\164\164\151\x6e\x67\x73" => $site->getPageSpeedSettings()]; goto aca51; E5b22: $currentNodeSettings = clone $nodejsSettings; goto Ffa56; dfe31: $phpSettingsForm->handleRequest($request); goto C4505; B29a4: Bccc0: goto fba2d; Cca2f: return $response; goto C9736; De03e: D6181: goto ec9a0; e8655: if (!(false === is_null($response))) { goto Ff8d9; } goto F349f; edaa9: $nodejsSettingsForm = $this->createNodejsSettingsForm($site, $nodejsSettings); goto C1479; Ede94: $reverseProxySettingsForm = $this->createReverseProxySettingsForm($site); goto b64c7; fe163: if (!(false === is_null($response))) { goto Ffc2b; } goto A42f8; F2be9: Da92f: goto De03e; e4624: $pythonSettingsForm->handleRequest($request); goto fb84a; Bf71a: $domainSettingsForm->handleRequest($request); goto Ad9f4; D9381: $response = $this->handlePhpSettingsForm($request, $phpSettingsForm, $currentPhpSettings, $site); goto fe163; C3444: if (!(false === is_null($response))) { goto C3280; } goto D9478; F88df: $response = $this->handleDomainSettingsForm($request, $domainSettingsForm, $site); goto c1024; D468e: a27f7: goto Ef408; c4b55: if (!(SiteEntity::TYPE_NODEJS == $site->getType())) { goto E0956; } goto a8876; a4df5: goto C4544; goto bd8a9; bebcc: $response = $this->handleReverseProxySettingsForm($request, $reverseProxySettingsForm, $site); goto C3444; f588d: $parameters = ["\x73\151\x74\x65" => $site, "\x64\x6f\x6d\x61\x69\156\123\x65\164\x74\x69\156\147\x73\x46\x6f\162\x6d" => $domainSettingsForm->createView(), "\x73\151\x74\x65\x55\x73\x65\162\123\x65\164\x74\x69\156\x67\163\106\157\x72\155" => $siteUserSettingsForm->createView(), "\160\x61\147\x65\x53\160\145\145\x64\x53\145\164\x74\x69\156\x67\x73\106\157\162\x6d" => $pageSpeedSettingsForm->createView(), "\x73\x69\x74\145\x44\x65\154\145\x74\x65\x46\157\162\155" => $siteDeleteForm->createView()]; goto c4b55; c48b7: $site = $this->getSite($request); goto Cad9c; dea30: $reverseProxySettingsForm->handleRequest($request); goto a62d4; D687b: E0512: goto f124e; c7d2f: add52: goto bc37a; b194d: if (!(false === is_null($response))) { goto Bccc0; } goto Cc511; E67eb: $siteUserSettingsForm = $this->createSiteUserSettingsForm($site, $siteUserSettingsData); goto c1352; E80d3: if (!(true === $nodejsSettingsForm->isSubmitted())) { goto F54ff; } goto Ee434; Ed32d: $siteUserSettingsData = ["\x73\151\x74\145\x55\163\x65\162" => $site->getUser(), "\x73\163\x68\x4b\145\171\x73" => $site->getSshKeys()]; goto d28a7; c1024: D619f: goto ee695; Dae2d: $parameters["\x70\150\160\x53\x65\x74\x74\x69\x6e\x67\163\106\157\x72\x6d"] = $phpSettingsForm->createView(); goto c589c; b59ee: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto A16b9; } goto Bf71a; Cc511: return $response; goto B29a4; bf7e7: $parameters["\x70\171\x74\x68\157\x6e\x53\x65\x74\x74\x69\156\147\x73\x46\157\162\x6d"] = $pythonSettingsForm->createView(); goto D687b; E3cd8: if (!(true === $siteDeleteForm->isSubmitted())) { goto d41d5; } goto Af275; Af275: $response = $this->handleSiteDeleteForm($request, $siteDeleteForm, $site); goto E1174; f69c0: bb0f7: goto bf7e7; bd8a9: ae838: goto d18e9; ea53e: $response = $this->render("\x46\x72\157\x6e\164\x65\156\144\x2f\x53\151\164\145\x2f\163\145\x74\x74\x69\x6e\147\163\56\x68\x74\155\x6c\56\x74\167\x69\x67", $parameters); goto f5e33; d18e9: $domainSettingsData = ["\x64\157\155\x61\151\156\116\141\x6d\145" => $site->getDomainName(), "\x72\157\157\164\x44\x69\x72\x65\143\164\157\162\x79" => $site->getRootDirectory()]; goto Ed32d; add7c: a25dc: goto c5c8c; fbe13: $pageSpeedSettingsForm->handleRequest($request); goto F3b34; F09f9: Ff8d9: goto fb0f2; A42f8: return $response; goto Fc444; A9a1b: $siteDeleteForm = $this->createSiteDeleteForm($site, $siteDeleteData); goto b59ee; fb84a: if (!(true === $pythonSettingsForm->isSubmitted())) { goto e8a3e; } goto C9b61; fd810: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto da417; } goto bee60; fc637: $siteDeleteForm->handleRequest($request); goto fbe13; D9478: return $response; goto dd285; a8876: $nodejsSettings = $site->getNodejsSettings(); goto edaa9; dd285: C3280: goto F2be9; f5e33: C4544: goto E458b; e4edb: $parameters["\x66\157\x72\155\105\x72\x72\x6f\x72\163"] = $this->formErrors; goto ea53e; E1174: d41d5: goto b194d; Cad9c: if (false === is_null($site)) { goto ae838; } goto Bc489; F3b34: $response = null; goto d9190; B7c7c: Dba3d: goto E3cd8; C1479: if (!(true === $request->isMethod("\x50\117\x53\124"))) { goto add52; } goto E5b22; C38a5: unset($parameters["\160\141\147\x65\123\160\x65\x65\144\123\x65\164\164\x69\156\x67\x73\106\x6f\162\x6d"]); goto Ff2a8; Ff2a8: C4840: goto e4edb; deba7: $pythonSettings = $site->getPythonSettings(); goto dc3d5; aca51: $domainSettingsForm = $this->createDomainSettingsForm($site, $domainSettingsData); goto E67eb; Ee434: $response = $this->handleNodejsSettingsForm($request, $nodejsSettingsForm, $currentNodeSettings, $site); goto e8655; C4505: if (!(true === $phpSettingsForm->isSubmitted())) { goto a25dc; } goto D9381; c589c: D2aea: goto Ce187; C96de: if (!(false === is_null($response))) { goto c05e6; } goto Cca2f; c1352: $pageSpeedSettingsForm = $this->createPageSpeedSettingsForm($site, $pageSpeedSettingsData); goto A9a1b; c5c8c: da417: goto Dae2d; ec9a0: $parameters["\x72\x65\x76\145\162\x73\145\x50\x72\x6f\170\x79\x53\145\164\164\x69\156\x67\163\106\157\x72\x6d"] = $reverseProxySettingsForm->createView(); goto C38a5; d28a7: $siteDeleteData = ["\144\157\x6d\x61\151\156\x4e\141\x6d\145" => $site->getDomainName()]; goto Aa72e; fbf38: $phpSettingsForm = $this->createPhpSettingsForm($site, $phpSettings); goto fd810; ee695: if (!(true === $siteUserSettingsForm->isSubmitted())) { goto a27f7; } goto D439f; Fc444: Ffc2b: goto add7c; D439f: $response = $this->handleSiteUserSettingsForm($request, $siteUserSettingsForm, $site); goto D468e; D21a2: if (!(SiteEntity::TYPE_PHP == $site->getType())) { goto D2aea; } goto F125e; F349f: return $response; goto F09f9; a62d4: if (!(true === $reverseProxySettingsForm->isSubmitted())) { goto Da92f; } goto bebcc; f60c9: } public function purgePageSpeedCache(Request $request) : Response { goto Ad7d4; d7ced: try { goto C19f0; e40b0: $eventData = ["\x73\151\164\145" => $site->getDomainName()]; goto C6d97; C19f0: $user = $this->getUser(); goto a7374; A7c88: $session->getFlashBag()->set("\x73\x75\x63\x63\145\163\x73", $this->translator->trans("\x50\141\147\145\x20\123\160\145\145\144\40\x43\x61\143\150\145\x20\150\x61\x73\40\x62\145\145\x6e\40\160\165\x72\147\x65\x64\x2e")); goto d7b15; c8a67: $siteUpdater = $this->getSiteUpdater($site); goto B42c3; B42c3: $siteUpdater->purgePageSpeedCache(); goto e40b0; C6d97: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_CACHE_PURGE, $user, $eventData, $request); goto A7c88; a7374: $session = $request->getSession(); goto c8a67; d7b15: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\101\x6e\40\145\162\x72\x6f\x72\x20\150\x61\x73\40\x6f\x63\143\165\162\162\145\144\54\x20\145\x72\x72\x6f\162\x20\155\145\x73\x73\x61\x67\145\72\x20\45\x65\x72\x72\x6f\x72\115\x65\163\x73\141\x67\145\x25", ["\x25\145\x72\162\157\162\115\145\163\163\141\x67\x65\45" => $e->getMessage()])); } goto F7aea; ceb2c: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\x74\x65\163")); goto a80b4; F7aea: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\164\145\137\163\x65\164\164\x69\x6e\147\163", ["\x64\157\x6d\x61\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto B2027; a80b4: goto cd300; goto B7d14; B2027: return $response; goto c6cad; c6cad: cd300: goto F38fa; B7d14: C358d: goto d7ced; Ad7d4: $site = $this->getSite($request); goto A1446; F38fa: return $response; goto F31d5; A1446: if (false === is_null($site)) { goto C358d; } goto ceb2c; F31d5: } private function createDomainSettingsForm(Site $site, array $data) : Form { goto e1dcb; Fb562: return $form; goto cad72; Cb58a: $form->add("\x73\165\142\155\x69\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\x6c\141\x73\x73" => "\142\x74\156\x20\x62\x74\x6e\x2d\142\x6c\165\145\40\x62\x74\156\x2d\x6c\x67"], "\154\141\x62\x65\x6c" => "\123\141\166\145"]); goto Fb562; e1dcb: $form = $this->createForm("\x41\160\x70\134\106\157\x72\x6d\x5c\123\x69\164\145\x44\157\x6d\x61\151\x6e\123\145\164\x74\151\156\147\163\124\x79\160\x65", $data, ["\x61\143\164\x69\157\156" => $this->generateUrl("\x63\154\x70\137\x73\x69\x74\145\137\163\145\164\x74\x69\156\x67\x73", ["\144\157\155\x61\x69\156\116\141\x6d\145" => $site->getDomainName()]), "\x6d\145\164\150\x6f\x64" => "\120\117\x53\124", "\x61\164\164\162" => []]); goto Cb58a; cad72: } private function createSiteUserSettingsForm(Site $site, array $data) : Form { goto e6bef; e7b71: $form->add("\x73\x75\x62\x6d\x69\164", SubmitType::class, ["\141\164\x74\162" => ["\143\x6c\x61\x73\x73" => "\142\164\156\x20\142\x74\x6e\x2d\142\154\x75\x65\x20\142\x74\156\x2d\154\x67"], "\154\141\142\145\154" => "\x53\x61\166\145"]); goto ad8ef; e6bef: $form = $this->createForm("\x41\x70\160\x5c\106\157\x72\x6d\134\123\x69\x74\145\x55\x73\x65\162\x53\145\x74\164\151\x6e\147\x73\x54\x79\x70\x65", $data, ["\x61\143\164\151\x6f\x6e" => $this->generateUrl("\x63\154\x70\x5f\x73\151\164\145\x5f\x73\x65\164\x74\151\156\x67\163", ["\x64\x6f\x6d\141\x69\156\116\141\x6d\145" => $site->getDomainName()]), "\x6d\145\x74\x68\157\x64" => "\120\x4f\123\124", "\141\x74\x74\x72" => []]); goto e7b71; ad8ef: return $form; goto Bc5b1; Bc5b1: } private function createPageSpeedSettingsForm(Site $site, array $data) : Form { goto d2385; D7607: return $form; goto D0d9e; b6fcd: $form->add("\x73\x75\142\x6d\x69\164", SubmitType::class, ["\x61\x74\164\162" => ["\143\x6c\x61\x73\163" => "\142\164\156\40\x62\x74\156\x2d\x62\x6c\x75\x65\x20\x62\x74\156\55\154\147"], "\154\141\x62\145\154" => "\123\141\166\x65"]); goto D7607; d2385: $form = $this->createForm("\101\160\160\x5c\x46\157\162\x6d\x5c\123\x69\x74\x65\x50\x61\x67\x65\x53\x70\145\145\144\123\145\x74\x74\151\156\147\163\124\x79\160\x65", $data, ["\141\143\164\x69\x6f\x6e" => $this->generateUrl("\143\154\x70\x5f\x73\151\164\145\137\163\145\164\164\x69\x6e\147\x73", ["\x64\157\x6d\141\x69\x6e\x4e\x61\155\145" => $site->getDomainName()]), "\x6d\x65\x74\150\x6f\x64" => "\x50\117\x53\124", "\x61\x74\164\162" => []]); goto b6fcd; D0d9e: } private function createReverseProxySettingsForm(Site $site) : Form { goto e6190; B7187: return $form; goto A1b6b; e6190: $data = ["\x72\x65\166\145\162\x73\145\x50\x72\157\170\171\x55\x72\154" => $site->getReverseProxyUrl()]; goto C1fb4; C1fb4: $form = $this->createForm("\x41\x70\x70\134\x46\157\162\x6d\x5c\123\x69\164\145\x52\x65\166\x65\162\x73\x65\x50\162\157\x78\x79\123\145\x74\x74\151\156\147\x73\x54\171\160\145", $data, ["\x61\x63\x74\151\157\156" => $this->generateUrl("\x63\x6c\x70\x5f\163\151\x74\145\137\x73\145\164\x74\151\156\x67\x73", ["\x64\x6f\155\141\x69\156\x4e\141\155\x65" => $site->getDomainName()]), "\155\x65\x74\150\x6f\144" => "\120\117\123\x54", "\141\x74\x74\x72" => ["\x69\x64" => "\x72\x65\166\x65\162\x73\145\x2d\x70\162\x6f\x78\171\x2d\163\x65\x74\164\151\156\x67\x73\x2d\146\157\x72\x6d"]]); goto d6361; d6361: $form->add("\x73\x75\142\x6d\151\x74", SubmitType::class, ["\141\x74\164\162" => ["\x63\x6c\141\x73\x73" => "\142\164\156\40\142\164\156\x2d\x62\154\165\145\x20\142\x74\156\55\x6c\147"], "\154\141\x62\x65\154" => "\x53\x61\166\145"]); goto B7187; A1b6b: } private function createNodejsSettingsForm(Site $site, NodejsSettings $nodejsSettings) : Form { goto Bf5f2; f8960: $form->add("\163\x75\142\x6d\151\164", SubmitType::class, ["\141\x74\x74\162" => ["\143\154\141\x73\x73" => "\142\x74\x6e\40\x62\x74\156\55\x62\154\x75\x65\40\142\x74\x6e\55\154\x67"], "\x6c\141\x62\145\154" => "\x53\x61\166\145"]); goto D829e; Bf5f2: $form = $this->createForm("\101\160\160\x5c\106\157\162\155\134\x53\x69\164\x65\116\x6f\144\x65\x6a\x73\x53\145\164\x74\x69\x6e\x67\x73\x54\x79\160\145", $nodejsSettings, ["\141\143\x74\x69\157\156" => $this->generateUrl("\143\154\160\x5f\163\151\164\x65\x5f\163\145\164\164\x69\x6e\147\163", ["\144\157\x6d\141\x69\x6e\116\x61\x6d\x65" => $site->getDomainName()]), "\155\145\164\150\157\x64" => "\120\117\123\x54", "\x61\164\164\162" => ["\x69\144" => "\x6e\157\x64\x65\152\163\55\x73\145\164\x74\x69\156\147\163\55\146\157\162\155"]]); goto f8960; D829e: return $form; goto B06b1; B06b1: } private function createPhpSettingsForm(Site $site, PhpSettings $phpSettings) : Form { goto C4cff; C4cff: $form = $this->createForm("\101\x70\160\x5c\x46\x6f\162\155\134\x53\151\164\x65\120\x68\x70\123\145\x74\164\x69\156\x67\163\x54\171\160\145", $phpSettings, ["\141\x63\164\x69\157\156" => $this->generateUrl("\x63\154\160\137\x73\x69\164\145\x5f\x73\x65\x74\164\x69\156\x67\163", ["\144\x6f\155\x61\151\x6e\116\141\155\x65" => $site->getDomainName()]), "\155\x65\x74\x68\x6f\144" => "\120\x4f\x53\124", "\141\x74\x74\162" => []]); goto ab10b; ab10b: $form->add("\x73\165\x62\x6d\x69\x74", SubmitType::class, ["\x61\164\x74\162" => ["\x63\154\141\x73\x73" => "\142\164\156\40\x62\164\x6e\55\142\154\165\145\40\x62\x74\x6e\55\154\x67"], "\154\141\x62\145\x6c" => "\123\x61\166\x65"]); goto Dfa7a; Dfa7a: return $form; goto A5e13; A5e13: } private function createPythonSettingsForm(Site $site, PythonSettings $pythonSettings) : Form { goto dce0c; Fb9ed: $form->add("\163\165\142\155\151\164", SubmitType::class, ["\x61\x74\164\162" => ["\143\154\141\163\163" => "\142\x74\156\x20\142\x74\156\55\142\154\x75\x65\40\x62\x74\156\x2d\x6c\147"], "\154\141\142\x65\154" => "\x53\x61\166\145"]); goto c8934; c8934: return $form; goto E7a70; dce0c: $form = $this->createForm("\x41\160\160\134\106\x6f\162\155\134\123\x69\164\145\x50\x79\164\x68\x6f\156\123\145\164\164\151\x6e\147\163\x54\171\160\x65", $pythonSettings, ["\x61\143\x74\151\x6f\x6e" => $this->generateUrl("\x63\x6c\160\x5f\x73\x69\164\145\x5f\163\x65\x74\x74\x69\x6e\147\x73", ["\x64\157\x6d\x61\x69\x6e\116\141\x6d\x65" => $site->getDomainName()]), "\x6d\145\x74\x68\x6f\144" => "\120\117\x53\124", "\x61\164\x74\x72" => []]); goto Fb9ed; E7a70: } private function createSiteDeleteForm(Site $site, array $data) : Form { goto Be0a7; c266b: return $form; goto Df144; c77ee: $form->add("\x73\165\142\155\151\x74", SubmitType::class, ["\141\x74\164\x72" => ["\143\x6c\x61\163\x73" => "\142\x74\x6e\x20\142\x74\x6e\x2d\x62\x6c\x75\x65\40\x62\164\x6e\x2d\154\x67", "\144\x69\x73\141\142\x6c\x65\144" => "\x64\151\x73\x61\142\x6c\x65\144"], "\154\x61\142\x65\154" => "\104\145\x6c\x65\164\145\40\x53\x69\x74\145"]); goto c266b; Be0a7: $form = $this->createForm("\101\x70\160\134\x46\157\162\x6d\x5c\x53\x69\x74\145\104\x65\x6c\145\x74\x65\x54\171\x70\145", $data, ["\141\x63\164\x69\157\156" => $this->generateUrl("\143\154\x70\x5f\x73\x69\x74\145\x5f\163\145\164\x74\x69\156\x67\163", ["\x64\157\155\141\x69\156\116\141\155\x65" => $site->getDomainName()]), "\155\145\164\150\x6f\144" => "\x50\117\x53\x54", "\141\164\x74\x72" => []]); goto c77ee; Df144: } private function handleDomainSettingsForm(Request $request, Form $form, Site $site) { goto fe52b; b07ef: $this->formErrors = $this->getErrorMessages($form); goto D68c3; D68c3: goto c8b86; goto Ee70a; B2353: c8b86: goto c7c4c; fe52b: if (true === $form->isValid()) { goto F11c6; } goto b07ef; f6668: try { goto bcac0; Abe78: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\x69\164\x65\137\163\x65\164\x74\151\156\x67\x73", ["\144\x6f\155\141\x69\156\x4e\x61\155\x65" => $site->getDomainName()])); goto Eb0d5; acf4d: $rootDirectory = rtrim($form->get("\162\x6f\x6f\164\104\x69\x72\145\143\x74\x6f\x72\171")->getData(), "\57"); goto e0b68; f9a9f: $eventData = ["\163\151\x74\145" => $domainName, "\162\x6f\x6f\x74\x44\x69\162\145\143\x74\x6f\162\171" => $rootDirectory]; goto F7aa4; e0b68: $site->setRootDirectory($rootDirectory); goto C4307; c50fe: $this->siteEntityManager->updateEntity($siteEntity); goto aae86; F7aa4: EventQueue::addEvent(EventQueue::EVENT_SITE_ROOT_DIRECTORY_UPDATE, $user, $eventData, $request); goto c56da; C4307: $siteEntity->setRootDirectory($rootDirectory); goto c50fe; bcac0: $user = $this->getUser(); goto c7f02; aae86: $siteUpdater = $this->getSiteUpdater($site); goto ec535; D40a0: Ecc00: goto Abe78; ec535: $siteUpdater->domainSettings(); goto f9a9f; c56da: $session->getFlashBag()->set("\x73\165\x63\x63\x65\x73\163", $this->translator->trans("\122\157\x6f\164\x20\104\151\162\145\143\164\x6f\x72\x79\x20\150\x61\x73\x20\x62\x65\x65\156\40\163\141\x76\x65\x64\x2e")); goto D40a0; C8293: $siteEntity = $this->getSiteEntity($domainName); goto E686c; E686c: if (!(false === is_null($siteEntity))) { goto Ecc00; } goto acf4d; c8b09: $domainName = $site->getDomainName(); goto C8293; c7f02: $session = $request->getSession(); goto c8b09; Eb0d5: return $response; goto a35c8; a35c8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\x65\162", $this->translator->trans("\101\x6e\x20\145\x72\162\157\x72\40\150\x61\163\40\x6f\143\x63\x75\x72\162\x65\144\54\40\x65\162\x72\x6f\162\40\155\x65\x73\x73\x61\x67\x65\x3a\40\x25\x65\x72\x72\157\162\115\x65\163\163\141\147\x65\45", ["\45\x65\x72\162\x6f\162\115\145\x73\163\x61\x67\145\45" => $e->getMessage()])); } goto B2353; Ee70a: F11c6: goto f6668; c7c4c: } private function handleSiteUserSettingsForm(Request $request, Form $form, Site $site) { goto Bb46e; Bb46e: if (true === $form->isValid()) { goto d8b71; } goto c7614; C9582: try { goto a19b1; f7633: $siteUpdater->changeUserPassword($siteUser, $password); goto af608; Fecf8: EventQueue::addEvent(EventQueue::EVENT_SITE_USER_SETTINGS_UPDATE, $user, $eventData, $request); goto Feddf; d228b: $siteUser = $site->getUser(); goto f2d6f; E33dd: $siteEntity->setSshKeys($sshKeys); goto c992f; Bc6fd: $eventData = ["\x73\151\164\145" => $domainName, "\x73\163\x68\x4b\145\171\x73" => $sshKeys]; goto Fecf8; a19b1: $user = $this->getUser(); goto F8892; dfa47: $siteEntity = $this->getSiteEntity($domainName); goto A9dbd; Dd610: $siteUpdater->updateUserSShKeys($siteUser, $sshKeys); goto a4e81; a4e81: if (!(false === empty($password))) { goto a11e3; } goto f7633; D0cdc: cc398: goto Dc314; af608: a11e3: goto Bc6fd; A9dbd: if (!(false === is_null($siteEntity))) { goto cc398; } goto d228b; Dc314: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\x74\145\x5f\163\x65\x74\164\x69\156\147\163", ["\x64\157\x6d\141\151\156\116\141\155\x65" => $site->getDomainName()])); goto Ee5ac; Ee5ac: return $response; goto Ff635; fe681: $siteUpdater = $this->getSiteUpdater($site); goto Dd610; c9198: $password = trim($form->get("\160\141\163\x73\167\x6f\x72\x64")->getData()); goto E33dd; f2d6f: $sshKeys = trim($form->get("\x73\163\150\113\145\171\x73")->getData()); goto c9198; adf90: $domainName = $site->getDomainName(); goto dfa47; c992f: $this->siteEntityManager->updateEntity($siteEntity); goto fe681; Feddf: $session->getFlashBag()->set("\163\x75\143\143\x65\163\163", $this->translator->trans("\x53\x69\x74\145\x20\x55\x73\145\x72\x20\123\x65\x74\x74\x69\x6e\x67\x73\40\150\141\166\145\40\x62\x65\145\156\x20\163\x61\166\x65\144\56")); goto D0cdc; F8892: $session = $request->getSession(); goto adf90; Ff635: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\x72", $this->translator->trans("\101\156\40\x65\162\x72\157\162\40\x68\141\x73\x20\157\143\x63\165\x72\x72\x65\144\54\40\145\x72\x72\x6f\x72\x20\x6d\x65\163\163\x61\147\145\x3a\x20\x25\x65\162\x72\x6f\x72\x4d\x65\163\x73\x61\x67\x65\x25", ["\45\145\x72\162\x6f\x72\x4d\145\x73\x73\x61\147\145\x25" => $e->getMessage()])); } goto Eabdb; C893f: goto C3888; goto d2abc; d2abc: d8b71: goto C9582; c7614: $this->formErrors = $this->getErrorMessages($form); goto C893f; Eabdb: C3888: goto D172c; D172c: } private function handlePageSpeedSettingsForm(Request $request, Form $form, Site $site) { goto Dd3df; C8003: a6e7b: goto e91cb; E24ab: e2d82: goto afc4e; b0b0b: $this->formErrors = $this->getErrorMessages($form); goto F346c; F346c: goto e2d82; goto C8003; Dd3df: if (true === $form->isValid()) { goto a6e7b; } goto b0b0b; e91cb: try { goto a5bd9; Cc4a3: $siteUpdater->updateNginxVhostWithRollback(); goto Eea7f; C9a8c: $siteEntity->setPageSpeedEnabled($isEnabled); goto fa3ad; D0887: $site->setPageSpeedEnabled($isEnabled); goto d7b3a; a5bd9: $user = $this->getUser(); goto Bdf39; Ba516: $session->getFlashBag()->set("\163\x75\x63\x63\x65\x73\x73", $this->translator->trans("\x50\141\x67\x65\40\x53\160\x65\145\x64\40\123\x65\164\164\151\156\x67\163\x20\150\x61\x76\x65\40\142\x65\x65\156\x20\163\141\x76\145\144\x2e")); goto e7e06; a9e3a: $siteEntity = $this->getSiteEntity($domainName); goto Eff8f; F7c4d: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\x74\145\137\x73\x65\x74\x74\x69\156\147\x73", ["\144\x6f\155\x61\x69\156\x4e\x61\155\145" => $site->getDomainName()])); goto F2a1d; fa3ad: $siteEntity->setPageSpeedSettings($settings); goto B35ec; ca81b: $siteUpdater = $this->getSiteUpdater($site); goto Cc4a3; F2a1d: return $response; goto c2624; Eff8f: if (!(false === is_null($siteEntity))) { goto Dc0b1; } goto Ae386; Eea7f: $siteUpdater->purgePageSpeedCache(); goto C9a8c; B35ec: $this->siteEntityManager->updateEntity($siteEntity); goto cd93a; f4d52: $settings = trim($form->get("\163\x65\x74\164\151\x6e\147\x73")->getData()); goto D0887; Ae386: $isEnabled = $form->get("\x69\x73\x45\x6e\x61\142\x6c\145\144")->getData(); goto f4d52; e7e06: Dc0b1: goto F7c4d; C2f64: $domainName = $site->getDomainName(); goto a9e3a; D75ac: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_SETTINGS_UPDATE, $user, $eventData, $request); goto Ba516; d7b3a: $site->setPageSpeedSettings($settings); goto ca81b; Bdf39: $session = $request->getSession(); goto C2f64; cd93a: $eventData = ["\163\151\x74\145" => $domainName, "\x70\x61\x67\x65\123\160\x65\145\x64\105\156\141\142\154\x65\144" => $isEnabled, "\160\141\x67\x65\x53\x70\x65\x65\x64\123\145\x74\164\x69\x6e\x67\163" => $settings]; goto D75ac; c2624: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\144\141\156\x67\x65\x72", $this->translator->trans("\120\141\147\x65\123\x70\x65\x65\144\40\x53\145\164\x74\x69\x6e\147\40\x61\162\145\40\x6e\x6f\164\40\166\141\154\x69\x64\54\40\145\x72\x72\x6f\162\x20\x6d\145\163\x73\141\147\x65\x3a\x20\x25\x65\162\x72\x6f\162\x4d\145\x73\163\x61\x67\x65\45", ["\45\x65\x72\x72\x6f\162\115\145\x73\163\x61\x67\x65\x25" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\162", $this->translator->trans("\x41\x6e\40\145\x72\162\x6f\162\x20\150\x61\x73\40\x6f\x63\143\165\x72\162\145\144\x2c\x20\145\162\162\157\162\40\155\145\x73\x73\141\147\145\72\40\x25\x65\x72\162\157\162\115\145\x73\163\x61\147\145\45", ["\x25\x65\x72\x72\157\162\x4d\145\x73\x73\141\147\x65\x25" => $e->getMessage()])); } goto E24ab; afc4e: } private function handleSiteDeleteForm(Request $request, Form $form, Site $site) { goto b80b1; a1c1c: try { goto ef573; ec699: $domainName = $site->getDomainName(); goto A9dd3; ac67a: $eventData = ["\x73\151\x74\145" => $domainName, "\x74\171\160\x65" => $site->getType()]; goto bbef3; a3ebd: $siteDeleter->delete(); goto fdc2f; aacb1: $session->getFlashBag()->set("\163\x75\x63\143\x65\163\163", $this->translator->trans("\123\151\164\x65\x20\x68\x61\x73\40\142\145\145\156\40\144\x65\x6c\145\x74\145\144\56")); goto Fcd73; a1208: $session = $request->getSession(); goto ec699; bbef3: EventQueue::addEvent(EventQueue::EVENT_SITE_DELETE, $user, $eventData, $request); goto aacb1; Dc0a2: return $response; goto F8fe8; df543: $siteDeleter = $this->getSiteDeleter($site); goto a3ebd; cc581: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\x74\x65\x73")); goto Dc0a2; A9dd3: $siteEntity = $this->getSiteEntity($domainName); goto B6779; B6779: if (!(false === is_null($siteEntity))) { goto b0788; } goto df543; ef573: $user = $this->getUser(); goto a1208; fdc2f: $this->siteEntityManager->deleteEntity($siteEntity); goto ac67a; Fcd73: b0788: goto cc581; F8fe8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\x67\145\x72", $this->translator->trans("\101\156\x20\x65\x72\162\157\x72\40\150\x61\163\40\157\x63\143\165\x72\162\x65\144\54\40\145\162\x72\157\162\x20\155\145\x73\x73\141\x67\145\x3a\40\x25\x65\x72\162\157\162\115\145\x73\x73\141\x67\145\45", ["\x25\x65\162\x72\x6f\162\x4d\x65\x73\x73\141\x67\x65\x25" => $e->getMessage()])); } goto Ef072; b80b1: if (true === $form->isValid()) { goto E277b; } goto af9ac; Dd837: E277b: goto a1c1c; Ef072: A8ce6: goto ba848; f783f: goto A8ce6; goto Dd837; af9ac: $this->formErrors = $this->getErrorMessages($form); goto f783f; ba848: } private function handleNodejsSettingsForm(Request $request, Form $form, NodejsSettings $currentNodejsSettings, Site $site) { goto Ac11b; Ebcc2: $this->formErrors = $this->getErrorMessages($form); goto d53c8; d53c8: goto bca3b; goto B0851; B52e2: bca3b: goto ab6d1; B0851: D4231: goto ebe7e; Ac11b: if (true === $form->isValid()) { goto D4231; } goto Ebcc2; ebe7e: try { goto B43d8; bfb96: $session = $request->getSession(); goto C17e5; E85ab: $siteUpdater->installNodejsVersion(); goto d8679; F3fd0: $session->getFlashBag()->set("\163\165\143\143\x65\x73\163", $this->translator->trans("\x4e\x6f\144\145\56\152\x73\x20\x53\x65\164\x74\151\x6e\147\x73\40\x68\x61\166\145\x20\142\x65\145\156\40\163\141\166\x65\x64\56")); goto D76a5; c5f05: $this->siteEntityManager->updateEntity($siteEntity); goto d92f5; d8679: bac4e: goto c1d39; B43d8: $user = $this->getUser(); goto bfb96; E6b7c: return $response; goto c3c20; E40a1: $siteEntity = $this->getSiteEntity($domainName); goto c83c8; Ac45e: $hasNodejsVersionChanged = $currentNodejsSettings->getNodejsVersion() != $nodejsVersion; goto Fa8d6; c83c8: if (!(false === is_null($siteEntity))) { goto de18a; } goto C1aad; b7f6e: if (!(true === $hasNodejsVersionChanged)) { goto bac4e; } goto E85ab; Fa8d6: $siteUpdater = $this->getSiteUpdater($site); goto b7f6e; D76a5: de18a: goto f92f4; c1d39: $siteUpdater->nodejsSettings(); goto c5f05; Dcb7b: EventQueue::addEvent(EventQueue::EVENT_SITE_NODEJS_SETTINGS_UPDATE, $user, $eventData, $request); goto F3fd0; d92f5: $eventData = ["\x73\x69\164\x65" => $domainName, "\156\157\144\145\152\x73\126\145\162\163\x69\x6f\156" => $nodejsVersion, "\160\157\162\164" => $nodejsSettings->getPort()]; goto Dcb7b; C17e5: $domainName = $site->getDomainName(); goto E40a1; f92f4: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\x74\145\137\x73\145\164\x74\x69\x6e\x67\163", ["\x64\x6f\x6d\x61\151\x6e\x4e\141\x6d\x65" => $site->getDomainName()])); goto E6b7c; c96e6: $nodejsVersion = $nodejsSettings->getNodejsVersion(); goto Ac45e; C1aad: $nodejsSettings = $form->getData(); goto c96e6; c3c20: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\162", $this->translator->trans("\x41\156\x20\x65\x72\x72\157\x72\x20\150\x61\163\40\157\143\x63\x75\x72\162\x65\144\x2c\40\145\162\x72\x6f\162\x20\155\145\x73\x73\x61\x67\145\72\x20\x25\x65\162\x72\x6f\x72\115\145\x73\x73\x61\x67\145\x25", ["\45\x65\162\162\x6f\x72\x4d\x65\x73\163\x61\147\145\x25" => $e->getMessage()])); } goto B52e2; ab6d1: } private function handlePythonSettingsForm(Request $request, Form $form, Site $site) { goto fafe8; f08f4: Ec27f: goto f8672; f06d2: dc41d: goto Ca522; a67ef: goto Ec27f; goto f06d2; c3f09: $this->formErrors = $this->getErrorMessages($form); goto a67ef; Ca522: try { goto ce5d8; F6078: $siteUpdater = $this->getSiteUpdater($site); goto Ce99c; B5d47: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\x69\x74\145\137\163\145\x74\164\x69\156\147\x73", ["\144\157\155\x61\x69\x6e\116\141\x6d\145" => $site->getDomainName()])); goto c2138; Afb39: dc3c1: goto B5d47; B57f3: $pythonSettings = $form->getData(); goto Bdcfa; ddd4b: $this->siteEntityManager->updateEntity($siteEntity); goto Af4c3; Af4c3: $eventData = ["\163\x69\x74\x65" => $domainName, "\x70\171\x74\x68\157\x6e\x56\x65\x72\163\x69\x6f\156" => $pythonVersion, "\x70\x6f\x72\x74" => $pythonSettings->getPort()]; goto F8d45; Bdcfa: $pythonVersion = $pythonSettings->getPythonVersion(); goto F6078; F8d45: EventQueue::addEvent(EventQueue::EVENT_SITE_PYTHON_SETTINGS_UPDATE, $user, $eventData, $request); goto C90ee; c2138: return $response; goto C1c84; c9193: $session = $request->getSession(); goto a721a; ba6bc: $siteEntity = $this->getSiteEntity($domainName); goto F9850; F9850: if (!(false === is_null($siteEntity))) { goto dc3c1; } goto B57f3; Ce99c: $siteUpdater->writePythonVersionFile(); goto b6c4f; b6c4f: $siteUpdater->pythonSettings(); goto ddd4b; C90ee: $session->getFlashBag()->set("\163\x75\x63\x63\x65\163\x73", $this->translator->trans("\120\x79\164\150\x6f\156\40\x53\145\x74\x74\151\156\147\163\40\150\x61\x76\145\40\x62\x65\145\156\40\163\x61\166\x65\144\56")); goto Afb39; ce5d8: $user = $this->getUser(); goto c9193; a721a: $domainName = $site->getDomainName(); goto ba6bc; C1c84: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\x72", $this->translator->trans("\x41\156\40\145\x72\162\157\x72\x20\150\x61\x73\x20\157\143\143\165\x72\x72\145\x64\54\40\145\162\x72\x6f\x72\40\x6d\x65\163\163\x61\147\145\x3a\40\45\x65\162\162\157\x72\115\145\163\x73\141\x67\145\x25", ["\x25\x65\162\162\x6f\x72\x4d\x65\x73\163\x61\x67\x65\x25" => $e->getMessage()])); } goto f08f4; fafe8: if (true === $form->isValid()) { goto dc41d; } goto c3f09; f8672: } private function handleReverseProxySettingsForm(Request $request, Form $form, Site $site) { goto ced67; F09a4: C702c: goto b32c9; ced67: if (true === $form->isValid()) { goto b428e; } goto cbd91; cbd91: $this->formErrors = $this->getErrorMessages($form); goto c0ed3; c0ed3: goto C702c; goto d246f; d246f: b428e: goto Bcd65; Bcd65: try { goto Ea93a; Bc52d: $this->siteEntityManager->updateEntity($siteEntity); goto d5244; A261e: $siteEntity = $this->getSiteEntity($domainName); goto d3dfb; e3e30: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\163", $this->translator->trans("\x52\145\x76\x65\162\x73\145\40\120\x72\157\x78\171\x20\123\x65\x74\x74\151\x6e\147\163\x20\x68\x61\x76\145\x20\x62\145\145\x6e\40\163\141\166\145\x64\x2e")); goto D49bb; D49bb: acc24: goto A21ae; Faa5d: $siteEntity->setReverseProxyUrl($reverseProxyUrl); goto E778c; ae73b: EventQueue::addEvent(EventQueue::EVENT_SITE_REVERSE_PROXY_SETTINGS_UPDATE, $user, $eventData, $request); goto e3e30; E173e: $site->setReverseProxyUrl($reverseProxyUrl); goto Faa5d; E778c: $siteUpdater = $this->getSiteUpdater($site); goto fcb9d; F3558: return $response; goto ed7ee; d3dfb: if (!(false === is_null($siteEntity))) { goto acc24; } goto F0992; d5244: $eventData = ["\x73\151\x74\145" => $domainName, "\162\x65\166\145\162\x73\145\x50\162\157\x78\171\x55\x72\x6c" => $reverseProxyUrl]; goto ae73b; Ea93a: $user = $this->getUser(); goto De55b; De55b: $session = $request->getSession(); goto Bf640; Bf640: $domainName = $site->getDomainName(); goto A261e; fcb9d: $siteUpdater->updateNginxVhostWithRollback(); goto Bc52d; F0992: $reverseProxyUrl = $form->get("\x72\145\166\145\x72\x73\145\120\162\157\x78\171\x55\x72\154")->getData(); goto E173e; A21ae: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\151\x74\x65\x5f\x73\145\x74\164\x69\156\147\163", ["\144\x6f\155\x61\151\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto F3558; ed7ee: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\x65\x72", $this->translator->trans("\101\156\40\145\x72\162\x6f\x72\x20\150\141\163\40\157\143\143\165\162\x72\x65\144\54\40\x65\162\162\x6f\162\x20\155\145\163\163\x61\147\145\x3a\x20\45\x65\162\x72\157\162\x4d\145\163\x73\x61\x67\145\x25", ["\x25\x65\162\x72\157\x72\x4d\145\163\x73\141\147\x65\x25" => $e->getMessage()])); } goto F09a4; b32c9: } private function handlePhpSettingsForm(Request $request, Form $form, PhpSettings $currentPhpSettings, Site $site) { goto a3422; Ccf0d: e5aa9: goto F93bc; db16e: $this->formErrors = $this->getErrorMessages($form); goto F554d; F554d: goto Dd89e; goto Ccf0d; a3422: if (true === $form->isValid()) { goto e5aa9; } goto db16e; F93bc: try { goto E4b4c; e7cb6: Ddf96: goto b4bf1; d1cb6: $session = $request->getSession(); goto Ca3a3; Cc0ff: $session->getFlashBag()->set("\x73\165\x63\143\145\x73\163", $this->translator->trans("\120\x48\x50\x20\x53\x65\x74\x74\151\x6e\147\x73\40\150\x61\x76\x65\40\x62\x65\145\156\x20\163\141\166\x65\x64\x2e")); goto Bb46c; c9373: $eventData = ["\x73\151\x74\145" => $domainName, "\x70\x68\x70\126\145\x72\x73\151\157\156" => $phpSettings->getPhpVersion(), "\155\145\x6d\157\x72\x79\x5f\154\x69\155\151\x74" => $phpSettings->getMemoryLimit(), "\155\141\x78\137\x65\170\145\x63\165\x74\151\157\x6e\x5f\x74\x69\155\145" => $phpSettings->getMaxExecutionTime(), "\x6d\x61\170\x5f\151\x6e\x70\x75\164\x5f\164\x69\155\145" => $phpSettings->getMaxInputTime(), "\155\141\x78\137\x69\156\160\x75\x74\x5f\x76\141\162\163" => $phpSettings->getMaxInputVars(), "\x70\x6f\163\x74\x5f\x6d\x61\170\x5f\163\x69\x7a\145" => $phpSettings->getPostMaxSize(), "\165\x70\154\157\141\x64\137\155\141\x78\137\x66\151\154\x65\163\x69\172\x65" => $phpSettings->getUploadMaxFileSize()]; goto c45cd; Bb46c: C31d6: goto Aae8a; Aae8a: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\x69\x74\145\x5f\163\145\x74\164\151\x6e\147\163", ["\x64\157\155\141\151\156\116\x61\155\145" => $site->getDomainName()])); goto Fa705; c02ac: if (!(false === is_null($siteEntity))) { goto C31d6; } goto C86e1; a556c: $this->siteEntityManager->updateEntity($siteEntity); goto c9373; E080e: $siteUpdater = $this->getSiteUpdater($site); goto d16cc; A5f4c: $siteEntity = $this->getSiteEntity($domainName); goto c02ac; d16cc: if (!(true === $hasPhpVersionChanged)) { goto Ddf96; } goto F7c06; Fa705: return $response; goto ea3a4; Ca3a3: $domainName = $site->getDomainName(); goto A5f4c; B640d: $hasPhpVersionChanged = $currentPhpSettings->getPhpVersion() != $phpSettings->getPhpVersion(); goto E080e; C86e1: $phpSettings = $form->getData(); goto B640d; c45cd: EventQueue::addEvent(EventQueue::EVENT_SITE_PHP_SETTINGS_UPDATE, $user, $eventData, $request); goto Cc0ff; F7c06: $siteUpdater->changePhpVersion($currentPhpSettings->getPhpVersion(), $phpSettings->getPhpVersion()); goto e7cb6; b4bf1: $siteUpdater->phpSettings(); goto a556c; E4b4c: $user = $this->getUser(); goto d1cb6; ea3a4: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\x72", $this->translator->trans("\x41\156\x20\x65\162\x72\x6f\162\x20\x68\141\163\x20\157\x63\x63\x75\x72\x72\145\x64\54\40\145\x72\162\x6f\x72\40\x6d\145\x73\x73\141\x67\145\x3a\40\x25\145\x72\162\157\x72\x4d\145\163\x73\x61\x67\145\45", ["\x25\145\x72\x72\157\x72\x4d\x65\163\163\x61\147\x65\x25" => $e->getMessage()])); } goto A86b0; A86b0: Dd89e: goto B3250; B3250: } private function getSite(Request $request) : ?Site { goto d0970; C7c8d: $siteDatabases = $this->getSiteDatabases($siteEntity); goto ecf19; D5eae: $siteEntity = $this->getSiteEntity($domainName); goto a27b8; d6274: return $site; goto fb59a; Be986: $site->setBasicAuth($siteEntity->getBasicAuth()); goto abe56; F1475: $site->setBlockedIps($siteEntity->getBlockedIps()); goto Ec7fb; d8d58: $site->setSshUsers($siteEntity->getSshUsers()); goto a2229; F57e1: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto ed0fa; f20c7: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto F4606; c3d4f: if (!(false === is_null($site))) { goto F11bb; } goto F57e1; bf847: $site->setCronJobs($siteEntity->getCronJobs()); goto Fddea; Df01b: if (!(false === is_null($siteEntity))) { goto ff12d; } goto Fa6f3; F06e2: return null; goto af450; F4606: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto c68e3; D13a0: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto F0ea5; Fddea: $site->setFtpUsers($siteEntity->getFtpUsers()); goto d8d58; a8cc3: $site->setSubdomain($subdomain); goto a7b04; a89c1: $siteType = $siteEntity->getType(); goto fdb31; ed0fa: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto c0638; abe56: $site->setBlockedBots($siteEntity->getBlockedBots()); goto F1475; cfa63: $site->setDomainName($siteEntity->getDomainName()); goto C49c3; F0ea5: F11bb: goto C74d7; c0638: $subdomain = $resolvedDomainName->subDomain()->toString(); goto afc5d; C74d7: ff12d: goto d6274; Caf49: $site->setCertificate($siteEntity->getCertificate()); goto B7ecc; fdb31: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto a460d; B68b5: goto b90d5; goto bd093; a460d: $site = new NodejsSite(); goto d20eb; d20eb: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto B68b5; bd093: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto b90d5; case SiteEntity::TYPE_PHP: goto De631; B94fe: $site->setPhpSettings($siteEntity->getPhpSettings()); goto F3236; De631: $site = new PhpSite(); goto B94fe; F2dbf: goto b90d5; goto a7d73; F3236: $site->setVarnishCache($siteEntity->getVarnishCache()); goto F2dbf; a7d73: case SiteEntity::TYPE_PYTHON: goto ca8d5; bd0ca: $site->setPythonSettings($siteEntity->getPythonSettings()); goto Ded83; Ded83: goto b90d5; goto A6640; ca8d5: $site = new PythonSite(); goto bd0ca; A6640: case SiteEntity::TYPE_REVERSE_PROXY: goto B54bb; Dc20d: goto b90d5; goto c2b46; d677f: $site->setReverseProxyUrl($siteEntity->getReverseProxyUrl()); goto Dc20d; B54bb: $site = new ReverseProxySite(); goto d677f; c2b46: } goto f00b1; c68e3: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto D13a0; a27b8: $site = null; goto Df01b; C49c3: $site->setRegistrableDomain($registrableDomain); goto a8cc3; Fa6f3: if (!(UserEntity::ROLE_USER == $user->getRole() && false === $user->hasSite($siteEntity))) { goto a08a6; } goto F06e2; c4ccc: b90d5: goto c3d4f; f00b1: d833f: goto c4ccc; Ec7fb: $site->setDatabases($siteDatabases); goto Caf49; B7ecc: $site->setCertificates($siteEntity->getCertificates()); goto bf847; d0970: $user = $this->getUser(); goto d9203; ecf19: $site->setUser($siteEntity->getUser()); goto cfa63; a7b04: $site->setRootDirectory($siteEntity->getRootDirectory()); goto Be986; af450: a08a6: goto a89c1; afc5d: $subdomain = false === empty($subdomain) ? $subdomain : null; goto C7c8d; a2229: $site->setSshKeys($siteEntity->getSshKeys()); goto f20c7; d9203: $domainName = $request->get("\x64\x6f\x6d\141\x69\x6e\116\141\155\x65"); goto D5eae; fb59a: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto Ba18b; e6962: return $siteDatabases; goto b59a1; D0684: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Eb138; Eb138: $databaseEntities = $siteEntity->getDatabases(); goto D0b90; Ba18b: $siteDatabases = new ArrayCollection(); goto D0684; d449d: Ec900: goto e6962; D0b90: foreach ($databaseEntities as $databaseEntity) { goto Df0ff; e2db0: ed1ac: goto D0453; F2d7a: a4a62: goto e2db0; D65c4: $siteDatabases->add($databaseEntity); goto F2d7a; A340f: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto a4a62; } goto D65c4; Df0ff: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto A340f; D0453: } goto d449d; b59a1: } private function getSiteUpdater(Site $site) : ?SiteUpdater { goto aeeba; aeeba: $siteUpdater = null; goto e3e6d; b0aca: return $siteUpdater; goto Fdd66; Dbcaa: Ba33e: goto B1421; e3e6d: $siteType = $site->getType(); goto E82ff; E82ff: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto b1c9a; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto b1c9a; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto b1c9a; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto b1c9a; case SiteEntity::TYPE_REVERSE_PROXY: $siteUpdater = new ReverseProxySiteUpdater($site); goto b1c9a; } goto Dbcaa; B1421: b1c9a: goto b0aca; Fdd66: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto b48ca; Ca1b9: b1db4: goto ec2e2; ec2e2: a8ff0: goto a9b68; F0f03: $siteType = $site->getType(); goto b651d; b651d: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto a8ff0; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto a8ff0; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto a8ff0; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto a8ff0; case SiteEntity::TYPE_REVERSE_PROXY: $siteDeleter = new ReverseProxySiteDeleter($site); goto a8ff0; } goto Ca1b9; a9b68: return $siteDeleter; goto c51e1; b48ca: $siteDeleter = null; goto F0f03; c51e1: } private function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } }
