<?php
 namespace App\EventListener; use Symfony\Component\HttpKernel\Event\RequestEvent; use Symfony\Component\EventDispatcher\EventSubscriberInterface; use Symfony\Component\Console\Event\ConsoleCommandEvent; use Symfony\Component\HttpKernel\KernelEvents; use Symfony\Component\Console\ConsoleEvents; use Symfony\Contracts\Cache\ItemInterface; use Psr\Cache\CacheItemPoolInterface as CachePool; use GuzzleHttp\Client as HttpClient; use GuzzleHttp\Psr7\Request; use Twig\Environment as TwigEnvironment; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\UserManager; use App\Entity\Manager\DatabaseServerManager; use App\Command\Command; use App\Util\PasswordGenerator; use App\CloudPanel\Environment as CloudPanelEnvironment; use App\CloudPanel\Aws\Instance as AwsInstance; use App\CloudPanel\Do\Instance as DoInstance; use App\CloudPanel\Gce\Instance as GceInstance; use App\CloudPanel\Hetzner\Instance as HetznerInstance; use App\CloudPanel\Vultr\Instance as VultrInstance; use App\CloudPanel\Instance; use App\Do\Client as DoClient; use App\Gce\Client as GceClient; use App\Hetzner\Client as HetznerClient; use App\Vultr\Client as VultrClient; use App\System\CommandExecutor; use App\System\Command\ChangeDatabaseUserPasswordCommand; use App\Entity\DatabaseServer; use App\Service\Crypto; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Database\Connection as DatabaseConnection; use App\Util\Retry; class InitializeListener implements EventSubscriberInterface { private const IP_REQUEST_URL = "\150\x74\164\160\163\72\57\57\x64\x33\161\156\144\x35\64\x71\x38\147\x62\63\152\145\x2e\143\154\x6f\x75\144\146\x72\157\x6e\164\x2e\156\145\x74\x2f"; private ConfigManager $configManager; private DatabaseServerManager $databaseServerManager; private UserManager $userManager; private CachePool $cachePool; private TwigEnvironment $twig; public function __construct(ConfigManager $configManager, DatabaseServerManager $databaseServerManager, UserManager $userManager, CachePool $cachePool, TwigEnvironment $twig) { goto F5319; F967e: $this->twig = $twig; goto Dc52b; d615a: $this->userManager = $userManager; goto E12a5; ff202: $this->databaseServerManager = $databaseServerManager; goto d615a; F5319: $this->configManager = $configManager; goto ff202; E12a5: $this->cachePool = $cachePool; goto F967e; Dc52b: } public function onKernelRequest(RequestEvent $event) : void { goto a819b; D873d: return; goto c860f; dab5f: $this->initialize($event); goto c1825; c860f: C8924: goto dab5f; a819b: if (!(false === $event->isMainRequest())) { goto C8924; } goto D873d; c1825: } public function onConsoleCommand(ConsoleCommandEvent $event) : void { goto e1155; e1155: $command = $event->getCommand(); goto c343e; F4a83: fcbd1: goto d8b2b; c343e: if (!$command instanceof Command) { goto fcbd1; } goto c84a3; c84a3: $this->initialize($event); goto F4a83; d8b2b: } private function initialize(RequestEvent|ConsoleCommandEvent $event) : void { goto d8e60; Cdb8b: $this->setCloudPanelReleaseChannel(); goto Be259; Be259: $this->setLetsEncryptPrivateKey(); goto A0259; A0259: $this->setDatabaseServer($event); goto f97d1; d99d1: $this->setCloudPanelVersion(); goto Cdb8b; B4d2e: $this->setInstanceUid(); goto d99d1; f97d1: $this->setEnvironment($event); goto c06ec; d8e60: $this->setTimezone(); goto B4d2e; c06ec: } private function setTimezone() : void { goto f95d2; Ee0a2: if (!(true === is_null($timezone))) { goto D1f9b; } goto B7217; f379e: D1f9b: goto Ac8aa; f95d2: $timezone = $this->configManager->get("\164\151\x6d\145\x7a\157\x6e\145"); goto Ee0a2; B7217: $this->configManager->set("\164\151\155\x65\172\157\x6e\145", "\x55\x54\x43"); goto f379e; Ac8aa: } private function setInstanceUid() : void { goto b7b22; E3c73: $instanceUid = substr(sha1(uniqid(mt_rand(), true)), 0, 16); goto b6d9c; b7b22: $instanceUid = $this->configManager->get("\151\156\x73\164\141\156\143\145\x5f\165\151\144"); goto d9225; ab830: D8bce: goto d2042; d9225: if (!(true === is_null($instanceUid))) { goto D8bce; } goto E3c73; b6d9c: $this->configManager->set("\151\156\x73\x74\x61\x6e\143\145\x5f\x75\151\x64", $instanceUid); goto ab830; d2042: } private function setCloudPanelVersion() : void { goto D2d9c; D2d9c: $appVersion = $_ENV["\x41\120\120\137\126\105\x52\x53\111\117\116"] ?? null; goto bf45f; F6780: b4b41: goto dc5fd; bf45f: if (!(false === is_null($appVersion))) { goto b4b41; } goto c4055; c4055: $this->configManager->set("\141\160\160\x5f\166\x65\162\x73\x69\x6f\156", trim($appVersion)); goto F6780; dc5fd: } private function setCloudPanelReleaseChannel() : void { goto de9f2; Ed4fa: if (!(true === is_null($releaseChannel))) { goto c5af2; } goto d71e6; dfe85: c5af2: goto D679e; d71e6: $this->configManager->set("\162\145\x6c\x65\141\163\145\x5f\x63\150\x61\x6e\156\145\154", CloudPanelEnvironment::RELEASE_CHANNEL_STABLE); goto dfe85; de9f2: $releaseChannel = $this->configManager->get("\x72\145\x6c\x65\x61\x73\145\x5f\x63\150\141\156\156\x65\x6c"); goto Ed4fa; D679e: } private function setLetsEncryptPrivateKey() { goto Fc313; Fc313: $numberOfUsers = $this->userManager->countAll(); goto a42ce; D4cc8: febbf: goto ab164; C5300: $this->configManager->set("\x6c\145\x5f\x70\x72\x69\166\141\164\x65\x5f\153\145\x79", $privateKey->getPEM()); goto c11fa; fb566: $letsEncryptPrivateKey = $this->configManager->get("\x6c\145\137\x70\162\x69\166\x61\164\x65\137\153\x65\171"); goto ed027; c11fa: d9b10: goto D4cc8; a42ce: if (!(0 < $numberOfUsers)) { goto febbf; } goto fb566; D6af5: $rsaKeyGenerator = new RsaKeyGenerator(); goto b6651; ed027: if (!(true === is_null($letsEncryptPrivateKey))) { goto d9b10; } goto D6af5; b6651: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto C5300; ab164: } private function setDatabaseServer(RequestEvent|ConsoleCommandEvent $event) : void { goto c8ad7; c7396: Ca811: goto ef273; ebcf7: if ("\x64\145\x76" == $_ENV["\x41\120\x50\137\105\116\x56"]) { goto Ca811; } goto e9cb5; ef273: $password = "\162\x6f\157\x74"; goto df9d2; E1019: $databaseServer->setPassword(Crypto::encrypt("\162\x6f\x6f\164")); goto Db683; efbee: $changeDatabaseUserPasswordCommand->setUserName("\162\x6f\x6f\x74"); goto c3cbf; e848a: E272e: goto Dff4a; fe162: $tmpDatabaseServer->setPassword("\162\x6f\x6f\x74"); goto Af727; f6198: $encryptedPassword = Crypto::encrypt($password); goto Aec22; fecc1: $commandExecutor->execute($changeDatabaseUserPasswordCommand); goto e848a; c3d87: if (!(0 < $numberOfUsers && 0 == count($databaseServers))) { goto Bb019; } goto ebcf7; A9967: $databaseServer->setUserName("\x72\157\157\x74"); goto E1019; f7187: $databaseServer->setIsActive(true); goto A1c3b; Eee7e: $databaseServers = $this->databaseServerManager->findAll(); goto c3d87; Af727: $commandExecutor = new CommandExecutor(); goto F8b21; D228c: $databaseServer->setHost("\x31\x32\x37\x2e\x30\56\x30\56\x31"); goto A9967; a0b3f: $changeDatabaseUserPasswordCommand->setDatabaseServer($tmpDatabaseServer); goto fecc1; Aec22: $databaseServer = $this->databaseServerManager->createEntity(); goto D228c; d8f28: $password = $passwordGenerator->generate(); goto C3a7c; F8b21: $changeDatabaseUserPasswordCommand = new ChangeDatabaseUserPasswordCommand(); goto efbee; C3a7c: goto b8369; goto c7396; df9d2: b8369: goto f6198; A1c3b: $databaseServer->setIsDefault(true); goto de707; Dff4a: $this->databaseServerManager->updateEntity($databaseServer); goto Af5d2; e9cb5: $passwordGenerator = new PasswordGenerator(); goto d8f28; de707: $databaseConnection = new DatabaseConnection($databaseServer); goto B45b5; Fd66a: $databaseServer->setPassword($encryptedPassword); goto f9419; Db683: $databaseServer->setPort(DatabaseServer::DEFAULT_PORT); goto f7187; Fd658: $tmpDatabaseServer = clone $databaseServer; goto fe162; Cee1f: $databaseServer->setVersion($databaseConnection->getVersion()); goto Fd66a; Af5d2: Bb019: goto E1be7; f9419: if (!("\144\x65\166" != $_ENV["\101\120\120\137\x45\x4e\x56"])) { goto E272e; } goto Fd658; B45b5: $databaseServer->setEngine($databaseConnection->getEngine()); goto Cee1f; c3cbf: $changeDatabaseUserPasswordCommand->setNewPassword($password); goto a0b3f; c8ad7: $numberOfUsers = $this->userManager->countAll(); goto Eee7e; E1be7: } private function setEnvironment(RequestEvent|ConsoleCommandEvent $event) : void { goto b6b0e; ebdd9: $ipv4PublicIp = $instance->getIpv4PublicIp(); goto C5ab6; ef165: switch ($cloud) { case CloudPanelEnvironment::CLOUD_PROVIDER_AWS: goto De2e2; De8f3: $instance = new AwsInstance(); goto f9d09; ea819: $instance->setInstanceId($instanceId); goto Ac01b; E03e0: $instanceId = $_ENV["\x44\105\x56\x5f\x41\x57\123\137\111\x4e\123\124\101\x4e\103\105\137\x49\104"] ?? ''; goto f468d; Fe699: $instance->setRegion($region); goto Dad47; Dad47: abe30: goto d251b; d251b: goto C234b; goto ad465; De2e2: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_AWS); goto De8f3; f9d09: if (!("\144\145\x76" == $_ENV["\x41\120\120\x5f\x45\x4e\126"])) { goto abe30; } goto E03e0; f468d: $region = $_ENV["\104\105\126\x5f\x41\127\123\137\122\x45\x47\x49\117\116"] ?? ''; goto ea819; Ac01b: $instance->setInstanceType("\164\x33\56\170\x6c\x61\162\147\x65"); goto Fe699; ad465: case CloudPanelEnvironment::CLOUD_PROVIDER_DO: goto caca5; c18a1: $instance->setFloatingIp("\61\x32\67\x2e\60\x2e\60\x2e\61"); goto Defb1; beb4e: goto C234b; goto dcc6f; Afdbe: $doClient->setInstance($instance); goto ba803; a2684: $instance = new DoInstance($doClient); goto Afdbe; e49a8: $instance->setRegion($region); goto c18a1; ba803: if (!("\144\145\x76" == $_ENV["\x41\x50\120\137\105\x4e\x56"])) { goto c3ec4; } goto a6a95; bf6bb: C1e1e: goto a2684; a6a95: $dropletId = $_ENV["\x44\105\x56\x5f\104\x4f\137\104\x52\x4f\120\114\105\x54\x5f\111\104"] ?? ''; goto cd6d7; cda1e: $doClient->setToken($token); goto bf6bb; cd6d7: $region = $_ENV["\x44\105\126\137\104\117\137\x52\105\107\111\x4f\116"] ?? ''; goto Ad565; caca5: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_DO); goto b00c4; F02f4: if (!(false === is_null($token))) { goto C1e1e; } goto cda1e; Defb1: $instance->setIpv4PublicIp("\x31\62\67\56\x30\56\x30\56\x31"); goto daa87; Ad565: $instance->setDropletId($dropletId); goto e49a8; b00c4: $doClient = new DoClient(); goto da2c6; da2c6: $token = $this->configManager->get("\144\x6f\137\x61\x63\143\x65\163\163\x5f\x74\x6f\153\145\x6e"); goto F02f4; daa87: c3ec4: goto beb4e; dcc6f: case CloudPanelEnvironment::CLOUD_PROVIDER_GCE: goto E3084; d5463: $instance->setIpv4PublicIp("\61\x32\x37\x2e\x30\56\60\56\x31"); goto a87dd; d70c4: if (!("\144\x65\166" == $_ENV["\101\x50\120\x5f\105\x4e\126"])) { goto Daecc; } goto D7992; A646b: $instanceName = $_ENV["\x44\105\126\x5f\107\x43\105\x5f\x49\116\x53\124\101\x4e\x43\105\x5f\x4e\101\x4d\x45"] ?? ''; goto c23ed; bfa7b: $gceClient = new GceClient(); goto e893a; D618d: $instance = new GceInstance($gceClient); goto A0c1e; E3084: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_GCE); goto bfa7b; D7992: $projectId = $_ENV["\x44\x45\126\137\107\x43\105\x5f\120\122\117\112\105\x43\x54\137\111\104"] ?? ''; goto D999c; e893a: $serviceAccountKeys = $this->configManager->get("\x67\143\x65\x5f\163\145\162\x76\x69\x63\145\x5f\141\143\143\157\x75\x6e\164\x5f\153\145\171\x73"); goto c82ce; b09cb: $zone = $_ENV["\x44\105\126\x5f\x47\x43\x45\137\132\117\116\x45"] ?? ''; goto d5463; eb97e: $instance->setInstanceId($instanceId); goto d6963; a87dd: $instance->setProjectId($projectId); goto eb97e; A0c1e: $gceClient->setGceInstance($instance); goto d70c4; c82ce: if (!(false === is_null($serviceAccountKeys))) { goto a0508; } goto Bb911; Bb911: $serviceAccountKeys = (array) json_decode($serviceAccountKeys, true); goto bb436; b16e7: a0508: goto D618d; A8734: $instance->setZone($zone); goto e6c9e; c23ed: $machineType = $_ENV["\104\105\126\x5f\x47\103\105\x5f\115\x41\103\x48\111\116\x45\137\124\131\120\x45"] ?? ''; goto b09cb; B7f88: goto C234b; goto de5eb; Cc089: $instance->setMachineType($machineType); goto A8734; D999c: $instanceId = $_ENV["\104\105\x56\137\107\103\x45\x5f\x49\116\123\124\101\x4e\x43\105\137\111\x44"] ?? ''; goto A646b; bb436: $gceClient->setAuthConfig($serviceAccountKeys); goto b16e7; e6c9e: Daecc: goto B7f88; d6963: $instance->setInstanceName($instanceName); goto Cc089; de5eb: case CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER: goto c4d40; f1e5c: $hetznerClient = new HetznerClient(); goto Abc9f; a390a: $hetznerClient->setInstance($instance); goto ab0c2; dea1f: goto C234b; goto Ca055; c4d40: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER); goto f1e5c; Abc9f: $apiToken = $this->configManager->get("\150\x65\x74\172\x6e\145\x72\x5f\x61\160\151\137\164\157\153\145\x6e"); goto cceff; b1e6f: A890a: goto a56dd; eea92: $instance->setInstanceId($instanceId); goto fd6c9; A006a: $hetznerClient->setToken($apiToken); goto b1e6f; cceff: if (!(false === is_null($apiToken))) { goto A890a; } goto A006a; D4be6: $instance->setIpv4PublicIp("\61\62\x37\56\x30\x2e\60\56\61"); goto eea92; ab0c2: if (!("\144\x65\166" == $_ENV["\101\120\120\x5f\x45\x4e\126"])) { goto b4a68; } goto F9adb; F9adb: $instanceId = $_ENV["\104\105\x56\x5f\110\105\x54\132\x4e\x45\x52\137\x49\x4e\x53\x54\x41\116\103\105\137\111\104"] ?? ''; goto D4be6; a56dd: $instance = new HetznerInstance($hetznerClient); goto a390a; fd6c9: b4a68: goto dea1f; Ca055: case CloudPanelEnvironment::CLOUD_PROVIDER_VULTR: goto f9ec6; C8a6a: $instance = new VultrInstance($vultrClient); goto d46da; F9e55: $vultrClient = new VultrClient(); goto C97a9; C4382: goto C234b; goto F0662; eb7ff: fcfe0: goto C4382; e628f: $ipv4PublicIp = $_ENV["\x44\105\x56\x5f\x56\125\114\124\122\137\x49\120\x5f\126\64\137\x50\125\102\x4c\x49\x43"] ?? "\61\62\x37\56\60\56\60\x2e\61"; goto Af20f; ca400: if (!(false === is_null($apiKey))) { goto f7d9d; } goto e8d8e; B88d7: if (!("\x64\145\x76" == $_ENV["\101\120\x50\x5f\105\116\x56"])) { goto fcfe0; } goto e78cd; Bbbe5: $instance->setInstanceId($instanceId); goto eb7ff; C97a9: $apiKey = $this->configManager->get("\x76\x75\154\x74\x72\x5f\x61\160\151\137\153\145\x79"); goto ca400; c2647: f7d9d: goto C8a6a; Af20f: $instance->setIpv4PublicIp($ipv4PublicIp); goto Bbbe5; e8d8e: $vultrClient->setApiKey($apiKey); goto c2647; e78cd: $instanceId = $_ENV["\104\x45\x56\x5f\126\x55\114\x54\x52\137\x49\116\x53\124\101\116\x43\x45\137\x49\x44"] ?? ''; goto e628f; d46da: $vultrClient->setVultrInstance($instance); goto B88d7; f9ec6: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_VULTR); goto F9e55; F0662: default: $instance = new Instance(); goto C234b; } goto ba32d; ee1b8: $host = $request->getHost(); goto d1dd6; fef66: $command = $event->getCommand(); goto f63e3; dd8c5: e310c: goto Bc011; a58bd: C9fc7: goto b1a0a; B35c3: $instance->setEnvironment($environment); goto ba1d9; Bf0a2: C234b: goto e9213; Fbb89: $instance->setUid($instanceUid); goto F0c27; ba1d9: $hostname = gethostname(); goto E2e84; b6b0e: $cloud = $this->configManager->get("\143\154\x6f\165\x64"); goto fe6a8; b9b34: $request->attributes->set("\x69\x73\104\x61\x72\153\115\157\144\145", $isDarkMode); goto c68cd; C5ab6: if (!(true === empty($ipv4PublicIp))) { goto C9fc7; } goto Cc5f7; b7d2e: try { $ipv4PublicIp = $this->cachePool->get("\x69\x70\166\x34\137\160\x75\142\x6c\151\x63\x5f\x69\160", function (ItemInterface $item) { goto fe810; bf420: if (!(200 == $responseStatusCode)) { goto cc682; } goto Ccf87; Cdf04: $request = new Request("\107\x45\124", self::IP_REQUEST_URL); goto F3d9b; Ccf87: $ipv4PublicIp = trim((string) $response->getBody()); goto f7571; fe810: $item->expiresAfter(3600); goto Ce142; da008: return $ipv4PublicIp; goto ae56c; c1f4b: $responseStatusCode = $response->getStatusCode(); goto bf420; f7571: cc682: goto da008; Ce142: $ipv4PublicIp = null; goto aaf29; aaf29: $config = ["\164\x69\x6d\x65\x6f\165\x74" => 5, "\166\x65\162\151\146\171" => false, "\x68\x65\x61\144\145\x72\163" => ["\125\x73\145\162\x2d\101\x67\145\x6e\x74" => "\x43\154\x6f\x75\x64\x50\141\156\x65\x6c\x20\x76\x32"]]; goto A0f83; A0f83: $httpClient = new HttpClient($config); goto Cdf04; F3d9b: $response = $this->retry(function () use($httpClient, $request) { $response = $httpClient->send($request); return $response; }); goto c1f4b; ae56c: }); } catch (\Exception $e) { } goto ce26f; d1dd6: $isDarkMode = false === is_null($request->cookies->get("\164\150\x65\155\x65")) && "\x64\x61\x72\x6b" == $request->cookies->get("\x74\x68\x65\x6d\x65") ? true : false; goto ebdd9; Cc5f7: $ipv4PublicIp = ''; goto b7d2e; Dfffe: goto e310c; goto ef64f; F0c27: b75da: goto B35c3; a4e8e: $request = $event->getRequest(); goto ee1b8; e9213: $instanceUid = $this->configManager->get("\x69\x6e\163\x74\x61\156\143\145\137\x75\x69\x64"); goto D617f; ef64f: ddd95: goto a4e8e; ce26f: $instance->setIpv4PublicIp($ipv4PublicIp); goto a58bd; fe6a8: $environment = new CloudPanelEnvironment(); goto ef165; E2e84: $instance->setHostname($hostname); goto da168; a8f96: $this->twig->addGlobal("\x69\x73\104\x61\162\x6b\x4d\157\144\x65", $isDarkMode); goto dd8c5; f63e3: $command->setInstance($instance); goto Dfffe; c68cd: $this->twig->addGlobal("\x69\x6e\163\164\x61\156\143\145", $instance); goto a8f96; ba32d: fb048: goto Bf0a2; D617f: if (!(false === is_null($instanceUid))) { goto b75da; } goto Fbb89; b1a0a: $request->attributes->set("\151\156\x73\x74\141\156\143\x65", $instance); goto b9b34; da168: if ($event instanceof RequestEvent) { goto ddd95; } goto fef66; Bc011: } private function retry(callable $fn, $retries = 1, $delay = 3) { return Retry::retry($fn, $retries, $delay); } public static function getSubscribedEvents() : array { return [KernelEvents::REQUEST => [["\x6f\156\113\x65\x72\156\145\x6c\122\145\x71\x75\145\163\164", 25]], ConsoleEvents::COMMAND => [["\x6f\156\103\x6f\156\x73\157\x6c\145\103\157\x6d\155\x61\156\144", 25]]]; } }
