<?php
 namespace App\Site\Nginx\Vhost; use App\Site\Site; use App\Site\Nginx\Vhost\Processor\Processor; use App\Site\Nginx\Vhost\Processor\RootDirectory as RootDirectoryProcessor; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; use App\Site\Nginx\Vhost\Processor\NginxAccessLog as NginxAccessLogProcessor; use App\Site\Nginx\Vhost\Processor\NginxErrorLog as NginxErrorLogProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificateKey as NginxCertificateKeyProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificate as NginxCertificateProcessor; use App\Site\Nginx\Vhost\Processor\Settings as SettingsProcessor; class Template { protected Site $site; protected ?string $content = null; protected array $placeholders = []; protected array $processors = []; public function __construct(Site $site) { $this->site = $site; $this->init(); } protected function init() : void { goto c4420; D26c1: $nginxAccessLogProcessor = new NginxAccessLogProcessor(); goto B61fb; c5ebf: $this->addProcessor($nginxAccessLogProcessor); goto B8e74; F49d3: $this->addProcessor($certificateProcessor); goto Ffa1d; Ce901: $settingsProcessor = new SettingsProcessor(); goto f71df; Adda3: $this->addProcessor($redirectServerNameProcessor); goto d9b29; d8e71: $redirectServerNameProcessor = new RedirectServerNameProcessor(); goto Dbe29; d9b29: $this->addProcessor($redirectDomainProcessor); goto c5ebf; B61fb: $nginxErrorLogProcessor = new NginxErrorLogProcessor(); goto f7bd0; c4420: $rootDirectoryProcessor = new RootDirectoryProcessor(); goto Ae9c7; E966d: $this->addProcessor($serverNameProcessor); goto Adda3; f7bd0: $certificateKeyProcessor = new NginxCertificateKeyProcessor(); goto caf3e; B4808: $this->addProcessor($certificateKeyProcessor); goto F49d3; Ffa1d: $this->addProcessor($settingsProcessor); goto E7755; Ae9c7: $serverNameProcessor = new ServerNameProcessor(); goto d8e71; caf3e: $certificateProcessor = new NginxCertificateProcessor(); goto Ce901; f71df: $this->addProcessor($rootDirectoryProcessor); goto E966d; B8e74: $this->addProcessor($nginxErrorLogProcessor); goto B4808; Dbe29: $redirectDomainProcessor = new RedirectDomainProcessor(); goto D26c1; E7755: } public function getSite() : Site { return $this->site; } public function setContent(string $content) : void { $this->content = $content; } public function getContent() : ?string { return $this->content; } public function build() : void { goto ebc3a; D6ae3: c5c8b: goto Eb163; b72e9: foreach ($placeholders as $placeholder) { goto A9cd0; B9fd2: $this->removePlaceholder($placeholder); goto e3d00; e3d00: E4e2a: goto D4b2b; eee1f: $processor->setSite($this->site); goto a1f29; E39ee: $processor = $processors[$placeholder]; goto eee1f; a1f29: $this->content = $processor->process($this->content); goto B9fd2; A9cd0: $hasProcessor = $this->hasProcessor($placeholder); goto F513e; D4b2b: c5a64: goto Ed7dd; F513e: if (!(true === $hasProcessor)) { goto E4e2a; } goto E39ee; Ed7dd: } goto D6ae3; E3845: $placeholders = $this->getPlaceholders(); goto b72e9; ebc3a: $processors = $this->getProcessors(); goto E3845; Eb163: } public function removeEmptyPlaceholders() : void { goto f1e21; f1e21: $placeholders = $this->getPlaceholders(); goto c490c; c490c: foreach ($placeholders as $placeholder) { $this->content = str_replace($placeholder, '', $this->content); cb732: } goto f5c8d; f5c8d: Bb4be: goto Afe20; Afe20: } protected function hasProcessor(string $placeholder) : bool { return isset($this->processors[$placeholder]); } protected function getProcessors() : array { return $this->processors; } public function addProcessor(Processor $processor) : void { $this->processors[$processor->getPlaceholder()] = $processor; } public function resetProcessors() : void { $this->processors = []; } public function getPlaceholders() : array { goto A363e; a682e: foreach ($placeholders as $placeholder) { goto c84d5; B4e3e: $this->addPlaceholder($placeholder); goto c2519; dfb32: if (!(false === empty($placeholder))) { goto bef8c; } goto B4e3e; c84d5: $placeholder = trim($placeholder); goto dfb32; c2519: bef8c: goto b4325; b4325: cb0af: goto e17cd; e17cd: } goto dd1ca; e9617: Cff13: goto Dde76; Dde76: return $this->placeholders; goto Cffe4; fa185: if (!(true === isset($placeholders[0]) && count($placeholders[0]))) { goto F9fb2; } goto D82dd; D82dd: $placeholders = $placeholders[0]; goto a682e; dd1ca: a4dca: goto D628c; D628c: F9fb2: goto e9617; A67c5: preg_match_all("\x2f\x5b\x7b\x7b\x5d\x7b\x32\175\x28\133\134\x73\x61\55\172\x41\x2d\x5a\x30\55\71\x5f\x5d\53\x29\133\x7d\175\135\173\62\175\57", $this->content, $placeholders); goto fa185; A363e: if (!(true === empty($this->placeholders))) { goto Cff13; } goto A67c5; Cffe4: } private function addPlaceholder(string $placeholder) : void { $this->placeholders[$placeholder] = $placeholder; } private function removePlaceholder(string $placeholder) : void { goto b56df; b56df: if (!(true === isset($this->placeholders[$placeholder]))) { goto f572f; } goto db327; f404d: f572f: goto Ee403; db327: unset($this->placeholders[$placeholder]); goto f404d; Ee403: } }
