<?php
 namespace App\Site; use App\System\Command\CopyFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\NginxConfigTestCommand; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\ChmodCommand; use App\System\Command\FindChmodCommand; use App\System\Command\WriteFileCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\ChangeUserHomeDirectoryCommand; use App\System\Command\CreateUserCommand; use App\System\Command\DeleteUserCommand; use App\System\Command\ChangeUserPasswordCommand; use App\System\Command\CreateSymlinkCommand; use App\System\Command\ReadLinkCommand; use App\System\Command\ServiceReloadCommand; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Entity\Site as SiteEntity; use App\Site\Ssl\LetsEncrypt\CertificateOrder; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Nginx\Vhost\StaticTemplate; use App\Site\Nginx\Vhost\NodejsTemplate; use App\Site\Nginx\Vhost\PhpTemplate; use App\Site\Nginx\Vhost\PythonTemplate; use App\Site\Nginx\Vhost\ReverseProxyTemplate; abstract class Updater { public const NGINX_BASIC_AUTH_DIRECTORY = "\57\145\164\x63\x2f\x6e\x67\151\156\x78\x2f\x62\141\x73\x69\x63\x2d\141\165\x74\150\x2f"; public const NGINX_VHOST_DIRECTORY = "\57\145\164\x63\57\156\147\151\x6e\170\x2f\x73\151\164\x65\163\55\145\x6e\141\142\x6c\x65\144\x2f"; public const NGINX_SSL_CERTIFICATES_DIRECTORY = "\57\145\164\x63\x2f\x6e\x67\x69\156\170\x2f\163\x73\154\x2d\x63\145\x72\x74\151\x66\x69\143\x61\164\x65\163\57"; public const CRON_DIRECTORY = "\57\x65\x74\x63\57\143\162\x6f\156\x2e\144\57"; protected Site $site; protected CommandExecutor $commandExecutor; public function __construct(Site $site) { $this->site = $site; $this->commandExecutor = new CommandExecutor(); } public function domainSettings() : void { $this->updateNginxVhost(); $this->reloadNginxService(); } public function updateNginxVhost() : void { goto e7ba3; da654: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto D91c1; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto D91c1; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto D91c1; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto D91c1; case SiteEntity::TYPE_REVERSE_PROXY: $vhostTemplate = new ReverseProxyTemplate($this->site); goto D91c1; } goto B8f20; Afa92: $vhostTemplate->setContent($vhostFileContent); goto Eaefb; Eaefb: $vhostFile = sprintf("\x25\x73\x2f\x25\x73\x2e\x63\157\x6e\x66", rtrim(self::NGINX_VHOST_DIRECTORY, "\x2f"), $domainName); goto F39ca; Fdc7d: $vhostContent = $vhostTemplate->getContent(); goto Cacf5; A5ee8: $vhostFileContent = $this->site->getVhostTemplate(); goto da654; F39ca: $vhostTemplate->build(); goto E0620; D7ba2: $writeVhostFileCommand->setContent($vhostContent); goto d33ef; Cacf5: $writeVhostFileCommand = new WriteFileCommand(); goto Ae18e; d33ef: $this->commandExecutor->execute($writeVhostFileCommand); goto B7c59; E0620: $vhostTemplate->removeEmptyPlaceholders(); goto Fdc7d; e7ba3: $domainName = $this->site->getDomainName(); goto A5ee8; B88f9: D91c1: goto Afa92; B8f20: a0dbc: goto B88f9; Ae18e: $writeVhostFileCommand->setFile($vhostFile); goto D7ba2; B7c59: } public function updateNginxVhostWithRollback() : void { try { goto A0ded; fcec7: if (!("\x64\x65\166" != $_ENV["\x41\120\120\x5f\x45\116\x56"])) { goto Cddec; } goto D4198; Eac56: $deleteVhostBackupFileCommand->setFile($vhostBackupFile); goto ee96b; A66d6: $this->commandExecutor->execute($nginxConfigTestCommand); goto fcec7; d5780: $copyVhostBackupFileCommand = new CopyFileCommand(); goto Bccca; Ea3cc: $writeVhostFileCommand->setContent($vhostContent); goto ea684; Ad124: Cddec: goto ef89b; Bccca: $copyVhostBackupFileCommand->setSourceFile($vhostFile); goto A6d68; B4d94: $vhostContent = $vhostTemplate->getContent(); goto C6de4; d2dd6: $vhostTemplate->removeEmptyPlaceholders(); goto B4d94; cb655: $writeVhostFileCommand->setFile($vhostFile); goto Ea3cc; A0ded: $domainName = $this->site->getDomainName(); goto E6403; ef89b: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto c5338; D4198: $reloadNginxServiceCommand = new ServiceReloadCommand(); goto C71c0; Dc385: $this->commandExecutor->execute($writeVhostFileCommand); goto A66d6; f3a96: $vhostTemplate->setContent($vhostFileContent); goto A0c8f; Bed06: C4ddc: goto cf9b7; A6d68: $copyVhostBackupFileCommand->setDestinationFile($vhostBackupFile); goto f8062; ea684: $nginxConfigTestCommand = new NginxConfigTestCommand(); goto a2814; A0c8f: $vhostFile = sprintf("\45\x73\x2f\x25\x73\x2e\x63\157\x6e\146", rtrim(self::NGINX_VHOST_DIRECTORY, "\57"), $domainName); goto B0c0e; dc6b5: $this->commandExecutor->execute($reloadNginxServiceCommand); goto Ad124; E6403: $vhostFileContent = $this->site->getVhostTemplate(); goto Ce0c3; B0c0e: $vhostTemplate->build(); goto d2dd6; C6de4: $vhostBackupFile = sprintf("\x25\x73\57\45\x73\x2e\x63\157\x6e\x66\x2e\142\141\x6b", rtrim(self::NGINX_VHOST_DIRECTORY, "\x2f"), $domainName); goto d5780; cf9b7: Da537: goto f3a96; Ce0c3: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto Da537; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto Da537; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto Da537; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto Da537; case SiteEntity::TYPE_REVERSE_PROXY: $vhostTemplate = new ReverseProxyTemplate($this->site); goto Da537; } goto Bed06; C71c0: $reloadNginxServiceCommand->setServiceName("\156\x67\151\156\x78"); goto dc6b5; f8062: $writeVhostFileCommand = new WriteFileCommand(); goto cb655; a2814: $deleteVhostBackupFileCommand = new DeleteFileCommand(); goto Eac56; ee96b: $this->commandExecutor->execute($copyVhostBackupFileCommand); goto Dc385; c5338: } catch (\Exception $e) { goto bea62; ced12: ab383: goto Daeea; e15d0: if (!(true === isset($nginxConfigTestCommand))) { goto ab383; } goto d2e0e; bca8a: $this->commandExecutor->execute($reloadNginxServiceCommand); goto A9cc5; D8c06: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto d63bd; bea62: $errorMessage = $e->getMessage(); goto e15d0; A9cc5: C8e03: goto D8c06; ad283: $restoreBackupFileCommand->setSourceFile($vhostBackupFile); goto d454f; Daeea: $restoreBackupFileCommand = new CopyFileCommand(); goto ad283; d454f: $restoreBackupFileCommand->setDestinationFile($vhostFile); goto Ac7f3; Aeda5: if (!(true === isset($reloadNginxServiceCommand))) { goto C8e03; } goto bca8a; Ac7f3: $this->commandExecutor->execute($restoreBackupFileCommand); goto Aeda5; d2e0e: $errorMessage = $nginxConfigTestCommand->getOutput(); goto ced12; d63bd: throw new InvalidVhostException($errorMessage); goto d7c81; d7c81: } } public function createSshUser(SshUserEntity $sshUserEntity) : void { goto c4a71; E38b6: cda3d: goto Dfd3f; E20dd: $sshUserPassword = $sshUserEntity->getPassword(); goto bd4aa; C6eee: $changeSiteUserHomeDirectoryPermissionsCommand = new ChmodCommand(); goto b8ea8; cbc2f: $sshDirectoryChmodCommand->setFile($sshDirectory); goto Ce879; Ae5f3: $siteUserHomeDirectory = sprintf("\x2f\x68\157\155\x65\x2f\45\163", $siteUser); goto C6eee; ccb43: $changeSiteUserHomeDirectoryPermissionsCommand->setChmod(750); goto f3188; Ce174: $createUserCommand->setUserName($sshUserName); goto C0d61; C0bd0: $symlinkDirectories = ["\x62\141\x63\x6b\x75\160\163", "\x68\x74\x64\157\x63\163", "\154\157\147\x73"]; goto f4f64; d7c00: $createUserCommand = new CreateUserCommand(); goto Ce174; d49ee: $siteUser = $site->getUser(); goto C1586; B5861: $createUserCommand->setSkeletonDirectory($skeletonDirectory); goto b5415; b5415: $createUserCommand->setHomeDirectory($homeDirectory); goto D79cc; a8deb: $skeletonDirectory = realpath(dirname(__FILE__) . "\57\x2e\56\57\x2e\56\x2f\x72\145\x73\x6f\165\x72\143\x65\x73\x2f\145\x74\x63\57\x73\153\x65\x6c\x2f\163\x73\x68\x2d\165\163\145\162\x2f"); goto d7c00; c4a71: $site = $sshUserEntity->getSite(); goto d49ee; bf7e4: $this->commandExecutor->execute($changeSiteUserHomeDirectoryPermissionsCommand); goto b18e6; da49e: $this->commandExecutor->execute($createUserCommand); goto C0bd0; C0d61: $createUserCommand->setPassword($sshUserPassword); goto a62a3; a62a3: $createUserCommand->setGroup($siteUser); goto d353d; A2e3a: $sshDirectoryChmodCommand = new FindChmodCommand(); goto cbc2f; C1586: $sshUserName = $sshUserEntity->getUserName(); goto E20dd; f4f64: foreach ($symlinkDirectories as $symlinkDirectory) { goto F17da; D73ec: ebea0: goto Bbc4b; E9076: $this->commandExecutor->execute($symlinkCommand); goto D73ec; dd36c: if (!("\x64\x65\x76" != $_ENV["\101\x50\120\137\105\116\x56"])) { goto ebea0; } goto E9076; dfc9a: $destination = sprintf("\x2f\150\157\155\145\x2f\x25\163\x2f\45\x73", $sshUserName, $symlinkDirectory); goto D4c3e; B3acf: $symlinkCommand->setRunAsUser($sshUserName); goto c98ef; A1f0f: $symlinkCommand->setDestination($destination); goto dd36c; Bbc4b: b787d: goto c8219; F17da: $source = sprintf("\x2f\x68\x6f\x6d\x65\57\45\163\57\45\x73", $siteUser, $symlinkDirectory); goto dfc9a; D4c3e: $symlinkCommand = new CreateSymlinkCommand(); goto B3acf; c98ef: $symlinkCommand->setSource($source); goto A1f0f; c8219: } goto E38b6; Ce879: $sshDirectoryChmodCommand->setDirectoryChmod(700); goto e02aa; b2ba7: $changeSiteUserHomeDirectoryPermissionsCommand->setRecursive(false); goto ccb43; b8ea8: $changeSiteUserHomeDirectoryPermissionsCommand->setFile($siteUserHomeDirectory); goto b2ba7; D79cc: $createUserCommand->createHomeDirectory(true); goto da49e; bd4aa: $homeDirectory = sprintf("\57\150\x6f\155\145\57\45\x73", $sshUserName); goto a8deb; d353d: $createUserCommand->setShell("\57\x62\151\156\x2f\142\x61\x73\x68"); goto B5861; f3188: $this->commandExecutor->execute($sshDirectoryChmodCommand); goto bf7e4; Dfd3f: $sshDirectory = sprintf("\57\150\x6f\155\145\x2f\45\163\57\56\x73\x73\x68", $sshUserName); goto A2e3a; e02aa: $sshDirectoryChmodCommand->setFileChmod(600); goto Ae5f3; b18e6: } public function createFtpUser(FtpUserEntity $ftpUserEntity) : void { goto D4519; Baae5: $ftpUserPassword = $ftpUserEntity->getPassword(); goto B1fb3; f0230: $ftpUserName = $ftpUserEntity->getUserName(); goto Baae5; be3c2: $createUserCommand->setGroups(["\x66\x74\160\x2d\165\x73\x65\162"]); goto cc5af; b14c4: $siteUser = $site->getUser(); goto f0230; Bd0db: $this->commandExecutor->execute($changeSiteUserHomeDirectoryPermissionsCommand); goto D0239; Df4e4: $changeSiteUserHomeDirectoryPermissionsCommand->setChmod(750); goto ed76e; b2cca: $createUserCommand->createHomeDirectory(false); goto ae433; Ebfee: $createUserCommand = new CreateUserCommand(); goto F6c0a; Ad11a: $changeSiteUserHomeDirectoryPermissionsCommand->setFile($siteUserHomeDirectory); goto f8cec; ae433: $siteUserHomeDirectory = sprintf("\57\x68\x6f\155\x65\x2f\45\163", $siteUser); goto C5b90; B1fb3: $homeDirectory = $ftpUserEntity->getHomeDirectory(); goto Ebfee; c1a57: $createUserCommand->setPassword($ftpUserPassword); goto ae9cc; Eec72: $createUserCommand->setHomeDirectory($homeDirectory); goto b2cca; D4519: $site = $ftpUserEntity->getSite(); goto b14c4; F6c0a: $createUserCommand->setUserName($ftpUserName); goto c1a57; f8cec: $changeSiteUserHomeDirectoryPermissionsCommand->setRecursive(false); goto Df4e4; ed76e: $this->commandExecutor->execute($createUserCommand); goto Bd0db; cc5af: $createUserCommand->setShell("\57\x62\151\156\57\146\141\154\x73\145"); goto Eec72; C5b90: $changeSiteUserHomeDirectoryPermissionsCommand = new ChmodCommand(); goto Ad11a; ae9cc: $createUserCommand->setGroup($siteUser); goto be3c2; D0239: } public function deleteUser(string $userName, $removeHomeDirectory = true) : void { goto f596b; f596b: $deleteUserCommand = new DeleteUserCommand(); goto ce1f3; Cec02: $this->commandExecutor->execute($deleteUserCommand); goto f5b96; ce1f3: $deleteUserCommand->setUserName($userName); goto c7f6e; c7f6e: $deleteUserCommand->setRemoveHomeDirectory($removeHomeDirectory); goto Cec02; f5b96: } public function installCertificate(CertificateEntity $certificateEntity) : void { goto A9b19; Cc5eb: $this->commandExecutor->execute($writeCertificateFileCommand); goto Aa9a4; D947d: $writeCertificateFileCommand->setFile($certificateFile); goto dc215; c8741: $privateKeyFile = sprintf("\45\163\57\x25\x73\x2e\153\x65\x79", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\x2f"), $domainName); goto Ef767; b40de: $certificate .= sprintf("\x25\x73\45\163", PHP_EOL, trim($certificateEntity->getCertificateChain())); goto be9cb; D5830: $writePrivateKeyFileCommand->setFile($privateKeyFile); goto ef178; c5550: $writeCertificateFileCommand = new WriteFileCommand(); goto D947d; be9cb: C3b2e: goto B4f98; dc215: $writeCertificateFileCommand->setContent($certificate); goto B88cb; ed2c6: if (!(false === empty($certificateEntity->getCertificateChain()))) { goto C3b2e; } goto b40de; Ef767: $certificateFile = sprintf("\x25\x73\57\x25\x73\56\143\x72\x74", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\57"), $domainName); goto E61a2; B4f98: $writePrivateKeyFileCommand = new WriteFileCommand(); goto D5830; E61a2: $certificate = $certificateEntity->getCertificate(); goto ed2c6; A9b19: $domainName = $this->site->getDomainName(); goto c8741; ef178: $writePrivateKeyFileCommand->setContent($certificateEntity->getPrivateKey()); goto c5550; Aa9a4: $this->reloadService("\156\147\x69\x6e\170"); goto F9c5a; B88cb: $this->commandExecutor->execute($writePrivateKeyFileCommand); goto Cc5eb; F9c5a: } public function deleteLetsEncryptChallengeDirectory() : void { goto Ae59f; Ae59f: $rootDirectory = $this->getRootDirectory(); goto F031c; A75c6: $deleteAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto Bf308; Bf308: $this->commandExecutor->execute($deleteAcmeChallengeDirectoryCommand); goto fbd93; F031c: $acemeChallengeDirectory = sprintf("\45\x73\57\x2e\167\145\x6c\x6c\55\x6b\x6e\x6f\x77\x6e\x2f\x61\x63\x6d\145\55\143\150\141\x6c\x6c\x65\156\147\145\x2f", rtrim($rootDirectory, "\57")); goto C56c3; C56c3: $deleteAcmeChallengeDirectoryCommand = new DeleteDirectoryCommand(); goto A75c6; fbd93: } public function createBasicAuthFile(BasicAuthEntity $basicAuthEntity) : void { goto D9415; A568c: $this->commandExecutor->execute($writeBasicAuthFileCommand); goto d4eac; bce14: $writeBasicAuthFileCommand = new WriteFileCommand(); goto D9064; D9415: $basicAuthFile = sprintf("\45\x73\57\45\163", rtrim(self::NGINX_BASIC_AUTH_DIRECTORY, "\x2f"), $this->site->getDomainName()); goto a2119; a2119: $basicAuthFileContent = sprintf("\45\x73\x3a\45\x73", $basicAuthEntity->getUserName(), crypt($basicAuthEntity->getPassword(), base64_encode($basicAuthEntity->getPassword()))); goto bce14; D9064: $writeBasicAuthFileCommand->setFile($basicAuthFile); goto c74c9; c74c9: $writeBasicAuthFileCommand->setContent($basicAuthFileContent); goto A568c; d4eac: } public function createLetsEncryptChallengeFiles(CertificateOrder $certificateOrder) : void { goto C901a; f4954: $chmodWellKnownDirectoryCommand->setFile($wellKnownDirectory); goto Ea2bc; Ea2bc: $chmodWellKnownDirectoryCommand->setDirectoryChmod(750); goto B1966; A2c2c: $createAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto b8e06; bc8e5: $chownWellKnownDirectoryCommandCommand->setFile($wellKnownDirectory); goto C01c0; d3814: $rootDirectory = $this->getRootDirectory(); goto C42ae; D0c7e: $chmodWellKnownDirectoryCommand = new FindChmodCommand(); goto f4954; a2b72: foreach ($challenges as $challenge) { goto Dd042; C7102: F222e: goto f8634; D361a: $verificationContent = $challenge["\166\x65\162\x69\146\151\143\x61\x74\151\x6f\156\x43\157\x6e\164\145\x6e\x74"] ?? null; goto Ab7b2; D96a0: $this->commandExecutor->execute($challengeWriteFileCommand); goto C7102; ebe61: $challengeWriteFileCommand = new WriteFileCommand(); goto b8ff6; Cc20a: $challengeFile = sprintf("\x25\163\x2f\x25\163", rtrim($acemeChallengeDirectory, "\57"), $token); goto ebe61; b8ff6: $challengeWriteFileCommand->setFile($challengeFile); goto dd80c; dd80c: $challengeWriteFileCommand->setContent($verificationContent); goto D96a0; f8634: a2921: goto A4d74; Ab7b2: if (!(false === is_null($token) && false === is_null($verificationContent))) { goto F222e; } goto Cc20a; Dd042: $token = $challenge["\x74\157\x6b\145\156"] ?? null; goto D361a; A4d74: } goto b3cf9; C01c0: $chownWellKnownDirectoryCommandCommand->setRecursive(true); goto F6847; b433e: $this->commandExecutor->execute($chmodWellKnownDirectoryCommand); goto D2a25; d0257: $chownWellKnownDirectoryCommandCommand->setGroup($siteUser); goto D0c7e; b3cf9: be5d7: goto E06fe; E06fe: d2606: goto Da930; e3a8d: $acemeChallengeDirectory = sprintf("\45\x73\x2f\56\x77\x65\154\154\55\x6b\156\x6f\167\x6e\57\141\143\155\x65\x2d\x63\150\141\154\x6c\145\x6e\x67\145\57", rtrim($rootDirectory, "\x2f")); goto E231b; C901a: $siteUser = $this->site->getUser(); goto d3814; E231b: $challenges = $certificateOrder->getAuthorizationsChallenges(); goto Dfb9f; Da930: $chownWellKnownDirectoryCommandCommand = new ChownCommand(); goto bc8e5; e5ac7: if (!count($challenges)) { goto d2606; } goto a2b72; B1966: $chmodWellKnownDirectoryCommand->setFileChmod(770); goto Ab04f; Ab04f: $this->commandExecutor->execute($chownWellKnownDirectoryCommandCommand); goto b433e; Dfb9f: $createAcmeChallengeDirectoryCommand = new CreateDirectoryCommand(); goto A2c2c; C42ae: $wellKnownDirectory = sprintf("\x25\163\x2f\56\x77\x65\x6c\154\55\153\156\157\x77\x6e\x2f", rtrim($rootDirectory, "\57")); goto e3a8d; F6847: $chownWellKnownDirectoryCommandCommand->setUser($siteUser); goto d0257; b8e06: $this->commandExecutor->execute($createAcmeChallengeDirectoryCommand); goto e5ac7; D2a25: } public function updateUserCrontab() : void { goto B189d; df186: foreach ($cronJobs as $cronJob) { $crontabEntries[] = $cronJob->getCrontabExpression(); dade2: } goto c92c9; c10b4: $crontabEntries = ["\115\x41\x49\x4c\x54\117\75\42\x22"]; goto fb1ed; c92c9: A36d9: goto D0698; Ecf84: $writeCrontabFileCommand->setFile($crontabFile); goto C6de6; e1c6d: $writeCrontabFileCommand = new WriteFileCommand(); goto Ecf84; fb1ed: $cronJobs = $this->site->getCronJobs(); goto E6f3a; E9673: $crontabFile = sprintf("\x25\x73\57\x25\x73", rtrim(self::CRON_DIRECTORY, "\x2f"), $siteUser); goto c10b4; Fb847: $crontabContent = implode(PHP_EOL, $crontabEntries); goto e1c6d; C6de6: $writeCrontabFileCommand->setContent($crontabContent); goto e4821; D0698: Af7b4: goto Fb847; B189d: $siteUser = $this->site->getUser(); goto E9673; E6f3a: if (!count($cronJobs)) { goto Af7b4; } goto df186; e4821: $this->commandExecutor->execute($writeCrontabFileCommand); goto c0c45; c0c45: } public function purgePageSpeedCache() : void { goto a531d; F846d: $this->commandExecutor->execute($purgePageSpeedCacheFilesCommand, 300); goto E3e96; da166: $cacheDirectory = sprintf("\x2f\150\157\x6d\x65\x2f\x25\163\x2f\164\155\x70\x2f\160\141\147\x65\x73\160\145\x65\144\137\143\141\143\x68\x65", $siteUser); goto B9fc9; a531d: $siteUser = $this->site->getUser(); goto da166; C808e: $purgePageSpeedCacheFilesCommand->setDirectory($cacheDirectory); goto F846d; B9fc9: $purgePageSpeedCacheFilesCommand = new DeleteDirectoryCommand(); goto C808e; E3e96: } public function updateUserSShKeys(string $userName, $sshKeys) : void { goto da777; E0ad3: $readLinkPath = $readLinkCommand->getOutput(); goto be20e; F4908: $readLinkCommand->setFile($authorizedKeysFile); goto Aa992; e6265: $writeAuthorizedKeysFileCommand->setFile($authorizedKeysFile); goto Cba99; Cba99: $writeAuthorizedKeysFileCommand->setContent($sshKeys); goto baeb2; be20e: if (!(false === empty($readLinkPath) && $readLinkPath == $authorizedKeysFile)) { goto fee53; } goto e1cf5; Aa992: $this->commandExecutor->execute($readLinkCommand); goto E0ad3; C6243: fee53: goto A71fd; F6597: $readLinkCommand = new ReadLinkCommand(); goto F4908; e1cf5: $writeAuthorizedKeysFileCommand = new WriteFileCommand(); goto e6265; da777: $authorizedKeysFile = sprintf("\57\150\x6f\x6d\145\57\45\x73\57\x2e\x73\163\x68\x2f\141\165\x74\150\157\x72\151\x7a\145\x64\137\x6b\145\171\163", $userName); goto F6597; baeb2: $this->commandExecutor->execute($writeAuthorizedKeysFileCommand); goto C6243; A71fd: } public function changeUserHomeDirectory(string $userName, string $homeDirectory) : void { goto Ef467; Ef467: $changeUserHomeDirectoryCommand = new ChangeUserHomeDirectoryCommand(); goto be2d5; be2d5: $changeUserHomeDirectoryCommand->setUserName($userName); goto c7b7d; c7b7d: $changeUserHomeDirectoryCommand->setHomeDirectory($homeDirectory); goto Ecd0d; Ecd0d: $this->commandExecutor->execute($changeUserHomeDirectoryCommand); goto E30c3; E30c3: } public function changeUserPassword(string $userName, string $password) : void { goto Ba5a6; F8243: $this->commandExecutor->execute($changeUserPasswordCommand); goto F8429; fb049: $changeUserPasswordCommand->setPassword($password); goto F8243; Ba5a6: $changeUserPasswordCommand = new ChangeUserPasswordCommand(); goto fb969; fb969: $changeUserPasswordCommand->setUserName($userName); goto fb049; F8429: } protected function getRootDirectory() : string { goto f4a96; f4a96: $siteUser = $this->site->getUser(); goto Cfb35; E7278: $rootDirectory = sprintf("\57\150\x6f\155\x65\x2f\x25\163\x2f\x68\x74\144\x6f\143\163\x2f\45\x73", $siteUser, $rootDirectory); goto A3cfa; A3cfa: return $rootDirectory; goto Af80a; Cfb35: $rootDirectory = $this->site->getRootDirectory(); goto E7278; Af80a: } public function reloadNginxService() : void { $this->reloadService("\x6e\x67\x69\x6e\170"); } public function reloadService($serviceName) { goto C0557; D086d: $reloadServiceCommand->setServiceName($serviceName); goto c1971; C0557: if (!("\144\x65\x76" != $_ENV["\x41\x50\x50\x5f\x45\116\126"])) { goto E1ae5; } goto A6c28; c1971: $this->commandExecutor->execute($reloadServiceCommand); goto ca8ec; A6c28: $reloadServiceCommand = new ServiceReloadCommand(); goto D086d; ca8ec: E1ae5: goto a0e18; a0e18: } }
